
#include "StringOutput.h"
#include "obstack.h"


static Obstack obst_stringout;
static void *obst_base = 0;


static void InitStringOut()
{
   if (obst_base)
      return;

   obstack_init(&obst_stringout);
   obst_base = obstack_alloc(&obst_stringout, 0);
}

void FreeStringOut()
{
   if (!obst_base)
      return;

   obstack_free(&obst_stringout, obst_base);
   obst_base = obstack_alloc(&obst_stringout, 0);
}

#if defined(__STDC__) || defined(__cplusplus)
static void PrintString(PTG_OUTPUT_FILE f, char *s)
#else
static void PrintString(f, s) PTG_OUTPUT_FILE f; char *s;
#endif
{
   obstack_strgrow(&obst_stringout, s);
}

#if defined(__STDC__) || defined(__cplusplus)
static void PrintChar(PTG_OUTPUT_FILE f, char c)
#else
static void PrintChar(f, c) PTG_OUTPUT_FILE f; char c;
#endif
{
   obstack_1grow(&obst_stringout, c);
}

#if defined(__STDC__) || defined(__cplusplus)
char *PTG_StringOut(PTGNode root)
#else
char *PTG_StringOut(root) PTGNode root;
#endif
{
   /* Allocate the 'file' for ptg */
   PtgFilePtr ptgfile = NewPtgFile(0, PrintString);
   char *result = 0;

   ptgfile->PrintChar = PrintChar;

   /* Initialize Obstack, if necessary */
   InitStringOut();
 
   /* Create new blank region */
   obstack_blank(&obst_stringout, 0);

   /* Process the node into the region */
   PTGProcess(ptgfile, root);
  
   /* Null terminate the string */
   obstack_1grow(&obst_stringout, '\0');

   /* Retrieve the resulting string */
   result = (char *)obstack_finish(&obst_stringout);
   
   /* Remove the 'file' */
   FreePtgFile(ptgfile);

   return result;
}


