

#include "VLObjectPointerPtrList.h"
#include "err.h"
#include "obstack.h"

typedef struct {
  Obstack space;
  void *baseptr;
} Dyn, *DynP;

static DynP VLObjectPointerPtrListSpace = (DynP)0;

#if defined(__STDC__) || defined(__cplusplus)
void FinlVLObjectPointerPtrList (void)
#else
void FinlVLObjectPointerPtrList ()
#endif
{
    if (VLObjectPointerPtrListSpace != (DynP)0)
    {  obstack_free(&(VLObjectPointerPtrListSpace->space), VLObjectPointerPtrListSpace->baseptr);
       VLObjectPointerPtrListSpace->baseptr = obstack_alloc(&(VLObjectPointerPtrListSpace->space), 0);
    }
}/* FinlVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrList ConsVLObjectPointerPtrList (VLObjectPointerPtr e, VLObjectPointerPtrList l)
#else
VLObjectPointerPtrList ConsVLObjectPointerPtrList (e, l)
        VLObjectPointerPtr      e;
        VLObjectPointerPtrList  l;
#endif
{
    VLObjectPointerPtrList      h;

    if (VLObjectPointerPtrListSpace == (DynP)0)
    {   VLObjectPointerPtrListSpace = (DynP) malloc (sizeof(Dyn));
        if (VLObjectPointerPtrListSpace == (DynP)0)
        {  message (DEADLY, "no space for VLObjectPointerPtrList", 0, (POSITION*)0);
           exit (1);
        }
        obstack_init(&(VLObjectPointerPtrListSpace->space));
        VLObjectPointerPtrListSpace->baseptr =
                obstack_alloc(&(VLObjectPointerPtrListSpace->space), 0);
    }

    h = (VLObjectPointerPtrList)obstack_alloc(&(VLObjectPointerPtrListSpace->space),
                                  sizeof (struct _VLObjectPointerPtrLE));
    h->head = e;
    h->tail= l;
    return (h);
}/* ConsVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtr HeadVLObjectPointerPtrList (VLObjectPointerPtrList l)
#else
VLObjectPointerPtr HeadVLObjectPointerPtrList (l)
        VLObjectPointerPtrList  l;
#endif
{
    if (l == NULLVLObjectPointerPtrList)
    {
        message (DEADLY, "HeadVLObjectPointerPtrList: empty list", 0, (POSITION*)0);
        /* return ((VLObjectPointerPtr)0); */
    } /* if */
    return (l->head);
}/* HeadVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrList TailVLObjectPointerPtrList (VLObjectPointerPtrList l)
#else
VLObjectPointerPtrList TailVLObjectPointerPtrList (l)
        VLObjectPointerPtrList  l;
#endif
{
    return ((l==NULLVLObjectPointerPtrList) ? NULLVLObjectPointerPtrList : l->tail);
}/* TailVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int LengthVLObjectPointerPtrList (VLObjectPointerPtrList l)
#else
int LengthVLObjectPointerPtrList (l)
        VLObjectPointerPtrList  l;
#endif
{
    int res = 0;

    for (; l; l = l->tail)
        res++;
    return (res);
}/* LengthVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtr IthElemVLObjectPointerPtrList (VLObjectPointerPtrList l, int i)
#else
VLObjectPointerPtr IthElemVLObjectPointerPtrList (l, i)
        VLObjectPointerPtrList  l;
        int     i;
#endif
{
    while ((i>1) && l)
    {
        i--;
        l = l->tail;
    }

    if ((i<=0) || (l==NULLVLObjectPointerPtrList))
        message (DEADLY, "IthElemVLObjectPointerPtrList: no such element",
                 0, (POSITION*)0);
    return (l->head);
}/* IthVLObjectPointerPtrList */


#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrList CopyVLObjectPointerPtrList (VLObjectPointerPtrList l, VLObjectPointerPtrMapFct cp)
#else
VLObjectPointerPtrList CopyVLObjectPointerPtrList (l, cp)
        VLObjectPointerPtrList l;
        VLObjectPointerPtrMapFct        cp;
#endif
{
    VLObjectPointerPtrList NewList=NULLVLObjectPointerPtrList, *addr = &NewList;

    while (l)
    {
        (*addr) = ConsVLObjectPointerPtrList (cp (l->head), NULLVLObjectPointerPtrList);
        addr = &((*addr)->tail);
        l = l->tail;
    }
    return (NewList);
}/* CopyVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrList AppVLObjectPointerPtrList (VLObjectPointerPtrList l1, VLObjectPointerPtrList l2)
#else
VLObjectPointerPtrList AppVLObjectPointerPtrList (l1, l2)
        VLObjectPointerPtrList  l1, l2;
#endif
{
    VLObjectPointerPtrList      NewList;
    VLObjectPointerPtrList      *addr = &NewList;

    if (!l1) return (l2);
    if (!l2) return (l1);

    while (l1) {
        (*addr) = ConsVLObjectPointerPtrList (l1->head, NULLVLObjectPointerPtrList);
        addr = &((*addr)->tail);
        l1 = l1->tail;
    }
    (*addr) = l2;

    return (NewList);
}/* AppVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrList AppElVLObjectPointerPtrList (VLObjectPointerPtrList l, VLObjectPointerPtr e)
#else
VLObjectPointerPtrList AppElVLObjectPointerPtrList (l, e)
        VLObjectPointerPtrList  l;
        VLObjectPointerPtr      e;
#endif
{
    VLObjectPointerPtrList      res = l;
    if (!l)
        return (ConsVLObjectPointerPtrList (e, NULLVLObjectPointerPtrList));

    while (l->tail)
        l = l->tail;
    l->tail = ConsVLObjectPointerPtrList (e, NULLVLObjectPointerPtrList);

    return (res);
} /* AppElVLObjectPointerPtrList */


#if defined(__STDC__) || defined(__cplusplus)
void InsertAfterVLObjectPointerPtrList (VLObjectPointerPtrList l, VLObjectPointerPtr e)
#else
void InsertAfterVLObjectPointerPtrList (l, e)
        VLObjectPointerPtrList  l;
        VLObjectPointerPtr      e;
#endif
{
    if (!l)
        message (DEADLY, "InserAfterVLObjectPointerPtrList: null list", 0, (POSITION*)0);
    else
        l->tail = ConsVLObjectPointerPtrList (e, l->tail);
}/* InsertAfterVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrList OrderedInsertVLObjectPointerPtrList (VLObjectPointerPtrList l, VLObjectPointerPtr e, VLObjectPointerPtrCmpFctType fcmp)
#else
VLObjectPointerPtrList OrderedInsertVLObjectPointerPtrList (l, e, fcmp)
        VLObjectPointerPtrList  l;
        VLObjectPointerPtr      e;
        VLObjectPointerPtrCmpFctType fcmp;
#endif
{
    VLObjectPointerPtrList      p;
    if (!l)
        return (ConsVLObjectPointerPtrList (e, NULLVLObjectPointerPtrList));
    if (fcmp (e, l->head) <= 0)
        return (ConsVLObjectPointerPtrList (e, l));
    p = l;
    while (p->tail && (fcmp (e, p->tail->head) > 0))
        p = p->tail;
    p->tail = ConsVLObjectPointerPtrList (e, p->tail);
    return (l);
}/* OrderedInsertVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrListPtr RefEndConsVLObjectPointerPtrList (VLObjectPointerPtrListPtr addr, VLObjectPointerPtr e)
#else
VLObjectPointerPtrListPtr RefEndConsVLObjectPointerPtrList (addr, e)
        VLObjectPointerPtrListPtr       addr;
        VLObjectPointerPtr              e;
#endif
{
    if (!addr)
    {
        message (DEADLY, "RefEndConsVLObjectPointerPtrList: no VLObjectPointerPtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    (*addr) = ConsVLObjectPointerPtrList (e, NULLVLObjectPointerPtrList);
    return (&((*addr)->tail));
}/* RefEndConsVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrListPtr RefEndAppVLObjectPointerPtrList (VLObjectPointerPtrListPtr addr, VLObjectPointerPtrList l)
#else
VLObjectPointerPtrListPtr RefEndAppVLObjectPointerPtrList (addr, l)
        VLObjectPointerPtrListPtr       addr;
        VLObjectPointerPtrList          l;
#endif
{
    if (!addr) {
        message (DEADLY, "RefEndAppVLObjectPointerPtrList: no VLObjectPointerPtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    if (!l)
        return addr;

    (*addr) = l;

    while (l->tail)
        l = l->tail;
    return (&(l->tail));
}/* RefEndAppVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int ElemInVLObjectPointerPtrList (VLObjectPointerPtr e, VLObjectPointerPtrList l, VLObjectPointerPtrCmpFctType fcmp)
#else
int ElemInVLObjectPointerPtrList (e, l, fcmp)
        VLObjectPointerPtr      e;
        VLObjectPointerPtrList  l;
        VLObjectPointerPtrCmpFctType    fcmp;
#endif
{
    while (l != NULLVLObjectPointerPtrList) {
        if (fcmp (e, l->head) == 0)
            return (1);
        l = l->tail;
    }
    return (0);
}/* ElemInVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrList AddToSetVLObjectPointerPtrList (VLObjectPointerPtr e, VLObjectPointerPtrList l, VLObjectPointerPtrCmpFctType fcmp)
#else
VLObjectPointerPtrList AddToSetVLObjectPointerPtrList (e, l, fcmp)
        VLObjectPointerPtr      e;
        VLObjectPointerPtrList  l;
        VLObjectPointerPtrCmpFctType    fcmp;
#endif
{
    if (ElemInVLObjectPointerPtrList (e, l, fcmp))
        return (l);
    else
        return (ConsVLObjectPointerPtrList (e, l));
}/* AddToSetVLObjectPointerPtrList */


#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrList AddToOrderedSetVLObjectPointerPtrList (VLObjectPointerPtr e, VLObjectPointerPtrList l, VLObjectPointerPtrCmpFctType fcmp)
#else
VLObjectPointerPtrList AddToOrderedSetVLObjectPointerPtrList (e, l, fcmp)
        VLObjectPointerPtr  e;
        VLObjectPointerPtrList      l;
        VLObjectPointerPtrCmpFctType fcmp;
#endif
{   int test;
    VLObjectPointerPtrList  p;
    if (!l)
        return (ConsVLObjectPointerPtrList (e, NULLVLObjectPointerPtrList));
    if ((test = fcmp (e, l->head)) < 0)
        return (ConsVLObjectPointerPtrList (e, l));
    if (test == 0) return l;
    p = l;
    while (p->tail && ((test = fcmp (e, p->tail->head)) > 0))
        p = p->tail;
    if (test) p->tail = ConsVLObjectPointerPtrList (e, p->tail);
    return (l);
}/* AddToOrderedSetVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtrList MapVLObjectPointerPtrList (VLObjectPointerPtrList l, VLObjectPointerPtrMapFct f)
#else
VLObjectPointerPtrList MapVLObjectPointerPtrList (l, f)
        VLObjectPointerPtrList  l;
        VLObjectPointerPtrMapFct f;
#endif
{
    VLObjectPointerPtrList NewList = NULLVLObjectPointerPtrList;
    VLObjectPointerPtrList last = NULLVLObjectPointerPtrList;

    while (l)
    {
        if (!NewList) {
            NewList = ConsVLObjectPointerPtrList ((f (l->head)), NULLVLObjectPointerPtrList);
            last = NewList;
        }
        else
        {
            last->tail = ConsVLObjectPointerPtrList ((f (l->head)), NULLVLObjectPointerPtrList);
            last = last->tail;
        }
        l = l->tail;
    }
    return (NewList);
}/* MapVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int CompVLObjectPointerPtrList (VLObjectPointerPtrList l1, VLObjectPointerPtrList l2, VLObjectPointerPtrCmpFctType fcmp)
#else
int CompVLObjectPointerPtrList (l1, l2, fcmp)
        VLObjectPointerPtrList  l1, l2;
        VLObjectPointerPtrCmpFctType fcmp;
#endif
{
    int res = 0;
    while (l1 && l2 && (res == 0)) {
        res = (fcmp (l1->head, l2->head));
        l1 = l1->tail;
        l2 = l2->tail;
    }
    if (l1 && !l2)
        return (1);
    if (!l1 && l2)
        return (-1);
    return (res);
}/* CompVLObjectPointerPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VLObjectPointerPtr SumVLObjectPointerPtrList (VLObjectPointerPtrList l, VLObjectPointerPtrSumFct f, VLObjectPointerPtr a)
#else
VLObjectPointerPtr SumVLObjectPointerPtrList (l, f, a)
        VLObjectPointerPtrList  l;
        VLObjectPointerPtr ((*f) ());
        VLObjectPointerPtr      a;
#endif
{
    while (l) {
        a = (f (a, l->head));
        l = l->tail;
    }
    return (a);
}/* SumVLObjectPointerPtrList */
