

#include "VisContainerInterface2PtrList.h"
#include "err.h"
#include "obstack.h"

typedef struct {
  Obstack space;
  void *baseptr;
} Dyn, *DynP;

static DynP VisContainerInterface2PtrListSpace = (DynP)0;

#if defined(__STDC__) || defined(__cplusplus)
void FinlVisContainerInterface2PtrList (void)
#else
void FinlVisContainerInterface2PtrList ()
#endif
{
    if (VisContainerInterface2PtrListSpace != (DynP)0)
    {  obstack_free(&(VisContainerInterface2PtrListSpace->space), VisContainerInterface2PtrListSpace->baseptr);
       VisContainerInterface2PtrListSpace->baseptr = obstack_alloc(&(VisContainerInterface2PtrListSpace->space), 0);
    }
}/* FinlVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrList ConsVisContainerInterface2PtrList (VisContainerInterface2Ptr e, VisContainerInterface2PtrList l)
#else
VisContainerInterface2PtrList ConsVisContainerInterface2PtrList (e, l)
        VisContainerInterface2Ptr       e;
        VisContainerInterface2PtrList   l;
#endif
{
    VisContainerInterface2PtrList       h;

    if (VisContainerInterface2PtrListSpace == (DynP)0)
    {   VisContainerInterface2PtrListSpace = (DynP) malloc (sizeof(Dyn));
        if (VisContainerInterface2PtrListSpace == (DynP)0)
        {  message (DEADLY, "no space for VisContainerInterface2PtrList", 0, (POSITION*)0);
           exit (1);
        }
        obstack_init(&(VisContainerInterface2PtrListSpace->space));
        VisContainerInterface2PtrListSpace->baseptr =
                obstack_alloc(&(VisContainerInterface2PtrListSpace->space), 0);
    }

    h = (VisContainerInterface2PtrList)obstack_alloc(&(VisContainerInterface2PtrListSpace->space),
                                  sizeof (struct _VisContainerInterface2PtrLE));
    h->head = e;
    h->tail= l;
    return (h);
}/* ConsVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2Ptr HeadVisContainerInterface2PtrList (VisContainerInterface2PtrList l)
#else
VisContainerInterface2Ptr HeadVisContainerInterface2PtrList (l)
        VisContainerInterface2PtrList   l;
#endif
{
    if (l == NULLVisContainerInterface2PtrList)
    {
        message (DEADLY, "HeadVisContainerInterface2PtrList: empty list", 0, (POSITION*)0);
        /* return ((VisContainerInterface2Ptr)0); */
    } /* if */
    return (l->head);
}/* HeadVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrList TailVisContainerInterface2PtrList (VisContainerInterface2PtrList l)
#else
VisContainerInterface2PtrList TailVisContainerInterface2PtrList (l)
        VisContainerInterface2PtrList   l;
#endif
{
    return ((l==NULLVisContainerInterface2PtrList) ? NULLVisContainerInterface2PtrList : l->tail);
}/* TailVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
int LengthVisContainerInterface2PtrList (VisContainerInterface2PtrList l)
#else
int LengthVisContainerInterface2PtrList (l)
        VisContainerInterface2PtrList   l;
#endif
{
    int res = 0;

    for (; l; l = l->tail)
        res++;
    return (res);
}/* LengthVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2Ptr IthElemVisContainerInterface2PtrList (VisContainerInterface2PtrList l, int i)
#else
VisContainerInterface2Ptr IthElemVisContainerInterface2PtrList (l, i)
        VisContainerInterface2PtrList   l;
        int     i;
#endif
{
    while ((i>1) && l)
    {
        i--;
        l = l->tail;
    }

    if ((i<=0) || (l==NULLVisContainerInterface2PtrList))
        message (DEADLY, "IthElemVisContainerInterface2PtrList: no such element",
                 0, (POSITION*)0);
    return (l->head);
}/* IthVisContainerInterface2PtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrList CopyVisContainerInterface2PtrList (VisContainerInterface2PtrList l, VisContainerInterface2PtrMapFct cp)
#else
VisContainerInterface2PtrList CopyVisContainerInterface2PtrList (l, cp)
        VisContainerInterface2PtrList l;
        VisContainerInterface2PtrMapFct cp;
#endif
{
    VisContainerInterface2PtrList NewList=NULLVisContainerInterface2PtrList, *addr = &NewList;

    while (l)
    {
        (*addr) = ConsVisContainerInterface2PtrList (cp (l->head), NULLVisContainerInterface2PtrList);
        addr = &((*addr)->tail);
        l = l->tail;
    }
    return (NewList);
}/* CopyVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrList AppVisContainerInterface2PtrList (VisContainerInterface2PtrList l1, VisContainerInterface2PtrList l2)
#else
VisContainerInterface2PtrList AppVisContainerInterface2PtrList (l1, l2)
        VisContainerInterface2PtrList   l1, l2;
#endif
{
    VisContainerInterface2PtrList       NewList;
    VisContainerInterface2PtrList       *addr = &NewList;

    if (!l1) return (l2);
    if (!l2) return (l1);

    while (l1) {
        (*addr) = ConsVisContainerInterface2PtrList (l1->head, NULLVisContainerInterface2PtrList);
        addr = &((*addr)->tail);
        l1 = l1->tail;
    }
    (*addr) = l2;

    return (NewList);
}/* AppVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrList AppElVisContainerInterface2PtrList (VisContainerInterface2PtrList l, VisContainerInterface2Ptr e)
#else
VisContainerInterface2PtrList AppElVisContainerInterface2PtrList (l, e)
        VisContainerInterface2PtrList   l;
        VisContainerInterface2Ptr       e;
#endif
{
    VisContainerInterface2PtrList       res = l;
    if (!l)
        return (ConsVisContainerInterface2PtrList (e, NULLVisContainerInterface2PtrList));

    while (l->tail)
        l = l->tail;
    l->tail = ConsVisContainerInterface2PtrList (e, NULLVisContainerInterface2PtrList);

    return (res);
} /* AppElVisContainerInterface2PtrList */


#if defined(__STDC__) || defined(__cplusplus)
void InsertAfterVisContainerInterface2PtrList (VisContainerInterface2PtrList l, VisContainerInterface2Ptr e)
#else
void InsertAfterVisContainerInterface2PtrList (l, e)
        VisContainerInterface2PtrList   l;
        VisContainerInterface2Ptr       e;
#endif
{
    if (!l)
        message (DEADLY, "InserAfterVisContainerInterface2PtrList: null list", 0, (POSITION*)0);
    else
        l->tail = ConsVisContainerInterface2PtrList (e, l->tail);
}/* InsertAfterVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrList OrderedInsertVisContainerInterface2PtrList (VisContainerInterface2PtrList l, VisContainerInterface2Ptr e, VisContainerInterface2PtrCmpFctType fcmp)
#else
VisContainerInterface2PtrList OrderedInsertVisContainerInterface2PtrList (l, e, fcmp)
        VisContainerInterface2PtrList   l;
        VisContainerInterface2Ptr       e;
        VisContainerInterface2PtrCmpFctType fcmp;
#endif
{
    VisContainerInterface2PtrList       p;
    if (!l)
        return (ConsVisContainerInterface2PtrList (e, NULLVisContainerInterface2PtrList));
    if (fcmp (e, l->head) <= 0)
        return (ConsVisContainerInterface2PtrList (e, l));
    p = l;
    while (p->tail && (fcmp (e, p->tail->head) > 0))
        p = p->tail;
    p->tail = ConsVisContainerInterface2PtrList (e, p->tail);
    return (l);
}/* OrderedInsertVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrListPtr RefEndConsVisContainerInterface2PtrList (VisContainerInterface2PtrListPtr addr, VisContainerInterface2Ptr e)
#else
VisContainerInterface2PtrListPtr RefEndConsVisContainerInterface2PtrList (addr, e)
        VisContainerInterface2PtrListPtr        addr;
        VisContainerInterface2Ptr               e;
#endif
{
    if (!addr)
    {
        message (DEADLY, "RefEndConsVisContainerInterface2PtrList: no VisContainerInterface2PtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    (*addr) = ConsVisContainerInterface2PtrList (e, NULLVisContainerInterface2PtrList);
    return (&((*addr)->tail));
}/* RefEndConsVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrListPtr RefEndAppVisContainerInterface2PtrList (VisContainerInterface2PtrListPtr addr, VisContainerInterface2PtrList l)
#else
VisContainerInterface2PtrListPtr RefEndAppVisContainerInterface2PtrList (addr, l)
        VisContainerInterface2PtrListPtr        addr;
        VisContainerInterface2PtrList           l;
#endif
{
    if (!addr) {
        message (DEADLY, "RefEndAppVisContainerInterface2PtrList: no VisContainerInterface2PtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    if (!l)
        return addr;

    (*addr) = l;

    while (l->tail)
        l = l->tail;
    return (&(l->tail));
}/* RefEndAppVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
int ElemInVisContainerInterface2PtrList (VisContainerInterface2Ptr e, VisContainerInterface2PtrList l, VisContainerInterface2PtrCmpFctType fcmp)
#else
int ElemInVisContainerInterface2PtrList (e, l, fcmp)
        VisContainerInterface2Ptr       e;
        VisContainerInterface2PtrList   l;
        VisContainerInterface2PtrCmpFctType     fcmp;
#endif
{
    while (l != NULLVisContainerInterface2PtrList) {
        if (fcmp (e, l->head) == 0)
            return (1);
        l = l->tail;
    }
    return (0);
}/* ElemInVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrList AddToSetVisContainerInterface2PtrList (VisContainerInterface2Ptr e, VisContainerInterface2PtrList l, VisContainerInterface2PtrCmpFctType fcmp)
#else
VisContainerInterface2PtrList AddToSetVisContainerInterface2PtrList (e, l, fcmp)
        VisContainerInterface2Ptr       e;
        VisContainerInterface2PtrList   l;
        VisContainerInterface2PtrCmpFctType     fcmp;
#endif
{
    if (ElemInVisContainerInterface2PtrList (e, l, fcmp))
        return (l);
    else
        return (ConsVisContainerInterface2PtrList (e, l));
}/* AddToSetVisContainerInterface2PtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrList AddToOrderedSetVisContainerInterface2PtrList (VisContainerInterface2Ptr e, VisContainerInterface2PtrList l, VisContainerInterface2PtrCmpFctType fcmp)
#else
VisContainerInterface2PtrList AddToOrderedSetVisContainerInterface2PtrList (e, l, fcmp)
        VisContainerInterface2Ptr  e;
        VisContainerInterface2PtrList      l;
        VisContainerInterface2PtrCmpFctType fcmp;
#endif
{   int test;
    VisContainerInterface2PtrList  p;
    if (!l)
        return (ConsVisContainerInterface2PtrList (e, NULLVisContainerInterface2PtrList));
    if ((test = fcmp (e, l->head)) < 0)
        return (ConsVisContainerInterface2PtrList (e, l));
    if (test == 0) return l;
    p = l;
    while (p->tail && ((test = fcmp (e, p->tail->head)) > 0))
        p = p->tail;
    if (test) p->tail = ConsVisContainerInterface2PtrList (e, p->tail);
    return (l);
}/* AddToOrderedSetVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2PtrList MapVisContainerInterface2PtrList (VisContainerInterface2PtrList l, VisContainerInterface2PtrMapFct f)
#else
VisContainerInterface2PtrList MapVisContainerInterface2PtrList (l, f)
        VisContainerInterface2PtrList   l;
        VisContainerInterface2PtrMapFct f;
#endif
{
    VisContainerInterface2PtrList NewList = NULLVisContainerInterface2PtrList;
    VisContainerInterface2PtrList last = NULLVisContainerInterface2PtrList;

    while (l)
    {
        if (!NewList) {
            NewList = ConsVisContainerInterface2PtrList ((f (l->head)), NULLVisContainerInterface2PtrList);
            last = NewList;
        }
        else
        {
            last->tail = ConsVisContainerInterface2PtrList ((f (l->head)), NULLVisContainerInterface2PtrList);
            last = last->tail;
        }
        l = l->tail;
    }
    return (NewList);
}/* MapVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
int CompVisContainerInterface2PtrList (VisContainerInterface2PtrList l1, VisContainerInterface2PtrList l2, VisContainerInterface2PtrCmpFctType fcmp)
#else
int CompVisContainerInterface2PtrList (l1, l2, fcmp)
        VisContainerInterface2PtrList   l1, l2;
        VisContainerInterface2PtrCmpFctType fcmp;
#endif
{
    int res = 0;
    while (l1 && l2 && (res == 0)) {
        res = (fcmp (l1->head, l2->head));
        l1 = l1->tail;
        l2 = l2->tail;
    }
    if (l1 && !l2)
        return (1);
    if (!l1 && l2)
        return (-1);
    return (res);
}/* CompVisContainerInterface2PtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterface2Ptr SumVisContainerInterface2PtrList (VisContainerInterface2PtrList l, VisContainerInterface2PtrSumFct f, VisContainerInterface2Ptr a)
#else
VisContainerInterface2Ptr SumVisContainerInterface2PtrList (l, f, a)
        VisContainerInterface2PtrList   l;
        VisContainerInterface2Ptr ((*f) ());
        VisContainerInterface2Ptr       a;
#endif
{
    while (l) {
        a = (f (a, l->head));
        l = l->tail;
    }
    return (a);
}/* SumVisContainerInterface2PtrList */
