
/* interface of tree construction functions */

#ifndef feDlg_TREECON_H
#define feDlg_TREECON_H
#include "eliproto.h"

#include "err.h"

#include "feDlg_nodeptr.h"

#include "HEAD.h"


extern void feDlg_InitTree ELI_ARG((void));

extern void feDlg_FreeTree ELI_ARG((void));

extern NODEPTR feDlg_MkVIEWROOT ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_FormularTextElement ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_FormularTextElement_name ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_FormularTextElement_label ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_FormularTextElement_description ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_FormularTextElement_pvalue ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_FormularTextElement_required ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_FormularTextElement_validator ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_FormularTextElement_converter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_DoubleRangeValidator ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_LongRangeValidator ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_StringLengthValidator ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_RegExprValidator ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_CreditCardValidator ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_EmailValidator ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_PatternConverter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_DateTimeConverter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_BooleanConverter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_DoubleConverter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_FloatConverter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_BigIntegerConverter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_LongConverter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_IntegerConverter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_DoubleNumberConverter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_IntegerNumberConverter ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_RegExprValidator_pattern ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_StringLengthValidator_min ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_StringLengthValidator_max ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_LongRangeValidator_min ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_LongRangeValidator_max ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_DoubleRangeValidator_min ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_DoubleRangeValidator_max ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_IntegerNumberConverter_minIntegerDigits ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_IntegerNumberConverter_maxIntegerDigits ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_DoubleNumberConverter_minIntegerDigits ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_DoubleNumberConverter_maxIntegerDigits ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_DoubleNumberConverter_minFractionDigits ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_DoubleNumberConverter_maxFractionDigits ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkfeDlg_PatternConverter_pattern ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR feDlg_MkpEmpty ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpVIEWROOT_feDlg ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR feDlg_MkpfeDlg_FormularTextElement ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7));
extern NODEPTR feDlg_MkpfeDlg_FormularTextElement_name ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_FormularTextElement_label ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_FormularTextElement_description ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_FormularTextElement_pvalue ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_FormularTextElement_required ELI_ARG((POSITION *_coordref));
#define feDlg_Mk0pfeDlg_FormularTextElement_validator(_coordref) NULLNODEPTR
extern NODEPTR feDlg_Mk2pfeDlg_FormularTextElement_validator ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR feDlg_MkpfeDlg_FormularTextElement_validator ELI_ARG((POSITION *_coordref, NODEPTR t));
#define feDlg_Mk0pfeDlg_FormularTextElement_converter(_coordref) NULLNODEPTR
extern NODEPTR feDlg_Mk2pfeDlg_FormularTextElement_converter ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR feDlg_MkpfeDlg_FormularTextElement_converter ELI_ARG((POSITION *_coordref, NODEPTR t));
extern NODEPTR feDlg_MkpfeDlg_EmailValidator ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR feDlg_MkpfeDlg_CreditCardValidator ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR feDlg_MkpfeDlg_RegExprValidator ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1));
extern NODEPTR feDlg_MkpfeDlg_RegExprValidator_pattern ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_StringLengthValidator ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR feDlg_MkpfeDlg_StringLengthValidator_min ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_StringLengthValidator_max ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_LongRangeValidator ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR feDlg_MkpfeDlg_LongRangeValidator_min ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_LongRangeValidator_max ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_DoubleRangeValidator ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR feDlg_MkpfeDlg_DoubleRangeValidator_min ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_DoubleRangeValidator_max ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_IntegerNumberConverter ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR feDlg_MkpfeDlg_IntegerNumberConverter_minIntegerDigits ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_IntegerNumberConverter_maxIntegerDigits ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_DoubleNumberConverter ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4));
extern NODEPTR feDlg_MkpfeDlg_DoubleNumberConverter_minIntegerDigits ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_DoubleNumberConverter_maxIntegerDigits ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_DoubleNumberConverter_minFractionDigits ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_DoubleNumberConverter_maxFractionDigits ELI_ARG((POSITION *_coordref));
extern NODEPTR feDlg_MkpfeDlg_IntegerConverter ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR feDlg_MkpfeDlg_LongConverter ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR feDlg_MkpfeDlg_BigIntegerConverter ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR feDlg_MkpfeDlg_FloatConverter ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR feDlg_MkpfeDlg_DoubleConverter ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR feDlg_MkpfeDlg_BooleanConverter ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR feDlg_MkpfeDlg_DateTimeConverter ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR feDlg_MkpfeDlg_PatternConverter ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1));
extern NODEPTR feDlg_MkpfeDlg_PatternConverter_pattern ELI_ARG((POSITION *_coordref));
#define feDlg_MkID(pos,val) (val)
#endif
