
/* implementation of tree construction functions */

#include "optionsView_node.h"

#include "optionsView_nodecode.h"

#include "attrpredef.h"

#include "optionsView_visitmap.h"

#include "optionsView_treeact.h"

#ifdef MONITOR
#include "attr_mon_dapto.h"
#endif

#include <stdlib.h>

#define _USE_OBSTACK 1

/* use of obstack: */

#if _USE_OBSTACK

#include "obstack.h"
static struct obstack TreeSpace;
static void *_TreeBase;

#ifdef __cplusplus
void* optionsView_NODEPTR_SUB_struct::operator new(size_t size)
{
	return obstack_alloc(&TreeSpace, size);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* optionsView_TreeNodeAlloc(int size)
#else
char* optionsView_TreeNodeAlloc(size) int size;
#endif
{
	return (char *)(obstack_alloc(&TreeSpace, size));
}
#endif

void optionsView_InitTree()
{
	obstack_init(&TreeSpace);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

void optionsView_FreeTree()
{
	obstack_free(&TreeSpace, _TreeBase);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

#else

#include <stdio.h>

#ifdef __cplusplus
void* NODEPTR_struct::operator new(size_t size)
{
	void *retval = malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* optionsView_TreeNodeAlloc(int size)
#else
char* optionsView_TreeNodeAlloc(size) int size;
#endif
{
	char *retval = (char *) malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#endif

void optionsView_InitTree() { }

void optionsView_FreeTree() { }

#endif

#ifdef MONITOR
#define _SETCOORD(node) \
        node->_coord = _coordref ? *_coordref : NoCoord;
#define _COPYCOORD(node) \
        node->_coord = _currn->_desc1->_coord;
#else
#define _SETCOORD(node)
#define _COPYCOORD(node)
#endif
#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkVIEWROOT (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkVIEWROOT (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBVIEWROOT)) return (_currn);
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_FormularConstantSelectOption)) return (optionsView_MkpVIEWROOT_optionsView(_coordref, _currn));
return(NULLNODEPTR);
}/* optionsView_MkVIEWROOT */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_FormularConstantSelectOption (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_FormularConstantSelectOption (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_FormularConstantSelectOption)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_FormularConstantSelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_FormularConstantSelectOption_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_FormularConstantSelectOption_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_FormularConstantSelectOption_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_FormularConstantSelectOption_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_FormularConstantSelectOption_keyword2 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_FormularConstantSelectOption_keyword2 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_FormularConstantSelectOption_keyword2)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_FormularConstantSelectOption_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_FormularConstantSelectOption_options (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_FormularConstantSelectOption_options)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_FormularConstantSelectOption_options */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_FormularConstantSelectOption_keyword3 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_FormularConstantSelectOption_keyword3 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_FormularConstantSelectOption_keyword3)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_FormularConstantSelectOption_keyword3 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_SelectOption (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_SelectOption (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_SelectOption)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_SelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_SelectOption_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_SelectOption_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_SelectOption_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_SelectOption_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_SelectOption_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_SelectOption_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_SelectOption_value)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_SelectOption_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_SelectOption_keyword2 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_SelectOption_keyword2 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_SelectOption_keyword2)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_SelectOption_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_SelectOption_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_SelectOption_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_SelectOption_label)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_SelectOption_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkoptionsView_SelectOption_keyword3 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR optionsView_MkoptionsView_SelectOption_keyword3 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (optionsView_IsSymb (_currn, optionsView_SYMBoptionsView_SelectOption_keyword3)) return (_currn);
return(NULLNODEPTR);
}/* optionsView_MkoptionsView_SelectOption_keyword3 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpEmpty (POSITION *_coordref)
#else
NODEPTR optionsView_MkpEmpty (_coordref)
	POSITION *_coordref;
#endif
{	optionsView__TPPpEmpty _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpEmpty;
#else
_currn = (optionsView__TPPpEmpty) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpEmpty));
#endif
_currn->_prod = optionsView_RULEpEmpty;
_SETCOORD(_currn)
optionsView__TERMACT_pEmpty;
return ( (NODEPTR) _currn);
}/* optionsView_MkpEmpty */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpVIEWROOT_optionsView (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR optionsView_MkpVIEWROOT_optionsView (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	optionsView__TPPpVIEWROOT_optionsView _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpVIEWROOT_optionsView;
#else
_currn = (optionsView__TPPpVIEWROOT_optionsView) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpVIEWROOT_optionsView));
#endif
_currn->_prod = optionsView_RULEpVIEWROOT_optionsView;
_currn->_desc1 = (optionsView__TSPoptionsView_FormularConstantSelectOption) optionsView_MkoptionsView_FormularConstantSelectOption (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pVIEWROOT_optionsView: root of subtree no. 1 can not be made a optionsView_FormularConstantSelectOption node ", 0, _coordref);
_COPYCOORD(_currn)
optionsView__TERMACT_pVIEWROOT_optionsView;
return ( (NODEPTR) _currn);
}/* optionsView_MkpVIEWROOT_optionsView */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_FormularConstantSelectOption (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR optionsView_MkpoptionsView_FormularConstantSelectOption (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	optionsView__TPPpoptionsView_FormularConstantSelectOption _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpoptionsView_FormularConstantSelectOption;
#else
_currn = (optionsView__TPPpoptionsView_FormularConstantSelectOption) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_FormularConstantSelectOption));
#endif
_currn->_prod = optionsView_RULEpoptionsView_FormularConstantSelectOption;
_currn->_desc1 = (optionsView__TSPoptionsView_FormularConstantSelectOption_keyword1) optionsView_MkoptionsView_FormularConstantSelectOption_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE poptionsView_FormularConstantSelectOption: root of subtree no. 1 can not be made a optionsView_FormularConstantSelectOption_keyword1 node ", 0, _coordref);
_currn->_desc2 = (optionsView__TSPoptionsView_FormularConstantSelectOption_keyword2) optionsView_MkoptionsView_FormularConstantSelectOption_keyword2 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE poptionsView_FormularConstantSelectOption: root of subtree no. 2 can not be made a optionsView_FormularConstantSelectOption_keyword2 node ", 0, _coordref);
_currn->_desc3 = (optionsView__TSPoptionsView_FormularConstantSelectOption_options) optionsView_MkoptionsView_FormularConstantSelectOption_options (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE poptionsView_FormularConstantSelectOption: root of subtree no. 3 can not be made a optionsView_FormularConstantSelectOption_options node ", 0, _coordref);
_currn->_desc4 = (optionsView__TSPoptionsView_FormularConstantSelectOption_keyword3) optionsView_MkoptionsView_FormularConstantSelectOption_keyword3 (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE poptionsView_FormularConstantSelectOption: root of subtree no. 4 can not be made a optionsView_FormularConstantSelectOption_keyword3 node ", 0, _coordref);
_SETCOORD(_currn)
optionsView__TERMACT_poptionsView_FormularConstantSelectOption;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* optionsView_MkpoptionsView_FormularConstantSelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_FormularConstantSelectOption_keyword1 (POSITION *_coordref)
#else
NODEPTR optionsView_MkpoptionsView_FormularConstantSelectOption_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	optionsView__TPPpoptionsView_FormularConstantSelectOption_keyword1 _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpoptionsView_FormularConstantSelectOption_keyword1;
#else
_currn = (optionsView__TPPpoptionsView_FormularConstantSelectOption_keyword1) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_FormularConstantSelectOption_keyword1));
#endif
_currn->_prod = optionsView_RULEpoptionsView_FormularConstantSelectOption_keyword1;
_SETCOORD(_currn)
optionsView__TERMACT_poptionsView_FormularConstantSelectOption_keyword1;
return ( (NODEPTR) _currn);
}/* optionsView_MkpoptionsView_FormularConstantSelectOption_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_FormularConstantSelectOption_keyword2 (POSITION *_coordref)
#else
NODEPTR optionsView_MkpoptionsView_FormularConstantSelectOption_keyword2 (_coordref)
	POSITION *_coordref;
#endif
{	optionsView__TPPpoptionsView_FormularConstantSelectOption_keyword2 _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpoptionsView_FormularConstantSelectOption_keyword2;
#else
_currn = (optionsView__TPPpoptionsView_FormularConstantSelectOption_keyword2) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_FormularConstantSelectOption_keyword2));
#endif
_currn->_prod = optionsView_RULEpoptionsView_FormularConstantSelectOption_keyword2;
_SETCOORD(_currn)
optionsView__TERMACT_poptionsView_FormularConstantSelectOption_keyword2;
return ( (NODEPTR) _currn);
}/* optionsView_MkpoptionsView_FormularConstantSelectOption_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR optionsView__MkoptionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR optionsView__MkoptionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	optionsView__TPPLST_optionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options _new;
#ifdef __cplusplus
	_new = new optionsView__TPLST_optionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options;
#else
	_new = (optionsView__TPPLST_optionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPLST_optionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options));
#endif
	_new->_prod = optionsView_RULELST_optionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options;
	_new->_desc1 = (optionsView__TSPoptionsView_SelectOption)elem;
	_new->_desc2 = (optionsView__TSPLST_optionsView_FormularConstantSelectOption_options)_new;
	{optionsView__TPPLST_optionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options _currn = _new;
	 _SETCOORD(_currn)
	 optionsView__TERMACT_LST_optionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempoptionsView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempoptionsView_FormularConstantSelectOption_options (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (optionsView_IsSymb (t, optionsView_SYMBoptionsView_SelectOption)) 
		return optionsView__MkoptionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options (_coordref, optionsView_MkoptionsView_SelectOption (_coordref, t));
	message (DEADLY, "a poptionsView_FormularConstantSelectOption_options list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_Mk2poptionsView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR optionsView_Mk2poptionsView_FormularConstantSelectOption_options (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (optionsView_LHSMAP[l->_prod] != optionsView_SYMBLST_optionsView_FormularConstantSelectOption_options)
	l =_ElempoptionsView_FormularConstantSelectOption_options (_coordref, l);
if (optionsView_LHSMAP[r->_prod] != optionsView_SYMBLST_optionsView_FormularConstantSelectOption_options)
	r = _ElempoptionsView_FormularConstantSelectOption_options (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options)r)->_desc2);
((optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options)r)->_desc2 = ((optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options)l)->_desc2;
((optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR t)
#else
NODEPTR optionsView_MkpoptionsView_FormularConstantSelectOption_options (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; optionsView__TPPpoptionsView_FormularConstantSelectOption_options root;
	optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options)NULLNODEPTR;
else {	if (optionsView_LHSMAP[t->_prod] != optionsView_SYMBLST_optionsView_FormularConstantSelectOption_options)
		t = _ElempoptionsView_FormularConstantSelectOption_options (_coordref, t);
	remain = (optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options)(((optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options) t)->_desc2);
	((optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new optionsView__TPLST_0poptionsView_FormularConstantSelectOption_options;
#else
list = (optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPLST_0poptionsView_FormularConstantSelectOption_options));
#endif
list->_prod = optionsView_RULELST_0poptionsView_FormularConstantSelectOption_options;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (optionsView__TPPLST_0poptionsView_FormularConstantSelectOption_options)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == optionsView_RULELST_optionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options)
	{optionsView__TPPLST_optionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options _currn = _currn;
	 optionsView__TERMACT_LST_optionsView_SelectOptionpoptionsView_FormularConstantSelectOption_options;
	} this code has been moved to _ElempoptionsView_FormularConstantSelectOption_options*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new optionsView__TPpoptionsView_FormularConstantSelectOption_options;
#else
root = (optionsView__TPPpoptionsView_FormularConstantSelectOption_options) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_FormularConstantSelectOption_options));
#endif
root->_prod = optionsView_RULEpoptionsView_FormularConstantSelectOption_options;
root->_desc1 = (optionsView__TSPLST_optionsView_FormularConstantSelectOption_options)list;
{ optionsView__TPPpoptionsView_FormularConstantSelectOption_options _currn = root;
  _SETCOORD(_currn)
  optionsView__TERMACT_poptionsView_FormularConstantSelectOption_options;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_FormularConstantSelectOption_keyword3 (POSITION *_coordref)
#else
NODEPTR optionsView_MkpoptionsView_FormularConstantSelectOption_keyword3 (_coordref)
	POSITION *_coordref;
#endif
{	optionsView__TPPpoptionsView_FormularConstantSelectOption_keyword3 _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpoptionsView_FormularConstantSelectOption_keyword3;
#else
_currn = (optionsView__TPPpoptionsView_FormularConstantSelectOption_keyword3) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_FormularConstantSelectOption_keyword3));
#endif
_currn->_prod = optionsView_RULEpoptionsView_FormularConstantSelectOption_keyword3;
_SETCOORD(_currn)
optionsView__TERMACT_poptionsView_FormularConstantSelectOption_keyword3;
return ( (NODEPTR) _currn);
}/* optionsView_MkpoptionsView_FormularConstantSelectOption_keyword3 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_SelectOption (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5)
#else
NODEPTR optionsView_MkpoptionsView_SelectOption (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
#endif
{	optionsView__TPPpoptionsView_SelectOption _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpoptionsView_SelectOption;
#else
_currn = (optionsView__TPPpoptionsView_SelectOption) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_SelectOption));
#endif
_currn->_prod = optionsView_RULEpoptionsView_SelectOption;
_currn->_desc1 = (optionsView__TSPoptionsView_SelectOption_keyword1) optionsView_MkoptionsView_SelectOption_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE poptionsView_SelectOption: root of subtree no. 1 can not be made a optionsView_SelectOption_keyword1 node ", 0, _coordref);
_currn->_desc2 = (optionsView__TSPoptionsView_SelectOption_value) optionsView_MkoptionsView_SelectOption_value (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE poptionsView_SelectOption: root of subtree no. 2 can not be made a optionsView_SelectOption_value node ", 0, _coordref);
_currn->_desc3 = (optionsView__TSPoptionsView_SelectOption_keyword2) optionsView_MkoptionsView_SelectOption_keyword2 (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE poptionsView_SelectOption: root of subtree no. 3 can not be made a optionsView_SelectOption_keyword2 node ", 0, _coordref);
_currn->_desc4 = (optionsView__TSPoptionsView_SelectOption_label) optionsView_MkoptionsView_SelectOption_label (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE poptionsView_SelectOption: root of subtree no. 4 can not be made a optionsView_SelectOption_label node ", 0, _coordref);
_currn->_desc5 = (optionsView__TSPoptionsView_SelectOption_keyword3) optionsView_MkoptionsView_SelectOption_keyword3 (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE poptionsView_SelectOption: root of subtree no. 5 can not be made a optionsView_SelectOption_keyword3 node ", 0, _coordref);
_SETCOORD(_currn)
optionsView__TERMACT_poptionsView_SelectOption;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* optionsView_MkpoptionsView_SelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_SelectOption_keyword1 (POSITION *_coordref)
#else
NODEPTR optionsView_MkpoptionsView_SelectOption_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	optionsView__TPPpoptionsView_SelectOption_keyword1 _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpoptionsView_SelectOption_keyword1;
#else
_currn = (optionsView__TPPpoptionsView_SelectOption_keyword1) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_SelectOption_keyword1));
#endif
_currn->_prod = optionsView_RULEpoptionsView_SelectOption_keyword1;
_SETCOORD(_currn)
optionsView__TERMACT_poptionsView_SelectOption_keyword1;
return ( (NODEPTR) _currn);
}/* optionsView_MkpoptionsView_SelectOption_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_SelectOption_value (POSITION *_coordref)
#else
NODEPTR optionsView_MkpoptionsView_SelectOption_value (_coordref)
	POSITION *_coordref;
#endif
{	optionsView__TPPpoptionsView_SelectOption_value _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpoptionsView_SelectOption_value;
#else
_currn = (optionsView__TPPpoptionsView_SelectOption_value) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_SelectOption_value));
#endif
_currn->_prod = optionsView_RULEpoptionsView_SelectOption_value;
_SETCOORD(_currn)
optionsView__TERMACT_poptionsView_SelectOption_value;
return ( (NODEPTR) _currn);
}/* optionsView_MkpoptionsView_SelectOption_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_SelectOption_keyword2 (POSITION *_coordref)
#else
NODEPTR optionsView_MkpoptionsView_SelectOption_keyword2 (_coordref)
	POSITION *_coordref;
#endif
{	optionsView__TPPpoptionsView_SelectOption_keyword2 _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpoptionsView_SelectOption_keyword2;
#else
_currn = (optionsView__TPPpoptionsView_SelectOption_keyword2) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_SelectOption_keyword2));
#endif
_currn->_prod = optionsView_RULEpoptionsView_SelectOption_keyword2;
_SETCOORD(_currn)
optionsView__TERMACT_poptionsView_SelectOption_keyword2;
return ( (NODEPTR) _currn);
}/* optionsView_MkpoptionsView_SelectOption_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_SelectOption_label (POSITION *_coordref)
#else
NODEPTR optionsView_MkpoptionsView_SelectOption_label (_coordref)
	POSITION *_coordref;
#endif
{	optionsView__TPPpoptionsView_SelectOption_label _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpoptionsView_SelectOption_label;
#else
_currn = (optionsView__TPPpoptionsView_SelectOption_label) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_SelectOption_label));
#endif
_currn->_prod = optionsView_RULEpoptionsView_SelectOption_label;
_SETCOORD(_currn)
optionsView__TERMACT_poptionsView_SelectOption_label;
return ( (NODEPTR) _currn);
}/* optionsView_MkpoptionsView_SelectOption_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR optionsView_MkpoptionsView_SelectOption_keyword3 (POSITION *_coordref)
#else
NODEPTR optionsView_MkpoptionsView_SelectOption_keyword3 (_coordref)
	POSITION *_coordref;
#endif
{	optionsView__TPPpoptionsView_SelectOption_keyword3 _currn;
#ifdef __cplusplus
_currn = new optionsView__TPpoptionsView_SelectOption_keyword3;
#else
_currn = (optionsView__TPPpoptionsView_SelectOption_keyword3) optionsView_TreeNodeAlloc (sizeof (struct optionsView__TPpoptionsView_SelectOption_keyword3));
#endif
_currn->_prod = optionsView_RULEpoptionsView_SelectOption_keyword3;
_SETCOORD(_currn)
optionsView__TERMACT_poptionsView_SelectOption_keyword3;
return ( (NODEPTR) _currn);
}/* optionsView_MkpoptionsView_SelectOption_keyword3 */
