

#include "parboxText.h"
#include "vlDraw.h"

VLString getFormattedText(VLString text, VLString font, VLInt width)
{
 ParboxText *tmpText = new ParboxText(text, font, width);
 tmpText->formatText();
 VLString result = tmpText->getText();
 delete tmpText;
 return result;
}

ParboxText::ParboxText (VLString text, VLString font, VLInt width)
{
   if(width > 0) 
        this->width = width;
   else
        this->width = 0;
   this->text = text;
   this->font = font;
}

void ParboxText::formatText()
{
   VLString tmpText = text;
   int aktWidth = vlMeasure(text,font).getX();
   text = "";
   while(aktWidth > width.getInt())
   {
        int pos = tmpText.getLength();
        bool found = false;
        while(!found)
        {
            float factor = ((float)width.getInt()) / ((float)aktWidth);          
            pos = (int) floor(factor * pos);
            if(vlMeasure(tmpText.getSubstring(0,pos),font).getX() > width.getInt())
            {
               aktWidth = vlMeasure(tmpText.getSubstring(0,pos),font).getX();
            }
            else
            {

               pos = searchForward(tmpText,pos);
               found = true;

            }
        }
        // Finde Leerzeichen als Trennungsmerkmal

        pos = searchBackward (tmpText,pos,pos);
        
        // Falls  Breite kleiner als ein Zeichen
        if (pos < 1)
            pos = 1;
        
        
        text.append(tmpText.getSubstring(0,pos));
        text.append("\n");
        if(tmpText.getSubstring(pos,1).equals(" "))
        {
                tmpText = tmpText.getSubstring(pos + 1,tmpText.getLength() -pos -1);
        }
        else
        {
                tmpText = tmpText.getSubstring(pos,tmpText.getLength() -pos);
        }
        aktWidth = vlMeasure(tmpText,font).getX();
   }
   
   text.append(tmpText);
}

int ParboxText::searchBackward(VLString tmpText, int pos, int defaultPos)
{
   if(pos > 0)
   {
        if(tmpText.getSubstring(pos,1).equals(" "))
        {
             return pos;
        }
        else
        {
             return searchBackward(tmpText, pos -1, defaultPos );
        }
   }
   else
   {
        return defaultPos;
   }
}

int ParboxText::searchForward(VLString tmpText,int pos)
{
   if(vlMeasure(tmpText.getSubstring(0,pos + 1), font).getX() > width.getInt())
   {
      return pos;
   }
   else 
   {
      return searchForward(tmpText,pos + 1);
   }
}

VLString ParboxText::getText()
{
   
   return this->text;
}

VLPoint ParboxText::getSize()
{
   VLPoint size = vlMeasure(text,font);
   return size;
}

VLBoolean ParboxText::getMaxWidthFullfilled()
{
   return vlMeasure(text,font).getX() == width;
}


