#ifndef PDL_GEN_H
#define PDL_GEN_H

#include "deftbl.h"

#ifdef ELI_ARG
#undef ELI_ARG
#endif

#if defined(__STDC__) || defined(__cplusplus)
#define ELI_ARG(proto)    proto
#else
#define ELI_ARG(proto)    ()
#endif

#include "ptg_gen.h"
#include "visual.h"

#define TYPE PTGNode
extern TYPE GetPTGNode ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void SetPTGNode ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void ResetPTGNode ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE
#define TYPE int
extern TYPE Getint ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void Setint ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void Resetint ELI_ARG((int _Property, DefTableKey key, TYPE _val));
extern void Enlargeint ELI_ARG((int _Property, DefTableKey key, int x));
#undef TYPE
#define TYPE VLRegionPtr
extern TYPE GetVLRegionPtr ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void SetVLRegionPtr ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void ResetVLRegionPtr ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE

#define SetFileName(key, _add, _replace)   \
		SetPTGNode(1, (key), (_add), (_replace))
#define ResetFileName(key, _val)   \
		ResetPTGNode(1, (key), (_val))
#define GetFileName(key, deflt)   \
		GetPTGNode(1, (key), (deflt))
#define SetStyleSheetFileName(key, _add, _replace)   \
		SetPTGNode(2, (key), (_add), (_replace))
#define ResetStyleSheetFileName(key, _val)   \
		ResetPTGNode(2, (key), (_val))
#define GetStyleSheetFileName(key, deflt)   \
		GetPTGNode(2, (key), (deflt))
#define SetMetaFileName(key, _add, _replace)   \
		SetPTGNode(3, (key), (_add), (_replace))
#define ResetMetaFileName(key, _val)   \
		ResetPTGNode(3, (key), (_val))
#define GetMetaFileName(key, deflt)   \
		GetPTGNode(3, (key), (deflt))
#define SetCodeNode(key, _add, _replace)   \
		SetPTGNode(4, (key), (_add), (_replace))
#define ResetCodeNode(key, _val)   \
		ResetPTGNode(4, (key), (_val))
#define GetCodeNode(key, deflt)   \
		GetPTGNode(4, (key), (deflt))
#define SetClassName(key, _add, _replace)   \
		SetPTGNode(5, (key), (_add), (_replace))
#define ResetClassName(key, _val)   \
		ResetPTGNode(5, (key), (_val))
#define GetClassName(key, deflt)   \
		GetPTGNode(5, (key), (deflt))
#define SetSQLStatement(key, _add, _replace)   \
		SetPTGNode(6, (key), (_add), (_replace))
#define ResetSQLStatement(key, _val)   \
		ResetPTGNode(6, (key), (_val))
#define GetSQLStatement(key, deflt)   \
		GetPTGNode(6, (key), (deflt))
#define SetParameterMapping(key, _add, _replace)   \
		SetPTGNode(7, (key), (_add), (_replace))
#define ResetParameterMapping(key, _val)   \
		ResetPTGNode(7, (key), (_val))
#define GetParameterMapping(key, deflt)   \
		GetPTGNode(7, (key), (deflt))
#define SetModifyStatement(key, _add, _replace)   \
		SetPTGNode(8, (key), (_add), (_replace))
#define ResetModifyStatement(key, _val)   \
		ResetPTGNode(8, (key), (_val))
#define GetModifyStatement(key, deflt)   \
		GetPTGNode(8, (key), (deflt))
#define SetConditionDefinition(key, _add, _replace)   \
		SetPTGNode(9, (key), (_add), (_replace))
#define ResetConditionDefinition(key, _val)   \
		ResetPTGNode(9, (key), (_val))
#define GetConditionDefinition(key, deflt)   \
		GetPTGNode(9, (key), (deflt))
#define SetAction(key, _add, _replace)   \
		SetPTGNode(10, (key), (_add), (_replace))
#define ResetAction(key, _val)   \
		ResetPTGNode(10, (key), (_val))
#define GetAction(key, deflt)   \
		GetPTGNode(10, (key), (deflt))
#define SetMethod(key, _add, _replace)   \
		SetPTGNode(11, (key), (_add), (_replace))
#define ResetMethod(key, _val)   \
		ResetPTGNode(11, (key), (_val))
#define GetMethod(key, deflt)   \
		GetPTGNode(11, (key), (deflt))
#define SetMailContextParams(key, _add, _replace)   \
		SetPTGNode(12, (key), (_add), (_replace))
#define ResetMailContextParams(key, _val)   \
		ResetPTGNode(12, (key), (_val))
#define GetMailContextParams(key, deflt)   \
		GetPTGNode(12, (key), (deflt))
#define SetWebNodeExpression(key, _add, _replace)   \
		SetPTGNode(13, (key), (_add), (_replace))
#define ResetWebNodeExpression(key, _val)   \
		ResetPTGNode(13, (key), (_val))
#define GetWebNodeExpression(key, deflt)   \
		GetPTGNode(13, (key), (deflt))
#define SetMethodDefinitions(key, _add, _replace)   \
		SetPTGNode(14, (key), (_add), (_replace))
#define ResetMethodDefinitions(key, _val)   \
		ResetPTGNode(14, (key), (_val))
#define GetMethodDefinitions(key, deflt)   \
		GetPTGNode(14, (key), (deflt))
#define EnlargeReqColumnSize(key, x)   \
		Enlargeint(15, (key), (x))
#define SetReqColumnSize(key, _add, _replace)   \
		Setint(15, (key), (_add), (_replace))
#define ResetReqColumnSize(key, _val)   \
		Resetint(15, (key), (_val))
#define GetReqColumnSize(key, deflt)   \
		Getint(15, (key), (deflt))
#define SetProvColumnSize(key, _add, _replace)   \
		Setint(16, (key), (_add), (_replace))
#define ResetProvColumnSize(key, _val)   \
		Resetint(16, (key), (_val))
#define GetProvColumnSize(key, deflt)   \
		Getint(16, (key), (deflt))
#define SetColumnPos(key, _add, _replace)   \
		Setint(17, (key), (_add), (_replace))
#define ResetColumnPos(key, _val)   \
		Resetint(17, (key), (_val))
#define GetColumnPos(key, deflt)   \
		Getint(17, (key), (deflt))
#define SetPosition(key, _add, _replace)   \
		SetVLRegionPtr(18, (key), (_add), (_replace))
#define ResetPosition(key, _val)   \
		ResetVLRegionPtr(18, (key), (_val))
#define GetPosition(key, deflt)   \
		GetVLRegionPtr(18, (key), (deflt))

extern struct PropList PDLk[];


extern DefTableKey CloneKey ELI_ARG((DefTableKey key));
/* Clone a definition
 *    On entry-
 *       key=a valid definition
 *    On exit-
 *       CloneKey=Unique definition with the same properties
 *                and property values as key
 ***/

#ifdef MONITOR
extern void pdl_mon_properties ELI_ARG((DefTableKey));
#endif

#endif
