
/* implementation of tree construction functions */

#include "sspDlg_node.h"

#include "sspDlg_nodecode.h"

#include "attrpredef.h"

#include "sspDlg_visitmap.h"

#include "sspDlg_treeact.h"

#ifdef MONITOR
#include "attr_mon_dapto.h"
#endif

#include <stdlib.h>

#define _USE_OBSTACK 1

/* use of obstack: */

#if _USE_OBSTACK

#include "obstack.h"
static struct obstack TreeSpace;
static void *_TreeBase;

#ifdef __cplusplus
void* sspDlg_NODEPTR_SUB_struct::operator new(size_t size)
{
	return obstack_alloc(&TreeSpace, size);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* sspDlg_TreeNodeAlloc(int size)
#else
char* sspDlg_TreeNodeAlloc(size) int size;
#endif
{
	return (char *)(obstack_alloc(&TreeSpace, size));
}
#endif

void sspDlg_InitTree()
{
	obstack_init(&TreeSpace);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

void sspDlg_FreeTree()
{
	obstack_free(&TreeSpace, _TreeBase);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

#else

#include <stdio.h>

#ifdef __cplusplus
void* NODEPTR_struct::operator new(size_t size)
{
	void *retval = malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* sspDlg_TreeNodeAlloc(int size)
#else
char* sspDlg_TreeNodeAlloc(size) int size;
#endif
{
	char *retval = (char *) malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#endif

void sspDlg_InitTree() { }

void sspDlg_FreeTree() { }

#endif

#ifdef MONITOR
#define _SETCOORD(node) \
        node->_coord = _coordref ? *_coordref : NoCoord;
#define _COPYCOORD(node) \
        node->_coord = _currn->_desc1->_coord;
#else
#define _SETCOORD(node)
#define _COPYCOORD(node)
#endif
#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkVIEWROOT (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MkVIEWROOT (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBVIEWROOT)) return (_currn);
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_StyleSheetPair)) return (sspDlg_MkpVIEWROOT_sspDlg(_coordref, _currn));
return(NULLNODEPTR);
}/* sspDlg_MkVIEWROOT */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_StyleSheetPair (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_StyleSheetPair (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_StyleSheetPair)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_StyleSheetPair */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_StyleSheetPair_category (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_StyleSheetPair_category (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_StyleSheetPair_category)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_StyleSheetPair_category */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_StyleSheetPair_attribute (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_StyleSheetPair_attribute (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_StyleSheetPair_attribute)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_StyleSheetPair_attribute */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_StyleSheetPair_valueCategory (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_StyleSheetPair_valueCategory (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_StyleSheetPair_valueCategory)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_StyleSheetPair_valueCategory */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_StyleSheetPair_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_StyleSheetPair_value)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_StyleSheetPair_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_CustomValue (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_CustomValue (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_CustomValue)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_CustomValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_ListValue (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_ListValue (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_ListValue)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_ListValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_AlignmentValue (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_AlignmentValue (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_AlignmentValue)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_AlignmentValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_HeadingValue (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_HeadingValue (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_HeadingValue)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_HeadingValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_StyleValue (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_StyleValue (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_StyleValue)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_StyleValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_FamilyValue (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_FamilyValue (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_FamilyValue)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_FamilyValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_ColorValue (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_ColorValue (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_ColorValue)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_ColorValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_SizeValue (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_SizeValue (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_SizeValue)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_SizeValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_SizeValue_measure (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_SizeValue_measure (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_SizeValue_measure)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_SizeValue_measure */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_SizeValue_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_SizeValue_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_SizeValue_value)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_SizeValue_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_ColorValue_color (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_ColorValue_color (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_ColorValue_color)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_ColorValue_color */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_FamilyValue_family (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_FamilyValue_family (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_FamilyValue_family)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_FamilyValue_family */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_StyleValue_style (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_StyleValue_style (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_StyleValue_style)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_StyleValue_style */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_HeadingValue_heading (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_HeadingValue_heading (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_HeadingValue_heading)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_HeadingValue_heading */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_AlignmentValue_alignment (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_AlignmentValue_alignment (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_AlignmentValue_alignment)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_AlignmentValue_alignment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_ListValue_listed (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_ListValue_listed (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_ListValue_listed)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_ListValue_listed */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MksspDlg_CustomValue_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR sspDlg_MksspDlg_CustomValue_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (sspDlg_IsSymb (_currn, sspDlg_SYMBsspDlg_CustomValue_value)) return (_currn);
return(NULLNODEPTR);
}/* sspDlg_MksspDlg_CustomValue_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpEmpty (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpEmpty (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpEmpty _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpEmpty;
#else
_currn = (sspDlg__TPPpEmpty) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpEmpty));
#endif
_currn->_prod = sspDlg_RULEpEmpty;
_SETCOORD(_currn)
sspDlg__TERMACT_pEmpty;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpEmpty */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpVIEWROOT_sspDlg (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR sspDlg_MkpVIEWROOT_sspDlg (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	sspDlg__TPPpVIEWROOT_sspDlg _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpVIEWROOT_sspDlg;
#else
_currn = (sspDlg__TPPpVIEWROOT_sspDlg) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpVIEWROOT_sspDlg));
#endif
_currn->_prod = sspDlg_RULEpVIEWROOT_sspDlg;
_currn->_desc1 = (sspDlg__TSPsspDlg_StyleSheetPair) sspDlg_MksspDlg_StyleSheetPair (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pVIEWROOT_sspDlg: root of subtree no. 1 can not be made a sspDlg_StyleSheetPair node ", 0, _coordref);
_COPYCOORD(_currn)
sspDlg__TERMACT_pVIEWROOT_sspDlg;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpVIEWROOT_sspDlg */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_StyleSheetPair (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR sspDlg_MkpsspDlg_StyleSheetPair (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	sspDlg__TPPpsspDlg_StyleSheetPair _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_StyleSheetPair;
#else
_currn = (sspDlg__TPPpsspDlg_StyleSheetPair) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_StyleSheetPair));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_StyleSheetPair;
_currn->_desc1 = (sspDlg__TSPsspDlg_StyleSheetPair_category) sspDlg_MksspDlg_StyleSheetPair_category (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_StyleSheetPair: root of subtree no. 1 can not be made a sspDlg_StyleSheetPair_category node ", 0, _coordref);
_currn->_desc2 = (sspDlg__TSPsspDlg_StyleSheetPair_attribute) sspDlg_MksspDlg_StyleSheetPair_attribute (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_StyleSheetPair: root of subtree no. 2 can not be made a sspDlg_StyleSheetPair_attribute node ", 0, _coordref);
_currn->_desc3 = (sspDlg__TSPsspDlg_StyleSheetPair_valueCategory) sspDlg_MksspDlg_StyleSheetPair_valueCategory (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_StyleSheetPair: root of subtree no. 3 can not be made a sspDlg_StyleSheetPair_valueCategory node ", 0, _coordref);
_currn->_desc4 = (sspDlg__TSPsspDlg_StyleSheetPair_value) sspDlg_MksspDlg_StyleSheetPair_value (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_StyleSheetPair: root of subtree no. 4 can not be made a sspDlg_StyleSheetPair_value node ", 0, _coordref);
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_StyleSheetPair;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_StyleSheetPair */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_StyleSheetPair_category (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_StyleSheetPair_category (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_StyleSheetPair_category _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_StyleSheetPair_category;
#else
_currn = (sspDlg__TPPpsspDlg_StyleSheetPair_category) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_StyleSheetPair_category));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_StyleSheetPair_category;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_StyleSheetPair_category;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_StyleSheetPair_category */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_StyleSheetPair_attribute (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_StyleSheetPair_attribute (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_StyleSheetPair_attribute _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_StyleSheetPair_attribute;
#else
_currn = (sspDlg__TPPpsspDlg_StyleSheetPair_attribute) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_StyleSheetPair_attribute));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_StyleSheetPair_attribute;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_StyleSheetPair_attribute;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_StyleSheetPair_attribute */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_StyleSheetPair_valueCategory (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_StyleSheetPair_valueCategory (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_StyleSheetPair_valueCategory _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_StyleSheetPair_valueCategory;
#else
_currn = (sspDlg__TPPpsspDlg_StyleSheetPair_valueCategory) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_StyleSheetPair_valueCategory));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_StyleSheetPair_valueCategory;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_StyleSheetPair_valueCategory;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_StyleSheetPair_valueCategory */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR sspDlg__MksspDlg_SizeValuepsspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR sspDlg__MksspDlg_SizeValuepsspDlg_StyleSheetPair_value (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	sspDlg__TPPLST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value _new;
#ifdef __cplusplus
	_new = new sspDlg__TPLST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value;
#else
	_new = (sspDlg__TPPLST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPLST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value));
#endif
	_new->_prod = sspDlg_RULELST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value;
	_new->_desc1 = (sspDlg__TSPsspDlg_SizeValue)elem;
	_new->_desc2 = (sspDlg__TSPLST_sspDlg_StyleSheetPair_value)_new;
	{sspDlg__TPPLST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value _currn = _new;
	 _SETCOORD(_currn)
	 sspDlg__TERMACT_LST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR sspDlg__MksspDlg_ColorValuepsspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR sspDlg__MksspDlg_ColorValuepsspDlg_StyleSheetPair_value (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	sspDlg__TPPLST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value _new;
#ifdef __cplusplus
	_new = new sspDlg__TPLST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value;
#else
	_new = (sspDlg__TPPLST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPLST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value));
#endif
	_new->_prod = sspDlg_RULELST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value;
	_new->_desc1 = (sspDlg__TSPsspDlg_ColorValue)elem;
	_new->_desc2 = (sspDlg__TSPLST_sspDlg_StyleSheetPair_value)_new;
	{sspDlg__TPPLST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value _currn = _new;
	 _SETCOORD(_currn)
	 sspDlg__TERMACT_LST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR sspDlg__MksspDlg_FamilyValuepsspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR sspDlg__MksspDlg_FamilyValuepsspDlg_StyleSheetPair_value (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	sspDlg__TPPLST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value _new;
#ifdef __cplusplus
	_new = new sspDlg__TPLST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value;
#else
	_new = (sspDlg__TPPLST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPLST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value));
#endif
	_new->_prod = sspDlg_RULELST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value;
	_new->_desc1 = (sspDlg__TSPsspDlg_FamilyValue)elem;
	_new->_desc2 = (sspDlg__TSPLST_sspDlg_StyleSheetPair_value)_new;
	{sspDlg__TPPLST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value _currn = _new;
	 _SETCOORD(_currn)
	 sspDlg__TERMACT_LST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR sspDlg__MksspDlg_StyleValuepsspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR sspDlg__MksspDlg_StyleValuepsspDlg_StyleSheetPair_value (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	sspDlg__TPPLST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value _new;
#ifdef __cplusplus
	_new = new sspDlg__TPLST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value;
#else
	_new = (sspDlg__TPPLST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPLST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value));
#endif
	_new->_prod = sspDlg_RULELST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value;
	_new->_desc1 = (sspDlg__TSPsspDlg_StyleValue)elem;
	_new->_desc2 = (sspDlg__TSPLST_sspDlg_StyleSheetPair_value)_new;
	{sspDlg__TPPLST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value _currn = _new;
	 _SETCOORD(_currn)
	 sspDlg__TERMACT_LST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR sspDlg__MksspDlg_HeadingValuepsspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR sspDlg__MksspDlg_HeadingValuepsspDlg_StyleSheetPair_value (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	sspDlg__TPPLST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value _new;
#ifdef __cplusplus
	_new = new sspDlg__TPLST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value;
#else
	_new = (sspDlg__TPPLST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPLST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value));
#endif
	_new->_prod = sspDlg_RULELST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value;
	_new->_desc1 = (sspDlg__TSPsspDlg_HeadingValue)elem;
	_new->_desc2 = (sspDlg__TSPLST_sspDlg_StyleSheetPair_value)_new;
	{sspDlg__TPPLST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value _currn = _new;
	 _SETCOORD(_currn)
	 sspDlg__TERMACT_LST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR sspDlg__MksspDlg_AlignmentValuepsspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR sspDlg__MksspDlg_AlignmentValuepsspDlg_StyleSheetPair_value (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	sspDlg__TPPLST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value _new;
#ifdef __cplusplus
	_new = new sspDlg__TPLST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value;
#else
	_new = (sspDlg__TPPLST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPLST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value));
#endif
	_new->_prod = sspDlg_RULELST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value;
	_new->_desc1 = (sspDlg__TSPsspDlg_AlignmentValue)elem;
	_new->_desc2 = (sspDlg__TSPLST_sspDlg_StyleSheetPair_value)_new;
	{sspDlg__TPPLST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value _currn = _new;
	 _SETCOORD(_currn)
	 sspDlg__TERMACT_LST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR sspDlg__MksspDlg_ListValuepsspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR sspDlg__MksspDlg_ListValuepsspDlg_StyleSheetPair_value (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	sspDlg__TPPLST_sspDlg_ListValuepsspDlg_StyleSheetPair_value _new;
#ifdef __cplusplus
	_new = new sspDlg__TPLST_sspDlg_ListValuepsspDlg_StyleSheetPair_value;
#else
	_new = (sspDlg__TPPLST_sspDlg_ListValuepsspDlg_StyleSheetPair_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPLST_sspDlg_ListValuepsspDlg_StyleSheetPair_value));
#endif
	_new->_prod = sspDlg_RULELST_sspDlg_ListValuepsspDlg_StyleSheetPair_value;
	_new->_desc1 = (sspDlg__TSPsspDlg_ListValue)elem;
	_new->_desc2 = (sspDlg__TSPLST_sspDlg_StyleSheetPair_value)_new;
	{sspDlg__TPPLST_sspDlg_ListValuepsspDlg_StyleSheetPair_value _currn = _new;
	 _SETCOORD(_currn)
	 sspDlg__TERMACT_LST_sspDlg_ListValuepsspDlg_StyleSheetPair_value;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR sspDlg__MksspDlg_CustomValuepsspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR sspDlg__MksspDlg_CustomValuepsspDlg_StyleSheetPair_value (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	sspDlg__TPPLST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value _new;
#ifdef __cplusplus
	_new = new sspDlg__TPLST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value;
#else
	_new = (sspDlg__TPPLST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPLST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value));
#endif
	_new->_prod = sspDlg_RULELST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value;
	_new->_desc1 = (sspDlg__TSPsspDlg_CustomValue)elem;
	_new->_desc2 = (sspDlg__TSPLST_sspDlg_StyleSheetPair_value)_new;
	{sspDlg__TPPLST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value _currn = _new;
	 _SETCOORD(_currn)
	 sspDlg__TERMACT_LST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempsspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempsspDlg_StyleSheetPair_value (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (sspDlg_IsSymb (t, sspDlg_SYMBsspDlg_SizeValue)) 
		return sspDlg__MksspDlg_SizeValuepsspDlg_StyleSheetPair_value (_coordref, sspDlg_MksspDlg_SizeValue (_coordref, t));
	if (sspDlg_IsSymb (t, sspDlg_SYMBsspDlg_ColorValue)) 
		return sspDlg__MksspDlg_ColorValuepsspDlg_StyleSheetPair_value (_coordref, sspDlg_MksspDlg_ColorValue (_coordref, t));
	if (sspDlg_IsSymb (t, sspDlg_SYMBsspDlg_FamilyValue)) 
		return sspDlg__MksspDlg_FamilyValuepsspDlg_StyleSheetPair_value (_coordref, sspDlg_MksspDlg_FamilyValue (_coordref, t));
	if (sspDlg_IsSymb (t, sspDlg_SYMBsspDlg_StyleValue)) 
		return sspDlg__MksspDlg_StyleValuepsspDlg_StyleSheetPair_value (_coordref, sspDlg_MksspDlg_StyleValue (_coordref, t));
	if (sspDlg_IsSymb (t, sspDlg_SYMBsspDlg_HeadingValue)) 
		return sspDlg__MksspDlg_HeadingValuepsspDlg_StyleSheetPair_value (_coordref, sspDlg_MksspDlg_HeadingValue (_coordref, t));
	if (sspDlg_IsSymb (t, sspDlg_SYMBsspDlg_AlignmentValue)) 
		return sspDlg__MksspDlg_AlignmentValuepsspDlg_StyleSheetPair_value (_coordref, sspDlg_MksspDlg_AlignmentValue (_coordref, t));
	if (sspDlg_IsSymb (t, sspDlg_SYMBsspDlg_ListValue)) 
		return sspDlg__MksspDlg_ListValuepsspDlg_StyleSheetPair_value (_coordref, sspDlg_MksspDlg_ListValue (_coordref, t));
	if (sspDlg_IsSymb (t, sspDlg_SYMBsspDlg_CustomValue)) 
		return sspDlg__MksspDlg_CustomValuepsspDlg_StyleSheetPair_value (_coordref, sspDlg_MksspDlg_CustomValue (_coordref, t));
	message (DEADLY, "a psspDlg_StyleSheetPair_value list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_Mk2psspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR sspDlg_Mk2psspDlg_StyleSheetPair_value (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (sspDlg_LHSMAP[l->_prod] != sspDlg_SYMBLST_sspDlg_StyleSheetPair_value)
	l =_ElempsspDlg_StyleSheetPair_value (_coordref, l);
if (sspDlg_LHSMAP[r->_prod] != sspDlg_SYMBLST_sspDlg_StyleSheetPair_value)
	r = _ElempsspDlg_StyleSheetPair_value (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((sspDlg__TPPLST_0psspDlg_StyleSheetPair_value)r)->_desc2);
((sspDlg__TPPLST_0psspDlg_StyleSheetPair_value)r)->_desc2 = ((sspDlg__TPPLST_0psspDlg_StyleSheetPair_value)l)->_desc2;
((sspDlg__TPPLST_0psspDlg_StyleSheetPair_value)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_StyleSheetPair_value (POSITION *_coordref, NODEPTR t)
#else
NODEPTR sspDlg_MkpsspDlg_StyleSheetPair_value (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; sspDlg__TPPpsspDlg_StyleSheetPair_value root;
	sspDlg__TPPLST_0psspDlg_StyleSheetPair_value list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (sspDlg__TPPLST_0psspDlg_StyleSheetPair_value)NULLNODEPTR;
else {	if (sspDlg_LHSMAP[t->_prod] != sspDlg_SYMBLST_sspDlg_StyleSheetPair_value)
		t = _ElempsspDlg_StyleSheetPair_value (_coordref, t);
	remain = (sspDlg__TPPLST_0psspDlg_StyleSheetPair_value)(((sspDlg__TPPLST_0psspDlg_StyleSheetPair_value) t)->_desc2);
	((sspDlg__TPPLST_0psspDlg_StyleSheetPair_value) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new sspDlg__TPLST_0psspDlg_StyleSheetPair_value;
#else
list = (sspDlg__TPPLST_0psspDlg_StyleSheetPair_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPLST_0psspDlg_StyleSheetPair_value));
#endif
list->_prod = sspDlg_RULELST_0psspDlg_StyleSheetPair_value;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (sspDlg__TPPLST_0psspDlg_StyleSheetPair_value)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == sspDlg_RULELST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value)
	{sspDlg__TPPLST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value _currn = _currn;
	 sspDlg__TERMACT_LST_sspDlg_SizeValuepsspDlg_StyleSheetPair_value;
	} this code has been moved to _ElempsspDlg_StyleSheetPair_value*/
	/*if (_currn->_prod == sspDlg_RULELST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value)
	{sspDlg__TPPLST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value _currn = _currn;
	 sspDlg__TERMACT_LST_sspDlg_ColorValuepsspDlg_StyleSheetPair_value;
	} this code has been moved to _ElempsspDlg_StyleSheetPair_value*/
	/*if (_currn->_prod == sspDlg_RULELST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value)
	{sspDlg__TPPLST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value _currn = _currn;
	 sspDlg__TERMACT_LST_sspDlg_FamilyValuepsspDlg_StyleSheetPair_value;
	} this code has been moved to _ElempsspDlg_StyleSheetPair_value*/
	/*if (_currn->_prod == sspDlg_RULELST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value)
	{sspDlg__TPPLST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value _currn = _currn;
	 sspDlg__TERMACT_LST_sspDlg_StyleValuepsspDlg_StyleSheetPair_value;
	} this code has been moved to _ElempsspDlg_StyleSheetPair_value*/
	/*if (_currn->_prod == sspDlg_RULELST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value)
	{sspDlg__TPPLST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value _currn = _currn;
	 sspDlg__TERMACT_LST_sspDlg_HeadingValuepsspDlg_StyleSheetPair_value;
	} this code has been moved to _ElempsspDlg_StyleSheetPair_value*/
	/*if (_currn->_prod == sspDlg_RULELST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value)
	{sspDlg__TPPLST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value _currn = _currn;
	 sspDlg__TERMACT_LST_sspDlg_AlignmentValuepsspDlg_StyleSheetPair_value;
	} this code has been moved to _ElempsspDlg_StyleSheetPair_value*/
	/*if (_currn->_prod == sspDlg_RULELST_sspDlg_ListValuepsspDlg_StyleSheetPair_value)
	{sspDlg__TPPLST_sspDlg_ListValuepsspDlg_StyleSheetPair_value _currn = _currn;
	 sspDlg__TERMACT_LST_sspDlg_ListValuepsspDlg_StyleSheetPair_value;
	} this code has been moved to _ElempsspDlg_StyleSheetPair_value*/
	/*if (_currn->_prod == sspDlg_RULELST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value)
	{sspDlg__TPPLST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value _currn = _currn;
	 sspDlg__TERMACT_LST_sspDlg_CustomValuepsspDlg_StyleSheetPair_value;
	} this code has been moved to _ElempsspDlg_StyleSheetPair_value*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new sspDlg__TPpsspDlg_StyleSheetPair_value;
#else
root = (sspDlg__TPPpsspDlg_StyleSheetPair_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_StyleSheetPair_value));
#endif
root->_prod = sspDlg_RULEpsspDlg_StyleSheetPair_value;
root->_desc1 = (sspDlg__TSPLST_sspDlg_StyleSheetPair_value)list;
{ sspDlg__TPPpsspDlg_StyleSheetPair_value _currn = root;
  _SETCOORD(_currn)
  sspDlg__TERMACT_psspDlg_StyleSheetPair_value;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_SizeValue (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR sspDlg_MkpsspDlg_SizeValue (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	sspDlg__TPPpsspDlg_SizeValue _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_SizeValue;
#else
_currn = (sspDlg__TPPpsspDlg_SizeValue) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_SizeValue));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_SizeValue;
_currn->_desc1 = (sspDlg__TSPsspDlg_SizeValue_measure) sspDlg_MksspDlg_SizeValue_measure (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_SizeValue: root of subtree no. 1 can not be made a sspDlg_SizeValue_measure node ", 0, _coordref);
_currn->_desc2 = (sspDlg__TSPsspDlg_SizeValue_value) sspDlg_MksspDlg_SizeValue_value (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_SizeValue: root of subtree no. 2 can not be made a sspDlg_SizeValue_value node ", 0, _coordref);
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_SizeValue;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_SizeValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_SizeValue_measure (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_SizeValue_measure (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_SizeValue_measure _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_SizeValue_measure;
#else
_currn = (sspDlg__TPPpsspDlg_SizeValue_measure) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_SizeValue_measure));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_SizeValue_measure;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_SizeValue_measure;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_SizeValue_measure */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_SizeValue_value (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_SizeValue_value (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_SizeValue_value _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_SizeValue_value;
#else
_currn = (sspDlg__TPPpsspDlg_SizeValue_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_SizeValue_value));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_SizeValue_value;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_SizeValue_value;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_SizeValue_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_ColorValue (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR sspDlg_MkpsspDlg_ColorValue (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	sspDlg__TPPpsspDlg_ColorValue _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_ColorValue;
#else
_currn = (sspDlg__TPPpsspDlg_ColorValue) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_ColorValue));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_ColorValue;
_currn->_desc1 = (sspDlg__TSPsspDlg_ColorValue_color) sspDlg_MksspDlg_ColorValue_color (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_ColorValue: root of subtree no. 1 can not be made a sspDlg_ColorValue_color node ", 0, _coordref);
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_ColorValue;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_ColorValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_ColorValue_color (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_ColorValue_color (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_ColorValue_color _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_ColorValue_color;
#else
_currn = (sspDlg__TPPpsspDlg_ColorValue_color) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_ColorValue_color));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_ColorValue_color;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_ColorValue_color;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_ColorValue_color */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_FamilyValue (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR sspDlg_MkpsspDlg_FamilyValue (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	sspDlg__TPPpsspDlg_FamilyValue _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_FamilyValue;
#else
_currn = (sspDlg__TPPpsspDlg_FamilyValue) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_FamilyValue));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_FamilyValue;
_currn->_desc1 = (sspDlg__TSPsspDlg_FamilyValue_family) sspDlg_MksspDlg_FamilyValue_family (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_FamilyValue: root of subtree no. 1 can not be made a sspDlg_FamilyValue_family node ", 0, _coordref);
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_FamilyValue;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_FamilyValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_FamilyValue_family (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_FamilyValue_family (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_FamilyValue_family _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_FamilyValue_family;
#else
_currn = (sspDlg__TPPpsspDlg_FamilyValue_family) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_FamilyValue_family));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_FamilyValue_family;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_FamilyValue_family;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_FamilyValue_family */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_StyleValue (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR sspDlg_MkpsspDlg_StyleValue (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	sspDlg__TPPpsspDlg_StyleValue _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_StyleValue;
#else
_currn = (sspDlg__TPPpsspDlg_StyleValue) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_StyleValue));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_StyleValue;
_currn->_desc1 = (sspDlg__TSPsspDlg_StyleValue_style) sspDlg_MksspDlg_StyleValue_style (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_StyleValue: root of subtree no. 1 can not be made a sspDlg_StyleValue_style node ", 0, _coordref);
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_StyleValue;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_StyleValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_StyleValue_style (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_StyleValue_style (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_StyleValue_style _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_StyleValue_style;
#else
_currn = (sspDlg__TPPpsspDlg_StyleValue_style) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_StyleValue_style));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_StyleValue_style;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_StyleValue_style;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_StyleValue_style */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_HeadingValue (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR sspDlg_MkpsspDlg_HeadingValue (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	sspDlg__TPPpsspDlg_HeadingValue _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_HeadingValue;
#else
_currn = (sspDlg__TPPpsspDlg_HeadingValue) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_HeadingValue));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_HeadingValue;
_currn->_desc1 = (sspDlg__TSPsspDlg_HeadingValue_heading) sspDlg_MksspDlg_HeadingValue_heading (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_HeadingValue: root of subtree no. 1 can not be made a sspDlg_HeadingValue_heading node ", 0, _coordref);
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_HeadingValue;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_HeadingValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_HeadingValue_heading (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_HeadingValue_heading (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_HeadingValue_heading _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_HeadingValue_heading;
#else
_currn = (sspDlg__TPPpsspDlg_HeadingValue_heading) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_HeadingValue_heading));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_HeadingValue_heading;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_HeadingValue_heading;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_HeadingValue_heading */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_AlignmentValue (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR sspDlg_MkpsspDlg_AlignmentValue (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	sspDlg__TPPpsspDlg_AlignmentValue _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_AlignmentValue;
#else
_currn = (sspDlg__TPPpsspDlg_AlignmentValue) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_AlignmentValue));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_AlignmentValue;
_currn->_desc1 = (sspDlg__TSPsspDlg_AlignmentValue_alignment) sspDlg_MksspDlg_AlignmentValue_alignment (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_AlignmentValue: root of subtree no. 1 can not be made a sspDlg_AlignmentValue_alignment node ", 0, _coordref);
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_AlignmentValue;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_AlignmentValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_AlignmentValue_alignment (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_AlignmentValue_alignment (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_AlignmentValue_alignment _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_AlignmentValue_alignment;
#else
_currn = (sspDlg__TPPpsspDlg_AlignmentValue_alignment) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_AlignmentValue_alignment));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_AlignmentValue_alignment;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_AlignmentValue_alignment;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_AlignmentValue_alignment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_ListValue (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR sspDlg_MkpsspDlg_ListValue (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	sspDlg__TPPpsspDlg_ListValue _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_ListValue;
#else
_currn = (sspDlg__TPPpsspDlg_ListValue) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_ListValue));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_ListValue;
_currn->_desc1 = (sspDlg__TSPsspDlg_ListValue_listed) sspDlg_MksspDlg_ListValue_listed (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_ListValue: root of subtree no. 1 can not be made a sspDlg_ListValue_listed node ", 0, _coordref);
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_ListValue;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_ListValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_ListValue_listed (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_ListValue_listed (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_ListValue_listed _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_ListValue_listed;
#else
_currn = (sspDlg__TPPpsspDlg_ListValue_listed) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_ListValue_listed));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_ListValue_listed;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_ListValue_listed;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_ListValue_listed */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_CustomValue (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR sspDlg_MkpsspDlg_CustomValue (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	sspDlg__TPPpsspDlg_CustomValue _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_CustomValue;
#else
_currn = (sspDlg__TPPpsspDlg_CustomValue) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_CustomValue));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_CustomValue;
_currn->_desc1 = (sspDlg__TSPsspDlg_CustomValue_value) sspDlg_MksspDlg_CustomValue_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE psspDlg_CustomValue: root of subtree no. 1 can not be made a sspDlg_CustomValue_value node ", 0, _coordref);
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_CustomValue;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_CustomValue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR sspDlg_MkpsspDlg_CustomValue_value (POSITION *_coordref)
#else
NODEPTR sspDlg_MkpsspDlg_CustomValue_value (_coordref)
	POSITION *_coordref;
#endif
{	sspDlg__TPPpsspDlg_CustomValue_value _currn;
#ifdef __cplusplus
_currn = new sspDlg__TPpsspDlg_CustomValue_value;
#else
_currn = (sspDlg__TPPpsspDlg_CustomValue_value) sspDlg_TreeNodeAlloc (sizeof (struct sspDlg__TPpsspDlg_CustomValue_value));
#endif
_currn->_prod = sspDlg_RULEpsspDlg_CustomValue_value;
_SETCOORD(_currn)
sspDlg__TERMACT_psspDlg_CustomValue_value;
return ( (NODEPTR) _currn);
}/* sspDlg_MkpsspDlg_CustomValue_value */
