
/* implementation of tree construction functions */

#include "wnveDlg_node.h"

#include "wnveDlg_nodecode.h"

#include "attrpredef.h"

#include "wnveDlg_visitmap.h"

#include "wnveDlg_treeact.h"

#ifdef MONITOR
#include "attr_mon_dapto.h"
#endif

#include <stdlib.h>

#define _USE_OBSTACK 1

/* use of obstack: */

#if _USE_OBSTACK

#include "obstack.h"
static struct obstack TreeSpace;
static void *_TreeBase;

#ifdef __cplusplus
void* wnveDlg_NODEPTR_SUB_struct::operator new(size_t size)
{
	return obstack_alloc(&TreeSpace, size);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* wnveDlg_TreeNodeAlloc(int size)
#else
char* wnveDlg_TreeNodeAlloc(size) int size;
#endif
{
	return (char *)(obstack_alloc(&TreeSpace, size));
}
#endif

void wnveDlg_InitTree()
{
	obstack_init(&TreeSpace);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

void wnveDlg_FreeTree()
{
	obstack_free(&TreeSpace, _TreeBase);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

#else

#include <stdio.h>

#ifdef __cplusplus
void* NODEPTR_struct::operator new(size_t size)
{
	void *retval = malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* wnveDlg_TreeNodeAlloc(int size)
#else
char* wnveDlg_TreeNodeAlloc(size) int size;
#endif
{
	char *retval = (char *) malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#endif

void wnveDlg_InitTree() { }

void wnveDlg_FreeTree() { }

#endif

#ifdef MONITOR
#define _SETCOORD(node) \
        node->_coord = _coordref ? *_coordref : NoCoord;
#define _COPYCOORD(node) \
        node->_coord = _currn->_desc1->_coord;
#else
#define _SETCOORD(node)
#define _COPYCOORD(node)
#endif
#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkVIEWROOT (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR wnveDlg_MkVIEWROOT (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (wnveDlg_IsSymb (_currn, wnveDlg_SYMBVIEWROOT)) return (_currn);
if (wnveDlg_IsSymb (_currn, wnveDlg_SYMBwnveDlg_WebNodeVariableExpression)) return (wnveDlg_MkpVIEWROOT_wnveDlg(_coordref, _currn));
return(NULLNODEPTR);
}/* wnveDlg_MkVIEWROOT */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkwnveDlg_WebNodeVariableExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR wnveDlg_MkwnveDlg_WebNodeVariableExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (wnveDlg_IsSymb (_currn, wnveDlg_SYMBwnveDlg_WebNodeVariableExpression)) return (_currn);
return(NULLNODEPTR);
}/* wnveDlg_MkwnveDlg_WebNodeVariableExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkwnveDlg_WebNodeVariableExpression_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR wnveDlg_MkwnveDlg_WebNodeVariableExpression_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (wnveDlg_IsSymb (_currn, wnveDlg_SYMBwnveDlg_WebNodeVariableExpression_content)) return (_currn);
return(NULLNODEPTR);
}/* wnveDlg_MkwnveDlg_WebNodeVariableExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkwnveDlg_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR wnveDlg_MkwnveDlg_WebNodeVariableExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (wnveDlg_IsSymb (_currn, wnveDlg_SYMBwnveDlg_WebNodeVariableExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* wnveDlg_MkwnveDlg_WebNodeVariableExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkwnveDlg_JoinModifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR wnveDlg_MkwnveDlg_JoinModifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (wnveDlg_IsSymb (_currn, wnveDlg_SYMBwnveDlg_JoinModifier)) return (_currn);
return(NULLNODEPTR);
}/* wnveDlg_MkwnveDlg_JoinModifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkwnveDlg_MD5Modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR wnveDlg_MkwnveDlg_MD5Modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (wnveDlg_IsSymb (_currn, wnveDlg_SYMBwnveDlg_MD5Modifier)) return (_currn);
return(NULLNODEPTR);
}/* wnveDlg_MkwnveDlg_MD5Modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkwnveDlg_JoinModifier_separator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR wnveDlg_MkwnveDlg_JoinModifier_separator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (wnveDlg_IsSymb (_currn, wnveDlg_SYMBwnveDlg_JoinModifier_separator)) return (_currn);
return(NULLNODEPTR);
}/* wnveDlg_MkwnveDlg_JoinModifier_separator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkpEmpty (POSITION *_coordref)
#else
NODEPTR wnveDlg_MkpEmpty (_coordref)
	POSITION *_coordref;
#endif
{	wnveDlg__TPPpEmpty _currn;
#ifdef __cplusplus
_currn = new wnveDlg__TPpEmpty;
#else
_currn = (wnveDlg__TPPpEmpty) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPpEmpty));
#endif
_currn->_prod = wnveDlg_RULEpEmpty;
_SETCOORD(_currn)
wnveDlg__TERMACT_pEmpty;
return ( (NODEPTR) _currn);
}/* wnveDlg_MkpEmpty */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkpVIEWROOT_wnveDlg (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR wnveDlg_MkpVIEWROOT_wnveDlg (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	wnveDlg__TPPpVIEWROOT_wnveDlg _currn;
#ifdef __cplusplus
_currn = new wnveDlg__TPpVIEWROOT_wnveDlg;
#else
_currn = (wnveDlg__TPPpVIEWROOT_wnveDlg) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPpVIEWROOT_wnveDlg));
#endif
_currn->_prod = wnveDlg_RULEpVIEWROOT_wnveDlg;
_currn->_desc1 = (wnveDlg__TSPwnveDlg_WebNodeVariableExpression) wnveDlg_MkwnveDlg_WebNodeVariableExpression (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pVIEWROOT_wnveDlg: root of subtree no. 1 can not be made a wnveDlg_WebNodeVariableExpression node ", 0, _coordref);
_COPYCOORD(_currn)
wnveDlg__TERMACT_pVIEWROOT_wnveDlg;
return ( (NODEPTR) _currn);
}/* wnveDlg_MkpVIEWROOT_wnveDlg */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkpwnveDlg_WebNodeVariableExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR wnveDlg_MkpwnveDlg_WebNodeVariableExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	wnveDlg__TPPpwnveDlg_WebNodeVariableExpression _currn;
#ifdef __cplusplus
_currn = new wnveDlg__TPpwnveDlg_WebNodeVariableExpression;
#else
_currn = (wnveDlg__TPPpwnveDlg_WebNodeVariableExpression) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPpwnveDlg_WebNodeVariableExpression));
#endif
_currn->_prod = wnveDlg_RULEpwnveDlg_WebNodeVariableExpression;
_currn->_desc1 = (wnveDlg__TSPwnveDlg_WebNodeVariableExpression_content) wnveDlg_MkwnveDlg_WebNodeVariableExpression_content (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwnveDlg_WebNodeVariableExpression: root of subtree no. 1 can not be made a wnveDlg_WebNodeVariableExpression_content node ", 0, _coordref);
_currn->_desc2 = (wnveDlg__TSPwnveDlg_WebNodeVariableExpression_modifier) wnveDlg_MkwnveDlg_WebNodeVariableExpression_modifier (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwnveDlg_WebNodeVariableExpression: root of subtree no. 2 can not be made a wnveDlg_WebNodeVariableExpression_modifier node ", 0, _coordref);
_SETCOORD(_currn)
wnveDlg__TERMACT_pwnveDlg_WebNodeVariableExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* wnveDlg_MkpwnveDlg_WebNodeVariableExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkpwnveDlg_WebNodeVariableExpression_content (POSITION *_coordref)
#else
NODEPTR wnveDlg_MkpwnveDlg_WebNodeVariableExpression_content (_coordref)
	POSITION *_coordref;
#endif
{	wnveDlg__TPPpwnveDlg_WebNodeVariableExpression_content _currn;
#ifdef __cplusplus
_currn = new wnveDlg__TPpwnveDlg_WebNodeVariableExpression_content;
#else
_currn = (wnveDlg__TPPpwnveDlg_WebNodeVariableExpression_content) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPpwnveDlg_WebNodeVariableExpression_content));
#endif
_currn->_prod = wnveDlg_RULEpwnveDlg_WebNodeVariableExpression_content;
_SETCOORD(_currn)
wnveDlg__TERMACT_pwnveDlg_WebNodeVariableExpression_content;
return ( (NODEPTR) _currn);
}/* wnveDlg_MkpwnveDlg_WebNodeVariableExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR wnveDlg__MkwnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR wnveDlg__MkwnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	wnveDlg__TPPLST_wnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier _new;
#ifdef __cplusplus
	_new = new wnveDlg__TPLST_wnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier;
#else
	_new = (wnveDlg__TPPLST_wnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPLST_wnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier));
#endif
	_new->_prod = wnveDlg_RULELST_wnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier;
	_new->_desc1 = (wnveDlg__TSPwnveDlg_MD5Modifier)elem;
	_new->_desc2 = (wnveDlg__TSPLST_wnveDlg_WebNodeVariableExpression_modifier)_new;
	{wnveDlg__TPPLST_wnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 wnveDlg__TERMACT_LST_wnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR wnveDlg__MkwnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR wnveDlg__MkwnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	wnveDlg__TPPLST_wnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier _new;
#ifdef __cplusplus
	_new = new wnveDlg__TPLST_wnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier;
#else
	_new = (wnveDlg__TPPLST_wnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPLST_wnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier));
#endif
	_new->_prod = wnveDlg_RULELST_wnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier;
	_new->_desc1 = (wnveDlg__TSPwnveDlg_JoinModifier)elem;
	_new->_desc2 = (wnveDlg__TSPLST_wnveDlg_WebNodeVariableExpression_modifier)_new;
	{wnveDlg__TPPLST_wnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 wnveDlg__TERMACT_LST_wnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwnveDlg_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwnveDlg_WebNodeVariableExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (wnveDlg_IsSymb (t, wnveDlg_SYMBwnveDlg_MD5Modifier)) 
		return wnveDlg__MkwnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier (_coordref, wnveDlg_MkwnveDlg_MD5Modifier (_coordref, t));
	if (wnveDlg_IsSymb (t, wnveDlg_SYMBwnveDlg_JoinModifier)) 
		return wnveDlg__MkwnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier (_coordref, wnveDlg_MkwnveDlg_JoinModifier (_coordref, t));
	message (DEADLY, "a pwnveDlg_WebNodeVariableExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_Mk2pwnveDlg_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR wnveDlg_Mk2pwnveDlg_WebNodeVariableExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (wnveDlg_LHSMAP[l->_prod] != wnveDlg_SYMBLST_wnveDlg_WebNodeVariableExpression_modifier)
	l =_ElempwnveDlg_WebNodeVariableExpression_modifier (_coordref, l);
if (wnveDlg_LHSMAP[r->_prod] != wnveDlg_SYMBLST_wnveDlg_WebNodeVariableExpression_modifier)
	r = _ElempwnveDlg_WebNodeVariableExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier)r)->_desc2);
((wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier)r)->_desc2 = ((wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier)l)->_desc2;
((wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkpwnveDlg_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR wnveDlg_MkpwnveDlg_WebNodeVariableExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; wnveDlg__TPPpwnveDlg_WebNodeVariableExpression_modifier root;
	wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier)NULLNODEPTR;
else {	if (wnveDlg_LHSMAP[t->_prod] != wnveDlg_SYMBLST_wnveDlg_WebNodeVariableExpression_modifier)
		t = _ElempwnveDlg_WebNodeVariableExpression_modifier (_coordref, t);
	remain = (wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier)(((wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier) t)->_desc2);
	((wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new wnveDlg__TPLST_0pwnveDlg_WebNodeVariableExpression_modifier;
#else
list = (wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPLST_0pwnveDlg_WebNodeVariableExpression_modifier));
#endif
list->_prod = wnveDlg_RULELST_0pwnveDlg_WebNodeVariableExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (wnveDlg__TPPLST_0pwnveDlg_WebNodeVariableExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == wnveDlg_RULELST_wnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier)
	{wnveDlg__TPPLST_wnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier _currn = _currn;
	 wnveDlg__TERMACT_LST_wnveDlg_MD5ModifierpwnveDlg_WebNodeVariableExpression_modifier;
	} this code has been moved to _ElempwnveDlg_WebNodeVariableExpression_modifier*/
	/*if (_currn->_prod == wnveDlg_RULELST_wnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier)
	{wnveDlg__TPPLST_wnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier _currn = _currn;
	 wnveDlg__TERMACT_LST_wnveDlg_JoinModifierpwnveDlg_WebNodeVariableExpression_modifier;
	} this code has been moved to _ElempwnveDlg_WebNodeVariableExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new wnveDlg__TPpwnveDlg_WebNodeVariableExpression_modifier;
#else
root = (wnveDlg__TPPpwnveDlg_WebNodeVariableExpression_modifier) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPpwnveDlg_WebNodeVariableExpression_modifier));
#endif
root->_prod = wnveDlg_RULEpwnveDlg_WebNodeVariableExpression_modifier;
root->_desc1 = (wnveDlg__TSPLST_wnveDlg_WebNodeVariableExpression_modifier)list;
{ wnveDlg__TPPpwnveDlg_WebNodeVariableExpression_modifier _currn = root;
  _SETCOORD(_currn)
  wnveDlg__TERMACT_pwnveDlg_WebNodeVariableExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkpwnveDlg_MD5Modifier (POSITION *_coordref, int _TERM1)
#else
NODEPTR wnveDlg_MkpwnveDlg_MD5Modifier (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	wnveDlg__TPPpwnveDlg_MD5Modifier _currn;
#ifdef __cplusplus
_currn = new wnveDlg__TPpwnveDlg_MD5Modifier;
#else
_currn = (wnveDlg__TPPpwnveDlg_MD5Modifier) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPpwnveDlg_MD5Modifier));
#endif
_currn->_prod = wnveDlg_RULEpwnveDlg_MD5Modifier;
_SETCOORD(_currn)
wnveDlg__TERMACT_pwnveDlg_MD5Modifier;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* wnveDlg_MkpwnveDlg_MD5Modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkpwnveDlg_JoinModifier (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR wnveDlg_MkpwnveDlg_JoinModifier (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	wnveDlg__TPPpwnveDlg_JoinModifier _currn;
#ifdef __cplusplus
_currn = new wnveDlg__TPpwnveDlg_JoinModifier;
#else
_currn = (wnveDlg__TPPpwnveDlg_JoinModifier) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPpwnveDlg_JoinModifier));
#endif
_currn->_prod = wnveDlg_RULEpwnveDlg_JoinModifier;
_currn->_desc1 = (wnveDlg__TSPwnveDlg_JoinModifier_separator) wnveDlg_MkwnveDlg_JoinModifier_separator (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwnveDlg_JoinModifier: root of subtree no. 1 can not be made a wnveDlg_JoinModifier_separator node ", 0, _coordref);
_SETCOORD(_currn)
wnveDlg__TERMACT_pwnveDlg_JoinModifier;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* wnveDlg_MkpwnveDlg_JoinModifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR wnveDlg_MkpwnveDlg_JoinModifier_separator (POSITION *_coordref)
#else
NODEPTR wnveDlg_MkpwnveDlg_JoinModifier_separator (_coordref)
	POSITION *_coordref;
#endif
{	wnveDlg__TPPpwnveDlg_JoinModifier_separator _currn;
#ifdef __cplusplus
_currn = new wnveDlg__TPpwnveDlg_JoinModifier_separator;
#else
_currn = (wnveDlg__TPPpwnveDlg_JoinModifier_separator) wnveDlg_TreeNodeAlloc (sizeof (struct wnveDlg__TPpwnveDlg_JoinModifier_separator));
#endif
_currn->_prod = wnveDlg_RULEpwnveDlg_JoinModifier_separator;
_SETCOORD(_currn)
wnveDlg__TERMACT_pwnveDlg_JoinModifier_separator;
return ( (NODEPTR) _currn);
}/* wnveDlg_MkpwnveDlg_JoinModifier_separator */
