
# --- change operations  ----------------------------------------------------------------

# ACHTUNG! Diese Funktionen sollten nie direkt aufgerufen werden.
# Statt dessen sollten die Funktionen im Modul "change" benutzt werden.
#


namespace eval d {}



proc d::getFile {node} {
    variable fileArr
    return $fileArr([c::getRoot $node])
}


proc d::setFile {node file} {
    variable fileArr
    set fileArr($node) $file
}


proc d::createObject {className file} {
    set objNode [c::${className}_new]
    setFile $objNode $file
    return $objNode
}


proc d::createRoot {} {
    set objNode [c::Root_new]
    setFile $objNode $objNode
    return $objNode
}


proc d::setValue {obj value} {
    c::setValue_internal $obj $value
    file::changeOccured $obj
}


proc d::insert {context newElem} {
    c::insertBefore_internal $context $newElem
    file::changeOccured $newElem
    file::changeOccured [c::getParent $context]
}


proc d::delete {obj} {
    file::beforeDeletion [file::getFileOfRoot [getFile $obj]] $obj
    # xxx: really delete object!
}


proc d::extract {obj} {
    set changedNode [c::getParent $obj]
    c::extract $obj
    if { ![nullptr $changedNode] } {
        file::changeOccured $changedNode
    }
    file::changeOccured $obj

}


proc d::copy {obj file} {
    # Erzeugt eine exakte Kopie von $obj.
    # Die neue Kopie gehrt zu $file.
    # Interne Referenzen der Kopie zeigen auf kopierte Knoten.
    # Externe Referenzen bleiben erhalten.

    set newobj [copy_copyStructureRec $obj oldToNew $file]
    copy_changeReferencesRec $newobj oldToNew
    return $newobj
}


proc d::copy_copyStructureRec {obj oldToNewName file} {
    # private
    upvar $oldToNewName oldToNew
    set newobj [createObject [c::getClassName $obj] $file]
    set oldToNew($obj) $newobj
    foreach sub [c::getSubElements $obj] {
        set newsub [c::getSubElement $newobj [c::getRole $sub]]
        if [c::isValue $sub] {
            setValue $newsub [c::getValue $sub]
        } elseif [c::isReference $sub] {
            setValue $newsub [c::getValue $sub]
        } elseif [c::isAggregate $sub] {
            foreach subsub [c::getSubElements $sub] {
                insert [c::icBelow $newsub] [copy_copyStructureRec $subsub oldToNew $file]
            }
        } else {
            assert 0
        }
    }
    return $newobj
}


proc d::copy_changeReferencesRec {obj oldToNewName} {
    # private
    upvar $oldToNewName oldToNew
    if { [c::isReference $obj] && [info exists oldToNew([c::getValue $obj])] } {
        setValue $obj $oldToNew([c::getValue $obj])
    }
    foreach sub [c::getSubElements $obj] {
        copy_changeReferencesRec $sub oldToNew
    }
}
