
namespace eval dropEffect {
    set table ""
}

#PUBLIC (called by specification)
proc dropEffect::add {dragObjectType dropObjectType action} {
    lappend ::dropEffect::table [c::getTypeIdFromName $dragObjectType] [c::getTypeIdFromName $dropObjectType] $action
}


proc dropEffect::findApplicable {source target} {
    set sourceType [c::getTypeId $source]
    set targetType [c::getAcceptedType [c::getParent $target]]
    foreach "tableSourceType tableTargetType tableAction" $dropEffect::table {
        if { [c::isSubtypeOf $sourceType $tableSourceType] && [c::isSubtypeOf $tableTargetType $targetType] } {
            return $tableAction
        }
    }
    return ""
}

#PUBLIC (called by framework)
proc dropEffect::isApplicable {source target} {
    set action [findApplicable $source $target]
    return [expr ![empty $action]]
}

#PUBLIC (called by framework)
proc dropEffect::apply {source target} {
    set action [findApplicable $source $target]
    set result [eval $action $source $target]
    return result
}


# --- Library functions ------------------------------------------------------------------------


proc dropEffect::createApplication {className connectionAttribute dropSource dropTarget} {
    # Creates an object of class $className, inserts it at $dropTarget and sets the Attribute
    # $connectionAttribute to value $dropSource.

    set newNode [edit::createObject $className [edit::getFile $dropTarget]]
    edit::insert $dropTarget $newNode
    edit::setAttr $newNode $connectionAttribute $dropSource
    return newNode
}

