
/* implementation of tree construction functions */

#include "globalFrameView_node.h"

#include "globalFrameView_nodecode.h"

#include "attrpredef.h"

#include "globalFrameView_visitmap.h"

#include "globalFrameView_treeact.h"

#ifdef MONITOR
#include "attr_mon_dapto.h"
#endif

#include <stdlib.h>

#define _USE_OBSTACK 1

/* use of obstack: */

#if _USE_OBSTACK

#include "obstack.h"
static struct obstack TreeSpace;
static void *_TreeBase;

#ifdef __cplusplus
void* globalFrameView_NODEPTR_SUB_struct::operator new(size_t size)
{
	return obstack_alloc(&TreeSpace, size);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* globalFrameView_TreeNodeAlloc(int size)
#else
char* globalFrameView_TreeNodeAlloc(size) int size;
#endif
{
	return (char *)(obstack_alloc(&TreeSpace, size));
}
#endif

void globalFrameView_InitTree()
{
	obstack_init(&TreeSpace);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

void globalFrameView_FreeTree()
{
	obstack_free(&TreeSpace, _TreeBase);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

#else

#include <stdio.h>

#ifdef __cplusplus
void* NODEPTR_struct::operator new(size_t size)
{
	void *retval = malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* globalFrameView_TreeNodeAlloc(int size)
#else
char* globalFrameView_TreeNodeAlloc(size) int size;
#endif
{
	char *retval = (char *) malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#endif

void globalFrameView_InitTree() { }

void globalFrameView_FreeTree() { }

#endif

#ifdef MONITOR
#define _SETCOORD(node) \
        node->_coord = _coordref ? *_coordref : NoCoord;
#define _COPYCOORD(node) \
        node->_coord = _currn->_desc1->_coord;
#else
#define _SETCOORD(node)
#define _COPYCOORD(node)
#endif
#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkVIEWROOT (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkVIEWROOT (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBVIEWROOT)) return (_currn);
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_GlobalFrame)) return (globalFrameView_MkpVIEWROOT_globalFrameView(_coordref, _currn));
return(NULLNODEPTR);
}/* globalFrameView_MkVIEWROOT */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_GlobalFrame (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_GlobalFrame (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_GlobalFrame)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_GlobalFrame */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularCheckboxElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularCheckboxElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularCheckboxElement_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularCheckboxElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularCheckboxElement_type)) return (_currn);
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularCheckboxElement_name)) return (globalFrameView_MkpglobalFrameView_FormularCheckboxElement_type(_coordref, _currn));
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularCheckboxElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularCheckboxElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularCheckboxElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularCheckboxElement_description)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularCheckboxElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularCheckboxElement_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularCheckboxElement_name)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularCheckboxElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DoubleRangeValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DoubleRangeValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DoubleRangeValidator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DoubleRangeValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_LongRangeValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_LongRangeValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_LongRangeValidator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_LongRangeValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_StringLengthValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_StringLengthValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_StringLengthValidator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_StringLengthValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_RegExprValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_RegExprValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_RegExprValidator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_RegExprValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_CreditCardValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_CreditCardValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_CreditCardValidator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_CreditCardValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_EmailValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_EmailValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_EmailValidator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_EmailValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularTextElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularTextElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularTextElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularTextElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularTextElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularTextElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularTextElement_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularTextElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularTextElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularTextElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularTextElement_type)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularTextElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularTextElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularTextElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularTextElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularTextElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularTextElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularTextElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularTextElement_description)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularTextElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularDateElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularDateElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularDateElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularDateElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularDateElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularDateElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularDateElement_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularDateElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularDateElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularDateElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularDateElement_type)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularDateElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularDateElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularDateElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularDateElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularDateElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularDateElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularDateElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularDateElement_description)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularDateElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularFileUploadElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularFileUploadElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularFileUploadElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularFileUploadElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularFileUploadElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularFileUploadElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularFileUploadElement_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularFileUploadElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularFileUploadElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularFileUploadElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularFileUploadElement_type)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularFileUploadElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularFileUploadElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularFileUploadElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularFileUploadElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularFileUploadElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularFileUploadElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularFileUploadElement_description)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularFileUploadElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularPasswordElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularPasswordElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularPasswordElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularPasswordElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularPasswordElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularPasswordElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularPasswordElement_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularPasswordElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularPasswordElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularPasswordElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularPasswordElement_type)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularPasswordElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularPasswordElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularPasswordElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularPasswordElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularPasswordElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularPasswordElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularPasswordElement_description)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularPasswordElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularTextAreaElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularTextAreaElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularTextAreaElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularTextAreaElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularTextAreaElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularTextAreaElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularTextAreaElement_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularTextAreaElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularTextAreaElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularTextAreaElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularTextAreaElement_type)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularTextAreaElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularTextAreaElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularTextAreaElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularTextAreaElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularTextAreaElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularTextAreaElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularTextAreaElement_description)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularTextAreaElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularSelectElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularSelectElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularSelectElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularSelectElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularSelectElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularSelectElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularSelectElement_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularSelectElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularSelectElement_multiple (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularSelectElement_multiple (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularSelectElement_multiple)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularSelectElement_multiple */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularSelectElement_options (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularSelectElement_options (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularSelectElement_options)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularSelectElement_options */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularSelectElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularSelectElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularSelectElement_description)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularSelectElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularDataSourceSelectOption)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularConstantSelectOption (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularConstantSelectOption (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularConstantSelectOption)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularConstantSelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioElement_type)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioElement_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DataSourceActualParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DataSourceActualParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DataSourceActualParam)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DataSourceActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DataSourceActualParam_formalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DataSourceActualParam_formalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DataSourceActualParam_formalParam)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DataSourceActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DataSourceActualParam_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DataSourceActualParam_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DataSourceActualParam_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DataSourceActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DataSourceActualParam_expressions (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DataSourceActualParam_expressions)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DataSourceActualParam_expressions */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeSessionExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeSessionExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeSessionExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeSessionExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeVariableExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeVariableExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeVariableExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeVariableExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeConstantExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeConstantExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeConstantExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeActualParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeActualParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeActualParam)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeActualParam_formalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeActualParam_formalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeActualParam_formalParam)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeActualParam_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeActualParam_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeActualParam_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeActualParam_expressions (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeActualParam_expressions)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeActualParam_expressions */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_MapArea (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_MapArea (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_MapArea)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_MapArea */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_MapArea_altText (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_MapArea_altText (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_MapArea_altText)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_MapArea_altText */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_MapArea_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_MapArea_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_MapArea_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_MapArea_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_MapArea_coords (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_MapArea_coords (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_MapArea_coords)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_MapArea_coords */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_MapArea_keyword2 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_MapArea_keyword2 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_MapArea_keyword2)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_MapArea_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_MapArea_link (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_MapArea_link (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_MapArea_link)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_MapArea_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_MapArea_queryString (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_MapArea_queryString (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_MapArea_queryString)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_MapArea_queryString */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Frame (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Frame (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Frame)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Frame */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Frame_components (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Frame_components)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Frame_components */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageMap (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageMap (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageMap)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageMap */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_OutputMessagesElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_OutputMessagesElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_OutputMessagesElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_OutputMessagesElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Formular (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Formular (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Formular)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Formular */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Table (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Table (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Table)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Table */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Heading (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Heading (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Heading)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Heading */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Paragraph (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Paragraph (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Paragraph)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Paragraph */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FrameRef (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FrameRef (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FrameRef)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FrameRef */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_GlobalFrame_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_GlobalFrame_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_GlobalFrame_name)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_GlobalFrame_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_GlobalFrame_components (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_GlobalFrame_components)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_GlobalFrame_components */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_GlobalFrame_setSize (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_GlobalFrame_setSize (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_GlobalFrame_setSize)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_GlobalFrame_setSize */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FrameRef_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FrameRef_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FrameRef_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FrameRef_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FrameRef_frame (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FrameRef_frame (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FrameRef_frame)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FrameRef_frame */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_BinaryExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_BinaryExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_BinaryExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_BinaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_BinaryExpression_leftOperand (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_BinaryExpression_leftOperand)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_BinaryExpression_leftOperand */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_BinaryExpression_rightOperand (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_BinaryExpression_rightOperand)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_BinaryExpression_rightOperand */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_BinaryExpression_operator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_BinaryExpression_operator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_BinaryExpression_operator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_BinaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ComputationExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ComputationExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ComputationExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ComputationExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ParameterValueExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ParameterValueExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ParameterValueExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ParameterValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ProjectionColumnValueExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ColumnValueExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ColumnValueExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ColumnValueExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ConstantExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ConstantExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ConstantExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_PredefinedExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_PredefinedExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_PredefinedExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_PredefinedExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_UnaryExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_UnaryExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_UnaryExpression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_UnaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_UnaryExpression_operand (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_UnaryExpression_operand)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_UnaryExpression_operand */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_UnaryExpression_operator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_UnaryExpression_operator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_UnaryExpression_operator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_UnaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_PredefinedExpression_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_PredefinedExpression_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_PredefinedExpression_value)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_PredefinedExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ConstantExpression_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ConstantExpression_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ConstantExpression_value)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ColumnValueExpression_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ColumnValueExpression_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ColumnValueExpression_column)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ProjectionColumnValueExpression_column)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ParameterValueExpression_parameter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ParameterValueExpression_parameter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ParameterValueExpression_parameter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ParameterValueExpression_parameter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ComputationExpression_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ComputationExpression_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ComputationExpression_column)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ComputationExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ComputationExpression_computation (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ComputationExpression_computation (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ComputationExpression_computation)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ComputationExpression_computation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Paragraph_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Paragraph_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Paragraph_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Paragraph_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Paragraph_fragments (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Paragraph_fragments (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Paragraph_fragments)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Paragraph_fragments */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_OutputFragment (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_OutputFragment (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_OutputFragment)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_OutputFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageFragment)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_TextFragment (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_TextFragment (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_TextFragment)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_TextFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_TextFragment_link (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_TextFragment_link (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_TextFragment_link)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_TextFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_TextFragment_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_TextFragment_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_TextFragment_value)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_TextFragment_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_TextFragment_fontstyle (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_TextFragment_fontstyle (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_TextFragment_fontstyle)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_TextFragment_fontstyle */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_link (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_link (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageFragment_link)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_width (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_width (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageFragment_width)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageFragment_width */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_height (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_height (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageFragment_height)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageFragment_height */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_border (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_border (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageFragment_border)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageFragment_border */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_verticalAlign (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_verticalAlign (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageFragment_verticalAlign)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageFragment_verticalAlign */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_float (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_float (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageFragment_float)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageFragment_float */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_text (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_text (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageFragment_text)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageFragment_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_imageName (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageFragment_imageName (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageFragment_imageName)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageFragment_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Heading_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Heading_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Heading_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Heading_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Heading_text (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Heading_text (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Heading_text)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Heading_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Heading_level (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Heading_level (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Heading_level)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Heading_level */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Table_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Table_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Table_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Table_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Table_rows (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Table_rows (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Table_rows)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Table_rows */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Table_columns (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Table_columns (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Table_columns)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Table_columns */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_TableRow (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_TableRow (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_TableRow)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_TableRow */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_TableColumn (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_TableColumn (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_TableColumn)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_TableColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_TableRow_cells (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_TableRow_cells (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_TableRow_cells)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_TableRow_cells */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_TableCell (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_TableCell (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_TableCell)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_TableCell */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_TableCell_columnRef (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_TableCell_columnRef (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_TableCell_columnRef)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_TableCell_columnRef */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_TableCell_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_TableCell_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_TableCell_content)) return (_currn);
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Frame)) return (globalFrameView_Mkrule_1(_coordref, _currn));
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_TableCell_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Formular_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Formular_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Formular_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Formular_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Formular_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Formular_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Formular_name)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Formular_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Formular_action (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Formular_action (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Formular_action)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Formular_action */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Formular_dataSource (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Formular_dataSource (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Formular_dataSource)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Formular_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Formular_dataSourceId (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Formular_dataSourceId (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Formular_dataSourceId)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Formular_dataSourceId */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Formular_elements (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Formular_elements)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Formular_elements */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_Formular_actualParams (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_Formular_actualParams (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_Formular_actualParams)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_Formular_actualParams */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_RegExprValidator_pattern (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_RegExprValidator_pattern (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_RegExprValidator_pattern)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_RegExprValidator_pattern */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_StringLengthValidator_min (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_StringLengthValidator_min (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_StringLengthValidator_min)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_StringLengthValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_StringLengthValidator_max (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_StringLengthValidator_max (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_StringLengthValidator_max)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_StringLengthValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_LongRangeValidator_min (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_LongRangeValidator_min (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_LongRangeValidator_min)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_LongRangeValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_LongRangeValidator_max (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_LongRangeValidator_max (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_LongRangeValidator_max)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_LongRangeValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DoubleRangeValidator_min (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DoubleRangeValidator_min (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DoubleRangeValidator_min)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DoubleRangeValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DoubleRangeValidator_max (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DoubleRangeValidator_max (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DoubleRangeValidator_max)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DoubleRangeValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_IntegerNumberConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_IntegerNumberConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_IntegerNumberConverter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_IntegerNumberConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_IntegerNumberConverter_minIntegerDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_IntegerNumberConverter_minIntegerDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_IntegerNumberConverter_minIntegerDigits)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_IntegerNumberConverter_minIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_IntegerNumberConverter_maxIntegerDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_IntegerNumberConverter_maxIntegerDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_IntegerNumberConverter_maxIntegerDigits)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_IntegerNumberConverter_maxIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DoubleNumberConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DoubleNumberConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DoubleNumberConverter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DoubleNumberConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DoubleNumberConverter_minIntegerDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DoubleNumberConverter_minIntegerDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DoubleNumberConverter_minIntegerDigits)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DoubleNumberConverter_minIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DoubleNumberConverter_maxIntegerDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DoubleNumberConverter_maxIntegerDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DoubleNumberConverter_maxIntegerDigits)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DoubleNumberConverter_maxIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DoubleNumberConverter_minFractionDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DoubleNumberConverter_minFractionDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DoubleNumberConverter_minFractionDigits)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DoubleNumberConverter_minFractionDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DoubleNumberConverter_maxFractionDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DoubleNumberConverter_maxFractionDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DoubleNumberConverter_maxFractionDigits)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DoubleNumberConverter_maxFractionDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_IntegerConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_IntegerConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_IntegerConverter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_IntegerConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_LongConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_LongConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_LongConverter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_LongConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_BigIntegerConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_BigIntegerConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_BigIntegerConverter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_BigIntegerConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FloatConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FloatConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FloatConverter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FloatConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DoubleConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DoubleConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DoubleConverter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DoubleConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_BooleanConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_BooleanConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_BooleanConverter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_BooleanConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_DateTimeConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_DateTimeConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_DateTimeConverter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_DateTimeConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_PatternConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_PatternConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_PatternConverter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_PatternConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_PatternConverter_pattern (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_PatternConverter_pattern (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_PatternConverter_pattern)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_PatternConverter_pattern */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement_name)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement_description)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_pvalue (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_pvalue (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement_pvalue)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement_pvalue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_required (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_required (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement_required)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement_required */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_converter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement_converter)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement_converter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_layout (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_layout (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement_layout)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement_layout */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_elements (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_elements (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement_elements)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement_elements */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_checked (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularRadioGroupElement_checked (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement_checked)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularRadioGroupElement_checked */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularConstantSelectOption_options (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularConstantSelectOption_options)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularConstantSelectOption_options */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_SelectOption (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_SelectOption (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_SelectOption)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_SelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_SelectOption_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_SelectOption_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_SelectOption_value)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_SelectOption_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_SelectOption_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_SelectOption_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_SelectOption_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_SelectOption_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularDataSourceSelectOption_name)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_dataSource (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_dataSource (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularDataSourceSelectOption_dataSource)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularDataSourceSelectOption_value)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_FormularDataSourceSelectOption_label)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_MD5Modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_MD5Modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_MD5Modifier)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_MD5Modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_JoinModifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_JoinModifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_JoinModifier)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_JoinModifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_JoinModifier_separator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_JoinModifier_separator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_JoinModifier_separator)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_JoinModifier_separator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeConstantExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeConstantExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeConstantExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeConstantExpression_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeConstantExpression_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeConstantExpression_value)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeVariableExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeVariableExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeVariableExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeVariableExpression_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeVariableExpression_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeVariableExpression_content)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeVariableExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeSessionExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeSessionExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeSessionExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_WebNodeSessionExpression_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_WebNodeSessionExpression_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_WebNodeSessionExpression_content)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_WebNodeSessionExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_OutputFragment_link (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_OutputFragment_link (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_OutputFragment_link)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_OutputFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_OutputFragment_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_OutputFragment_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_OutputFragment_content)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_OutputFragment_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_OutputMessagesElement_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_OutputMessagesElement_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_OutputMessagesElement_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_OutputMessagesElement_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_OutputMessagesElement_errorStyleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_OutputMessagesElement_errorStyleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_OutputMessagesElement_errorStyleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_OutputMessagesElement_errorStyleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_OutputMessagesElement_infoStyleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_OutputMessagesElement_infoStyleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_OutputMessagesElement_infoStyleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_OutputMessagesElement_infoStyleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_OutputMessagesElement_layout (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_OutputMessagesElement_layout (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_OutputMessagesElement_layout)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_OutputMessagesElement_layout */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputActualParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputActualParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputActualParam)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputActualParam_formalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputActualParam_formalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputActualParam_formalParam)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputActualParam_expression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputActualParam_expression)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputActualParam_expression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_name)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_dataSourceActualParams (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_dataSourceActualParams)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_dataSourceActualParams */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_dataSource (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_dataSource (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_dataSource)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_maxNumberOfElements (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_maxNumberOfElements (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_maxNumberOfElements)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_maxNumberOfElements */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_renderAs (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_renderAs (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_renderAs)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_renderAs */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_navigationElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_navigationElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_navigationElement)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_navigationElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_columns (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_columns (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_columns)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_columns */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_headerStyleClass (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_headerStyleClass (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_headerStyleClass)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_headerStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_evenRowStyleClass (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_evenRowStyleClass (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_evenRowStyleClass)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_evenRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_oddRowStyleClass (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputElement_oddRowStyleClass (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputElement_oddRowStyleClass)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputElement_oddRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputColumn (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputColumn (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputColumn)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputColumn_header (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputColumn_header (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputColumn_header)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputColumn_header */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputColumn_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputColumn_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputColumn_content)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputColumn_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputActionConnectionsContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputActionConnectionsContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputActionConnectionsContent)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputActionConnectionsContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputNumerationContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputNumerationContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputNumerationContent)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputNumerationContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputProjectionContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputProjectionContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputProjectionContent)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputProjectionContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputRefContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputRefContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputRefContent)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputRefContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputConstantContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputConstantContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputConstantContent)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputConstantContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputConstantContent_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputConstantContent_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputConstantContent_value)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputConstantContent_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputRefContent_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputRefContent_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputRefContent_column)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputRefContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputProjectionContent_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputProjectionContent_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputProjectionContent_column)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputProjectionContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputNumerationContent_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputNumerationContent_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputNumerationContent_name)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputNumerationContent_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ListOutputActionConnectionsContent_actionConnections (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ListOutputActionConnectionsContent_actionConnections)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ListOutputActionConnectionsContent_actionConnections */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ActionConnection (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ActionConnection (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ActionConnection)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ActionConnection */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ActionConnection_action (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ActionConnection_action (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ActionConnection_action)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ActionConnection_action */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ActionConnection_imageName (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ActionConnection_imageName (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ActionConnection_imageName)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ActionConnection_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ActionConnection_text (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ActionConnection_text (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ActionConnection_text)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ActionConnection_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ActionConnection_actualParams (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ActionConnection_actualParams)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ActionConnection_actualParams */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageMap_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageMap_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageMap_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageMap_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageMap_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageMap_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageMap_name)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageMap_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageMap_imageName (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageMap_imageName (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageMap_imageName)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageMap_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageMap_altText (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageMap_altText (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageMap_altText)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageMap_altText */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkglobalFrameView_ImageMap_mapAreas (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR globalFrameView_MkglobalFrameView_ImageMap_mapAreas (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (globalFrameView_IsSymb (_currn, globalFrameView_SYMBglobalFrameView_ImageMap_mapAreas)) return (_currn);
return(NULLNODEPTR);
}/* globalFrameView_MkglobalFrameView_ImageMap_mapAreas */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpEmpty (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpEmpty (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpEmpty _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpEmpty;
#else
_currn = (globalFrameView__TPPpEmpty) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpEmpty));
#endif
_currn->_prod = globalFrameView_RULEpEmpty;
_SETCOORD(_currn)
globalFrameView__TERMACT_pEmpty;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpEmpty */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpVIEWROOT_globalFrameView (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpVIEWROOT_globalFrameView (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpVIEWROOT_globalFrameView _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpVIEWROOT_globalFrameView;
#else
_currn = (globalFrameView__TPPpVIEWROOT_globalFrameView) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpVIEWROOT_globalFrameView));
#endif
_currn->_prod = globalFrameView_RULEpVIEWROOT_globalFrameView;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_GlobalFrame) globalFrameView_MkglobalFrameView_GlobalFrame (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pVIEWROOT_globalFrameView: root of subtree no. 1 can not be made a globalFrameView_GlobalFrame node ", 0, _coordref);
_COPYCOORD(_currn)
globalFrameView__TERMACT_pVIEWROOT_globalFrameView;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpVIEWROOT_globalFrameView */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularCheckboxElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularCheckboxElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularCheckboxElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularCheckboxElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularCheckboxElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularCheckboxElement_label) globalFrameView_MkglobalFrameView_FormularCheckboxElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularCheckboxElement: root of subtree no. 1 can not be made a globalFrameView_FormularCheckboxElement_label node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FormularCheckboxElement_type) globalFrameView_MkglobalFrameView_FormularCheckboxElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularCheckboxElement: root of subtree no. 2 can not be made a globalFrameView_FormularCheckboxElement_type node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_FormularCheckboxElement_validator) globalFrameView_MkglobalFrameView_FormularCheckboxElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularCheckboxElement: root of subtree no. 3 can not be made a globalFrameView_FormularCheckboxElement_validator node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_FormularCheckboxElement_description) globalFrameView_MkglobalFrameView_FormularCheckboxElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularCheckboxElement: root of subtree no. 4 can not be made a globalFrameView_FormularCheckboxElement_description node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularCheckboxElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularCheckboxElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularCheckboxElement_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularCheckboxElement_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularCheckboxElement_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularCheckboxElement_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularCheckboxElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement_name (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement_name (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_name _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularCheckboxElement_name;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_name) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularCheckboxElement_name));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularCheckboxElement_name;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularCheckboxElement_name;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularCheckboxElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement_type (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement_type (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_type _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularCheckboxElement_type;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_type) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularCheckboxElement_type));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularCheckboxElement_type;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularCheckboxElement_name) globalFrameView_MkglobalFrameView_FormularCheckboxElement_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularCheckboxElement_type: root of subtree no. 1 can not be made a globalFrameView_FormularCheckboxElement_name node ", 0, _coordref);
_COPYCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularCheckboxElement_type;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularCheckboxElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_EmailValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularCheckboxElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_CreditCardValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularCheckboxElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_RegExprValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularCheckboxElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_StringLengthValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularCheckboxElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_LongRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularCheckboxElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularCheckboxElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularCheckboxElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_EmailValidator)) 
		return globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, globalFrameView_MkglobalFrameView_EmailValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_CreditCardValidator)) 
		return globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, globalFrameView_MkglobalFrameView_CreditCardValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_RegExprValidator)) 
		return globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, globalFrameView_MkglobalFrameView_RegExprValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_StringLengthValidator)) 
		return globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, globalFrameView_MkglobalFrameView_StringLengthValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_LongRangeValidator)) 
		return globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, globalFrameView_MkglobalFrameView_LongRangeValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DoubleRangeValidator)) 
		return globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator (_coordref, globalFrameView_MkglobalFrameView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularCheckboxElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularCheckboxElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularCheckboxElement_validator)
	l =_ElempglobalFrameView_FormularCheckboxElement_validator (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularCheckboxElement_validator)
	r = _ElempglobalFrameView_FormularCheckboxElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_validator root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularCheckboxElement_validator)
		t = _ElempglobalFrameView_FormularCheckboxElement_validator (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator)(((globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularCheckboxElement_validator;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularCheckboxElement_validator));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularCheckboxElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularCheckboxElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator)
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularCheckboxElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator)
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularCheckboxElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator)
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularCheckboxElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator)
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularCheckboxElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator)
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularCheckboxElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator)
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularCheckboxElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularCheckboxElement_validator;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularCheckboxElement_validator));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularCheckboxElement_validator;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularCheckboxElement_validator)list;
{ globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_validator _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularCheckboxElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement_description (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularCheckboxElement_description (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_description _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularCheckboxElement_description;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularCheckboxElement_description) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularCheckboxElement_description));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularCheckboxElement_description;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularCheckboxElement_description;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularCheckboxElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularTextElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularTextElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularTextElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularTextElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularTextElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularTextElement_label) globalFrameView_MkglobalFrameView_FormularTextElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularTextElement: root of subtree no. 1 can not be made a globalFrameView_FormularTextElement_label node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FormularTextElement_type) globalFrameView_MkglobalFrameView_FormularTextElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularTextElement: root of subtree no. 2 can not be made a globalFrameView_FormularTextElement_type node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_FormularTextElement_validator) globalFrameView_MkglobalFrameView_FormularTextElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularTextElement: root of subtree no. 3 can not be made a globalFrameView_FormularTextElement_validator node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_FormularTextElement_description) globalFrameView_MkglobalFrameView_FormularTextElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularTextElement: root of subtree no. 4 can not be made a globalFrameView_FormularTextElement_description node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularTextElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularTextElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextElement_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextElement_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularTextElement_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularTextElement_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularTextElement_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularTextElement_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularTextElement_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularTextElement_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularTextElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextElement_type (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextElement_type (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularTextElement_type _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularTextElement_type;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularTextElement_type) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularTextElement_type));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularTextElement_type;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularTextElement_type;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularTextElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_EmailValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_CreditCardValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_RegExprValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_StringLengthValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_LongRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularTextElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularTextElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_EmailValidator)) 
		return globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator (_coordref, globalFrameView_MkglobalFrameView_EmailValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_CreditCardValidator)) 
		return globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator (_coordref, globalFrameView_MkglobalFrameView_CreditCardValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_RegExprValidator)) 
		return globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator (_coordref, globalFrameView_MkglobalFrameView_RegExprValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_StringLengthValidator)) 
		return globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator (_coordref, globalFrameView_MkglobalFrameView_StringLengthValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_LongRangeValidator)) 
		return globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator (_coordref, globalFrameView_MkglobalFrameView_LongRangeValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DoubleRangeValidator)) 
		return globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator (_coordref, globalFrameView_MkglobalFrameView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularTextElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularTextElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularTextElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularTextElement_validator)
	l =_ElempglobalFrameView_FormularTextElement_validator (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularTextElement_validator)
	r = _ElempglobalFrameView_FormularTextElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularTextElement_validator root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularTextElement_validator)
		t = _ElempglobalFrameView_FormularTextElement_validator (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator)(((globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularTextElement_validator;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularTextElement_validator));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularTextElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularTextElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator)
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator)
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator)
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator)
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator)
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator)
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularTextElement_validator;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularTextElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularTextElement_validator));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularTextElement_validator;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularTextElement_validator)list;
{ globalFrameView__TPPpglobalFrameView_FormularTextElement_validator _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularTextElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextElement_description (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextElement_description (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularTextElement_description _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularTextElement_description;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularTextElement_description) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularTextElement_description));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularTextElement_description;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularTextElement_description;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularTextElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularDateElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularDateElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularDateElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularDateElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularDateElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularDateElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularDateElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularDateElement_label) globalFrameView_MkglobalFrameView_FormularDateElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularDateElement: root of subtree no. 1 can not be made a globalFrameView_FormularDateElement_label node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FormularDateElement_type) globalFrameView_MkglobalFrameView_FormularDateElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularDateElement: root of subtree no. 2 can not be made a globalFrameView_FormularDateElement_type node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_FormularDateElement_validator) globalFrameView_MkglobalFrameView_FormularDateElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularDateElement: root of subtree no. 3 can not be made a globalFrameView_FormularDateElement_validator node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_FormularDateElement_description) globalFrameView_MkglobalFrameView_FormularDateElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularDateElement: root of subtree no. 4 can not be made a globalFrameView_FormularDateElement_description node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularDateElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularDateElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularDateElement_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularDateElement_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularDateElement_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularDateElement_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularDateElement_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularDateElement_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularDateElement_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularDateElement_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularDateElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularDateElement_type (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularDateElement_type (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularDateElement_type _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularDateElement_type;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularDateElement_type) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularDateElement_type));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularDateElement_type;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularDateElement_type;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularDateElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_EmailValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularDateElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_CreditCardValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularDateElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_RegExprValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularDateElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_StringLengthValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularDateElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_LongRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularDateElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularDateElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularDateElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularDateElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_EmailValidator)) 
		return globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator (_coordref, globalFrameView_MkglobalFrameView_EmailValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_CreditCardValidator)) 
		return globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator (_coordref, globalFrameView_MkglobalFrameView_CreditCardValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_RegExprValidator)) 
		return globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator (_coordref, globalFrameView_MkglobalFrameView_RegExprValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_StringLengthValidator)) 
		return globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator (_coordref, globalFrameView_MkglobalFrameView_StringLengthValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_LongRangeValidator)) 
		return globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator (_coordref, globalFrameView_MkglobalFrameView_LongRangeValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DoubleRangeValidator)) 
		return globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator (_coordref, globalFrameView_MkglobalFrameView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularDateElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularDateElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularDateElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularDateElement_validator)
	l =_ElempglobalFrameView_FormularDateElement_validator (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularDateElement_validator)
	r = _ElempglobalFrameView_FormularDateElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularDateElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularDateElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularDateElement_validator root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularDateElement_validator)
		t = _ElempglobalFrameView_FormularDateElement_validator (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator)(((globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularDateElement_validator;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularDateElement_validator));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularDateElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularDateElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator)
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularDateElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularDateElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator)
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularDateElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularDateElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator)
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularDateElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularDateElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator)
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularDateElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularDateElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator)
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularDateElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularDateElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator)
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularDateElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularDateElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularDateElement_validator;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularDateElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularDateElement_validator));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularDateElement_validator;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularDateElement_validator)list;
{ globalFrameView__TPPpglobalFrameView_FormularDateElement_validator _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularDateElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularDateElement_description (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularDateElement_description (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularDateElement_description _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularDateElement_description;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularDateElement_description) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularDateElement_description));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularDateElement_description;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularDateElement_description;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularDateElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularFileUploadElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularFileUploadElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularFileUploadElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularFileUploadElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularFileUploadElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularFileUploadElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularFileUploadElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularFileUploadElement_label) globalFrameView_MkglobalFrameView_FormularFileUploadElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularFileUploadElement: root of subtree no. 1 can not be made a globalFrameView_FormularFileUploadElement_label node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FormularFileUploadElement_type) globalFrameView_MkglobalFrameView_FormularFileUploadElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularFileUploadElement: root of subtree no. 2 can not be made a globalFrameView_FormularFileUploadElement_type node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_FormularFileUploadElement_validator) globalFrameView_MkglobalFrameView_FormularFileUploadElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularFileUploadElement: root of subtree no. 3 can not be made a globalFrameView_FormularFileUploadElement_validator node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_FormularFileUploadElement_description) globalFrameView_MkglobalFrameView_FormularFileUploadElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularFileUploadElement: root of subtree no. 4 can not be made a globalFrameView_FormularFileUploadElement_description node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularFileUploadElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularFileUploadElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularFileUploadElement_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularFileUploadElement_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularFileUploadElement_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularFileUploadElement_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularFileUploadElement_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularFileUploadElement_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularFileUploadElement_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularFileUploadElement_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularFileUploadElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularFileUploadElement_type (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularFileUploadElement_type (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularFileUploadElement_type _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularFileUploadElement_type;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularFileUploadElement_type) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularFileUploadElement_type));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularFileUploadElement_type;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularFileUploadElement_type;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularFileUploadElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_EmailValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularFileUploadElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_CreditCardValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularFileUploadElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_RegExprValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularFileUploadElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_StringLengthValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularFileUploadElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_LongRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularFileUploadElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularFileUploadElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularFileUploadElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_EmailValidator)) 
		return globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, globalFrameView_MkglobalFrameView_EmailValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_CreditCardValidator)) 
		return globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, globalFrameView_MkglobalFrameView_CreditCardValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_RegExprValidator)) 
		return globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, globalFrameView_MkglobalFrameView_RegExprValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_StringLengthValidator)) 
		return globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, globalFrameView_MkglobalFrameView_StringLengthValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_LongRangeValidator)) 
		return globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, globalFrameView_MkglobalFrameView_LongRangeValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DoubleRangeValidator)) 
		return globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator (_coordref, globalFrameView_MkglobalFrameView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularFileUploadElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularFileUploadElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularFileUploadElement_validator)
	l =_ElempglobalFrameView_FormularFileUploadElement_validator (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularFileUploadElement_validator)
	r = _ElempglobalFrameView_FormularFileUploadElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularFileUploadElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularFileUploadElement_validator root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularFileUploadElement_validator)
		t = _ElempglobalFrameView_FormularFileUploadElement_validator (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator)(((globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularFileUploadElement_validator;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularFileUploadElement_validator));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularFileUploadElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularFileUploadElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator)
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularFileUploadElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator)
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularFileUploadElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator)
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularFileUploadElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator)
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularFileUploadElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator)
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularFileUploadElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator)
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularFileUploadElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularFileUploadElement_validator;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularFileUploadElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularFileUploadElement_validator));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularFileUploadElement_validator;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularFileUploadElement_validator)list;
{ globalFrameView__TPPpglobalFrameView_FormularFileUploadElement_validator _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularFileUploadElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularFileUploadElement_description (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularFileUploadElement_description (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularFileUploadElement_description _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularFileUploadElement_description;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularFileUploadElement_description) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularFileUploadElement_description));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularFileUploadElement_description;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularFileUploadElement_description;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularFileUploadElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularPasswordElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularPasswordElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularPasswordElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularPasswordElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularPasswordElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularPasswordElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularPasswordElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularPasswordElement_label) globalFrameView_MkglobalFrameView_FormularPasswordElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularPasswordElement: root of subtree no. 1 can not be made a globalFrameView_FormularPasswordElement_label node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FormularPasswordElement_type) globalFrameView_MkglobalFrameView_FormularPasswordElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularPasswordElement: root of subtree no. 2 can not be made a globalFrameView_FormularPasswordElement_type node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_FormularPasswordElement_validator) globalFrameView_MkglobalFrameView_FormularPasswordElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularPasswordElement: root of subtree no. 3 can not be made a globalFrameView_FormularPasswordElement_validator node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_FormularPasswordElement_description) globalFrameView_MkglobalFrameView_FormularPasswordElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularPasswordElement: root of subtree no. 4 can not be made a globalFrameView_FormularPasswordElement_description node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularPasswordElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularPasswordElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularPasswordElement_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularPasswordElement_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularPasswordElement_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularPasswordElement_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularPasswordElement_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularPasswordElement_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularPasswordElement_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularPasswordElement_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularPasswordElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularPasswordElement_type (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularPasswordElement_type (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularPasswordElement_type _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularPasswordElement_type;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularPasswordElement_type) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularPasswordElement_type));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularPasswordElement_type;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularPasswordElement_type;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularPasswordElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_EmailValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularPasswordElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_CreditCardValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularPasswordElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_RegExprValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularPasswordElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_StringLengthValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularPasswordElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_LongRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularPasswordElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularPasswordElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularPasswordElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_EmailValidator)) 
		return globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, globalFrameView_MkglobalFrameView_EmailValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_CreditCardValidator)) 
		return globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, globalFrameView_MkglobalFrameView_CreditCardValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_RegExprValidator)) 
		return globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, globalFrameView_MkglobalFrameView_RegExprValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_StringLengthValidator)) 
		return globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, globalFrameView_MkglobalFrameView_StringLengthValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_LongRangeValidator)) 
		return globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, globalFrameView_MkglobalFrameView_LongRangeValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DoubleRangeValidator)) 
		return globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator (_coordref, globalFrameView_MkglobalFrameView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularPasswordElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularPasswordElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularPasswordElement_validator)
	l =_ElempglobalFrameView_FormularPasswordElement_validator (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularPasswordElement_validator)
	r = _ElempglobalFrameView_FormularPasswordElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularPasswordElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularPasswordElement_validator root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularPasswordElement_validator)
		t = _ElempglobalFrameView_FormularPasswordElement_validator (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator)(((globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularPasswordElement_validator;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularPasswordElement_validator));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularPasswordElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularPasswordElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator)
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularPasswordElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularPasswordElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator)
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularPasswordElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularPasswordElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator)
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularPasswordElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularPasswordElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator)
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularPasswordElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularPasswordElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator)
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularPasswordElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularPasswordElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator)
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularPasswordElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularPasswordElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularPasswordElement_validator;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularPasswordElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularPasswordElement_validator));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularPasswordElement_validator;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularPasswordElement_validator)list;
{ globalFrameView__TPPpglobalFrameView_FormularPasswordElement_validator _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularPasswordElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularPasswordElement_description (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularPasswordElement_description (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularPasswordElement_description _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularPasswordElement_description;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularPasswordElement_description) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularPasswordElement_description));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularPasswordElement_description;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularPasswordElement_description;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularPasswordElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextAreaElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextAreaElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularTextAreaElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularTextAreaElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularTextAreaElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularTextAreaElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularTextAreaElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularTextAreaElement_label) globalFrameView_MkglobalFrameView_FormularTextAreaElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularTextAreaElement: root of subtree no. 1 can not be made a globalFrameView_FormularTextAreaElement_label node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FormularTextAreaElement_type) globalFrameView_MkglobalFrameView_FormularTextAreaElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularTextAreaElement: root of subtree no. 2 can not be made a globalFrameView_FormularTextAreaElement_type node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_FormularTextAreaElement_validator) globalFrameView_MkglobalFrameView_FormularTextAreaElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularTextAreaElement: root of subtree no. 3 can not be made a globalFrameView_FormularTextAreaElement_validator node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_FormularTextAreaElement_description) globalFrameView_MkglobalFrameView_FormularTextAreaElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularTextAreaElement: root of subtree no. 4 can not be made a globalFrameView_FormularTextAreaElement_description node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularTextAreaElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularTextAreaElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextAreaElement_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextAreaElement_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularTextAreaElement_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularTextAreaElement_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularTextAreaElement_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularTextAreaElement_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularTextAreaElement_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularTextAreaElement_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularTextAreaElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextAreaElement_type (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextAreaElement_type (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularTextAreaElement_type _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularTextAreaElement_type;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularTextAreaElement_type) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularTextAreaElement_type));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularTextAreaElement_type;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularTextAreaElement_type;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularTextAreaElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_EmailValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextAreaElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_CreditCardValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextAreaElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_RegExprValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextAreaElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_StringLengthValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextAreaElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_LongRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextAreaElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularTextAreaElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularTextAreaElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_EmailValidator)) 
		return globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, globalFrameView_MkglobalFrameView_EmailValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_CreditCardValidator)) 
		return globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, globalFrameView_MkglobalFrameView_CreditCardValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_RegExprValidator)) 
		return globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, globalFrameView_MkglobalFrameView_RegExprValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_StringLengthValidator)) 
		return globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, globalFrameView_MkglobalFrameView_StringLengthValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_LongRangeValidator)) 
		return globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, globalFrameView_MkglobalFrameView_LongRangeValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DoubleRangeValidator)) 
		return globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator (_coordref, globalFrameView_MkglobalFrameView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularTextAreaElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularTextAreaElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularTextAreaElement_validator)
	l =_ElempglobalFrameView_FormularTextAreaElement_validator (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularTextAreaElement_validator)
	r = _ElempglobalFrameView_FormularTextAreaElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextAreaElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularTextAreaElement_validator root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularTextAreaElement_validator)
		t = _ElempglobalFrameView_FormularTextAreaElement_validator (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator)(((globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularTextAreaElement_validator;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularTextAreaElement_validator));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularTextAreaElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularTextAreaElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator)
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextAreaElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator)
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextAreaElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator)
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextAreaElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator)
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextAreaElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator)
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextAreaElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator)
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularTextAreaElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularTextAreaElement_validator;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularTextAreaElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularTextAreaElement_validator));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularTextAreaElement_validator;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularTextAreaElement_validator)list;
{ globalFrameView__TPPpglobalFrameView_FormularTextAreaElement_validator _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularTextAreaElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextAreaElement_description (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularTextAreaElement_description (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularTextAreaElement_description _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularTextAreaElement_description;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularTextAreaElement_description) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularTextAreaElement_description));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularTextAreaElement_description;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularTextAreaElement_description;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularTextAreaElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularSelectElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularSelectElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularSelectElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularSelectElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularSelectElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularSelectElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularSelectElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularSelectElement_label) globalFrameView_MkglobalFrameView_FormularSelectElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularSelectElement: root of subtree no. 1 can not be made a globalFrameView_FormularSelectElement_label node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FormularSelectElement_multiple) globalFrameView_MkglobalFrameView_FormularSelectElement_multiple (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularSelectElement: root of subtree no. 2 can not be made a globalFrameView_FormularSelectElement_multiple node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_FormularSelectElement_options) globalFrameView_MkglobalFrameView_FormularSelectElement_options (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularSelectElement: root of subtree no. 3 can not be made a globalFrameView_FormularSelectElement_options node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_FormularSelectElement_description) globalFrameView_MkglobalFrameView_FormularSelectElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularSelectElement: root of subtree no. 4 can not be made a globalFrameView_FormularSelectElement_description node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularSelectElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularSelectElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularSelectElement_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularSelectElement_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularSelectElement_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularSelectElement_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularSelectElement_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularSelectElement_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularSelectElement_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularSelectElement_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularSelectElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularSelectElement_multiple (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularSelectElement_multiple (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularSelectElement_multiple _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularSelectElement_multiple;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularSelectElement_multiple) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularSelectElement_multiple));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularSelectElement_multiple;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularSelectElement_multiple;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularSelectElement_multiple */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularConstantSelectOption)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularSelectElement_options)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularDataSourceSelectOption)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularSelectElement_options)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularSelectElement_options (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularSelectElement_options (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularConstantSelectOption)) 
		return globalFrameView__MkglobalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options (_coordref, globalFrameView_MkglobalFrameView_FormularConstantSelectOption (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularDataSourceSelectOption)) 
		return globalFrameView__MkglobalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options (_coordref, globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularSelectElement_options list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularSelectElement_options (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularSelectElement_options (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularSelectElement_options)
	l =_ElempglobalFrameView_FormularSelectElement_options (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularSelectElement_options)
	r = _ElempglobalFrameView_FormularSelectElement_options (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularSelectElement_options (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularSelectElement_options (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularSelectElement_options root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularSelectElement_options)
		t = _ElempglobalFrameView_FormularSelectElement_options (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options)(((globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularSelectElement_options;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularSelectElement_options));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularSelectElement_options;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularSelectElement_options)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options)
	{globalFrameView__TPPLST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularConstantSelectOptionpglobalFrameView_FormularSelectElement_options;
	} this code has been moved to _ElempglobalFrameView_FormularSelectElement_options*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options)
	{globalFrameView__TPPLST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularDataSourceSelectOptionpglobalFrameView_FormularSelectElement_options;
	} this code has been moved to _ElempglobalFrameView_FormularSelectElement_options*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularSelectElement_options;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularSelectElement_options) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularSelectElement_options));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularSelectElement_options;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularSelectElement_options)list;
{ globalFrameView__TPPpglobalFrameView_FormularSelectElement_options _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularSelectElement_options;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularSelectElement_description (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularSelectElement_description (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularSelectElement_description _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularSelectElement_description;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularSelectElement_description) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularSelectElement_description));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularSelectElement_description;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularSelectElement_description;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularSelectElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioElement (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularRadioElement_type) globalFrameView_MkglobalFrameView_FormularRadioElement_type (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioElement: root of subtree no. 1 can not be made a globalFrameView_FormularRadioElement_type node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FormularRadioElement_label) globalFrameView_MkglobalFrameView_FormularRadioElement_label (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioElement: root of subtree no. 2 can not be made a globalFrameView_FormularRadioElement_label node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioElement_type (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioElement_type (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioElement_type _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioElement_type;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioElement_type) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioElement_type));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioElement_type;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioElement_type;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioElement_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioElement_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioElement_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioElement_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioElement_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioElement_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioElement_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioElement_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DataSourceActualParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DataSourceActualParam (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	globalFrameView__TPPpglobalFrameView_DataSourceActualParam _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DataSourceActualParam;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DataSourceActualParam) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DataSourceActualParam));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DataSourceActualParam;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_DataSourceActualParam_formalParam) globalFrameView_MkglobalFrameView_DataSourceActualParam_formalParam (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_DataSourceActualParam: root of subtree no. 1 can not be made a globalFrameView_DataSourceActualParam_formalParam node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_DataSourceActualParam_keyword1) globalFrameView_MkglobalFrameView_DataSourceActualParam_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_DataSourceActualParam: root of subtree no. 2 can not be made a globalFrameView_DataSourceActualParam_keyword1 node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_DataSourceActualParam_expressions) globalFrameView_MkglobalFrameView_DataSourceActualParam_expressions (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_DataSourceActualParam: root of subtree no. 3 can not be made a globalFrameView_DataSourceActualParam_expressions node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DataSourceActualParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DataSourceActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DataSourceActualParam_formalParam (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DataSourceActualParam_formalParam (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_DataSourceActualParam_formalParam _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DataSourceActualParam_formalParam;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DataSourceActualParam_formalParam) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DataSourceActualParam_formalParam));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DataSourceActualParam_formalParam;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DataSourceActualParam_formalParam;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DataSourceActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DataSourceActualParam_keyword1 (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DataSourceActualParam_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_DataSourceActualParam_keyword1 _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DataSourceActualParam_keyword1;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DataSourceActualParam_keyword1) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DataSourceActualParam_keyword1));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DataSourceActualParam_keyword1;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DataSourceActualParam_keyword1;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DataSourceActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeConstantExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_DataSourceActualParam_expressions)_new;
	{globalFrameView__TPPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeVariableExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_DataSourceActualParam_expressions)_new;
	{globalFrameView__TPPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeSessionExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_DataSourceActualParam_expressions)_new;
	{globalFrameView__TPPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_DataSourceActualParam_expressions (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_WebNodeConstantExpression)) 
		return globalFrameView__MkglobalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions (_coordref, globalFrameView_MkglobalFrameView_WebNodeConstantExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_WebNodeVariableExpression)) 
		return globalFrameView__MkglobalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions (_coordref, globalFrameView_MkglobalFrameView_WebNodeVariableExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_WebNodeSessionExpression)) 
		return globalFrameView__MkglobalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions (_coordref, globalFrameView_MkglobalFrameView_WebNodeSessionExpression (_coordref, t));
	message (DEADLY, "a pglobalFrameView_DataSourceActualParam_expressions list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_DataSourceActualParam_expressions (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_DataSourceActualParam_expressions)
	l =_ElempglobalFrameView_DataSourceActualParam_expressions (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_DataSourceActualParam_expressions)
	r = _ElempglobalFrameView_DataSourceActualParam_expressions (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DataSourceActualParam_expressions (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_DataSourceActualParam_expressions root;
	globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_DataSourceActualParam_expressions)
		t = _ElempglobalFrameView_DataSourceActualParam_expressions (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions)(((globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_DataSourceActualParam_expressions;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_DataSourceActualParam_expressions));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_DataSourceActualParam_expressions;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_DataSourceActualParam_expressions)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions)
	{globalFrameView__TPPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_DataSourceActualParam_expressions;
	} this code has been moved to _ElempglobalFrameView_DataSourceActualParam_expressions*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions)
	{globalFrameView__TPPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_DataSourceActualParam_expressions;
	} this code has been moved to _ElempglobalFrameView_DataSourceActualParam_expressions*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions)
	{globalFrameView__TPPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_DataSourceActualParam_expressions;
	} this code has been moved to _ElempglobalFrameView_DataSourceActualParam_expressions*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_DataSourceActualParam_expressions;
#else
root = (globalFrameView__TPPpglobalFrameView_DataSourceActualParam_expressions) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DataSourceActualParam_expressions));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_DataSourceActualParam_expressions;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_DataSourceActualParam_expressions)list;
{ globalFrameView__TPPpglobalFrameView_DataSourceActualParam_expressions _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_DataSourceActualParam_expressions;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeActualParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeActualParam (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	globalFrameView__TPPpglobalFrameView_WebNodeActualParam _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_WebNodeActualParam;
#else
_currn = (globalFrameView__TPPpglobalFrameView_WebNodeActualParam) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeActualParam));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_WebNodeActualParam;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeActualParam_formalParam) globalFrameView_MkglobalFrameView_WebNodeActualParam_formalParam (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_WebNodeActualParam: root of subtree no. 1 can not be made a globalFrameView_WebNodeActualParam_formalParam node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_WebNodeActualParam_keyword1) globalFrameView_MkglobalFrameView_WebNodeActualParam_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_WebNodeActualParam: root of subtree no. 2 can not be made a globalFrameView_WebNodeActualParam_keyword1 node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_WebNodeActualParam_expressions) globalFrameView_MkglobalFrameView_WebNodeActualParam_expressions (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_WebNodeActualParam: root of subtree no. 3 can not be made a globalFrameView_WebNodeActualParam_expressions node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_WebNodeActualParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_WebNodeActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeActualParam_formalParam (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeActualParam_formalParam (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_WebNodeActualParam_formalParam _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_WebNodeActualParam_formalParam;
#else
_currn = (globalFrameView__TPPpglobalFrameView_WebNodeActualParam_formalParam) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeActualParam_formalParam));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_WebNodeActualParam_formalParam;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_WebNodeActualParam_formalParam;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_WebNodeActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeActualParam_keyword1 (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeActualParam_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_WebNodeActualParam_keyword1 _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_WebNodeActualParam_keyword1;
#else
_currn = (globalFrameView__TPPpglobalFrameView_WebNodeActualParam_keyword1) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeActualParam_keyword1));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_WebNodeActualParam_keyword1;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_WebNodeActualParam_keyword1;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_WebNodeActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeConstantExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_WebNodeActualParam_expressions)_new;
	{globalFrameView__TPPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeVariableExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_WebNodeActualParam_expressions)_new;
	{globalFrameView__TPPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeSessionExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_WebNodeActualParam_expressions)_new;
	{globalFrameView__TPPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_WebNodeActualParam_expressions (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_WebNodeConstantExpression)) 
		return globalFrameView__MkglobalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions (_coordref, globalFrameView_MkglobalFrameView_WebNodeConstantExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_WebNodeVariableExpression)) 
		return globalFrameView__MkglobalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions (_coordref, globalFrameView_MkglobalFrameView_WebNodeVariableExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_WebNodeSessionExpression)) 
		return globalFrameView__MkglobalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions (_coordref, globalFrameView_MkglobalFrameView_WebNodeSessionExpression (_coordref, t));
	message (DEADLY, "a pglobalFrameView_WebNodeActualParam_expressions list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_WebNodeActualParam_expressions (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeActualParam_expressions)
	l =_ElempglobalFrameView_WebNodeActualParam_expressions (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeActualParam_expressions)
	r = _ElempglobalFrameView_WebNodeActualParam_expressions (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeActualParam_expressions (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_WebNodeActualParam_expressions root;
	globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeActualParam_expressions)
		t = _ElempglobalFrameView_WebNodeActualParam_expressions (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions)(((globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_WebNodeActualParam_expressions;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_WebNodeActualParam_expressions));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_WebNodeActualParam_expressions;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeActualParam_expressions)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions)
	{globalFrameView__TPPLST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeConstantExpressionpglobalFrameView_WebNodeActualParam_expressions;
	} this code has been moved to _ElempglobalFrameView_WebNodeActualParam_expressions*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions)
	{globalFrameView__TPPLST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeVariableExpressionpglobalFrameView_WebNodeActualParam_expressions;
	} this code has been moved to _ElempglobalFrameView_WebNodeActualParam_expressions*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions)
	{globalFrameView__TPPLST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeSessionExpressionpglobalFrameView_WebNodeActualParam_expressions;
	} this code has been moved to _ElempglobalFrameView_WebNodeActualParam_expressions*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_WebNodeActualParam_expressions;
#else
root = (globalFrameView__TPPpglobalFrameView_WebNodeActualParam_expressions) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeActualParam_expressions));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_WebNodeActualParam_expressions;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_WebNodeActualParam_expressions)list;
{ globalFrameView__TPPpglobalFrameView_WebNodeActualParam_expressions _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_WebNodeActualParam_expressions;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_MapArea (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6)
#else
NODEPTR globalFrameView_MkpglobalFrameView_MapArea (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
#endif
{	globalFrameView__TPPpglobalFrameView_MapArea _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_MapArea;
#else
_currn = (globalFrameView__TPPpglobalFrameView_MapArea) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_MapArea));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_MapArea;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_MapArea_altText) globalFrameView_MkglobalFrameView_MapArea_altText (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_MapArea: root of subtree no. 1 can not be made a globalFrameView_MapArea_altText node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_MapArea_keyword1) globalFrameView_MkglobalFrameView_MapArea_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_MapArea: root of subtree no. 2 can not be made a globalFrameView_MapArea_keyword1 node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_MapArea_coords) globalFrameView_MkglobalFrameView_MapArea_coords (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_MapArea: root of subtree no. 3 can not be made a globalFrameView_MapArea_coords node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_MapArea_keyword2) globalFrameView_MkglobalFrameView_MapArea_keyword2 (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_MapArea: root of subtree no. 4 can not be made a globalFrameView_MapArea_keyword2 node ", 0, _coordref);
_currn->_desc5 = (globalFrameView__TSPglobalFrameView_MapArea_link) globalFrameView_MkglobalFrameView_MapArea_link (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_MapArea: root of subtree no. 5 can not be made a globalFrameView_MapArea_link node ", 0, _coordref);
_currn->_desc6 = (globalFrameView__TSPglobalFrameView_MapArea_queryString) globalFrameView_MkglobalFrameView_MapArea_queryString (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_MapArea: root of subtree no. 6 can not be made a globalFrameView_MapArea_queryString node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_MapArea;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_MapArea */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_altText (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_altText (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_MapArea_altText _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_MapArea_altText;
#else
_currn = (globalFrameView__TPPpglobalFrameView_MapArea_altText) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_MapArea_altText));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_MapArea_altText;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_MapArea_altText;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_MapArea_altText */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_keyword1 (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_MapArea_keyword1 _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_MapArea_keyword1;
#else
_currn = (globalFrameView__TPPpglobalFrameView_MapArea_keyword1) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_MapArea_keyword1));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_MapArea_keyword1;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_MapArea_keyword1;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_MapArea_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_coords (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_coords (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_MapArea_coords _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_MapArea_coords;
#else
_currn = (globalFrameView__TPPpglobalFrameView_MapArea_coords) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_MapArea_coords));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_MapArea_coords;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_MapArea_coords;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_MapArea_coords */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_keyword2 (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_keyword2 (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_MapArea_keyword2 _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_MapArea_keyword2;
#else
_currn = (globalFrameView__TPPpglobalFrameView_MapArea_keyword2) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_MapArea_keyword2));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_MapArea_keyword2;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_MapArea_keyword2;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_MapArea_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_link (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_link (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_MapArea_link _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_MapArea_link;
#else
_currn = (globalFrameView__TPPpglobalFrameView_MapArea_link) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_MapArea_link));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_MapArea_link;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_MapArea_link;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_MapArea_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_queryString (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_MapArea_queryString (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_MapArea_queryString _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_MapArea_queryString;
#else
_currn = (globalFrameView__TPPpglobalFrameView_MapArea_queryString) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_MapArea_queryString));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_MapArea_queryString;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_MapArea_queryString;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_MapArea_queryString */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Frame (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Frame (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_Frame _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Frame;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Frame) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Frame));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Frame;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_Frame_components) globalFrameView_MkglobalFrameView_Frame_components (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Frame: root of subtree no. 1 can not be made a globalFrameView_Frame_components node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Frame;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Frame */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FrameRefpglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FrameRefpglobalFrameView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FrameRefpglobalFrameView_Frame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FrameRefpglobalFrameView_Frame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FrameRefpglobalFrameView_Frame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FrameRefpglobalFrameView_Frame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FrameRefpglobalFrameView_Frame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FrameRef)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Frame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_FrameRefpglobalFrameView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FrameRefpglobalFrameView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ParagraphpglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ParagraphpglobalFrameView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ParagraphpglobalFrameView_Frame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ParagraphpglobalFrameView_Frame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ParagraphpglobalFrameView_Frame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ParagraphpglobalFrameView_Frame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ParagraphpglobalFrameView_Frame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_Paragraph)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Frame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_ParagraphpglobalFrameView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ParagraphpglobalFrameView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_HeadingpglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_HeadingpglobalFrameView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_HeadingpglobalFrameView_Frame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_HeadingpglobalFrameView_Frame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_HeadingpglobalFrameView_Frame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_HeadingpglobalFrameView_Frame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_HeadingpglobalFrameView_Frame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_Heading)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Frame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_HeadingpglobalFrameView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_HeadingpglobalFrameView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_TablepglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_TablepglobalFrameView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_TablepglobalFrameView_Frame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_TablepglobalFrameView_Frame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_TablepglobalFrameView_Frame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_TablepglobalFrameView_Frame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_TablepglobalFrameView_Frame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_Table)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Frame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_TablepglobalFrameView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_TablepglobalFrameView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularpglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularpglobalFrameView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularpglobalFrameView_Frame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularpglobalFrameView_Frame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularpglobalFrameView_Frame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularpglobalFrameView_Frame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularpglobalFrameView_Frame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_Formular)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Frame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularpglobalFrameView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularpglobalFrameView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_OutputMessagesElementpglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_OutputMessagesElementpglobalFrameView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_OutputMessagesElementpglobalFrameView_Frame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_OutputMessagesElementpglobalFrameView_Frame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_OutputMessagesElementpglobalFrameView_Frame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_OutputMessagesElementpglobalFrameView_Frame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_OutputMessagesElementpglobalFrameView_Frame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_OutputMessagesElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Frame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_OutputMessagesElementpglobalFrameView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_OutputMessagesElementpglobalFrameView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputElementpglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputElementpglobalFrameView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Frame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ImageMappglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ImageMappglobalFrameView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ImageMappglobalFrameView_Frame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ImageMappglobalFrameView_Frame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ImageMappglobalFrameView_Frame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ImageMappglobalFrameView_Frame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ImageMappglobalFrameView_Frame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ImageMap)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Frame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_ImageMappglobalFrameView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ImageMappglobalFrameView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_Frame_components (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FrameRef)) 
		return globalFrameView__MkglobalFrameView_FrameRefpglobalFrameView_Frame_components (_coordref, globalFrameView_MkglobalFrameView_FrameRef (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_Paragraph)) 
		return globalFrameView__MkglobalFrameView_ParagraphpglobalFrameView_Frame_components (_coordref, globalFrameView_MkglobalFrameView_Paragraph (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_Heading)) 
		return globalFrameView__MkglobalFrameView_HeadingpglobalFrameView_Frame_components (_coordref, globalFrameView_MkglobalFrameView_Heading (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_Table)) 
		return globalFrameView__MkglobalFrameView_TablepglobalFrameView_Frame_components (_coordref, globalFrameView_MkglobalFrameView_Table (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_Formular)) 
		return globalFrameView__MkglobalFrameView_FormularpglobalFrameView_Frame_components (_coordref, globalFrameView_MkglobalFrameView_Formular (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_OutputMessagesElement)) 
		return globalFrameView__MkglobalFrameView_OutputMessagesElementpglobalFrameView_Frame_components (_coordref, globalFrameView_MkglobalFrameView_OutputMessagesElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ListOutputElement)) 
		return globalFrameView__MkglobalFrameView_ListOutputElementpglobalFrameView_Frame_components (_coordref, globalFrameView_MkglobalFrameView_ListOutputElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ImageMap)) 
		return globalFrameView__MkglobalFrameView_ImageMappglobalFrameView_Frame_components (_coordref, globalFrameView_MkglobalFrameView_ImageMap (_coordref, t));
	message (DEADLY, "a pglobalFrameView_Frame_components list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_Frame_components (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_Frame_components)
	l =_ElempglobalFrameView_Frame_components (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_Frame_components)
	r = _ElempglobalFrameView_Frame_components (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_Frame_components)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_Frame_components)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_Frame_components)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_Frame_components)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Frame_components (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Frame_components (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_Frame_components root;
	globalFrameView__TPPLST_0pglobalFrameView_Frame_components list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Frame_components)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_Frame_components)
		t = _ElempglobalFrameView_Frame_components (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Frame_components)(((globalFrameView__TPPLST_0pglobalFrameView_Frame_components) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_Frame_components) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_Frame_components;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_Frame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_Frame_components));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_Frame_components;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_Frame_components)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FrameRefpglobalFrameView_Frame_components)
	{globalFrameView__TPPLST_globalFrameView_FrameRefpglobalFrameView_Frame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FrameRefpglobalFrameView_Frame_components;
	} this code has been moved to _ElempglobalFrameView_Frame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ParagraphpglobalFrameView_Frame_components)
	{globalFrameView__TPPLST_globalFrameView_ParagraphpglobalFrameView_Frame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ParagraphpglobalFrameView_Frame_components;
	} this code has been moved to _ElempglobalFrameView_Frame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_HeadingpglobalFrameView_Frame_components)
	{globalFrameView__TPPLST_globalFrameView_HeadingpglobalFrameView_Frame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_HeadingpglobalFrameView_Frame_components;
	} this code has been moved to _ElempglobalFrameView_Frame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_TablepglobalFrameView_Frame_components)
	{globalFrameView__TPPLST_globalFrameView_TablepglobalFrameView_Frame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_TablepglobalFrameView_Frame_components;
	} this code has been moved to _ElempglobalFrameView_Frame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularpglobalFrameView_Frame_components)
	{globalFrameView__TPPLST_globalFrameView_FormularpglobalFrameView_Frame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularpglobalFrameView_Frame_components;
	} this code has been moved to _ElempglobalFrameView_Frame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_OutputMessagesElementpglobalFrameView_Frame_components)
	{globalFrameView__TPPLST_globalFrameView_OutputMessagesElementpglobalFrameView_Frame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_OutputMessagesElementpglobalFrameView_Frame_components;
	} this code has been moved to _ElempglobalFrameView_Frame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components)
	{globalFrameView__TPPLST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputElementpglobalFrameView_Frame_components;
	} this code has been moved to _ElempglobalFrameView_Frame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ImageMappglobalFrameView_Frame_components)
	{globalFrameView__TPPLST_globalFrameView_ImageMappglobalFrameView_Frame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ImageMappglobalFrameView_Frame_components;
	} this code has been moved to _ElempglobalFrameView_Frame_components*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_Frame_components;
#else
root = (globalFrameView__TPPpglobalFrameView_Frame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Frame_components));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_Frame_components;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_Frame_components)list;
{ globalFrameView__TPPpglobalFrameView_Frame_components _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_Frame_components;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_GlobalFrame (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR globalFrameView_MkpglobalFrameView_GlobalFrame (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	globalFrameView__TPPpglobalFrameView_GlobalFrame _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_GlobalFrame;
#else
_currn = (globalFrameView__TPPpglobalFrameView_GlobalFrame) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_GlobalFrame));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_GlobalFrame;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_GlobalFrame_name) globalFrameView_MkglobalFrameView_GlobalFrame_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_GlobalFrame: root of subtree no. 1 can not be made a globalFrameView_GlobalFrame_name node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_GlobalFrame_components) globalFrameView_MkglobalFrameView_GlobalFrame_components (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_GlobalFrame: root of subtree no. 2 can not be made a globalFrameView_GlobalFrame_components node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_GlobalFrame_setSize) globalFrameView_MkglobalFrameView_GlobalFrame_setSize (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_GlobalFrame: root of subtree no. 3 can not be made a globalFrameView_GlobalFrame_setSize node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_GlobalFrame;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_GlobalFrame */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_GlobalFrame_name (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_GlobalFrame_name (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_GlobalFrame_name _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_GlobalFrame_name;
#else
_currn = (globalFrameView__TPPpglobalFrameView_GlobalFrame_name) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_GlobalFrame_name));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_GlobalFrame_name;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_GlobalFrame_name;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_GlobalFrame_name */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FrameRefpglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FrameRefpglobalFrameView_GlobalFrame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FrameRef)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_GlobalFrame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ParagraphpglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ParagraphpglobalFrameView_GlobalFrame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_Paragraph)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_GlobalFrame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_HeadingpglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_HeadingpglobalFrameView_GlobalFrame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_Heading)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_GlobalFrame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_TablepglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_TablepglobalFrameView_GlobalFrame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_TablepglobalFrameView_GlobalFrame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_TablepglobalFrameView_GlobalFrame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_TablepglobalFrameView_GlobalFrame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_TablepglobalFrameView_GlobalFrame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_TablepglobalFrameView_GlobalFrame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_Table)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_GlobalFrame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_TablepglobalFrameView_GlobalFrame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_TablepglobalFrameView_GlobalFrame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularpglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularpglobalFrameView_GlobalFrame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_Formular)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_GlobalFrame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_OutputMessagesElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_GlobalFrame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_GlobalFrame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ImageMappglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ImageMappglobalFrameView_GlobalFrame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ImageMappglobalFrameView_GlobalFrame_components _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ImageMappglobalFrameView_GlobalFrame_components;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ImageMappglobalFrameView_GlobalFrame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ImageMappglobalFrameView_GlobalFrame_components));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ImageMappglobalFrameView_GlobalFrame_components;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ImageMap)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_GlobalFrame_components)_new;
	{globalFrameView__TPPLST_globalFrameView_ImageMappglobalFrameView_GlobalFrame_components _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ImageMappglobalFrameView_GlobalFrame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_GlobalFrame_components (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FrameRef)) 
		return globalFrameView__MkglobalFrameView_FrameRefpglobalFrameView_GlobalFrame_components (_coordref, globalFrameView_MkglobalFrameView_FrameRef (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_Paragraph)) 
		return globalFrameView__MkglobalFrameView_ParagraphpglobalFrameView_GlobalFrame_components (_coordref, globalFrameView_MkglobalFrameView_Paragraph (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_Heading)) 
		return globalFrameView__MkglobalFrameView_HeadingpglobalFrameView_GlobalFrame_components (_coordref, globalFrameView_MkglobalFrameView_Heading (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_Table)) 
		return globalFrameView__MkglobalFrameView_TablepglobalFrameView_GlobalFrame_components (_coordref, globalFrameView_MkglobalFrameView_Table (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_Formular)) 
		return globalFrameView__MkglobalFrameView_FormularpglobalFrameView_GlobalFrame_components (_coordref, globalFrameView_MkglobalFrameView_Formular (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_OutputMessagesElement)) 
		return globalFrameView__MkglobalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components (_coordref, globalFrameView_MkglobalFrameView_OutputMessagesElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ListOutputElement)) 
		return globalFrameView__MkglobalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components (_coordref, globalFrameView_MkglobalFrameView_ListOutputElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ImageMap)) 
		return globalFrameView__MkglobalFrameView_ImageMappglobalFrameView_GlobalFrame_components (_coordref, globalFrameView_MkglobalFrameView_ImageMap (_coordref, t));
	message (DEADLY, "a pglobalFrameView_GlobalFrame_components list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_GlobalFrame_components (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_GlobalFrame_components)
	l =_ElempglobalFrameView_GlobalFrame_components (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_GlobalFrame_components)
	r = _ElempglobalFrameView_GlobalFrame_components (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_GlobalFrame_components (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_GlobalFrame_components (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_GlobalFrame_components root;
	globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_GlobalFrame_components)
		t = _ElempglobalFrameView_GlobalFrame_components (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components)(((globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_GlobalFrame_components;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_GlobalFrame_components));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_GlobalFrame_components;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_GlobalFrame_components)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components)
	{globalFrameView__TPPLST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FrameRefpglobalFrameView_GlobalFrame_components;
	} this code has been moved to _ElempglobalFrameView_GlobalFrame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components)
	{globalFrameView__TPPLST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ParagraphpglobalFrameView_GlobalFrame_components;
	} this code has been moved to _ElempglobalFrameView_GlobalFrame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components)
	{globalFrameView__TPPLST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_HeadingpglobalFrameView_GlobalFrame_components;
	} this code has been moved to _ElempglobalFrameView_GlobalFrame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_TablepglobalFrameView_GlobalFrame_components)
	{globalFrameView__TPPLST_globalFrameView_TablepglobalFrameView_GlobalFrame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_TablepglobalFrameView_GlobalFrame_components;
	} this code has been moved to _ElempglobalFrameView_GlobalFrame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components)
	{globalFrameView__TPPLST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularpglobalFrameView_GlobalFrame_components;
	} this code has been moved to _ElempglobalFrameView_GlobalFrame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components)
	{globalFrameView__TPPLST_globalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_OutputMessagesElementpglobalFrameView_GlobalFrame_components;
	} this code has been moved to _ElempglobalFrameView_GlobalFrame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components)
	{globalFrameView__TPPLST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputElementpglobalFrameView_GlobalFrame_components;
	} this code has been moved to _ElempglobalFrameView_GlobalFrame_components*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ImageMappglobalFrameView_GlobalFrame_components)
	{globalFrameView__TPPLST_globalFrameView_ImageMappglobalFrameView_GlobalFrame_components _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ImageMappglobalFrameView_GlobalFrame_components;
	} this code has been moved to _ElempglobalFrameView_GlobalFrame_components*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_GlobalFrame_components;
#else
root = (globalFrameView__TPPpglobalFrameView_GlobalFrame_components) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_GlobalFrame_components));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_GlobalFrame_components;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_GlobalFrame_components)list;
{ globalFrameView__TPPpglobalFrameView_GlobalFrame_components _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_GlobalFrame_components;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_GlobalFrame_setSize (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_GlobalFrame_setSize (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_GlobalFrame_setSize _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_GlobalFrame_setSize;
#else
_currn = (globalFrameView__TPPpglobalFrameView_GlobalFrame_setSize) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_GlobalFrame_setSize));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_GlobalFrame_setSize;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_GlobalFrame_setSize;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_GlobalFrame_setSize */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FrameRef (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FrameRef (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_FrameRef _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FrameRef;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FrameRef) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FrameRef));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FrameRef;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FrameRef_styleSheetBlock) globalFrameView_MkglobalFrameView_FrameRef_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FrameRef: root of subtree no. 1 can not be made a globalFrameView_FrameRef_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FrameRef_frame) globalFrameView_MkglobalFrameView_FrameRef_frame (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FrameRef: root of subtree no. 2 can not be made a globalFrameView_FrameRef_frame node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FrameRef;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FrameRef */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FrameRef_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FrameRef_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FrameRef_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FrameRef_styleSheetBlock;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FrameRef_styleSheetBlock) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FrameRef_styleSheetBlock));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FrameRef_styleSheetBlock;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FrameRef_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FrameRef_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FrameRef_frame (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FrameRef_frame (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FrameRef_frame _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FrameRef_frame;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FrameRef_frame) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FrameRef_frame));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FrameRef_frame;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FrameRef_frame;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FrameRef_frame */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_BinaryExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR globalFrameView_MkpglobalFrameView_BinaryExpression (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	globalFrameView__TPPpglobalFrameView_BinaryExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_BinaryExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_BinaryExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_BinaryExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_BinaryExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_BinaryExpression_leftOperand) globalFrameView_MkglobalFrameView_BinaryExpression_leftOperand (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_BinaryExpression: root of subtree no. 1 can not be made a globalFrameView_BinaryExpression_leftOperand node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_BinaryExpression_rightOperand) globalFrameView_MkglobalFrameView_BinaryExpression_rightOperand (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_BinaryExpression: root of subtree no. 2 can not be made a globalFrameView_BinaryExpression_rightOperand node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_BinaryExpression_operator) globalFrameView_MkglobalFrameView_BinaryExpression_operator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_BinaryExpression: root of subtree no. 3 can not be made a globalFrameView_BinaryExpression_operator node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_BinaryExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_BinaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_BinaryExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_leftOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_UnaryExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_leftOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_PredefinedExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_leftOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ConstantExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_leftOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ColumnValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_leftOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_leftOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ParameterValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_leftOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ComputationExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_leftOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_BinaryExpression_leftOperand (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_BinaryExpression)) 
		return globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, globalFrameView_MkglobalFrameView_BinaryExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_UnaryExpression)) 
		return globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, globalFrameView_MkglobalFrameView_UnaryExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_PredefinedExpression)) 
		return globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, globalFrameView_MkglobalFrameView_PredefinedExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ConstantExpression)) 
		return globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, globalFrameView_MkglobalFrameView_ConstantExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ColumnValueExpression)) 
		return globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, globalFrameView_MkglobalFrameView_ColumnValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ProjectionColumnValueExpression)) 
		return globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ParameterValueExpression)) 
		return globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, globalFrameView_MkglobalFrameView_ParameterValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ComputationExpression)) 
		return globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand (_coordref, globalFrameView_MkglobalFrameView_ComputationExpression (_coordref, t));
	message (DEADLY, "a pglobalFrameView_BinaryExpression_leftOperand list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_BinaryExpression_leftOperand (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_BinaryExpression_leftOperand)
	l =_ElempglobalFrameView_BinaryExpression_leftOperand (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_BinaryExpression_leftOperand)
	r = _ElempglobalFrameView_BinaryExpression_leftOperand (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_BinaryExpression_leftOperand (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_BinaryExpression_leftOperand root;
	globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_BinaryExpression_leftOperand)
		t = _ElempglobalFrameView_BinaryExpression_leftOperand (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand)(((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_BinaryExpression_leftOperand;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_BinaryExpression_leftOperand));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_BinaryExpression_leftOperand;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_leftOperand)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand)
	{globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand)
	{globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand)
	{globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand)
	{globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand)
	{globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand)
	{globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand)
	{globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand)
	{globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_leftOperand*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_BinaryExpression_leftOperand;
#else
root = (globalFrameView__TPPpglobalFrameView_BinaryExpression_leftOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_BinaryExpression_leftOperand));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_BinaryExpression_leftOperand;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_leftOperand)list;
{ globalFrameView__TPPpglobalFrameView_BinaryExpression_leftOperand _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_BinaryExpression_leftOperand;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_BinaryExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_rightOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_UnaryExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_rightOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_PredefinedExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_rightOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ConstantExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_rightOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ColumnValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_rightOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_rightOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ParameterValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_rightOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ComputationExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_rightOperand)_new;
	{globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_BinaryExpression_rightOperand (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_BinaryExpression)) 
		return globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, globalFrameView_MkglobalFrameView_BinaryExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_UnaryExpression)) 
		return globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, globalFrameView_MkglobalFrameView_UnaryExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_PredefinedExpression)) 
		return globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, globalFrameView_MkglobalFrameView_PredefinedExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ConstantExpression)) 
		return globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, globalFrameView_MkglobalFrameView_ConstantExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ColumnValueExpression)) 
		return globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, globalFrameView_MkglobalFrameView_ColumnValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ProjectionColumnValueExpression)) 
		return globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ParameterValueExpression)) 
		return globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, globalFrameView_MkglobalFrameView_ParameterValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ComputationExpression)) 
		return globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand (_coordref, globalFrameView_MkglobalFrameView_ComputationExpression (_coordref, t));
	message (DEADLY, "a pglobalFrameView_BinaryExpression_rightOperand list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_BinaryExpression_rightOperand (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_BinaryExpression_rightOperand)
	l =_ElempglobalFrameView_BinaryExpression_rightOperand (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_BinaryExpression_rightOperand)
	r = _ElempglobalFrameView_BinaryExpression_rightOperand (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_BinaryExpression_rightOperand (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_BinaryExpression_rightOperand root;
	globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_BinaryExpression_rightOperand)
		t = _ElempglobalFrameView_BinaryExpression_rightOperand (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand)(((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_BinaryExpression_rightOperand;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_BinaryExpression_rightOperand));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_BinaryExpression_rightOperand;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_BinaryExpression_rightOperand)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand)
	{globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_BinaryExpressionpglobalFrameView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand)
	{globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_UnaryExpressionpglobalFrameView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand)
	{globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_PredefinedExpressionpglobalFrameView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand)
	{globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ConstantExpressionpglobalFrameView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand)
	{globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand)
	{globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand)
	{globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ParameterValueExpressionpglobalFrameView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand)
	{globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ComputationExpressionpglobalFrameView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempglobalFrameView_BinaryExpression_rightOperand*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_BinaryExpression_rightOperand;
#else
root = (globalFrameView__TPPpglobalFrameView_BinaryExpression_rightOperand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_BinaryExpression_rightOperand));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_BinaryExpression_rightOperand;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_BinaryExpression_rightOperand)list;
{ globalFrameView__TPPpglobalFrameView_BinaryExpression_rightOperand _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_BinaryExpression_rightOperand;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_BinaryExpression_operator (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_BinaryExpression_operator (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_BinaryExpression_operator _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_BinaryExpression_operator;
#else
_currn = (globalFrameView__TPPpglobalFrameView_BinaryExpression_operator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_BinaryExpression_operator));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_BinaryExpression_operator;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_BinaryExpression_operator;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_BinaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_UnaryExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_UnaryExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_UnaryExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_UnaryExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_UnaryExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_UnaryExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_UnaryExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_UnaryExpression_operand) globalFrameView_MkglobalFrameView_UnaryExpression_operand (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_UnaryExpression: root of subtree no. 1 can not be made a globalFrameView_UnaryExpression_operand node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_UnaryExpression_operator) globalFrameView_MkglobalFrameView_UnaryExpression_operator (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_UnaryExpression: root of subtree no. 2 can not be made a globalFrameView_UnaryExpression_operator node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_UnaryExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_UnaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_BinaryExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_UnaryExpression_operand)_new;
	{globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_UnaryExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_UnaryExpression_operand)_new;
	{globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_PredefinedExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_UnaryExpression_operand)_new;
	{globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ConstantExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_UnaryExpression_operand)_new;
	{globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ColumnValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_UnaryExpression_operand)_new;
	{globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_UnaryExpression_operand)_new;
	{globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ParameterValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_UnaryExpression_operand)_new;
	{globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ComputationExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_UnaryExpression_operand)_new;
	{globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_UnaryExpression_operand (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_BinaryExpression)) 
		return globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand (_coordref, globalFrameView_MkglobalFrameView_BinaryExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_UnaryExpression)) 
		return globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand (_coordref, globalFrameView_MkglobalFrameView_UnaryExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_PredefinedExpression)) 
		return globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand (_coordref, globalFrameView_MkglobalFrameView_PredefinedExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ConstantExpression)) 
		return globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand (_coordref, globalFrameView_MkglobalFrameView_ConstantExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ColumnValueExpression)) 
		return globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand (_coordref, globalFrameView_MkglobalFrameView_ColumnValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ProjectionColumnValueExpression)) 
		return globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand (_coordref, globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ParameterValueExpression)) 
		return globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand (_coordref, globalFrameView_MkglobalFrameView_ParameterValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ComputationExpression)) 
		return globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand (_coordref, globalFrameView_MkglobalFrameView_ComputationExpression (_coordref, t));
	message (DEADLY, "a pglobalFrameView_UnaryExpression_operand list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_UnaryExpression_operand (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_UnaryExpression_operand)
	l =_ElempglobalFrameView_UnaryExpression_operand (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_UnaryExpression_operand)
	r = _ElempglobalFrameView_UnaryExpression_operand (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_UnaryExpression_operand (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_UnaryExpression_operand (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_UnaryExpression_operand root;
	globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_UnaryExpression_operand)
		t = _ElempglobalFrameView_UnaryExpression_operand (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand)(((globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_UnaryExpression_operand;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_UnaryExpression_operand));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_UnaryExpression_operand;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_UnaryExpression_operand)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand)
	{globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_BinaryExpressionpglobalFrameView_UnaryExpression_operand;
	} this code has been moved to _ElempglobalFrameView_UnaryExpression_operand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand)
	{globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_UnaryExpressionpglobalFrameView_UnaryExpression_operand;
	} this code has been moved to _ElempglobalFrameView_UnaryExpression_operand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand)
	{globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_PredefinedExpressionpglobalFrameView_UnaryExpression_operand;
	} this code has been moved to _ElempglobalFrameView_UnaryExpression_operand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand)
	{globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ConstantExpressionpglobalFrameView_UnaryExpression_operand;
	} this code has been moved to _ElempglobalFrameView_UnaryExpression_operand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand)
	{globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ColumnValueExpressionpglobalFrameView_UnaryExpression_operand;
	} this code has been moved to _ElempglobalFrameView_UnaryExpression_operand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand)
	{globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_UnaryExpression_operand;
	} this code has been moved to _ElempglobalFrameView_UnaryExpression_operand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand)
	{globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ParameterValueExpressionpglobalFrameView_UnaryExpression_operand;
	} this code has been moved to _ElempglobalFrameView_UnaryExpression_operand*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand)
	{globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ComputationExpressionpglobalFrameView_UnaryExpression_operand;
	} this code has been moved to _ElempglobalFrameView_UnaryExpression_operand*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_UnaryExpression_operand;
#else
root = (globalFrameView__TPPpglobalFrameView_UnaryExpression_operand) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_UnaryExpression_operand));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_UnaryExpression_operand;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_UnaryExpression_operand)list;
{ globalFrameView__TPPpglobalFrameView_UnaryExpression_operand _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_UnaryExpression_operand;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_UnaryExpression_operator (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_UnaryExpression_operator (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_UnaryExpression_operator _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_UnaryExpression_operator;
#else
_currn = (globalFrameView__TPPpglobalFrameView_UnaryExpression_operator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_UnaryExpression_operator));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_UnaryExpression_operator;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_UnaryExpression_operator;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_UnaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_PredefinedExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_PredefinedExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_PredefinedExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_PredefinedExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_PredefinedExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_PredefinedExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_PredefinedExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_PredefinedExpression_value) globalFrameView_MkglobalFrameView_PredefinedExpression_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_PredefinedExpression: root of subtree no. 1 can not be made a globalFrameView_PredefinedExpression_value node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_PredefinedExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_PredefinedExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_PredefinedExpression_value (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_PredefinedExpression_value (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_PredefinedExpression_value _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_PredefinedExpression_value;
#else
_currn = (globalFrameView__TPPpglobalFrameView_PredefinedExpression_value) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_PredefinedExpression_value));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_PredefinedExpression_value;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_PredefinedExpression_value;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_PredefinedExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ConstantExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ConstantExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_ConstantExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ConstantExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ConstantExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ConstantExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ConstantExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ConstantExpression_value) globalFrameView_MkglobalFrameView_ConstantExpression_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ConstantExpression: root of subtree no. 1 can not be made a globalFrameView_ConstantExpression_value node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ConstantExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ConstantExpression_value (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ConstantExpression_value (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ConstantExpression_value _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ConstantExpression_value;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ConstantExpression_value) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ConstantExpression_value));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ConstantExpression_value;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ConstantExpression_value;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ColumnValueExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ColumnValueExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_ColumnValueExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ColumnValueExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ColumnValueExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ColumnValueExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ColumnValueExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ColumnValueExpression_column) globalFrameView_MkglobalFrameView_ColumnValueExpression_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ColumnValueExpression: root of subtree no. 1 can not be made a globalFrameView_ColumnValueExpression_column node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ColumnValueExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ColumnValueExpression_column (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ColumnValueExpression_column (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ColumnValueExpression_column _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ColumnValueExpression_column;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ColumnValueExpression_column) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ColumnValueExpression_column));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ColumnValueExpression_column;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ColumnValueExpression_column;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ProjectionColumnValueExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ProjectionColumnValueExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_ProjectionColumnValueExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ProjectionColumnValueExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ProjectionColumnValueExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ProjectionColumnValueExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ProjectionColumnValueExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ProjectionColumnValueExpression_column) globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ProjectionColumnValueExpression: root of subtree no. 1 can not be made a globalFrameView_ProjectionColumnValueExpression_column node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ProjectionColumnValueExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ProjectionColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ProjectionColumnValueExpression_column (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ProjectionColumnValueExpression_column (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ProjectionColumnValueExpression_column _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ProjectionColumnValueExpression_column;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ProjectionColumnValueExpression_column) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ProjectionColumnValueExpression_column));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ProjectionColumnValueExpression_column;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ProjectionColumnValueExpression_column;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ProjectionColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ParameterValueExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ParameterValueExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_ParameterValueExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ParameterValueExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ParameterValueExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ParameterValueExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ParameterValueExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ParameterValueExpression_parameter) globalFrameView_MkglobalFrameView_ParameterValueExpression_parameter (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ParameterValueExpression: root of subtree no. 1 can not be made a globalFrameView_ParameterValueExpression_parameter node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ParameterValueExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ParameterValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ParameterValueExpression_parameter (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ParameterValueExpression_parameter (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ParameterValueExpression_parameter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ParameterValueExpression_parameter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ParameterValueExpression_parameter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ParameterValueExpression_parameter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ParameterValueExpression_parameter;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ParameterValueExpression_parameter;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ParameterValueExpression_parameter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ComputationExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ComputationExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_ComputationExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ComputationExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ComputationExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ComputationExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ComputationExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ComputationExpression_column) globalFrameView_MkglobalFrameView_ComputationExpression_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ComputationExpression: root of subtree no. 1 can not be made a globalFrameView_ComputationExpression_column node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_ComputationExpression_computation) globalFrameView_MkglobalFrameView_ComputationExpression_computation (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ComputationExpression: root of subtree no. 2 can not be made a globalFrameView_ComputationExpression_computation node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ComputationExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ComputationExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ComputationExpression_column (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ComputationExpression_column (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ComputationExpression_column _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ComputationExpression_column;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ComputationExpression_column) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ComputationExpression_column));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ComputationExpression_column;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ComputationExpression_column;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ComputationExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ComputationExpression_computation (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ComputationExpression_computation (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ComputationExpression_computation _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ComputationExpression_computation;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ComputationExpression_computation) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ComputationExpression_computation));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ComputationExpression_computation;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ComputationExpression_computation;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ComputationExpression_computation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Paragraph (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Paragraph (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_Paragraph _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Paragraph;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Paragraph) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Paragraph));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Paragraph;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_Paragraph_styleSheetBlock) globalFrameView_MkglobalFrameView_Paragraph_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Paragraph: root of subtree no. 1 can not be made a globalFrameView_Paragraph_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_Paragraph_fragments) globalFrameView_MkglobalFrameView_Paragraph_fragments (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Paragraph: root of subtree no. 2 can not be made a globalFrameView_Paragraph_fragments node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Paragraph;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Paragraph */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Paragraph_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Paragraph_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_Paragraph_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Paragraph_styleSheetBlock;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Paragraph_styleSheetBlock) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Paragraph_styleSheetBlock));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Paragraph_styleSheetBlock;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Paragraph_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Paragraph_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_TextFragment)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Paragraph_fragments)_new;
	{globalFrameView__TPPLST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ImageFragment)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Paragraph_fragments)_new;
	{globalFrameView__TPPLST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_OutputFragment)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Paragraph_fragments)_new;
	{globalFrameView__TPPLST_globalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_Paragraph_fragments (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_Paragraph_fragments (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_TextFragment)) 
		return globalFrameView__MkglobalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments (_coordref, globalFrameView_MkglobalFrameView_TextFragment (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ImageFragment)) 
		return globalFrameView__MkglobalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments (_coordref, globalFrameView_MkglobalFrameView_ImageFragment (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_OutputFragment)) 
		return globalFrameView__MkglobalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments (_coordref, globalFrameView_MkglobalFrameView_OutputFragment (_coordref, t));
	message (DEADLY, "a pglobalFrameView_Paragraph_fragments list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_Paragraph_fragments (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_Paragraph_fragments (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_Paragraph_fragments)
	l =_ElempglobalFrameView_Paragraph_fragments (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_Paragraph_fragments)
	r = _ElempglobalFrameView_Paragraph_fragments (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Paragraph_fragments (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Paragraph_fragments (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_Paragraph_fragments root;
	globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_Paragraph_fragments)
		t = _ElempglobalFrameView_Paragraph_fragments (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments)(((globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_Paragraph_fragments;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_Paragraph_fragments));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_Paragraph_fragments;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_Paragraph_fragments)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments)
	{globalFrameView__TPPLST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_TextFragmentpglobalFrameView_Paragraph_fragments;
	} this code has been moved to _ElempglobalFrameView_Paragraph_fragments*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments)
	{globalFrameView__TPPLST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ImageFragmentpglobalFrameView_Paragraph_fragments;
	} this code has been moved to _ElempglobalFrameView_Paragraph_fragments*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments)
	{globalFrameView__TPPLST_globalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_OutputFragmentpglobalFrameView_Paragraph_fragments;
	} this code has been moved to _ElempglobalFrameView_Paragraph_fragments*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_Paragraph_fragments;
#else
root = (globalFrameView__TPPpglobalFrameView_Paragraph_fragments) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Paragraph_fragments));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_Paragraph_fragments;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_Paragraph_fragments)list;
{ globalFrameView__TPPpglobalFrameView_Paragraph_fragments _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_Paragraph_fragments;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_TextFragment (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR globalFrameView_MkpglobalFrameView_TextFragment (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	globalFrameView__TPPpglobalFrameView_TextFragment _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_TextFragment;
#else
_currn = (globalFrameView__TPPpglobalFrameView_TextFragment) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_TextFragment));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_TextFragment;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_TextFragment_link) globalFrameView_MkglobalFrameView_TextFragment_link (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_TextFragment: root of subtree no. 1 can not be made a globalFrameView_TextFragment_link node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_TextFragment_value) globalFrameView_MkglobalFrameView_TextFragment_value (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_TextFragment: root of subtree no. 2 can not be made a globalFrameView_TextFragment_value node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_TextFragment_fontstyle) globalFrameView_MkglobalFrameView_TextFragment_fontstyle (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_TextFragment: root of subtree no. 3 can not be made a globalFrameView_TextFragment_fontstyle node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_TextFragment;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_TextFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_TextFragment_link (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_TextFragment_link (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_TextFragment_link _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_TextFragment_link;
#else
_currn = (globalFrameView__TPPpglobalFrameView_TextFragment_link) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_TextFragment_link));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_TextFragment_link;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_TextFragment_link;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_TextFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_TextFragment_value (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_TextFragment_value (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_TextFragment_value _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_TextFragment_value;
#else
_currn = (globalFrameView__TPPpglobalFrameView_TextFragment_value) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_TextFragment_value));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_TextFragment_value;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_TextFragment_value;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_TextFragment_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_TextFragment_fontstyle (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_TextFragment_fontstyle (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_TextFragment_fontstyle _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_TextFragment_fontstyle;
#else
_currn = (globalFrameView__TPPpglobalFrameView_TextFragment_fontstyle) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_TextFragment_fontstyle));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_TextFragment_fontstyle;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_TextFragment_fontstyle;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_TextFragment_fontstyle */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7, NODEPTR _desc8)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7,_desc8)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
	NODEPTR _desc8;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageFragment _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageFragment;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageFragment) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageFragment));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageFragment;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ImageFragment_link) globalFrameView_MkglobalFrameView_ImageFragment_link (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageFragment: root of subtree no. 1 can not be made a globalFrameView_ImageFragment_link node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_ImageFragment_width) globalFrameView_MkglobalFrameView_ImageFragment_width (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageFragment: root of subtree no. 2 can not be made a globalFrameView_ImageFragment_width node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_ImageFragment_height) globalFrameView_MkglobalFrameView_ImageFragment_height (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageFragment: root of subtree no. 3 can not be made a globalFrameView_ImageFragment_height node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_ImageFragment_border) globalFrameView_MkglobalFrameView_ImageFragment_border (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageFragment: root of subtree no. 4 can not be made a globalFrameView_ImageFragment_border node ", 0, _coordref);
_currn->_desc5 = (globalFrameView__TSPglobalFrameView_ImageFragment_verticalAlign) globalFrameView_MkglobalFrameView_ImageFragment_verticalAlign (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageFragment: root of subtree no. 5 can not be made a globalFrameView_ImageFragment_verticalAlign node ", 0, _coordref);
_currn->_desc6 = (globalFrameView__TSPglobalFrameView_ImageFragment_float) globalFrameView_MkglobalFrameView_ImageFragment_float (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageFragment: root of subtree no. 6 can not be made a globalFrameView_ImageFragment_float node ", 0, _coordref);
_currn->_desc7 = (globalFrameView__TSPglobalFrameView_ImageFragment_text) globalFrameView_MkglobalFrameView_ImageFragment_text (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageFragment: root of subtree no. 7 can not be made a globalFrameView_ImageFragment_text node ", 0, _coordref);
_currn->_desc8 = (globalFrameView__TSPglobalFrameView_ImageFragment_imageName) globalFrameView_MkglobalFrameView_ImageFragment_imageName (_coordref, _desc8);	
if (((NODEPTR)_currn->_desc8) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageFragment: root of subtree no. 8 can not be made a globalFrameView_ImageFragment_imageName node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageFragment;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_link (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_link (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageFragment_link _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageFragment_link;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageFragment_link) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageFragment_link));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageFragment_link;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageFragment_link;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_width (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_width (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageFragment_width _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageFragment_width;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageFragment_width) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageFragment_width));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageFragment_width;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageFragment_width;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageFragment_width */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_height (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_height (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageFragment_height _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageFragment_height;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageFragment_height) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageFragment_height));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageFragment_height;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageFragment_height;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageFragment_height */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_border (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_border (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageFragment_border _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageFragment_border;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageFragment_border) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageFragment_border));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageFragment_border;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageFragment_border;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageFragment_border */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_verticalAlign (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_verticalAlign (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageFragment_verticalAlign _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageFragment_verticalAlign;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageFragment_verticalAlign) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageFragment_verticalAlign));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageFragment_verticalAlign;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageFragment_verticalAlign;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageFragment_verticalAlign */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_float (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_float (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageFragment_float _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageFragment_float;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageFragment_float) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageFragment_float));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageFragment_float;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageFragment_float;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageFragment_float */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_text (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_text (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageFragment_text _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageFragment_text;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageFragment_text) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageFragment_text));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageFragment_text;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageFragment_text;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageFragment_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_imageName (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageFragment_imageName (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageFragment_imageName _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageFragment_imageName;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageFragment_imageName) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageFragment_imageName));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageFragment_imageName;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageFragment_imageName;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageFragment_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Heading (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Heading (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	globalFrameView__TPPpglobalFrameView_Heading _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Heading;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Heading) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Heading));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Heading;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_Heading_styleSheetBlock) globalFrameView_MkglobalFrameView_Heading_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Heading: root of subtree no. 1 can not be made a globalFrameView_Heading_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_Heading_text) globalFrameView_MkglobalFrameView_Heading_text (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Heading: root of subtree no. 2 can not be made a globalFrameView_Heading_text node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_Heading_level) globalFrameView_MkglobalFrameView_Heading_level (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Heading: root of subtree no. 3 can not be made a globalFrameView_Heading_level node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Heading;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Heading */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Heading_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Heading_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_Heading_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Heading_styleSheetBlock;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Heading_styleSheetBlock) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Heading_styleSheetBlock));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Heading_styleSheetBlock;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Heading_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Heading_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Heading_text (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Heading_text (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_Heading_text _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Heading_text;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Heading_text) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Heading_text));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Heading_text;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Heading_text;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Heading_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Heading_level (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Heading_level (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_Heading_level _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Heading_level;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Heading_level) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Heading_level));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Heading_level;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Heading_level;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Heading_level */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Table (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Table (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	globalFrameView__TPPpglobalFrameView_Table _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Table;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Table) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Table));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Table;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_Table_styleSheetBlock) globalFrameView_MkglobalFrameView_Table_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Table: root of subtree no. 1 can not be made a globalFrameView_Table_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_Table_rows) globalFrameView_MkglobalFrameView_Table_rows (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Table: root of subtree no. 2 can not be made a globalFrameView_Table_rows node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_Table_columns) globalFrameView_MkglobalFrameView_Table_columns (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Table: root of subtree no. 3 can not be made a globalFrameView_Table_columns node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Table;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Table */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Table_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Table_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_Table_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Table_styleSheetBlock;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Table_styleSheetBlock) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Table_styleSheetBlock));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Table_styleSheetBlock;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Table_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Table_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_TableRowpglobalFrameView_Table_rows (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_TableRowpglobalFrameView_Table_rows (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_TableRowpglobalFrameView_Table_rows _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_TableRowpglobalFrameView_Table_rows;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_TableRowpglobalFrameView_Table_rows) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_TableRowpglobalFrameView_Table_rows));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_TableRowpglobalFrameView_Table_rows;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_TableRow)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Table_rows)_new;
	{globalFrameView__TPPLST_globalFrameView_TableRowpglobalFrameView_Table_rows _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_TableRowpglobalFrameView_Table_rows;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_Table_rows (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_Table_rows (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_TableRow)) 
		return globalFrameView__MkglobalFrameView_TableRowpglobalFrameView_Table_rows (_coordref, globalFrameView_MkglobalFrameView_TableRow (_coordref, t));
	message (DEADLY, "a pglobalFrameView_Table_rows list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_Table_rows (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_Table_rows (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_Table_rows)
	l =_ElempglobalFrameView_Table_rows (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_Table_rows)
	r = _ElempglobalFrameView_Table_rows (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_Table_rows)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_Table_rows)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_Table_rows)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_Table_rows)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Table_rows (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Table_rows (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_Table_rows root;
	globalFrameView__TPPLST_0pglobalFrameView_Table_rows list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Table_rows)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_Table_rows)
		t = _ElempglobalFrameView_Table_rows (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Table_rows)(((globalFrameView__TPPLST_0pglobalFrameView_Table_rows) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_Table_rows) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_Table_rows;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_Table_rows) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_Table_rows));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_Table_rows;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_Table_rows)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_TableRowpglobalFrameView_Table_rows)
	{globalFrameView__TPPLST_globalFrameView_TableRowpglobalFrameView_Table_rows _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_TableRowpglobalFrameView_Table_rows;
	} this code has been moved to _ElempglobalFrameView_Table_rows*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_Table_rows;
#else
root = (globalFrameView__TPPpglobalFrameView_Table_rows) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Table_rows));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_Table_rows;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_Table_rows)list;
{ globalFrameView__TPPpglobalFrameView_Table_rows _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_Table_rows;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_TableColumnpglobalFrameView_Table_columns (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_TableColumnpglobalFrameView_Table_columns (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_TableColumnpglobalFrameView_Table_columns _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_TableColumnpglobalFrameView_Table_columns;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_TableColumnpglobalFrameView_Table_columns) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_TableColumnpglobalFrameView_Table_columns));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_TableColumnpglobalFrameView_Table_columns;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_TableColumn)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Table_columns)_new;
	{globalFrameView__TPPLST_globalFrameView_TableColumnpglobalFrameView_Table_columns _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_TableColumnpglobalFrameView_Table_columns;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_Table_columns (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_Table_columns (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_TableColumn)) 
		return globalFrameView__MkglobalFrameView_TableColumnpglobalFrameView_Table_columns (_coordref, globalFrameView_MkglobalFrameView_TableColumn (_coordref, t));
	message (DEADLY, "a pglobalFrameView_Table_columns list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_Table_columns (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_Table_columns (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_Table_columns)
	l =_ElempglobalFrameView_Table_columns (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_Table_columns)
	r = _ElempglobalFrameView_Table_columns (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_Table_columns)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_Table_columns)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_Table_columns)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_Table_columns)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Table_columns (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Table_columns (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_Table_columns root;
	globalFrameView__TPPLST_0pglobalFrameView_Table_columns list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Table_columns)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_Table_columns)
		t = _ElempglobalFrameView_Table_columns (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Table_columns)(((globalFrameView__TPPLST_0pglobalFrameView_Table_columns) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_Table_columns) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_Table_columns;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_Table_columns) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_Table_columns));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_Table_columns;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_Table_columns)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_TableColumnpglobalFrameView_Table_columns)
	{globalFrameView__TPPLST_globalFrameView_TableColumnpglobalFrameView_Table_columns _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_TableColumnpglobalFrameView_Table_columns;
	} this code has been moved to _ElempglobalFrameView_Table_columns*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_Table_columns;
#else
root = (globalFrameView__TPPpglobalFrameView_Table_columns) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Table_columns));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_Table_columns;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_Table_columns)list;
{ globalFrameView__TPPpglobalFrameView_Table_columns _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_Table_columns;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_TableRow (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_TableRow (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_TableRow _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_TableRow;
#else
_currn = (globalFrameView__TPPpglobalFrameView_TableRow) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_TableRow));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_TableRow;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_TableRow_cells) globalFrameView_MkglobalFrameView_TableRow_cells (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_TableRow: root of subtree no. 1 can not be made a globalFrameView_TableRow_cells node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_TableRow;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_TableRow */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_TableCellpglobalFrameView_TableRow_cells (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_TableCellpglobalFrameView_TableRow_cells (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_TableCellpglobalFrameView_TableRow_cells _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_TableCellpglobalFrameView_TableRow_cells;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_TableCellpglobalFrameView_TableRow_cells) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_TableCellpglobalFrameView_TableRow_cells));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_TableCellpglobalFrameView_TableRow_cells;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_TableCell)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_TableRow_cells)_new;
	{globalFrameView__TPPLST_globalFrameView_TableCellpglobalFrameView_TableRow_cells _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_TableCellpglobalFrameView_TableRow_cells;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_TableRow_cells (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_TableRow_cells (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_TableCell)) 
		return globalFrameView__MkglobalFrameView_TableCellpglobalFrameView_TableRow_cells (_coordref, globalFrameView_MkglobalFrameView_TableCell (_coordref, t));
	message (DEADLY, "a pglobalFrameView_TableRow_cells list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_TableRow_cells (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_TableRow_cells (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_TableRow_cells)
	l =_ElempglobalFrameView_TableRow_cells (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_TableRow_cells)
	r = _ElempglobalFrameView_TableRow_cells (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_TableRow_cells (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_TableRow_cells (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_TableRow_cells root;
	globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_TableRow_cells)
		t = _ElempglobalFrameView_TableRow_cells (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells)(((globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_TableRow_cells;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_TableRow_cells));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_TableRow_cells;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_TableRow_cells)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_TableCellpglobalFrameView_TableRow_cells)
	{globalFrameView__TPPLST_globalFrameView_TableCellpglobalFrameView_TableRow_cells _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_TableCellpglobalFrameView_TableRow_cells;
	} this code has been moved to _ElempglobalFrameView_TableRow_cells*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_TableRow_cells;
#else
root = (globalFrameView__TPPpglobalFrameView_TableRow_cells) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_TableRow_cells));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_TableRow_cells;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_TableRow_cells)list;
{ globalFrameView__TPPpglobalFrameView_TableRow_cells _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_TableRow_cells;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_TableColumn (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_TableColumn (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_TableColumn _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_TableColumn;
#else
_currn = (globalFrameView__TPPpglobalFrameView_TableColumn) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_TableColumn));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_TableColumn;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_TableColumn;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_TableColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_TableCell (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_TableCell (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_TableCell _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_TableCell;
#else
_currn = (globalFrameView__TPPpglobalFrameView_TableCell) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_TableCell));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_TableCell;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_TableCell_columnRef) globalFrameView_MkglobalFrameView_TableCell_columnRef (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_TableCell: root of subtree no. 1 can not be made a globalFrameView_TableCell_columnRef node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_TableCell_content) globalFrameView_MkglobalFrameView_TableCell_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_TableCell: root of subtree no. 2 can not be made a globalFrameView_TableCell_content node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_TableCell;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_TableCell */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_TableCell_columnRef (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_TableCell_columnRef (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_TableCell_columnRef _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_TableCell_columnRef;
#else
_currn = (globalFrameView__TPPpglobalFrameView_TableCell_columnRef) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_TableCell_columnRef));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_TableCell_columnRef;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_TableCell_columnRef;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_TableCell_columnRef */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Formular (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Formular (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
#endif
{	globalFrameView__TPPpglobalFrameView_Formular _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Formular;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Formular) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Formular));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Formular;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_Formular_styleSheetBlock) globalFrameView_MkglobalFrameView_Formular_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Formular: root of subtree no. 1 can not be made a globalFrameView_Formular_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_Formular_name) globalFrameView_MkglobalFrameView_Formular_name (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Formular: root of subtree no. 2 can not be made a globalFrameView_Formular_name node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_Formular_action) globalFrameView_MkglobalFrameView_Formular_action (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Formular: root of subtree no. 3 can not be made a globalFrameView_Formular_action node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_Formular_dataSource) globalFrameView_MkglobalFrameView_Formular_dataSource (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Formular: root of subtree no. 4 can not be made a globalFrameView_Formular_dataSource node ", 0, _coordref);
_currn->_desc5 = (globalFrameView__TSPglobalFrameView_Formular_dataSourceId) globalFrameView_MkglobalFrameView_Formular_dataSourceId (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Formular: root of subtree no. 5 can not be made a globalFrameView_Formular_dataSourceId node ", 0, _coordref);
_currn->_desc6 = (globalFrameView__TSPglobalFrameView_Formular_elements) globalFrameView_MkglobalFrameView_Formular_elements (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Formular: root of subtree no. 6 can not be made a globalFrameView_Formular_elements node ", 0, _coordref);
_currn->_desc7 = (globalFrameView__TSPglobalFrameView_Formular_actualParams) globalFrameView_MkglobalFrameView_Formular_actualParams (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_Formular: root of subtree no. 7 can not be made a globalFrameView_Formular_actualParams node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Formular;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Formular */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Formular_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Formular_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_Formular_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Formular_styleSheetBlock;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Formular_styleSheetBlock) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Formular_styleSheetBlock));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Formular_styleSheetBlock;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Formular_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Formular_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Formular_name (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Formular_name (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_Formular_name _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Formular_name;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Formular_name) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Formular_name));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Formular_name;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Formular_name;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Formular_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Formular_action (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Formular_action (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_Formular_action _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Formular_action;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Formular_action) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Formular_action));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Formular_action;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Formular_action;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Formular_action */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Formular_dataSource (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Formular_dataSource (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_Formular_dataSource _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Formular_dataSource;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Formular_dataSource) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Formular_dataSource));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Formular_dataSource;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Formular_dataSource;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Formular_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Formular_dataSourceId (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Formular_dataSourceId (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_Formular_dataSourceId _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_Formular_dataSourceId;
#else
_currn = (globalFrameView__TPPpglobalFrameView_Formular_dataSourceId) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Formular_dataSourceId));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_Formular_dataSourceId;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_Formular_dataSourceId;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_Formular_dataSourceId */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Formular_elements)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularTextElementpglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularTextElementpglobalFrameView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularTextElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Formular_elements)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularTextAreaElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Formular_elements)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularPasswordElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Formular_elements)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularDateElementpglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularDateElementpglobalFrameView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularDateElementpglobalFrameView_Formular_elements _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularDateElementpglobalFrameView_Formular_elements;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularDateElementpglobalFrameView_Formular_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularDateElementpglobalFrameView_Formular_elements));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularDateElementpglobalFrameView_Formular_elements;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularDateElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Formular_elements)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularDateElementpglobalFrameView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularDateElementpglobalFrameView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularFileUploadElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Formular_elements)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularCheckboxElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Formular_elements)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularSelectElementpglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularSelectElementpglobalFrameView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularSelectElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Formular_elements)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_Formular_elements (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularRadioGroupElement)) 
		return globalFrameView__MkglobalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements (_coordref, globalFrameView_MkglobalFrameView_FormularRadioGroupElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularTextElement)) 
		return globalFrameView__MkglobalFrameView_FormularTextElementpglobalFrameView_Formular_elements (_coordref, globalFrameView_MkglobalFrameView_FormularTextElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularTextAreaElement)) 
		return globalFrameView__MkglobalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements (_coordref, globalFrameView_MkglobalFrameView_FormularTextAreaElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularPasswordElement)) 
		return globalFrameView__MkglobalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements (_coordref, globalFrameView_MkglobalFrameView_FormularPasswordElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularDateElement)) 
		return globalFrameView__MkglobalFrameView_FormularDateElementpglobalFrameView_Formular_elements (_coordref, globalFrameView_MkglobalFrameView_FormularDateElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularFileUploadElement)) 
		return globalFrameView__MkglobalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements (_coordref, globalFrameView_MkglobalFrameView_FormularFileUploadElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularCheckboxElement)) 
		return globalFrameView__MkglobalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements (_coordref, globalFrameView_MkglobalFrameView_FormularCheckboxElement (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularSelectElement)) 
		return globalFrameView__MkglobalFrameView_FormularSelectElementpglobalFrameView_Formular_elements (_coordref, globalFrameView_MkglobalFrameView_FormularSelectElement (_coordref, t));
	message (DEADLY, "a pglobalFrameView_Formular_elements list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_Formular_elements (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_Formular_elements)
	l =_ElempglobalFrameView_Formular_elements (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_Formular_elements)
	r = _ElempglobalFrameView_Formular_elements (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_Formular_elements)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_Formular_elements)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_Formular_elements)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_Formular_elements)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Formular_elements (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Formular_elements (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_Formular_elements root;
	globalFrameView__TPPLST_0pglobalFrameView_Formular_elements list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Formular_elements)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_Formular_elements)
		t = _ElempglobalFrameView_Formular_elements (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Formular_elements)(((globalFrameView__TPPLST_0pglobalFrameView_Formular_elements) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_Formular_elements) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_Formular_elements;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_Formular_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_Formular_elements));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_Formular_elements;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_Formular_elements)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements)
	{globalFrameView__TPPLST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularRadioGroupElementpglobalFrameView_Formular_elements;
	} this code has been moved to _ElempglobalFrameView_Formular_elements*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements)
	{globalFrameView__TPPLST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularTextElementpglobalFrameView_Formular_elements;
	} this code has been moved to _ElempglobalFrameView_Formular_elements*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements)
	{globalFrameView__TPPLST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularTextAreaElementpglobalFrameView_Formular_elements;
	} this code has been moved to _ElempglobalFrameView_Formular_elements*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements)
	{globalFrameView__TPPLST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularPasswordElementpglobalFrameView_Formular_elements;
	} this code has been moved to _ElempglobalFrameView_Formular_elements*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularDateElementpglobalFrameView_Formular_elements)
	{globalFrameView__TPPLST_globalFrameView_FormularDateElementpglobalFrameView_Formular_elements _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularDateElementpglobalFrameView_Formular_elements;
	} this code has been moved to _ElempglobalFrameView_Formular_elements*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements)
	{globalFrameView__TPPLST_globalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularFileUploadElementpglobalFrameView_Formular_elements;
	} this code has been moved to _ElempglobalFrameView_Formular_elements*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements)
	{globalFrameView__TPPLST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularCheckboxElementpglobalFrameView_Formular_elements;
	} this code has been moved to _ElempglobalFrameView_Formular_elements*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements)
	{globalFrameView__TPPLST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularSelectElementpglobalFrameView_Formular_elements;
	} this code has been moved to _ElempglobalFrameView_Formular_elements*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_Formular_elements;
#else
root = (globalFrameView__TPPpglobalFrameView_Formular_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Formular_elements));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_Formular_elements;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_Formular_elements)list;
{ globalFrameView__TPPpglobalFrameView_Formular_elements _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_Formular_elements;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeActualParam)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_Formular_actualParams)_new;
	{globalFrameView__TPPLST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_Formular_actualParams (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_Formular_actualParams (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_WebNodeActualParam)) 
		return globalFrameView__MkglobalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams (_coordref, globalFrameView_MkglobalFrameView_WebNodeActualParam (_coordref, t));
	message (DEADLY, "a pglobalFrameView_Formular_actualParams list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_Formular_actualParams (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_Formular_actualParams (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_Formular_actualParams)
	l =_ElempglobalFrameView_Formular_actualParams (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_Formular_actualParams)
	r = _ElempglobalFrameView_Formular_actualParams (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_Formular_actualParams (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_Formular_actualParams (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_Formular_actualParams root;
	globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_Formular_actualParams)
		t = _ElempglobalFrameView_Formular_actualParams (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams)(((globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_Formular_actualParams;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_Formular_actualParams));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_Formular_actualParams;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_Formular_actualParams)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams)
	{globalFrameView__TPPLST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_WebNodeActualParampglobalFrameView_Formular_actualParams;
	} this code has been moved to _ElempglobalFrameView_Formular_actualParams*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_Formular_actualParams;
#else
root = (globalFrameView__TPPpglobalFrameView_Formular_actualParams) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_Formular_actualParams));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_Formular_actualParams;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_Formular_actualParams)list;
{ globalFrameView__TPPpglobalFrameView_Formular_actualParams _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_Formular_actualParams;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_EmailValidator (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_EmailValidator (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_EmailValidator _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_EmailValidator;
#else
_currn = (globalFrameView__TPPpglobalFrameView_EmailValidator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_EmailValidator));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_EmailValidator;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_EmailValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_EmailValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_CreditCardValidator (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_CreditCardValidator (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_CreditCardValidator _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_CreditCardValidator;
#else
_currn = (globalFrameView__TPPpglobalFrameView_CreditCardValidator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_CreditCardValidator));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_CreditCardValidator;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_CreditCardValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_CreditCardValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_RegExprValidator (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_RegExprValidator (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_RegExprValidator _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_RegExprValidator;
#else
_currn = (globalFrameView__TPPpglobalFrameView_RegExprValidator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_RegExprValidator));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_RegExprValidator;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_RegExprValidator_pattern) globalFrameView_MkglobalFrameView_RegExprValidator_pattern (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_RegExprValidator: root of subtree no. 1 can not be made a globalFrameView_RegExprValidator_pattern node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_RegExprValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_RegExprValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_RegExprValidator_pattern (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_RegExprValidator_pattern (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_RegExprValidator_pattern _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_RegExprValidator_pattern;
#else
_currn = (globalFrameView__TPPpglobalFrameView_RegExprValidator_pattern) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_RegExprValidator_pattern));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_RegExprValidator_pattern;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_RegExprValidator_pattern;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_RegExprValidator_pattern */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_StringLengthValidator (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_StringLengthValidator (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_StringLengthValidator _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_StringLengthValidator;
#else
_currn = (globalFrameView__TPPpglobalFrameView_StringLengthValidator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_StringLengthValidator));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_StringLengthValidator;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_StringLengthValidator_min) globalFrameView_MkglobalFrameView_StringLengthValidator_min (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_StringLengthValidator: root of subtree no. 1 can not be made a globalFrameView_StringLengthValidator_min node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_StringLengthValidator_max) globalFrameView_MkglobalFrameView_StringLengthValidator_max (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_StringLengthValidator: root of subtree no. 2 can not be made a globalFrameView_StringLengthValidator_max node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_StringLengthValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_StringLengthValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_StringLengthValidator_min (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_StringLengthValidator_min (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_StringLengthValidator_min _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_StringLengthValidator_min;
#else
_currn = (globalFrameView__TPPpglobalFrameView_StringLengthValidator_min) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_StringLengthValidator_min));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_StringLengthValidator_min;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_StringLengthValidator_min;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_StringLengthValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_StringLengthValidator_max (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_StringLengthValidator_max (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_StringLengthValidator_max _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_StringLengthValidator_max;
#else
_currn = (globalFrameView__TPPpglobalFrameView_StringLengthValidator_max) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_StringLengthValidator_max));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_StringLengthValidator_max;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_StringLengthValidator_max;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_StringLengthValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_LongRangeValidator (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_LongRangeValidator (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_LongRangeValidator _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_LongRangeValidator;
#else
_currn = (globalFrameView__TPPpglobalFrameView_LongRangeValidator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_LongRangeValidator));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_LongRangeValidator;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_LongRangeValidator_min) globalFrameView_MkglobalFrameView_LongRangeValidator_min (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_LongRangeValidator: root of subtree no. 1 can not be made a globalFrameView_LongRangeValidator_min node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_LongRangeValidator_max) globalFrameView_MkglobalFrameView_LongRangeValidator_max (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_LongRangeValidator: root of subtree no. 2 can not be made a globalFrameView_LongRangeValidator_max node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_LongRangeValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_LongRangeValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_LongRangeValidator_min (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_LongRangeValidator_min (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_LongRangeValidator_min _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_LongRangeValidator_min;
#else
_currn = (globalFrameView__TPPpglobalFrameView_LongRangeValidator_min) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_LongRangeValidator_min));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_LongRangeValidator_min;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_LongRangeValidator_min;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_LongRangeValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_LongRangeValidator_max (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_LongRangeValidator_max (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_LongRangeValidator_max _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_LongRangeValidator_max;
#else
_currn = (globalFrameView__TPPpglobalFrameView_LongRangeValidator_max) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_LongRangeValidator_max));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_LongRangeValidator_max;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_LongRangeValidator_max;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_LongRangeValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DoubleRangeValidator (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DoubleRangeValidator (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_DoubleRangeValidator _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DoubleRangeValidator;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DoubleRangeValidator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DoubleRangeValidator));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DoubleRangeValidator;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleRangeValidator_min) globalFrameView_MkglobalFrameView_DoubleRangeValidator_min (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_DoubleRangeValidator: root of subtree no. 1 can not be made a globalFrameView_DoubleRangeValidator_min node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_DoubleRangeValidator_max) globalFrameView_MkglobalFrameView_DoubleRangeValidator_max (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_DoubleRangeValidator: root of subtree no. 2 can not be made a globalFrameView_DoubleRangeValidator_max node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DoubleRangeValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DoubleRangeValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DoubleRangeValidator_min (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DoubleRangeValidator_min (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_DoubleRangeValidator_min _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DoubleRangeValidator_min;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DoubleRangeValidator_min) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DoubleRangeValidator_min));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DoubleRangeValidator_min;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DoubleRangeValidator_min;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DoubleRangeValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DoubleRangeValidator_max (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DoubleRangeValidator_max (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_DoubleRangeValidator_max _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DoubleRangeValidator_max;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DoubleRangeValidator_max) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DoubleRangeValidator_max));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DoubleRangeValidator_max;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DoubleRangeValidator_max;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DoubleRangeValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_IntegerNumberConverter (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_IntegerNumberConverter (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_IntegerNumberConverter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_IntegerNumberConverter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_IntegerNumberConverter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_IntegerNumberConverter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_IntegerNumberConverter;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_IntegerNumberConverter_minIntegerDigits) globalFrameView_MkglobalFrameView_IntegerNumberConverter_minIntegerDigits (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_IntegerNumberConverter: root of subtree no. 1 can not be made a globalFrameView_IntegerNumberConverter_minIntegerDigits node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_IntegerNumberConverter_maxIntegerDigits) globalFrameView_MkglobalFrameView_IntegerNumberConverter_maxIntegerDigits (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_IntegerNumberConverter: root of subtree no. 2 can not be made a globalFrameView_IntegerNumberConverter_maxIntegerDigits node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_IntegerNumberConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_IntegerNumberConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_IntegerNumberConverter_minIntegerDigits (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_IntegerNumberConverter_minIntegerDigits (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_IntegerNumberConverter_minIntegerDigits _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_IntegerNumberConverter_minIntegerDigits;
#else
_currn = (globalFrameView__TPPpglobalFrameView_IntegerNumberConverter_minIntegerDigits) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_IntegerNumberConverter_minIntegerDigits));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_IntegerNumberConverter_minIntegerDigits;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_IntegerNumberConverter_minIntegerDigits;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_IntegerNumberConverter_minIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_IntegerNumberConverter_maxIntegerDigits (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_IntegerNumberConverter_maxIntegerDigits (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_IntegerNumberConverter_maxIntegerDigits _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_IntegerNumberConverter_maxIntegerDigits;
#else
_currn = (globalFrameView__TPPpglobalFrameView_IntegerNumberConverter_maxIntegerDigits) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_IntegerNumberConverter_maxIntegerDigits));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_IntegerNumberConverter_maxIntegerDigits;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_IntegerNumberConverter_maxIntegerDigits;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_IntegerNumberConverter_maxIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DoubleNumberConverter (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DoubleNumberConverter (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_DoubleNumberConverter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DoubleNumberConverter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DoubleNumberConverter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DoubleNumberConverter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DoubleNumberConverter;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleNumberConverter_minIntegerDigits) globalFrameView_MkglobalFrameView_DoubleNumberConverter_minIntegerDigits (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_DoubleNumberConverter: root of subtree no. 1 can not be made a globalFrameView_DoubleNumberConverter_minIntegerDigits node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_DoubleNumberConverter_maxIntegerDigits) globalFrameView_MkglobalFrameView_DoubleNumberConverter_maxIntegerDigits (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_DoubleNumberConverter: root of subtree no. 2 can not be made a globalFrameView_DoubleNumberConverter_maxIntegerDigits node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_DoubleNumberConverter_minFractionDigits) globalFrameView_MkglobalFrameView_DoubleNumberConverter_minFractionDigits (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_DoubleNumberConverter: root of subtree no. 3 can not be made a globalFrameView_DoubleNumberConverter_minFractionDigits node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_DoubleNumberConverter_maxFractionDigits) globalFrameView_MkglobalFrameView_DoubleNumberConverter_maxFractionDigits (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_DoubleNumberConverter: root of subtree no. 4 can not be made a globalFrameView_DoubleNumberConverter_maxFractionDigits node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DoubleNumberConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DoubleNumberConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DoubleNumberConverter_minIntegerDigits (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DoubleNumberConverter_minIntegerDigits (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_DoubleNumberConverter_minIntegerDigits _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DoubleNumberConverter_minIntegerDigits;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DoubleNumberConverter_minIntegerDigits) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DoubleNumberConverter_minIntegerDigits));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DoubleNumberConverter_minIntegerDigits;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DoubleNumberConverter_minIntegerDigits;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DoubleNumberConverter_minIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DoubleNumberConverter_maxIntegerDigits (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DoubleNumberConverter_maxIntegerDigits (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_DoubleNumberConverter_maxIntegerDigits _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DoubleNumberConverter_maxIntegerDigits;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DoubleNumberConverter_maxIntegerDigits) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DoubleNumberConverter_maxIntegerDigits));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DoubleNumberConverter_maxIntegerDigits;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DoubleNumberConverter_maxIntegerDigits;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DoubleNumberConverter_maxIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DoubleNumberConverter_minFractionDigits (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DoubleNumberConverter_minFractionDigits (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_DoubleNumberConverter_minFractionDigits _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DoubleNumberConverter_minFractionDigits;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DoubleNumberConverter_minFractionDigits) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DoubleNumberConverter_minFractionDigits));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DoubleNumberConverter_minFractionDigits;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DoubleNumberConverter_minFractionDigits;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DoubleNumberConverter_minFractionDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DoubleNumberConverter_maxFractionDigits (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DoubleNumberConverter_maxFractionDigits (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_DoubleNumberConverter_maxFractionDigits _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DoubleNumberConverter_maxFractionDigits;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DoubleNumberConverter_maxFractionDigits) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DoubleNumberConverter_maxFractionDigits));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DoubleNumberConverter_maxFractionDigits;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DoubleNumberConverter_maxFractionDigits;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DoubleNumberConverter_maxFractionDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_IntegerConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_IntegerConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_IntegerConverter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_IntegerConverter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_IntegerConverter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_IntegerConverter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_IntegerConverter;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_IntegerConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_IntegerConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_LongConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_LongConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_LongConverter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_LongConverter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_LongConverter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_LongConverter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_LongConverter;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_LongConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_LongConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_BigIntegerConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_BigIntegerConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_BigIntegerConverter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_BigIntegerConverter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_BigIntegerConverter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_BigIntegerConverter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_BigIntegerConverter;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_BigIntegerConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_BigIntegerConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FloatConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FloatConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_FloatConverter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FloatConverter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FloatConverter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FloatConverter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FloatConverter;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FloatConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FloatConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DoubleConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DoubleConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_DoubleConverter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DoubleConverter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DoubleConverter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DoubleConverter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DoubleConverter;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DoubleConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DoubleConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_BooleanConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_BooleanConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_BooleanConverter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_BooleanConverter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_BooleanConverter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_BooleanConverter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_BooleanConverter;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_BooleanConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_BooleanConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_DateTimeConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_DateTimeConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_DateTimeConverter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_DateTimeConverter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_DateTimeConverter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_DateTimeConverter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_DateTimeConverter;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_DateTimeConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_DateTimeConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_PatternConverter (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_PatternConverter (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_PatternConverter _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_PatternConverter;
#else
_currn = (globalFrameView__TPPpglobalFrameView_PatternConverter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_PatternConverter));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_PatternConverter;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_PatternConverter_pattern) globalFrameView_MkglobalFrameView_PatternConverter_pattern (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_PatternConverter: root of subtree no. 1 can not be made a globalFrameView_PatternConverter_pattern node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_PatternConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_PatternConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_PatternConverter_pattern (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_PatternConverter_pattern (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_PatternConverter_pattern _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_PatternConverter_pattern;
#else
_currn = (globalFrameView__TPPpglobalFrameView_PatternConverter_pattern) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_PatternConverter_pattern));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_PatternConverter_pattern;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_PatternConverter_pattern;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_PatternConverter_pattern */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7, NODEPTR _desc8, NODEPTR _desc9, NODEPTR _desc10)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7,_desc8,_desc9,_desc10)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
	NODEPTR _desc8;
	NODEPTR _desc9;
	NODEPTR _desc10;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement_name) globalFrameView_MkglobalFrameView_FormularRadioGroupElement_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioGroupElement: root of subtree no. 1 can not be made a globalFrameView_FormularRadioGroupElement_name node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement_label) globalFrameView_MkglobalFrameView_FormularRadioGroupElement_label (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioGroupElement: root of subtree no. 2 can not be made a globalFrameView_FormularRadioGroupElement_label node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement_description) globalFrameView_MkglobalFrameView_FormularRadioGroupElement_description (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioGroupElement: root of subtree no. 3 can not be made a globalFrameView_FormularRadioGroupElement_description node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement_pvalue) globalFrameView_MkglobalFrameView_FormularRadioGroupElement_pvalue (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioGroupElement: root of subtree no. 4 can not be made a globalFrameView_FormularRadioGroupElement_pvalue node ", 0, _coordref);
_currn->_desc5 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement_required) globalFrameView_MkglobalFrameView_FormularRadioGroupElement_required (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioGroupElement: root of subtree no. 5 can not be made a globalFrameView_FormularRadioGroupElement_required node ", 0, _coordref);
_currn->_desc6 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement_validator) globalFrameView_MkglobalFrameView_FormularRadioGroupElement_validator (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioGroupElement: root of subtree no. 6 can not be made a globalFrameView_FormularRadioGroupElement_validator node ", 0, _coordref);
_currn->_desc7 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_MkglobalFrameView_FormularRadioGroupElement_converter (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioGroupElement: root of subtree no. 7 can not be made a globalFrameView_FormularRadioGroupElement_converter node ", 0, _coordref);
_currn->_desc8 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement_layout) globalFrameView_MkglobalFrameView_FormularRadioGroupElement_layout (_coordref, _desc8);	
if (((NODEPTR)_currn->_desc8) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioGroupElement: root of subtree no. 8 can not be made a globalFrameView_FormularRadioGroupElement_layout node ", 0, _coordref);
_currn->_desc9 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement_elements) globalFrameView_MkglobalFrameView_FormularRadioGroupElement_elements (_coordref, _desc9);	
if (((NODEPTR)_currn->_desc9) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioGroupElement: root of subtree no. 9 can not be made a globalFrameView_FormularRadioGroupElement_elements node ", 0, _coordref);
_currn->_desc10 = (globalFrameView__TSPglobalFrameView_FormularRadioGroupElement_checked) globalFrameView_MkglobalFrameView_FormularRadioGroupElement_checked (_coordref, _desc10);	
if (((NODEPTR)_currn->_desc10) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularRadioGroupElement: root of subtree no. 10 can not be made a globalFrameView_FormularRadioGroupElement_checked node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioGroupElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_name (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_name (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_name _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_name;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_name) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_name));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement_name;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement_name;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_description (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_description (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_description _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_description;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_description) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_description));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement_description;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement_description;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_pvalue (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_pvalue (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_pvalue _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_pvalue;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_pvalue) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_pvalue));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement_pvalue;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement_pvalue;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_pvalue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_required (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_required (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_required _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_required;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_required) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_required));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement_required;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement_required;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_required */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_EmailValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_CreditCardValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_RegExprValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_StringLengthValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_LongRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleRangeValidator)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_validator)_new;
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularRadioGroupElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_EmailValidator)) 
		return globalFrameView__MkglobalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, globalFrameView_MkglobalFrameView_EmailValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_CreditCardValidator)) 
		return globalFrameView__MkglobalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, globalFrameView_MkglobalFrameView_CreditCardValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_RegExprValidator)) 
		return globalFrameView__MkglobalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, globalFrameView_MkglobalFrameView_RegExprValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_StringLengthValidator)) 
		return globalFrameView__MkglobalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, globalFrameView_MkglobalFrameView_StringLengthValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_LongRangeValidator)) 
		return globalFrameView__MkglobalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, globalFrameView_MkglobalFrameView_LongRangeValidator (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DoubleRangeValidator)) 
		return globalFrameView__MkglobalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator (_coordref, globalFrameView_MkglobalFrameView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularRadioGroupElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularRadioGroupElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularRadioGroupElement_validator)
	l =_ElempglobalFrameView_FormularRadioGroupElement_validator (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularRadioGroupElement_validator)
	r = _ElempglobalFrameView_FormularRadioGroupElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_validator root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularRadioGroupElement_validator)
		t = _ElempglobalFrameView_FormularRadioGroupElement_validator (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator)(((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularRadioGroupElement_validator;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularRadioGroupElement_validator));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularRadioGroupElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator)
	{globalFrameView__TPPLST_globalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_EmailValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator)
	{globalFrameView__TPPLST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_CreditCardValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator)
	{globalFrameView__TPPLST_globalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_RegExprValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator)
	{globalFrameView__TPPLST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_StringLengthValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator)
	{globalFrameView__TPPLST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_LongRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_validator*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator)
	{globalFrameView__TPPLST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleRangeValidatorpglobalFrameView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_validator;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_validator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_validator));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement_validator;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_validator)list;
{ globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_validator _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_IntegerNumberConverter)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)_new;
	{globalFrameView__TPPLST_globalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleNumberConverter)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)_new;
	{globalFrameView__TPPLST_globalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_IntegerConverter)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)_new;
	{globalFrameView__TPPLST_globalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_LongConverter)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)_new;
	{globalFrameView__TPPLST_globalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_BigIntegerConverter)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)_new;
	{globalFrameView__TPPLST_globalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FloatConverter)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)_new;
	{globalFrameView__TPPLST_globalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DoubleConverter)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)_new;
	{globalFrameView__TPPLST_globalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_BooleanConverter)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)_new;
	{globalFrameView__TPPLST_globalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DateTimeConverter)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)_new;
	{globalFrameView__TPPLST_globalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_PatternConverter)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)_new;
	{globalFrameView__TPPLST_globalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularRadioGroupElement_converter (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_IntegerNumberConverter)) 
		return globalFrameView__MkglobalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, globalFrameView_MkglobalFrameView_IntegerNumberConverter (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DoubleNumberConverter)) 
		return globalFrameView__MkglobalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, globalFrameView_MkglobalFrameView_DoubleNumberConverter (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_IntegerConverter)) 
		return globalFrameView__MkglobalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, globalFrameView_MkglobalFrameView_IntegerConverter (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_LongConverter)) 
		return globalFrameView__MkglobalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, globalFrameView_MkglobalFrameView_LongConverter (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_BigIntegerConverter)) 
		return globalFrameView__MkglobalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, globalFrameView_MkglobalFrameView_BigIntegerConverter (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FloatConverter)) 
		return globalFrameView__MkglobalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, globalFrameView_MkglobalFrameView_FloatConverter (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DoubleConverter)) 
		return globalFrameView__MkglobalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, globalFrameView_MkglobalFrameView_DoubleConverter (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_BooleanConverter)) 
		return globalFrameView__MkglobalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, globalFrameView_MkglobalFrameView_BooleanConverter (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DateTimeConverter)) 
		return globalFrameView__MkglobalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, globalFrameView_MkglobalFrameView_DateTimeConverter (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_PatternConverter)) 
		return globalFrameView__MkglobalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter (_coordref, globalFrameView_MkglobalFrameView_PatternConverter (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularRadioGroupElement_converter list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularRadioGroupElement_converter (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularRadioGroupElement_converter)
	l =_ElempglobalFrameView_FormularRadioGroupElement_converter (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularRadioGroupElement_converter)
	r = _ElempglobalFrameView_FormularRadioGroupElement_converter (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_converter (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_converter root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularRadioGroupElement_converter)
		t = _ElempglobalFrameView_FormularRadioGroupElement_converter (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter)(((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularRadioGroupElement_converter;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularRadioGroupElement_converter));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularRadioGroupElement_converter;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_converter)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter)
	{globalFrameView__TPPLST_globalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_IntegerNumberConverterpglobalFrameView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter)
	{globalFrameView__TPPLST_globalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleNumberConverterpglobalFrameView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter)
	{globalFrameView__TPPLST_globalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_IntegerConverterpglobalFrameView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter)
	{globalFrameView__TPPLST_globalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_LongConverterpglobalFrameView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter)
	{globalFrameView__TPPLST_globalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_BigIntegerConverterpglobalFrameView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter)
	{globalFrameView__TPPLST_globalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FloatConverterpglobalFrameView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter)
	{globalFrameView__TPPLST_globalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DoubleConverterpglobalFrameView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter)
	{globalFrameView__TPPLST_globalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_BooleanConverterpglobalFrameView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter)
	{globalFrameView__TPPLST_globalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DateTimeConverterpglobalFrameView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter)
	{globalFrameView__TPPLST_globalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_PatternConverterpglobalFrameView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_converter*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_converter;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_converter) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_converter));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement_converter;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_converter)list;
{ globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_converter _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement_converter;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_layout (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_layout (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_layout _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_layout;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_layout) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_layout));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement_layout;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement_layout;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_layout */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_FormularRadioElement)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_elements)_new;
	{globalFrameView__TPPLST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularRadioGroupElement_elements (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularRadioGroupElement_elements (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_FormularRadioElement)) 
		return globalFrameView__MkglobalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements (_coordref, globalFrameView_MkglobalFrameView_FormularRadioElement (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularRadioGroupElement_elements list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularRadioGroupElement_elements (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularRadioGroupElement_elements (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularRadioGroupElement_elements)
	l =_ElempglobalFrameView_FormularRadioGroupElement_elements (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularRadioGroupElement_elements)
	r = _ElempglobalFrameView_FormularRadioGroupElement_elements (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_elements (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_elements (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_elements root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularRadioGroupElement_elements)
		t = _ElempglobalFrameView_FormularRadioGroupElement_elements (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements)(((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularRadioGroupElement_elements;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularRadioGroupElement_elements));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularRadioGroupElement_elements;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularRadioGroupElement_elements)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements)
	{globalFrameView__TPPLST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_FormularRadioElementpglobalFrameView_FormularRadioGroupElement_elements;
	} this code has been moved to _ElempglobalFrameView_FormularRadioGroupElement_elements*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_elements;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_elements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_elements));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement_elements;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularRadioGroupElement_elements)list;
{ globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_elements _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement_elements;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_checked (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_checked (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_checked _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_checked;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularRadioGroupElement_checked) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularRadioGroupElement_checked));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularRadioGroupElement_checked;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularRadioGroupElement_checked;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularRadioGroupElement_checked */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularConstantSelectOption (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularConstantSelectOption (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularConstantSelectOption _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularConstantSelectOption;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularConstantSelectOption) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularConstantSelectOption));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularConstantSelectOption;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularConstantSelectOption_options) globalFrameView_MkglobalFrameView_FormularConstantSelectOption_options (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularConstantSelectOption: root of subtree no. 1 can not be made a globalFrameView_FormularConstantSelectOption_options node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularConstantSelectOption;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularConstantSelectOption */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_SelectOption)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_FormularConstantSelectOption_options)_new;
	{globalFrameView__TPPLST_globalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_FormularConstantSelectOption_options (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_SelectOption)) 
		return globalFrameView__MkglobalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options (_coordref, globalFrameView_MkglobalFrameView_SelectOption (_coordref, t));
	message (DEADLY, "a pglobalFrameView_FormularConstantSelectOption_options list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_FormularConstantSelectOption_options (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularConstantSelectOption_options)
	l =_ElempglobalFrameView_FormularConstantSelectOption_options (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularConstantSelectOption_options)
	r = _ElempglobalFrameView_FormularConstantSelectOption_options (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularConstantSelectOption_options (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_FormularConstantSelectOption_options root;
	globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_FormularConstantSelectOption_options)
		t = _ElempglobalFrameView_FormularConstantSelectOption_options (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options)(((globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_FormularConstantSelectOption_options;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_FormularConstantSelectOption_options));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_FormularConstantSelectOption_options;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_FormularConstantSelectOption_options)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options)
	{globalFrameView__TPPLST_globalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_SelectOptionpglobalFrameView_FormularConstantSelectOption_options;
	} this code has been moved to _ElempglobalFrameView_FormularConstantSelectOption_options*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_FormularConstantSelectOption_options;
#else
root = (globalFrameView__TPPpglobalFrameView_FormularConstantSelectOption_options) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularConstantSelectOption_options));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_FormularConstantSelectOption_options;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_FormularConstantSelectOption_options)list;
{ globalFrameView__TPPpglobalFrameView_FormularConstantSelectOption_options _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_FormularConstantSelectOption_options;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_SelectOption (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_SelectOption (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_SelectOption _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_SelectOption;
#else
_currn = (globalFrameView__TPPpglobalFrameView_SelectOption) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_SelectOption));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_SelectOption;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_SelectOption_value) globalFrameView_MkglobalFrameView_SelectOption_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_SelectOption: root of subtree no. 1 can not be made a globalFrameView_SelectOption_value node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_SelectOption_label) globalFrameView_MkglobalFrameView_SelectOption_label (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_SelectOption: root of subtree no. 2 can not be made a globalFrameView_SelectOption_label node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_SelectOption;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_SelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_SelectOption_value (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_SelectOption_value (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_SelectOption_value _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_SelectOption_value;
#else
_currn = (globalFrameView__TPPpglobalFrameView_SelectOption_value) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_SelectOption_value));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_SelectOption_value;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_SelectOption_value;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_SelectOption_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_SelectOption_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_SelectOption_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_SelectOption_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_SelectOption_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_SelectOption_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_SelectOption_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_SelectOption_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_SelectOption_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_SelectOption_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularDataSourceSelectOption _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularDataSourceSelectOption;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularDataSourceSelectOption) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularDataSourceSelectOption));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularDataSourceSelectOption;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_FormularDataSourceSelectOption_name) globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularDataSourceSelectOption: root of subtree no. 1 can not be made a globalFrameView_FormularDataSourceSelectOption_name node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_FormularDataSourceSelectOption_dataSource) globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_dataSource (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularDataSourceSelectOption: root of subtree no. 2 can not be made a globalFrameView_FormularDataSourceSelectOption_dataSource node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_FormularDataSourceSelectOption_value) globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_value (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularDataSourceSelectOption: root of subtree no. 3 can not be made a globalFrameView_FormularDataSourceSelectOption_value node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_FormularDataSourceSelectOption_label) globalFrameView_MkglobalFrameView_FormularDataSourceSelectOption_label (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_FormularDataSourceSelectOption: root of subtree no. 4 can not be made a globalFrameView_FormularDataSourceSelectOption_label node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularDataSourceSelectOption;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_name (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_name (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularDataSourceSelectOption_name _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularDataSourceSelectOption_name;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularDataSourceSelectOption_name) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularDataSourceSelectOption_name));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularDataSourceSelectOption_name;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularDataSourceSelectOption_name;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_dataSource (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_dataSource (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularDataSourceSelectOption_dataSource _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularDataSourceSelectOption_dataSource;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularDataSourceSelectOption_dataSource) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularDataSourceSelectOption_dataSource));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularDataSourceSelectOption_dataSource;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularDataSourceSelectOption_dataSource;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_value (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_value (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularDataSourceSelectOption_value _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularDataSourceSelectOption_value;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularDataSourceSelectOption_value) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularDataSourceSelectOption_value));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularDataSourceSelectOption_value;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularDataSourceSelectOption_value;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_label (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_label (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_FormularDataSourceSelectOption_label _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_FormularDataSourceSelectOption_label;
#else
_currn = (globalFrameView__TPPpglobalFrameView_FormularDataSourceSelectOption_label) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_FormularDataSourceSelectOption_label));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_FormularDataSourceSelectOption_label;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_FormularDataSourceSelectOption_label;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_FormularDataSourceSelectOption_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_MD5Modifier (POSITION *_coordref, int _TERM1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_MD5Modifier (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	globalFrameView__TPPpglobalFrameView_MD5Modifier _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_MD5Modifier;
#else
_currn = (globalFrameView__TPPpglobalFrameView_MD5Modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_MD5Modifier));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_MD5Modifier;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_MD5Modifier;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_MD5Modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_JoinModifier (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_JoinModifier (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_JoinModifier _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_JoinModifier;
#else
_currn = (globalFrameView__TPPpglobalFrameView_JoinModifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_JoinModifier));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_JoinModifier;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_JoinModifier_separator) globalFrameView_MkglobalFrameView_JoinModifier_separator (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_JoinModifier: root of subtree no. 1 can not be made a globalFrameView_JoinModifier_separator node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_JoinModifier;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_JoinModifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_JoinModifier_separator (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_JoinModifier_separator (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_JoinModifier_separator _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_JoinModifier_separator;
#else
_currn = (globalFrameView__TPPpglobalFrameView_JoinModifier_separator) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_JoinModifier_separator));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_JoinModifier_separator;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_JoinModifier_separator;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_JoinModifier_separator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeConstantExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeConstantExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_WebNodeConstantExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_WebNodeConstantExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_WebNodeConstantExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeConstantExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_WebNodeConstantExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeConstantExpression_modifier) globalFrameView_MkglobalFrameView_WebNodeConstantExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_WebNodeConstantExpression: root of subtree no. 1 can not be made a globalFrameView_WebNodeConstantExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_WebNodeConstantExpression_value) globalFrameView_MkglobalFrameView_WebNodeConstantExpression_value (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_WebNodeConstantExpression: root of subtree no. 2 can not be made a globalFrameView_WebNodeConstantExpression_value node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_WebNodeConstantExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_WebNodeConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_MD5Modifier)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_WebNodeConstantExpression_modifier)_new;
	{globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_JoinModifier)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_WebNodeConstantExpression_modifier)_new;
	{globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_WebNodeConstantExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_MD5Modifier)) 
		return globalFrameView__MkglobalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier (_coordref, globalFrameView_MkglobalFrameView_MD5Modifier (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_JoinModifier)) 
		return globalFrameView__MkglobalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier (_coordref, globalFrameView_MkglobalFrameView_JoinModifier (_coordref, t));
	message (DEADLY, "a pglobalFrameView_WebNodeConstantExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_WebNodeConstantExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeConstantExpression_modifier)
	l =_ElempglobalFrameView_WebNodeConstantExpression_modifier (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeConstantExpression_modifier)
	r = _ElempglobalFrameView_WebNodeConstantExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeConstantExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_WebNodeConstantExpression_modifier root;
	globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeConstantExpression_modifier)
		t = _ElempglobalFrameView_WebNodeConstantExpression_modifier (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier)(((globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_WebNodeConstantExpression_modifier;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_WebNodeConstantExpression_modifier));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_WebNodeConstantExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeConstantExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier)
	{globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeConstantExpression_modifier;
	} this code has been moved to _ElempglobalFrameView_WebNodeConstantExpression_modifier*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier)
	{globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_JoinModifierpglobalFrameView_WebNodeConstantExpression_modifier;
	} this code has been moved to _ElempglobalFrameView_WebNodeConstantExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_WebNodeConstantExpression_modifier;
#else
root = (globalFrameView__TPPpglobalFrameView_WebNodeConstantExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeConstantExpression_modifier));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_WebNodeConstantExpression_modifier;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_WebNodeConstantExpression_modifier)list;
{ globalFrameView__TPPpglobalFrameView_WebNodeConstantExpression_modifier _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_WebNodeConstantExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeConstantExpression_value (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeConstantExpression_value (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_WebNodeConstantExpression_value _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_WebNodeConstantExpression_value;
#else
_currn = (globalFrameView__TPPpglobalFrameView_WebNodeConstantExpression_value) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeConstantExpression_value));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_WebNodeConstantExpression_value;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_WebNodeConstantExpression_value;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_WebNodeConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeVariableExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeVariableExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_WebNodeVariableExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_WebNodeVariableExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_WebNodeVariableExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeVariableExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_WebNodeVariableExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeVariableExpression_modifier) globalFrameView_MkglobalFrameView_WebNodeVariableExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_WebNodeVariableExpression: root of subtree no. 1 can not be made a globalFrameView_WebNodeVariableExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_WebNodeVariableExpression_content) globalFrameView_MkglobalFrameView_WebNodeVariableExpression_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_WebNodeVariableExpression: root of subtree no. 2 can not be made a globalFrameView_WebNodeVariableExpression_content node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_WebNodeVariableExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_WebNodeVariableExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_MD5Modifier)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_WebNodeVariableExpression_modifier)_new;
	{globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_JoinModifier)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_WebNodeVariableExpression_modifier)_new;
	{globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_WebNodeVariableExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_MD5Modifier)) 
		return globalFrameView__MkglobalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier (_coordref, globalFrameView_MkglobalFrameView_MD5Modifier (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_JoinModifier)) 
		return globalFrameView__MkglobalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier (_coordref, globalFrameView_MkglobalFrameView_JoinModifier (_coordref, t));
	message (DEADLY, "a pglobalFrameView_WebNodeVariableExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_WebNodeVariableExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeVariableExpression_modifier)
	l =_ElempglobalFrameView_WebNodeVariableExpression_modifier (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeVariableExpression_modifier)
	r = _ElempglobalFrameView_WebNodeVariableExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeVariableExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_WebNodeVariableExpression_modifier root;
	globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeVariableExpression_modifier)
		t = _ElempglobalFrameView_WebNodeVariableExpression_modifier (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier)(((globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_WebNodeVariableExpression_modifier;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_WebNodeVariableExpression_modifier));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_WebNodeVariableExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeVariableExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier)
	{globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeVariableExpression_modifier;
	} this code has been moved to _ElempglobalFrameView_WebNodeVariableExpression_modifier*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier)
	{globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_JoinModifierpglobalFrameView_WebNodeVariableExpression_modifier;
	} this code has been moved to _ElempglobalFrameView_WebNodeVariableExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_WebNodeVariableExpression_modifier;
#else
root = (globalFrameView__TPPpglobalFrameView_WebNodeVariableExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeVariableExpression_modifier));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_WebNodeVariableExpression_modifier;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_WebNodeVariableExpression_modifier)list;
{ globalFrameView__TPPpglobalFrameView_WebNodeVariableExpression_modifier _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_WebNodeVariableExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeVariableExpression_content (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeVariableExpression_content (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_WebNodeVariableExpression_content _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_WebNodeVariableExpression_content;
#else
_currn = (globalFrameView__TPPpglobalFrameView_WebNodeVariableExpression_content) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeVariableExpression_content));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_WebNodeVariableExpression_content;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_WebNodeVariableExpression_content;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_WebNodeVariableExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeSessionExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeSessionExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_WebNodeSessionExpression _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_WebNodeSessionExpression;
#else
_currn = (globalFrameView__TPPpglobalFrameView_WebNodeSessionExpression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeSessionExpression));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_WebNodeSessionExpression;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_WebNodeSessionExpression_modifier) globalFrameView_MkglobalFrameView_WebNodeSessionExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_WebNodeSessionExpression: root of subtree no. 1 can not be made a globalFrameView_WebNodeSessionExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_WebNodeSessionExpression_content) globalFrameView_MkglobalFrameView_WebNodeSessionExpression_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_WebNodeSessionExpression: root of subtree no. 2 can not be made a globalFrameView_WebNodeSessionExpression_content node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_WebNodeSessionExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_WebNodeSessionExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_MD5Modifier)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_WebNodeSessionExpression_modifier)_new;
	{globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_JoinModifier)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_WebNodeSessionExpression_modifier)_new;
	{globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_WebNodeSessionExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_MD5Modifier)) 
		return globalFrameView__MkglobalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier (_coordref, globalFrameView_MkglobalFrameView_MD5Modifier (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_JoinModifier)) 
		return globalFrameView__MkglobalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier (_coordref, globalFrameView_MkglobalFrameView_JoinModifier (_coordref, t));
	message (DEADLY, "a pglobalFrameView_WebNodeSessionExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_WebNodeSessionExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeSessionExpression_modifier)
	l =_ElempglobalFrameView_WebNodeSessionExpression_modifier (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeSessionExpression_modifier)
	r = _ElempglobalFrameView_WebNodeSessionExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeSessionExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_WebNodeSessionExpression_modifier root;
	globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_WebNodeSessionExpression_modifier)
		t = _ElempglobalFrameView_WebNodeSessionExpression_modifier (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier)(((globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_WebNodeSessionExpression_modifier;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_WebNodeSessionExpression_modifier));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_WebNodeSessionExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_WebNodeSessionExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier)
	{globalFrameView__TPPLST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_MD5ModifierpglobalFrameView_WebNodeSessionExpression_modifier;
	} this code has been moved to _ElempglobalFrameView_WebNodeSessionExpression_modifier*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier)
	{globalFrameView__TPPLST_globalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_JoinModifierpglobalFrameView_WebNodeSessionExpression_modifier;
	} this code has been moved to _ElempglobalFrameView_WebNodeSessionExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_WebNodeSessionExpression_modifier;
#else
root = (globalFrameView__TPPpglobalFrameView_WebNodeSessionExpression_modifier) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeSessionExpression_modifier));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_WebNodeSessionExpression_modifier;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_WebNodeSessionExpression_modifier)list;
{ globalFrameView__TPPpglobalFrameView_WebNodeSessionExpression_modifier _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_WebNodeSessionExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeSessionExpression_content (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_WebNodeSessionExpression_content (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_WebNodeSessionExpression_content _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_WebNodeSessionExpression_content;
#else
_currn = (globalFrameView__TPPpglobalFrameView_WebNodeSessionExpression_content) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_WebNodeSessionExpression_content));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_WebNodeSessionExpression_content;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_WebNodeSessionExpression_content;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_WebNodeSessionExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_OutputFragment (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_OutputFragment (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_OutputFragment _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_OutputFragment;
#else
_currn = (globalFrameView__TPPpglobalFrameView_OutputFragment) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_OutputFragment));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_OutputFragment;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_OutputFragment_link) globalFrameView_MkglobalFrameView_OutputFragment_link (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_OutputFragment: root of subtree no. 1 can not be made a globalFrameView_OutputFragment_link node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_OutputFragment_content) globalFrameView_MkglobalFrameView_OutputFragment_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_OutputFragment: root of subtree no. 2 can not be made a globalFrameView_OutputFragment_content node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_OutputFragment;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_OutputFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_OutputFragment_link (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_OutputFragment_link (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_OutputFragment_link _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_OutputFragment_link;
#else
_currn = (globalFrameView__TPPpglobalFrameView_OutputFragment_link) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_OutputFragment_link));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_OutputFragment_link;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_OutputFragment_link;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_OutputFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_OutputFragment_content (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_OutputFragment_content (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_OutputFragment_content _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_OutputFragment_content;
#else
_currn = (globalFrameView__TPPpglobalFrameView_OutputFragment_content) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_OutputFragment_content));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_OutputFragment_content;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_OutputFragment_content;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_OutputFragment_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_OutputMessagesElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_OutputMessagesElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_OutputMessagesElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_OutputMessagesElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_OutputMessagesElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_OutputMessagesElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_OutputMessagesElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_OutputMessagesElement_styleSheetBlock) globalFrameView_MkglobalFrameView_OutputMessagesElement_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_OutputMessagesElement: root of subtree no. 1 can not be made a globalFrameView_OutputMessagesElement_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_OutputMessagesElement_errorStyleSheetBlock) globalFrameView_MkglobalFrameView_OutputMessagesElement_errorStyleSheetBlock (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_OutputMessagesElement: root of subtree no. 2 can not be made a globalFrameView_OutputMessagesElement_errorStyleSheetBlock node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_OutputMessagesElement_infoStyleSheetBlock) globalFrameView_MkglobalFrameView_OutputMessagesElement_infoStyleSheetBlock (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_OutputMessagesElement: root of subtree no. 3 can not be made a globalFrameView_OutputMessagesElement_infoStyleSheetBlock node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_OutputMessagesElement_layout) globalFrameView_MkglobalFrameView_OutputMessagesElement_layout (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_OutputMessagesElement: root of subtree no. 4 can not be made a globalFrameView_OutputMessagesElement_layout node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_OutputMessagesElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_OutputMessagesElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_OutputMessagesElement_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_OutputMessagesElement_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_OutputMessagesElement_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_OutputMessagesElement_styleSheetBlock;
#else
_currn = (globalFrameView__TPPpglobalFrameView_OutputMessagesElement_styleSheetBlock) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_OutputMessagesElement_styleSheetBlock));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_OutputMessagesElement_styleSheetBlock;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_OutputMessagesElement_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_OutputMessagesElement_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_OutputMessagesElement_errorStyleSheetBlock (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_OutputMessagesElement_errorStyleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_OutputMessagesElement_errorStyleSheetBlock _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_OutputMessagesElement_errorStyleSheetBlock;
#else
_currn = (globalFrameView__TPPpglobalFrameView_OutputMessagesElement_errorStyleSheetBlock) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_OutputMessagesElement_errorStyleSheetBlock));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_OutputMessagesElement_errorStyleSheetBlock;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_OutputMessagesElement_errorStyleSheetBlock;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_OutputMessagesElement_errorStyleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_OutputMessagesElement_infoStyleSheetBlock (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_OutputMessagesElement_infoStyleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_OutputMessagesElement_infoStyleSheetBlock _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_OutputMessagesElement_infoStyleSheetBlock;
#else
_currn = (globalFrameView__TPPpglobalFrameView_OutputMessagesElement_infoStyleSheetBlock) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_OutputMessagesElement_infoStyleSheetBlock));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_OutputMessagesElement_infoStyleSheetBlock;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_OutputMessagesElement_infoStyleSheetBlock;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_OutputMessagesElement_infoStyleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_OutputMessagesElement_layout (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_OutputMessagesElement_layout (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_OutputMessagesElement_layout _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_OutputMessagesElement_layout;
#else
_currn = (globalFrameView__TPPpglobalFrameView_OutputMessagesElement_layout) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_OutputMessagesElement_layout));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_OutputMessagesElement_layout;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_OutputMessagesElement_layout;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_OutputMessagesElement_layout */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputActualParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputActualParam (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputActualParam _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputActualParam;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputActualParam) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputActualParam));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputActualParam;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputActualParam_formalParam) globalFrameView_MkglobalFrameView_ListOutputActualParam_formalParam (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputActualParam: root of subtree no. 1 can not be made a globalFrameView_ListOutputActualParam_formalParam node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_ListOutputActualParam_expression) globalFrameView_MkglobalFrameView_ListOutputActualParam_expression (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputActualParam: root of subtree no. 2 can not be made a globalFrameView_ListOutputActualParam_expression node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputActualParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputActualParam_formalParam (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputActualParam_formalParam (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputActualParam_formalParam _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputActualParam_formalParam;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputActualParam_formalParam) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputActualParam_formalParam));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputActualParam_formalParam;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputActualParam_formalParam;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_BinaryExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputActualParam_expression)_new;
	{globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_UnaryExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputActualParam_expression)_new;
	{globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_PredefinedExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputActualParam_expression)_new;
	{globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ConstantExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputActualParam_expression)_new;
	{globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ColumnValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputActualParam_expression)_new;
	{globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputActualParam_expression)_new;
	{globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ParameterValueExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputActualParam_expression)_new;
	{globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ComputationExpression)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputActualParam_expression)_new;
	{globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_ListOutputActualParam_expression (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_BinaryExpression)) 
		return globalFrameView__MkglobalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, globalFrameView_MkglobalFrameView_BinaryExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_UnaryExpression)) 
		return globalFrameView__MkglobalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, globalFrameView_MkglobalFrameView_UnaryExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_PredefinedExpression)) 
		return globalFrameView__MkglobalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, globalFrameView_MkglobalFrameView_PredefinedExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ConstantExpression)) 
		return globalFrameView__MkglobalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, globalFrameView_MkglobalFrameView_ConstantExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ColumnValueExpression)) 
		return globalFrameView__MkglobalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, globalFrameView_MkglobalFrameView_ColumnValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ProjectionColumnValueExpression)) 
		return globalFrameView__MkglobalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, globalFrameView_MkglobalFrameView_ProjectionColumnValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ParameterValueExpression)) 
		return globalFrameView__MkglobalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, globalFrameView_MkglobalFrameView_ParameterValueExpression (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ComputationExpression)) 
		return globalFrameView__MkglobalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression (_coordref, globalFrameView_MkglobalFrameView_ComputationExpression (_coordref, t));
	message (DEADLY, "a pglobalFrameView_ListOutputActualParam_expression list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_ListOutputActualParam_expression (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputActualParam_expression)
	l =_ElempglobalFrameView_ListOutputActualParam_expression (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputActualParam_expression)
	r = _ElempglobalFrameView_ListOutputActualParam_expression (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputActualParam_expression (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_ListOutputActualParam_expression root;
	globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputActualParam_expression)
		t = _ElempglobalFrameView_ListOutputActualParam_expression (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression)(((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_ListOutputActualParam_expression;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_ListOutputActualParam_expression));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_ListOutputActualParam_expression;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputActualParam_expression)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression)
	{globalFrameView__TPPLST_globalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_BinaryExpressionpglobalFrameView_ListOutputActualParam_expression;
	} this code has been moved to _ElempglobalFrameView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression)
	{globalFrameView__TPPLST_globalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_UnaryExpressionpglobalFrameView_ListOutputActualParam_expression;
	} this code has been moved to _ElempglobalFrameView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression)
	{globalFrameView__TPPLST_globalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_PredefinedExpressionpglobalFrameView_ListOutputActualParam_expression;
	} this code has been moved to _ElempglobalFrameView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression)
	{globalFrameView__TPPLST_globalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ConstantExpressionpglobalFrameView_ListOutputActualParam_expression;
	} this code has been moved to _ElempglobalFrameView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression)
	{globalFrameView__TPPLST_globalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression;
	} this code has been moved to _ElempglobalFrameView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression)
	{globalFrameView__TPPLST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ProjectionColumnValueExpressionpglobalFrameView_ListOutputActualParam_expression;
	} this code has been moved to _ElempglobalFrameView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression)
	{globalFrameView__TPPLST_globalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ParameterValueExpressionpglobalFrameView_ListOutputActualParam_expression;
	} this code has been moved to _ElempglobalFrameView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression)
	{globalFrameView__TPPLST_globalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ComputationExpressionpglobalFrameView_ListOutputActualParam_expression;
	} this code has been moved to _ElempglobalFrameView_ListOutputActualParam_expression*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_ListOutputActualParam_expression;
#else
root = (globalFrameView__TPPpglobalFrameView_ListOutputActualParam_expression) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputActualParam_expression));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_ListOutputActualParam_expression;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_ListOutputActualParam_expression)list;
{ globalFrameView__TPPpglobalFrameView_ListOutputActualParam_expression _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_ListOutputActualParam_expression;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7, NODEPTR _desc8, NODEPTR _desc9, NODEPTR _desc10, NODEPTR _desc11)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7,_desc8,_desc9,_desc10,_desc11)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
	NODEPTR _desc8;
	NODEPTR _desc9;
	NODEPTR _desc10;
	NODEPTR _desc11;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputElement_styleSheetBlock) globalFrameView_MkglobalFrameView_ListOutputElement_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 1 can not be made a globalFrameView_ListOutputElement_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_ListOutputElement_name) globalFrameView_MkglobalFrameView_ListOutputElement_name (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 2 can not be made a globalFrameView_ListOutputElement_name node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_ListOutputElement_dataSourceActualParams) globalFrameView_MkglobalFrameView_ListOutputElement_dataSourceActualParams (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 3 can not be made a globalFrameView_ListOutputElement_dataSourceActualParams node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_ListOutputElement_dataSource) globalFrameView_MkglobalFrameView_ListOutputElement_dataSource (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 4 can not be made a globalFrameView_ListOutputElement_dataSource node ", 0, _coordref);
_currn->_desc5 = (globalFrameView__TSPglobalFrameView_ListOutputElement_maxNumberOfElements) globalFrameView_MkglobalFrameView_ListOutputElement_maxNumberOfElements (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 5 can not be made a globalFrameView_ListOutputElement_maxNumberOfElements node ", 0, _coordref);
_currn->_desc6 = (globalFrameView__TSPglobalFrameView_ListOutputElement_renderAs) globalFrameView_MkglobalFrameView_ListOutputElement_renderAs (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 6 can not be made a globalFrameView_ListOutputElement_renderAs node ", 0, _coordref);
_currn->_desc7 = (globalFrameView__TSPglobalFrameView_ListOutputElement_navigationElement) globalFrameView_MkglobalFrameView_ListOutputElement_navigationElement (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 7 can not be made a globalFrameView_ListOutputElement_navigationElement node ", 0, _coordref);
_currn->_desc8 = (globalFrameView__TSPglobalFrameView_ListOutputElement_columns) globalFrameView_MkglobalFrameView_ListOutputElement_columns (_coordref, _desc8);	
if (((NODEPTR)_currn->_desc8) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 8 can not be made a globalFrameView_ListOutputElement_columns node ", 0, _coordref);
_currn->_desc9 = (globalFrameView__TSPglobalFrameView_ListOutputElement_headerStyleClass) globalFrameView_MkglobalFrameView_ListOutputElement_headerStyleClass (_coordref, _desc9);	
if (((NODEPTR)_currn->_desc9) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 9 can not be made a globalFrameView_ListOutputElement_headerStyleClass node ", 0, _coordref);
_currn->_desc10 = (globalFrameView__TSPglobalFrameView_ListOutputElement_evenRowStyleClass) globalFrameView_MkglobalFrameView_ListOutputElement_evenRowStyleClass (_coordref, _desc10);	
if (((NODEPTR)_currn->_desc10) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 10 can not be made a globalFrameView_ListOutputElement_evenRowStyleClass node ", 0, _coordref);
_currn->_desc11 = (globalFrameView__TSPglobalFrameView_ListOutputElement_oddRowStyleClass) globalFrameView_MkglobalFrameView_ListOutputElement_oddRowStyleClass (_coordref, _desc11);	
if (((NODEPTR)_currn->_desc11) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputElement: root of subtree no. 11 can not be made a globalFrameView_ListOutputElement_oddRowStyleClass node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputElement_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputElement_styleSheetBlock;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputElement_styleSheetBlock) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_styleSheetBlock));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_styleSheetBlock;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputElement_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_name (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_name (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputElement_name _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputElement_name;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputElement_name) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_name));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_name;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_name;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputElement_name */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_DataSourceActualParam)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputElement_dataSourceActualParams)_new;
	{globalFrameView__TPPLST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_ListOutputElement_dataSourceActualParams (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_DataSourceActualParam)) 
		return globalFrameView__MkglobalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams (_coordref, globalFrameView_MkglobalFrameView_DataSourceActualParam (_coordref, t));
	message (DEADLY, "a pglobalFrameView_ListOutputElement_dataSourceActualParams list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_ListOutputElement_dataSourceActualParams (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputElement_dataSourceActualParams)
	l =_ElempglobalFrameView_ListOutputElement_dataSourceActualParams (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputElement_dataSourceActualParams)
	r = _ElempglobalFrameView_ListOutputElement_dataSourceActualParams (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_dataSourceActualParams (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_ListOutputElement_dataSourceActualParams root;
	globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputElement_dataSourceActualParams)
		t = _ElempglobalFrameView_ListOutputElement_dataSourceActualParams (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams)(((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_ListOutputElement_dataSourceActualParams;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_dataSourceActualParams)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams)
	{globalFrameView__TPPLST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_DataSourceActualParampglobalFrameView_ListOutputElement_dataSourceActualParams;
	} this code has been moved to _ElempglobalFrameView_ListOutputElement_dataSourceActualParams*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_ListOutputElement_dataSourceActualParams;
#else
root = (globalFrameView__TPPpglobalFrameView_ListOutputElement_dataSourceActualParams) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_dataSourceActualParams));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_dataSourceActualParams;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_ListOutputElement_dataSourceActualParams)list;
{ globalFrameView__TPPpglobalFrameView_ListOutputElement_dataSourceActualParams _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_dataSourceActualParams;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_dataSource (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_dataSource (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputElement_dataSource _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputElement_dataSource;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputElement_dataSource) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_dataSource));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_dataSource;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_dataSource;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputElement_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_maxNumberOfElements (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_maxNumberOfElements (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputElement_maxNumberOfElements _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputElement_maxNumberOfElements;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputElement_maxNumberOfElements) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_maxNumberOfElements));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_maxNumberOfElements;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_maxNumberOfElements;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputElement_maxNumberOfElements */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_renderAs (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_renderAs (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputElement_renderAs _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputElement_renderAs;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputElement_renderAs) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_renderAs));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_renderAs;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_renderAs;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputElement_renderAs */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_navigationElement (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_navigationElement (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputElement_navigationElement _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputElement_navigationElement;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputElement_navigationElement) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_navigationElement));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_navigationElement;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_navigationElement;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputElement_navigationElement */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputColumn)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputElement_columns)_new;
	{globalFrameView__TPPLST_globalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_ListOutputElement_columns (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_ListOutputElement_columns (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ListOutputColumn)) 
		return globalFrameView__MkglobalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns (_coordref, globalFrameView_MkglobalFrameView_ListOutputColumn (_coordref, t));
	message (DEADLY, "a pglobalFrameView_ListOutputElement_columns list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_ListOutputElement_columns (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_ListOutputElement_columns (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputElement_columns)
	l =_ElempglobalFrameView_ListOutputElement_columns (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputElement_columns)
	r = _ElempglobalFrameView_ListOutputElement_columns (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_columns (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_columns (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_ListOutputElement_columns root;
	globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputElement_columns)
		t = _ElempglobalFrameView_ListOutputElement_columns (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns)(((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_ListOutputElement_columns;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_ListOutputElement_columns));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_ListOutputElement_columns;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputElement_columns)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns)
	{globalFrameView__TPPLST_globalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputColumnpglobalFrameView_ListOutputElement_columns;
	} this code has been moved to _ElempglobalFrameView_ListOutputElement_columns*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_ListOutputElement_columns;
#else
root = (globalFrameView__TPPpglobalFrameView_ListOutputElement_columns) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_columns));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_columns;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_ListOutputElement_columns)list;
{ globalFrameView__TPPpglobalFrameView_ListOutputElement_columns _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_columns;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_headerStyleClass (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_headerStyleClass (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputElement_headerStyleClass _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputElement_headerStyleClass;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputElement_headerStyleClass) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_headerStyleClass));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_headerStyleClass;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_headerStyleClass;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputElement_headerStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_evenRowStyleClass (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_evenRowStyleClass (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputElement_evenRowStyleClass _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputElement_evenRowStyleClass;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputElement_evenRowStyleClass) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_evenRowStyleClass));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_evenRowStyleClass;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_evenRowStyleClass;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputElement_evenRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_oddRowStyleClass (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputElement_oddRowStyleClass (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputElement_oddRowStyleClass _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputElement_oddRowStyleClass;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputElement_oddRowStyleClass) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputElement_oddRowStyleClass));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputElement_oddRowStyleClass;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputElement_oddRowStyleClass;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputElement_oddRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputColumn (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputColumn (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputColumn _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputColumn;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputColumn) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputColumn));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputColumn;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputColumn_header) globalFrameView_MkglobalFrameView_ListOutputColumn_header (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputColumn: root of subtree no. 1 can not be made a globalFrameView_ListOutputColumn_header node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_ListOutputColumn_content) globalFrameView_MkglobalFrameView_ListOutputColumn_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputColumn: root of subtree no. 2 can not be made a globalFrameView_ListOutputColumn_content node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputColumn;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputColumn_header (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputColumn_header (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputColumn_header _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputColumn_header;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputColumn_header) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputColumn_header));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputColumn_header;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputColumn_header;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputColumn_header */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputConstantContent)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputColumn_content)_new;
	{globalFrameView__TPPLST_globalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputRefContent)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputColumn_content)_new;
	{globalFrameView__TPPLST_globalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputProjectionContent)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputColumn_content)_new;
	{globalFrameView__TPPLST_globalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputNumerationContent)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputColumn_content)_new;
	{globalFrameView__TPPLST_globalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputActionConnectionsContent)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputColumn_content)_new;
	{globalFrameView__TPPLST_globalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_ListOutputColumn_content (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_ListOutputColumn_content (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ListOutputConstantContent)) 
		return globalFrameView__MkglobalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content (_coordref, globalFrameView_MkglobalFrameView_ListOutputConstantContent (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ListOutputRefContent)) 
		return globalFrameView__MkglobalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content (_coordref, globalFrameView_MkglobalFrameView_ListOutputRefContent (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ListOutputProjectionContent)) 
		return globalFrameView__MkglobalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content (_coordref, globalFrameView_MkglobalFrameView_ListOutputProjectionContent (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ListOutputNumerationContent)) 
		return globalFrameView__MkglobalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content (_coordref, globalFrameView_MkglobalFrameView_ListOutputNumerationContent (_coordref, t));
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ListOutputActionConnectionsContent)) 
		return globalFrameView__MkglobalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content (_coordref, globalFrameView_MkglobalFrameView_ListOutputActionConnectionsContent (_coordref, t));
	message (DEADLY, "a pglobalFrameView_ListOutputColumn_content list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_ListOutputColumn_content (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_ListOutputColumn_content (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputColumn_content)
	l =_ElempglobalFrameView_ListOutputColumn_content (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputColumn_content)
	r = _ElempglobalFrameView_ListOutputColumn_content (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputColumn_content (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputColumn_content (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_ListOutputColumn_content root;
	globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputColumn_content)
		t = _ElempglobalFrameView_ListOutputColumn_content (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content)(((globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_ListOutputColumn_content;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_ListOutputColumn_content));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_ListOutputColumn_content;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputColumn_content)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content)
	{globalFrameView__TPPLST_globalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputConstantContentpglobalFrameView_ListOutputColumn_content;
	} this code has been moved to _ElempglobalFrameView_ListOutputColumn_content*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content)
	{globalFrameView__TPPLST_globalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputRefContentpglobalFrameView_ListOutputColumn_content;
	} this code has been moved to _ElempglobalFrameView_ListOutputColumn_content*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content)
	{globalFrameView__TPPLST_globalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputProjectionContentpglobalFrameView_ListOutputColumn_content;
	} this code has been moved to _ElempglobalFrameView_ListOutputColumn_content*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content)
	{globalFrameView__TPPLST_globalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputNumerationContentpglobalFrameView_ListOutputColumn_content;
	} this code has been moved to _ElempglobalFrameView_ListOutputColumn_content*/
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content)
	{globalFrameView__TPPLST_globalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputActionConnectionsContentpglobalFrameView_ListOutputColumn_content;
	} this code has been moved to _ElempglobalFrameView_ListOutputColumn_content*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_ListOutputColumn_content;
#else
root = (globalFrameView__TPPpglobalFrameView_ListOutputColumn_content) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputColumn_content));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_ListOutputColumn_content;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_ListOutputColumn_content)list;
{ globalFrameView__TPPpglobalFrameView_ListOutputColumn_content _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_ListOutputColumn_content;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputConstantContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputConstantContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputConstantContent _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputConstantContent;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputConstantContent) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputConstantContent));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputConstantContent;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputConstantContent_value) globalFrameView_MkglobalFrameView_ListOutputConstantContent_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputConstantContent: root of subtree no. 1 can not be made a globalFrameView_ListOutputConstantContent_value node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputConstantContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputConstantContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputConstantContent_value (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputConstantContent_value (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputConstantContent_value _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputConstantContent_value;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputConstantContent_value) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputConstantContent_value));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputConstantContent_value;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputConstantContent_value;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputConstantContent_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputRefContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputRefContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputRefContent _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputRefContent;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputRefContent) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputRefContent));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputRefContent;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputRefContent_column) globalFrameView_MkglobalFrameView_ListOutputRefContent_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputRefContent: root of subtree no. 1 can not be made a globalFrameView_ListOutputRefContent_column node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputRefContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputRefContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputRefContent_column (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputRefContent_column (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputRefContent_column _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputRefContent_column;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputRefContent_column) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputRefContent_column));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputRefContent_column;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputRefContent_column;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputRefContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputProjectionContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputProjectionContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputProjectionContent _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputProjectionContent;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputProjectionContent) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputProjectionContent));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputProjectionContent;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputProjectionContent_column) globalFrameView_MkglobalFrameView_ListOutputProjectionContent_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputProjectionContent: root of subtree no. 1 can not be made a globalFrameView_ListOutputProjectionContent_column node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputProjectionContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputProjectionContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputProjectionContent_column (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputProjectionContent_column (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputProjectionContent_column _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputProjectionContent_column;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputProjectionContent_column) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputProjectionContent_column));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputProjectionContent_column;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputProjectionContent_column;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputProjectionContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputNumerationContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputNumerationContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputNumerationContent _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputNumerationContent;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputNumerationContent) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputNumerationContent));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputNumerationContent;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputNumerationContent_name) globalFrameView_MkglobalFrameView_ListOutputNumerationContent_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputNumerationContent: root of subtree no. 1 can not be made a globalFrameView_ListOutputNumerationContent_name node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputNumerationContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputNumerationContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputNumerationContent_name (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputNumerationContent_name (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputNumerationContent_name _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputNumerationContent_name;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputNumerationContent_name) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputNumerationContent_name));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputNumerationContent_name;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputNumerationContent_name;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputNumerationContent_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputActionConnectionsContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputActionConnectionsContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPpglobalFrameView_ListOutputActionConnectionsContent _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ListOutputActionConnectionsContent;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ListOutputActionConnectionsContent) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputActionConnectionsContent));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ListOutputActionConnectionsContent;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputActionConnectionsContent_actionConnections) globalFrameView_MkglobalFrameView_ListOutputActionConnectionsContent_actionConnections (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ListOutputActionConnectionsContent: root of subtree no. 1 can not be made a globalFrameView_ListOutputActionConnectionsContent_actionConnections node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ListOutputActionConnectionsContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ListOutputActionConnectionsContent */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ActionConnection)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ListOutputActionConnectionsContent_actionConnections)_new;
	{globalFrameView__TPPLST_globalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_ListOutputActionConnectionsContent_actionConnections (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ActionConnection)) 
		return globalFrameView__MkglobalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections (_coordref, globalFrameView_MkglobalFrameView_ActionConnection (_coordref, t));
	message (DEADLY, "a pglobalFrameView_ListOutputActionConnectionsContent_actionConnections list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_ListOutputActionConnectionsContent_actionConnections (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputActionConnectionsContent_actionConnections)
	l =_ElempglobalFrameView_ListOutputActionConnectionsContent_actionConnections (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputActionConnectionsContent_actionConnections)
	r = _ElempglobalFrameView_ListOutputActionConnectionsContent_actionConnections (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ListOutputActionConnectionsContent_actionConnections (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_ListOutputActionConnectionsContent_actionConnections root;
	globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_ListOutputActionConnectionsContent_actionConnections)
		t = _ElempglobalFrameView_ListOutputActionConnectionsContent_actionConnections (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections)(((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_ListOutputActionConnectionsContent_actionConnections)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections)
	{globalFrameView__TPPLST_globalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ActionConnectionpglobalFrameView_ListOutputActionConnectionsContent_actionConnections;
	} this code has been moved to _ElempglobalFrameView_ListOutputActionConnectionsContent_actionConnections*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_ListOutputActionConnectionsContent_actionConnections;
#else
root = (globalFrameView__TPPpglobalFrameView_ListOutputActionConnectionsContent_actionConnections) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ListOutputActionConnectionsContent_actionConnections));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_ListOutputActionConnectionsContent_actionConnections;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_ListOutputActionConnectionsContent_actionConnections)list;
{ globalFrameView__TPPpglobalFrameView_ListOutputActionConnectionsContent_actionConnections _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_ListOutputActionConnectionsContent_actionConnections;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ActionConnection (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ActionConnection (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	globalFrameView__TPPpglobalFrameView_ActionConnection _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ActionConnection;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ActionConnection) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ActionConnection));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ActionConnection;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ActionConnection_action) globalFrameView_MkglobalFrameView_ActionConnection_action (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ActionConnection: root of subtree no. 1 can not be made a globalFrameView_ActionConnection_action node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_ActionConnection_imageName) globalFrameView_MkglobalFrameView_ActionConnection_imageName (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ActionConnection: root of subtree no. 2 can not be made a globalFrameView_ActionConnection_imageName node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_ActionConnection_text) globalFrameView_MkglobalFrameView_ActionConnection_text (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ActionConnection: root of subtree no. 3 can not be made a globalFrameView_ActionConnection_text node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_ActionConnection_actualParams) globalFrameView_MkglobalFrameView_ActionConnection_actualParams (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ActionConnection: root of subtree no. 4 can not be made a globalFrameView_ActionConnection_actualParams node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ActionConnection;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ActionConnection */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ActionConnection_action (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ActionConnection_action (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ActionConnection_action _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ActionConnection_action;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ActionConnection_action) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ActionConnection_action));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ActionConnection_action;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ActionConnection_action;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ActionConnection_action */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ActionConnection_imageName (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ActionConnection_imageName (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ActionConnection_imageName _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ActionConnection_imageName;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ActionConnection_imageName) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ActionConnection_imageName));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ActionConnection_imageName;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ActionConnection_imageName;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ActionConnection_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ActionConnection_text (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ActionConnection_text (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ActionConnection_text _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ActionConnection_text;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ActionConnection_text) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ActionConnection_text));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ActionConnection_text;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ActionConnection_text;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ActionConnection_text */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_ListOutputActualParam)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ActionConnection_actualParams)_new;
	{globalFrameView__TPPLST_globalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_ActionConnection_actualParams (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_ListOutputActualParam)) 
		return globalFrameView__MkglobalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams (_coordref, globalFrameView_MkglobalFrameView_ListOutputActualParam (_coordref, t));
	message (DEADLY, "a pglobalFrameView_ActionConnection_actualParams list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_ActionConnection_actualParams (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_ActionConnection_actualParams)
	l =_ElempglobalFrameView_ActionConnection_actualParams (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_ActionConnection_actualParams)
	r = _ElempglobalFrameView_ActionConnection_actualParams (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ActionConnection_actualParams (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_ActionConnection_actualParams root;
	globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_ActionConnection_actualParams)
		t = _ElempglobalFrameView_ActionConnection_actualParams (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams)(((globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_ActionConnection_actualParams;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_ActionConnection_actualParams));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_ActionConnection_actualParams;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_ActionConnection_actualParams)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams)
	{globalFrameView__TPPLST_globalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_ListOutputActualParampglobalFrameView_ActionConnection_actualParams;
	} this code has been moved to _ElempglobalFrameView_ActionConnection_actualParams*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_ActionConnection_actualParams;
#else
root = (globalFrameView__TPPpglobalFrameView_ActionConnection_actualParams) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ActionConnection_actualParams));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_ActionConnection_actualParams;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_ActionConnection_actualParams)list;
{ globalFrameView__TPPpglobalFrameView_ActionConnection_actualParams _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_ActionConnection_actualParams;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageMap _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageMap;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageMap) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageMap));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageMap;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_ImageMap_styleSheetBlock) globalFrameView_MkglobalFrameView_ImageMap_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageMap: root of subtree no. 1 can not be made a globalFrameView_ImageMap_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (globalFrameView__TSPglobalFrameView_ImageMap_name) globalFrameView_MkglobalFrameView_ImageMap_name (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageMap: root of subtree no. 2 can not be made a globalFrameView_ImageMap_name node ", 0, _coordref);
_currn->_desc3 = (globalFrameView__TSPglobalFrameView_ImageMap_imageName) globalFrameView_MkglobalFrameView_ImageMap_imageName (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageMap: root of subtree no. 3 can not be made a globalFrameView_ImageMap_imageName node ", 0, _coordref);
_currn->_desc4 = (globalFrameView__TSPglobalFrameView_ImageMap_altText) globalFrameView_MkglobalFrameView_ImageMap_altText (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageMap: root of subtree no. 4 can not be made a globalFrameView_ImageMap_altText node ", 0, _coordref);
_currn->_desc5 = (globalFrameView__TSPglobalFrameView_ImageMap_mapAreas) globalFrameView_MkglobalFrameView_ImageMap_mapAreas (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pglobalFrameView_ImageMap: root of subtree no. 5 can not be made a globalFrameView_ImageMap_mapAreas node ", 0, _coordref);
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageMap;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageMap */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageMap_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageMap_styleSheetBlock;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageMap_styleSheetBlock) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageMap_styleSheetBlock));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageMap_styleSheetBlock;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageMap_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageMap_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap_name (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap_name (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageMap_name _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageMap_name;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageMap_name) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageMap_name));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageMap_name;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageMap_name;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageMap_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap_imageName (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap_imageName (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageMap_imageName _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageMap_imageName;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageMap_imageName) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageMap_imageName));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageMap_imageName;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageMap_imageName;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageMap_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap_altText (POSITION *_coordref)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap_altText (_coordref)
	POSITION *_coordref;
#endif
{	globalFrameView__TPPpglobalFrameView_ImageMap_altText _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPpglobalFrameView_ImageMap_altText;
#else
_currn = (globalFrameView__TPPpglobalFrameView_ImageMap_altText) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageMap_altText));
#endif
_currn->_prod = globalFrameView_RULEpglobalFrameView_ImageMap_altText;
_SETCOORD(_currn)
globalFrameView__TERMACT_pglobalFrameView_ImageMap_altText;
return ( (NODEPTR) _currn);
}/* globalFrameView_MkpglobalFrameView_ImageMap_altText */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR globalFrameView__MkglobalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR globalFrameView__MkglobalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	globalFrameView__TPPLST_globalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas _new;
#ifdef __cplusplus
	_new = new globalFrameView__TPLST_globalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas;
#else
	_new = (globalFrameView__TPPLST_globalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_globalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas));
#endif
	_new->_prod = globalFrameView_RULELST_globalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas;
	_new->_desc1 = (globalFrameView__TSPglobalFrameView_MapArea)elem;
	_new->_desc2 = (globalFrameView__TSPLST_globalFrameView_ImageMap_mapAreas)_new;
	{globalFrameView__TPPLST_globalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas _currn = _new;
	 _SETCOORD(_currn)
	 globalFrameView__TERMACT_LST_globalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempglobalFrameView_ImageMap_mapAreas (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempglobalFrameView_ImageMap_mapAreas (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (globalFrameView_IsSymb (t, globalFrameView_SYMBglobalFrameView_MapArea)) 
		return globalFrameView__MkglobalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas (_coordref, globalFrameView_MkglobalFrameView_MapArea (_coordref, t));
	message (DEADLY, "a pglobalFrameView_ImageMap_mapAreas list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mk2pglobalFrameView_ImageMap_mapAreas (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR globalFrameView_Mk2pglobalFrameView_ImageMap_mapAreas (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (globalFrameView_LHSMAP[l->_prod] != globalFrameView_SYMBLST_globalFrameView_ImageMap_mapAreas)
	l =_ElempglobalFrameView_ImageMap_mapAreas (_coordref, l);
if (globalFrameView_LHSMAP[r->_prod] != globalFrameView_SYMBLST_globalFrameView_ImageMap_mapAreas)
	r = _ElempglobalFrameView_ImageMap_mapAreas (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas)r)->_desc2);
((globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas)r)->_desc2 = ((globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas)l)->_desc2;
((globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap_mapAreas (POSITION *_coordref, NODEPTR t)
#else
NODEPTR globalFrameView_MkpglobalFrameView_ImageMap_mapAreas (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; globalFrameView__TPPpglobalFrameView_ImageMap_mapAreas root;
	globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas)NULLNODEPTR;
else {	if (globalFrameView_LHSMAP[t->_prod] != globalFrameView_SYMBLST_globalFrameView_ImageMap_mapAreas)
		t = _ElempglobalFrameView_ImageMap_mapAreas (_coordref, t);
	remain = (globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas)(((globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas) t)->_desc2);
	((globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new globalFrameView__TPLST_0pglobalFrameView_ImageMap_mapAreas;
#else
list = (globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPLST_0pglobalFrameView_ImageMap_mapAreas));
#endif
list->_prod = globalFrameView_RULELST_0pglobalFrameView_ImageMap_mapAreas;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (globalFrameView__TPPLST_0pglobalFrameView_ImageMap_mapAreas)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == globalFrameView_RULELST_globalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas)
	{globalFrameView__TPPLST_globalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas _currn = _currn;
	 globalFrameView__TERMACT_LST_globalFrameView_MapAreapglobalFrameView_ImageMap_mapAreas;
	} this code has been moved to _ElempglobalFrameView_ImageMap_mapAreas*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new globalFrameView__TPpglobalFrameView_ImageMap_mapAreas;
#else
root = (globalFrameView__TPPpglobalFrameView_ImageMap_mapAreas) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPpglobalFrameView_ImageMap_mapAreas));
#endif
root->_prod = globalFrameView_RULEpglobalFrameView_ImageMap_mapAreas;
root->_desc1 = (globalFrameView__TSPLST_globalFrameView_ImageMap_mapAreas)list;
{ globalFrameView__TPPpglobalFrameView_ImageMap_mapAreas _currn = root;
  _SETCOORD(_currn)
  globalFrameView__TERMACT_pglobalFrameView_ImageMap_mapAreas;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR globalFrameView_Mkrule_1 (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR globalFrameView_Mkrule_1 (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	globalFrameView__TPPrule_1 _currn;
#ifdef __cplusplus
_currn = new globalFrameView__TPrule_1;
#else
_currn = (globalFrameView__TPPrule_1) globalFrameView_TreeNodeAlloc (sizeof (struct globalFrameView__TPrule_1));
#endif
_currn->_prod = globalFrameView_RULErule_1;
_currn->_desc1 = (globalFrameView__TSPglobalFrameView_Frame) globalFrameView_MkglobalFrameView_Frame (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE rule_1: root of subtree no. 1 can not be made a globalFrameView_Frame node ", 0, _coordref);
_COPYCOORD(_currn)
globalFrameView__TERMACT_rule_1;
return ( (NODEPTR) _currn);
}/* globalFrameView_Mkrule_1 */
