
/* implementation of tree construction functions */

#include "listOutputView_node.h"

#include "listOutputView_nodecode.h"

#include "attrpredef.h"

#include "listOutputView_visitmap.h"

#include "listOutputView_treeact.h"

#ifdef MONITOR
#include "attr_mon_dapto.h"
#endif

#include <stdlib.h>

#define _USE_OBSTACK 1

/* use of obstack: */

#if _USE_OBSTACK

#include "obstack.h"
static struct obstack TreeSpace;
static void *_TreeBase;

#ifdef __cplusplus
void* listOutputView_NODEPTR_SUB_struct::operator new(size_t size)
{
	return obstack_alloc(&TreeSpace, size);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* listOutputView_TreeNodeAlloc(int size)
#else
char* listOutputView_TreeNodeAlloc(size) int size;
#endif
{
	return (char *)(obstack_alloc(&TreeSpace, size));
}
#endif

void listOutputView_InitTree()
{
	obstack_init(&TreeSpace);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

void listOutputView_FreeTree()
{
	obstack_free(&TreeSpace, _TreeBase);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

#else

#include <stdio.h>

#ifdef __cplusplus
void* NODEPTR_struct::operator new(size_t size)
{
	void *retval = malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* listOutputView_TreeNodeAlloc(int size)
#else
char* listOutputView_TreeNodeAlloc(size) int size;
#endif
{
	char *retval = (char *) malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#endif

void listOutputView_InitTree() { }

void listOutputView_FreeTree() { }

#endif

#ifdef MONITOR
#define _SETCOORD(node) \
        node->_coord = _coordref ? *_coordref : NoCoord;
#define _COPYCOORD(node) \
        node->_coord = _currn->_desc1->_coord;
#else
#define _SETCOORD(node)
#define _COPYCOORD(node)
#endif
#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkVIEWROOT (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MkVIEWROOT (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBVIEWROOT)) return (_currn);
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement)) return (listOutputView_MkpVIEWROOT_listOutputView(_coordref, _currn));
return(NULLNODEPTR);
}/* listOutputView_MkVIEWROOT */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputActualParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputActualParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputActualParam)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputActualParam_formalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputActualParam_formalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputActualParam_formalParam)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputActualParam_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputActualParam_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputActualParam_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputActualParam_expression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputActualParam_expression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputActualParam_expression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ComputationExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ComputationExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ComputationExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ComputationExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ParameterValueExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ParameterValueExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ParameterValueExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ParameterValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ProjectionColumnValueExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ProjectionColumnValueExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ProjectionColumnValueExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ProjectionColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ColumnValueExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ColumnValueExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ColumnValueExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ConstantExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ConstantExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ConstantExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_PredefinedExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_PredefinedExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_PredefinedExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_PredefinedExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_UnaryExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_UnaryExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_UnaryExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_UnaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_BinaryExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_BinaryExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_BinaryExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_BinaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_DataSourceActualParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_DataSourceActualParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_DataSourceActualParam)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_DataSourceActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_DataSourceActualParam_formalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_DataSourceActualParam_formalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_DataSourceActualParam_formalParam)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_DataSourceActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_DataSourceActualParam_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_DataSourceActualParam_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_DataSourceActualParam_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_DataSourceActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_DataSourceActualParam_expressions (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_DataSourceActualParam_expressions)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_DataSourceActualParam_expressions */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_WebNodeSessionExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_WebNodeSessionExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_WebNodeSessionExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_WebNodeSessionExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_WebNodeVariableExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_WebNodeVariableExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_WebNodeVariableExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_WebNodeVariableExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_WebNodeConstantExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_WebNodeConstantExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_WebNodeConstantExpression)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_WebNodeConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_BinaryExpression_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_BinaryExpression_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_BinaryExpression_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_BinaryExpression_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_BinaryExpression_leftOperand (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_BinaryExpression_leftOperand)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_BinaryExpression_leftOperand */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_BinaryExpression_operator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_BinaryExpression_operator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_BinaryExpression_operator)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_BinaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_BinaryExpression_rightOperand (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_BinaryExpression_rightOperand)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_BinaryExpression_rightOperand */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_BinaryExpression_keyword2 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_BinaryExpression_keyword2 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_BinaryExpression_keyword2)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_BinaryExpression_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_UnaryExpression_operator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_UnaryExpression_operator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_UnaryExpression_operator)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_UnaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_UnaryExpression_operand (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_UnaryExpression_operand)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_UnaryExpression_operand */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_PredefinedExpression_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_PredefinedExpression_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_PredefinedExpression_value)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_PredefinedExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ConstantExpression_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ConstantExpression_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ConstantExpression_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ConstantExpression_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ConstantExpression_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ConstantExpression_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ConstantExpression_value)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ConstantExpression_keyword2 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ConstantExpression_keyword2 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ConstantExpression_keyword2)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ConstantExpression_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ColumnValueExpression_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ColumnValueExpression_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ColumnValueExpression_column)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ProjectionColumnValueExpression_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ProjectionColumnValueExpression_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ProjectionColumnValueExpression_column)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ProjectionColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ParameterValueExpression_parameter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ParameterValueExpression_parameter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ParameterValueExpression_parameter)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ParameterValueExpression_parameter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ComputationExpression_computation (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ComputationExpression_computation (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ComputationExpression_computation)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ComputationExpression_computation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ComputationExpression_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ComputationExpression_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ComputationExpression_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ComputationExpression_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ComputationExpression_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ComputationExpression_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ComputationExpression_column)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ComputationExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ComputationExpression_keyword2 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ComputationExpression_keyword2 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ComputationExpression_keyword2)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ComputationExpression_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_MD5Modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_MD5Modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_MD5Modifier)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_MD5Modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_JoinModifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_JoinModifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_JoinModifier)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_JoinModifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_JoinModifier_separator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_JoinModifier_separator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_JoinModifier_separator)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_JoinModifier_separator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_WebNodeConstantExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_WebNodeConstantExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_WebNodeConstantExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_WebNodeConstantExpression_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_WebNodeConstantExpression_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_WebNodeConstantExpression_value)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_WebNodeConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_WebNodeVariableExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_WebNodeVariableExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_WebNodeVariableExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_WebNodeVariableExpression_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_WebNodeVariableExpression_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_WebNodeVariableExpression_content)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_WebNodeVariableExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_WebNodeSessionExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_WebNodeSessionExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_WebNodeSessionExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_WebNodeSessionExpression_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_WebNodeSessionExpression_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_WebNodeSessionExpression_content)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_WebNodeSessionExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_name)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_dataSourceActualParams (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_dataSourceActualParams)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_dataSourceActualParams */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_dataSource (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_dataSource (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_dataSource)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_maxNumberOfElements (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_maxNumberOfElements (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_maxNumberOfElements)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_maxNumberOfElements */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_renderAs (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_renderAs (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_renderAs)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_renderAs */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_navigationElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_navigationElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_navigationElement)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_navigationElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_columns (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_columns (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_columns)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_columns */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_headerStyleClass (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_headerStyleClass (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_headerStyleClass)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_headerStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_evenRowStyleClass (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_evenRowStyleClass (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_evenRowStyleClass)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_evenRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputElement_oddRowStyleClass (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputElement_oddRowStyleClass (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputElement_oddRowStyleClass)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputElement_oddRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputColumn (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputColumn (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputColumn)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputColumn_header (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputColumn_header (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputColumn_header)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputColumn_header */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputColumn_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputColumn_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputColumn_content)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputColumn_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputActionConnectionsContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputActionConnectionsContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputActionConnectionsContent)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputActionConnectionsContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputNumerationContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputNumerationContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputNumerationContent)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputNumerationContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputProjectionContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputProjectionContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputProjectionContent)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputProjectionContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputRefContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputRefContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputRefContent)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputRefContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputConstantContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputConstantContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputConstantContent)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputConstantContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputConstantContent_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputConstantContent_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputConstantContent_value)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputConstantContent_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputRefContent_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputRefContent_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputRefContent_column)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputRefContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputProjectionContent_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputProjectionContent_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputProjectionContent_column)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputProjectionContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputNumerationContent_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputNumerationContent_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputNumerationContent_name)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputNumerationContent_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ListOutputActionConnectionsContent_actionConnections (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ListOutputActionConnectionsContent_actionConnections)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ListOutputActionConnectionsContent_actionConnections */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ActionConnection (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ActionConnection (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ActionConnection)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ActionConnection */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ActionConnection_action (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ActionConnection_action (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ActionConnection_action)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ActionConnection_action */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ActionConnection_imageName (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ActionConnection_imageName (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ActionConnection_imageName)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ActionConnection_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ActionConnection_text (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ActionConnection_text (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ActionConnection_text)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ActionConnection_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MklistOutputView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR listOutputView_MklistOutputView_ActionConnection_actualParams (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (listOutputView_IsSymb (_currn, listOutputView_SYMBlistOutputView_ActionConnection_actualParams)) return (_currn);
return(NULLNODEPTR);
}/* listOutputView_MklistOutputView_ActionConnection_actualParams */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkpEmpty (POSITION *_coordref)
#else
NODEPTR listOutputView_MkpEmpty (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPpEmpty _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPpEmpty;
#else
_currn = (listOutputView__TPPpEmpty) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPpEmpty));
#endif
_currn->_prod = listOutputView_RULEpEmpty;
_SETCOORD(_currn)
listOutputView__TERMACT_pEmpty;
return ( (NODEPTR) _currn);
}/* listOutputView_MkpEmpty */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkpVIEWROOT_listOutputView (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkpVIEWROOT_listOutputView (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPpVIEWROOT_listOutputView _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPpVIEWROOT_listOutputView;
#else
_currn = (listOutputView__TPPpVIEWROOT_listOutputView) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPpVIEWROOT_listOutputView));
#endif
_currn->_prod = listOutputView_RULEpVIEWROOT_listOutputView;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ListOutputElement) listOutputView_MklistOutputView_ListOutputElement (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pVIEWROOT_listOutputView: root of subtree no. 1 can not be made a listOutputView_ListOutputElement node ", 0, _coordref);
_COPYCOORD(_currn)
listOutputView__TERMACT_pVIEWROOT_listOutputView;
return ( (NODEPTR) _currn);
}/* listOutputView_MkpVIEWROOT_listOutputView */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputActualParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputActualParam (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	listOutputView__TPPplistOutputView_ListOutputActualParam _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputActualParam;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputActualParam) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputActualParam));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputActualParam;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ListOutputActualParam_formalParam) listOutputView_MklistOutputView_ListOutputActualParam_formalParam (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputActualParam: root of subtree no. 1 can not be made a listOutputView_ListOutputActualParam_formalParam node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_ListOutputActualParam_keyword1) listOutputView_MklistOutputView_ListOutputActualParam_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputActualParam: root of subtree no. 2 can not be made a listOutputView_ListOutputActualParam_keyword1 node ", 0, _coordref);
_currn->_desc3 = (listOutputView__TSPlistOutputView_ListOutputActualParam_expression) listOutputView_MklistOutputView_ListOutputActualParam_expression (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputActualParam: root of subtree no. 3 can not be made a listOutputView_ListOutputActualParam_expression node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputActualParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputActualParam_formalParam (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputActualParam_formalParam (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputActualParam_formalParam _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputActualParam_formalParam;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputActualParam_formalParam) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputActualParam_formalParam));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputActualParam_formalParam;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputActualParam_formalParam;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputActualParam_keyword1 (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputActualParam_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputActualParam_keyword1 _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputActualParam_keyword1;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputActualParam_keyword1) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputActualParam_keyword1));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputActualParam_keyword1;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputActualParam_keyword1;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression;
#else
	_new = (listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression;
	_new->_desc1 = (listOutputView__TSPlistOutputView_BinaryExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputActualParam_expression)_new;
	{listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression;
#else
	_new = (listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression;
	_new->_desc1 = (listOutputView__TSPlistOutputView_UnaryExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputActualParam_expression)_new;
	{listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression;
#else
	_new = (listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression;
	_new->_desc1 = (listOutputView__TSPlistOutputView_PredefinedExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputActualParam_expression)_new;
	{listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression;
#else
	_new = (listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ConstantExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputActualParam_expression)_new;
	{listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression;
#else
	_new = (listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ColumnValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputActualParam_expression)_new;
	{listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression;
#else
	_new = (listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputActualParam_expression)_new;
	{listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression;
#else
	_new = (listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ParameterValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputActualParam_expression)_new;
	{listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression;
#else
	_new = (listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ComputationExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputActualParam_expression)_new;
	{listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_ListOutputActualParam_expression (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_BinaryExpression)) 
		return listOutputView__MklistOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression (_coordref, listOutputView_MklistOutputView_BinaryExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_UnaryExpression)) 
		return listOutputView__MklistOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression (_coordref, listOutputView_MklistOutputView_UnaryExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_PredefinedExpression)) 
		return listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression (_coordref, listOutputView_MklistOutputView_PredefinedExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ConstantExpression)) 
		return listOutputView__MklistOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression (_coordref, listOutputView_MklistOutputView_ConstantExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ColumnValueExpression)) 
		return listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression (_coordref, listOutputView_MklistOutputView_ColumnValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ProjectionColumnValueExpression)) 
		return listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression (_coordref, listOutputView_MklistOutputView_ProjectionColumnValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ParameterValueExpression)) 
		return listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression (_coordref, listOutputView_MklistOutputView_ParameterValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ComputationExpression)) 
		return listOutputView__MklistOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression (_coordref, listOutputView_MklistOutputView_ComputationExpression (_coordref, t));
	message (DEADLY, "a plistOutputView_ListOutputActualParam_expression list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_ListOutputActualParam_expression (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputActualParam_expression)
	l =_ElemplistOutputView_ListOutputActualParam_expression (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputActualParam_expression)
	r = _ElemplistOutputView_ListOutputActualParam_expression (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputActualParam_expression (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_ListOutputActualParam_expression root;
	listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputActualParam_expression)
		t = _ElemplistOutputView_ListOutputActualParam_expression (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression)(((listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_ListOutputActualParam_expression;
#else
list = (listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_ListOutputActualParam_expression));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_ListOutputActualParam_expression;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_ListOutputActualParam_expression)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression)
	{listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_BinaryExpressionplistOutputView_ListOutputActualParam_expression;
	} this code has been moved to _ElemplistOutputView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression)
	{listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_UnaryExpressionplistOutputView_ListOutputActualParam_expression;
	} this code has been moved to _ElemplistOutputView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression)
	{listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_PredefinedExpressionplistOutputView_ListOutputActualParam_expression;
	} this code has been moved to _ElemplistOutputView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression)
	{listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ConstantExpressionplistOutputView_ListOutputActualParam_expression;
	} this code has been moved to _ElemplistOutputView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression)
	{listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ColumnValueExpressionplistOutputView_ListOutputActualParam_expression;
	} this code has been moved to _ElemplistOutputView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression)
	{listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ProjectionColumnValueExpressionplistOutputView_ListOutputActualParam_expression;
	} this code has been moved to _ElemplistOutputView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression)
	{listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ParameterValueExpressionplistOutputView_ListOutputActualParam_expression;
	} this code has been moved to _ElemplistOutputView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression)
	{listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ComputationExpressionplistOutputView_ListOutputActualParam_expression;
	} this code has been moved to _ElemplistOutputView_ListOutputActualParam_expression*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_ListOutputActualParam_expression;
#else
root = (listOutputView__TPPplistOutputView_ListOutputActualParam_expression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputActualParam_expression));
#endif
root->_prod = listOutputView_RULEplistOutputView_ListOutputActualParam_expression;
root->_desc1 = (listOutputView__TSPLST_listOutputView_ListOutputActualParam_expression)list;
{ listOutputView__TPPplistOutputView_ListOutputActualParam_expression _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_ListOutputActualParam_expression;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_DataSourceActualParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR listOutputView_MkplistOutputView_DataSourceActualParam (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	listOutputView__TPPplistOutputView_DataSourceActualParam _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_DataSourceActualParam;
#else
_currn = (listOutputView__TPPplistOutputView_DataSourceActualParam) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_DataSourceActualParam));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_DataSourceActualParam;
_currn->_desc1 = (listOutputView__TSPlistOutputView_DataSourceActualParam_formalParam) listOutputView_MklistOutputView_DataSourceActualParam_formalParam (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_DataSourceActualParam: root of subtree no. 1 can not be made a listOutputView_DataSourceActualParam_formalParam node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_DataSourceActualParam_keyword1) listOutputView_MklistOutputView_DataSourceActualParam_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_DataSourceActualParam: root of subtree no. 2 can not be made a listOutputView_DataSourceActualParam_keyword1 node ", 0, _coordref);
_currn->_desc3 = (listOutputView__TSPlistOutputView_DataSourceActualParam_expressions) listOutputView_MklistOutputView_DataSourceActualParam_expressions (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_DataSourceActualParam: root of subtree no. 3 can not be made a listOutputView_DataSourceActualParam_expressions node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_DataSourceActualParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_DataSourceActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_DataSourceActualParam_formalParam (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_DataSourceActualParam_formalParam (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_DataSourceActualParam_formalParam _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_DataSourceActualParam_formalParam;
#else
_currn = (listOutputView__TPPplistOutputView_DataSourceActualParam_formalParam) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_DataSourceActualParam_formalParam));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_DataSourceActualParam_formalParam;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_DataSourceActualParam_formalParam;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_DataSourceActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_DataSourceActualParam_keyword1 (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_DataSourceActualParam_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_DataSourceActualParam_keyword1 _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_DataSourceActualParam_keyword1;
#else
_currn = (listOutputView__TPPplistOutputView_DataSourceActualParam_keyword1) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_DataSourceActualParam_keyword1));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_DataSourceActualParam_keyword1;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_DataSourceActualParam_keyword1;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_DataSourceActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions;
#else
	_new = (listOutputView__TPPLST_listOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions;
	_new->_desc1 = (listOutputView__TSPlistOutputView_WebNodeConstantExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_DataSourceActualParam_expressions)_new;
	{listOutputView__TPPLST_listOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions;
#else
	_new = (listOutputView__TPPLST_listOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions;
	_new->_desc1 = (listOutputView__TSPlistOutputView_WebNodeVariableExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_DataSourceActualParam_expressions)_new;
	{listOutputView__TPPLST_listOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions;
#else
	_new = (listOutputView__TPPLST_listOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions;
	_new->_desc1 = (listOutputView__TSPlistOutputView_WebNodeSessionExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_DataSourceActualParam_expressions)_new;
	{listOutputView__TPPLST_listOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_DataSourceActualParam_expressions (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_WebNodeConstantExpression)) 
		return listOutputView__MklistOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions (_coordref, listOutputView_MklistOutputView_WebNodeConstantExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_WebNodeVariableExpression)) 
		return listOutputView__MklistOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions (_coordref, listOutputView_MklistOutputView_WebNodeVariableExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_WebNodeSessionExpression)) 
		return listOutputView__MklistOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions (_coordref, listOutputView_MklistOutputView_WebNodeSessionExpression (_coordref, t));
	message (DEADLY, "a plistOutputView_DataSourceActualParam_expressions list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_DataSourceActualParam_expressions (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_DataSourceActualParam_expressions)
	l =_ElemplistOutputView_DataSourceActualParam_expressions (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_DataSourceActualParam_expressions)
	r = _ElemplistOutputView_DataSourceActualParam_expressions (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_DataSourceActualParam_expressions (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_DataSourceActualParam_expressions root;
	listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_DataSourceActualParam_expressions)
		t = _ElemplistOutputView_DataSourceActualParam_expressions (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions)(((listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_DataSourceActualParam_expressions;
#else
list = (listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_DataSourceActualParam_expressions));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_DataSourceActualParam_expressions;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_DataSourceActualParam_expressions)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions)
	{listOutputView__TPPLST_listOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_WebNodeConstantExpressionplistOutputView_DataSourceActualParam_expressions;
	} this code has been moved to _ElemplistOutputView_DataSourceActualParam_expressions*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions)
	{listOutputView__TPPLST_listOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_WebNodeVariableExpressionplistOutputView_DataSourceActualParam_expressions;
	} this code has been moved to _ElemplistOutputView_DataSourceActualParam_expressions*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions)
	{listOutputView__TPPLST_listOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_WebNodeSessionExpressionplistOutputView_DataSourceActualParam_expressions;
	} this code has been moved to _ElemplistOutputView_DataSourceActualParam_expressions*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_DataSourceActualParam_expressions;
#else
root = (listOutputView__TPPplistOutputView_DataSourceActualParam_expressions) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_DataSourceActualParam_expressions));
#endif
root->_prod = listOutputView_RULEplistOutputView_DataSourceActualParam_expressions;
root->_desc1 = (listOutputView__TSPLST_listOutputView_DataSourceActualParam_expressions)list;
{ listOutputView__TPPplistOutputView_DataSourceActualParam_expressions _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_DataSourceActualParam_expressions;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_BinaryExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5)
#else
NODEPTR listOutputView_MkplistOutputView_BinaryExpression (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
#endif
{	listOutputView__TPPplistOutputView_BinaryExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_BinaryExpression;
#else
_currn = (listOutputView__TPPplistOutputView_BinaryExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_BinaryExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_BinaryExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_BinaryExpression_keyword1) listOutputView_MklistOutputView_BinaryExpression_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_BinaryExpression: root of subtree no. 1 can not be made a listOutputView_BinaryExpression_keyword1 node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_BinaryExpression_leftOperand) listOutputView_MklistOutputView_BinaryExpression_leftOperand (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_BinaryExpression: root of subtree no. 2 can not be made a listOutputView_BinaryExpression_leftOperand node ", 0, _coordref);
_currn->_desc3 = (listOutputView__TSPlistOutputView_BinaryExpression_operator) listOutputView_MklistOutputView_BinaryExpression_operator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_BinaryExpression: root of subtree no. 3 can not be made a listOutputView_BinaryExpression_operator node ", 0, _coordref);
_currn->_desc4 = (listOutputView__TSPlistOutputView_BinaryExpression_rightOperand) listOutputView_MklistOutputView_BinaryExpression_rightOperand (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_BinaryExpression: root of subtree no. 4 can not be made a listOutputView_BinaryExpression_rightOperand node ", 0, _coordref);
_currn->_desc5 = (listOutputView__TSPlistOutputView_BinaryExpression_keyword2) listOutputView_MklistOutputView_BinaryExpression_keyword2 (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_BinaryExpression: root of subtree no. 5 can not be made a listOutputView_BinaryExpression_keyword2 node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_BinaryExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_BinaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_BinaryExpression_keyword1 (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_BinaryExpression_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_BinaryExpression_keyword1 _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_BinaryExpression_keyword1;
#else
_currn = (listOutputView__TPPplistOutputView_BinaryExpression_keyword1) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_BinaryExpression_keyword1));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_BinaryExpression_keyword1;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_BinaryExpression_keyword1;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_BinaryExpression_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_BinaryExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_leftOperand)_new;
	{listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_UnaryExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_leftOperand)_new;
	{listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_PredefinedExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_leftOperand)_new;
	{listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ConstantExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_leftOperand)_new;
	{listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ColumnValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_leftOperand)_new;
	{listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_leftOperand)_new;
	{listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ParameterValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_leftOperand)_new;
	{listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ComputationExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_leftOperand)_new;
	{listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_BinaryExpression_leftOperand (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_BinaryExpression)) 
		return listOutputView__MklistOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, listOutputView_MklistOutputView_BinaryExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_UnaryExpression)) 
		return listOutputView__MklistOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, listOutputView_MklistOutputView_UnaryExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_PredefinedExpression)) 
		return listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, listOutputView_MklistOutputView_PredefinedExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ConstantExpression)) 
		return listOutputView__MklistOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, listOutputView_MklistOutputView_ConstantExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ColumnValueExpression)) 
		return listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, listOutputView_MklistOutputView_ColumnValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ProjectionColumnValueExpression)) 
		return listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, listOutputView_MklistOutputView_ProjectionColumnValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ParameterValueExpression)) 
		return listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, listOutputView_MklistOutputView_ParameterValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ComputationExpression)) 
		return listOutputView__MklistOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand (_coordref, listOutputView_MklistOutputView_ComputationExpression (_coordref, t));
	message (DEADLY, "a plistOutputView_BinaryExpression_leftOperand list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_BinaryExpression_leftOperand (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_BinaryExpression_leftOperand)
	l =_ElemplistOutputView_BinaryExpression_leftOperand (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_BinaryExpression_leftOperand)
	r = _ElemplistOutputView_BinaryExpression_leftOperand (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_BinaryExpression_leftOperand (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_BinaryExpression_leftOperand root;
	listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_BinaryExpression_leftOperand)
		t = _ElemplistOutputView_BinaryExpression_leftOperand (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand)(((listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_BinaryExpression_leftOperand;
#else
list = (listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_BinaryExpression_leftOperand));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_BinaryExpression_leftOperand;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_BinaryExpression_leftOperand)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand)
	{listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_leftOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand)
	{listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_leftOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand)
	{listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_leftOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand)
	{listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_leftOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand)
	{listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_leftOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand)
	{listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_leftOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand)
	{listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_leftOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand)
	{listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_leftOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_leftOperand*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_BinaryExpression_leftOperand;
#else
root = (listOutputView__TPPplistOutputView_BinaryExpression_leftOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_BinaryExpression_leftOperand));
#endif
root->_prod = listOutputView_RULEplistOutputView_BinaryExpression_leftOperand;
root->_desc1 = (listOutputView__TSPLST_listOutputView_BinaryExpression_leftOperand)list;
{ listOutputView__TPPplistOutputView_BinaryExpression_leftOperand _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_BinaryExpression_leftOperand;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_BinaryExpression_operator (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_BinaryExpression_operator (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_BinaryExpression_operator _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_BinaryExpression_operator;
#else
_currn = (listOutputView__TPPplistOutputView_BinaryExpression_operator) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_BinaryExpression_operator));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_BinaryExpression_operator;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_BinaryExpression_operator;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_BinaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_BinaryExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_rightOperand)_new;
	{listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_UnaryExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_rightOperand)_new;
	{listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_PredefinedExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_rightOperand)_new;
	{listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ConstantExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_rightOperand)_new;
	{listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ColumnValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_rightOperand)_new;
	{listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_rightOperand)_new;
	{listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ParameterValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_rightOperand)_new;
	{listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ComputationExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_BinaryExpression_rightOperand)_new;
	{listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_BinaryExpression_rightOperand (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_BinaryExpression)) 
		return listOutputView__MklistOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, listOutputView_MklistOutputView_BinaryExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_UnaryExpression)) 
		return listOutputView__MklistOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, listOutputView_MklistOutputView_UnaryExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_PredefinedExpression)) 
		return listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, listOutputView_MklistOutputView_PredefinedExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ConstantExpression)) 
		return listOutputView__MklistOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, listOutputView_MklistOutputView_ConstantExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ColumnValueExpression)) 
		return listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, listOutputView_MklistOutputView_ColumnValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ProjectionColumnValueExpression)) 
		return listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, listOutputView_MklistOutputView_ProjectionColumnValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ParameterValueExpression)) 
		return listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, listOutputView_MklistOutputView_ParameterValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ComputationExpression)) 
		return listOutputView__MklistOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand (_coordref, listOutputView_MklistOutputView_ComputationExpression (_coordref, t));
	message (DEADLY, "a plistOutputView_BinaryExpression_rightOperand list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_BinaryExpression_rightOperand (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_BinaryExpression_rightOperand)
	l =_ElemplistOutputView_BinaryExpression_rightOperand (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_BinaryExpression_rightOperand)
	r = _ElemplistOutputView_BinaryExpression_rightOperand (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_BinaryExpression_rightOperand (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_BinaryExpression_rightOperand root;
	listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_BinaryExpression_rightOperand)
		t = _ElemplistOutputView_BinaryExpression_rightOperand (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand)(((listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_BinaryExpression_rightOperand;
#else
list = (listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_BinaryExpression_rightOperand));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_BinaryExpression_rightOperand;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_BinaryExpression_rightOperand)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand)
	{listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_BinaryExpressionplistOutputView_BinaryExpression_rightOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand)
	{listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_UnaryExpressionplistOutputView_BinaryExpression_rightOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand)
	{listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_PredefinedExpressionplistOutputView_BinaryExpression_rightOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand)
	{listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ConstantExpressionplistOutputView_BinaryExpression_rightOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand)
	{listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ColumnValueExpressionplistOutputView_BinaryExpression_rightOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand)
	{listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ProjectionColumnValueExpressionplistOutputView_BinaryExpression_rightOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand)
	{listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ParameterValueExpressionplistOutputView_BinaryExpression_rightOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand)
	{listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ComputationExpressionplistOutputView_BinaryExpression_rightOperand;
	} this code has been moved to _ElemplistOutputView_BinaryExpression_rightOperand*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_BinaryExpression_rightOperand;
#else
root = (listOutputView__TPPplistOutputView_BinaryExpression_rightOperand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_BinaryExpression_rightOperand));
#endif
root->_prod = listOutputView_RULEplistOutputView_BinaryExpression_rightOperand;
root->_desc1 = (listOutputView__TSPLST_listOutputView_BinaryExpression_rightOperand)list;
{ listOutputView__TPPplistOutputView_BinaryExpression_rightOperand _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_BinaryExpression_rightOperand;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_BinaryExpression_keyword2 (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_BinaryExpression_keyword2 (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_BinaryExpression_keyword2 _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_BinaryExpression_keyword2;
#else
_currn = (listOutputView__TPPplistOutputView_BinaryExpression_keyword2) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_BinaryExpression_keyword2));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_BinaryExpression_keyword2;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_BinaryExpression_keyword2;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_BinaryExpression_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_UnaryExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR listOutputView_MkplistOutputView_UnaryExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	listOutputView__TPPplistOutputView_UnaryExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_UnaryExpression;
#else
_currn = (listOutputView__TPPplistOutputView_UnaryExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_UnaryExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_UnaryExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_UnaryExpression_operator) listOutputView_MklistOutputView_UnaryExpression_operator (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_UnaryExpression: root of subtree no. 1 can not be made a listOutputView_UnaryExpression_operator node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_UnaryExpression_operand) listOutputView_MklistOutputView_UnaryExpression_operand (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_UnaryExpression: root of subtree no. 2 can not be made a listOutputView_UnaryExpression_operand node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_UnaryExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_UnaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_UnaryExpression_operator (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_UnaryExpression_operator (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_UnaryExpression_operator _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_UnaryExpression_operator;
#else
_currn = (listOutputView__TPPplistOutputView_UnaryExpression_operator) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_UnaryExpression_operator));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_UnaryExpression_operator;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_UnaryExpression_operator;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_UnaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand;
#else
	_new = (listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_BinaryExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_UnaryExpression_operand)_new;
	{listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand;
#else
	_new = (listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_UnaryExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_UnaryExpression_operand)_new;
	{listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand;
#else
	_new = (listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_PredefinedExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_UnaryExpression_operand)_new;
	{listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ConstantExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_UnaryExpression_operand)_new;
	{listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ColumnValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_UnaryExpression_operand)_new;
	{listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_UnaryExpression_operand)_new;
	{listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ParameterValueExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_UnaryExpression_operand)_new;
	{listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand;
#else
	_new = (listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ComputationExpression)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_UnaryExpression_operand)_new;
	{listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_UnaryExpression_operand (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_BinaryExpression)) 
		return listOutputView__MklistOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand (_coordref, listOutputView_MklistOutputView_BinaryExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_UnaryExpression)) 
		return listOutputView__MklistOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand (_coordref, listOutputView_MklistOutputView_UnaryExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_PredefinedExpression)) 
		return listOutputView__MklistOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand (_coordref, listOutputView_MklistOutputView_PredefinedExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ConstantExpression)) 
		return listOutputView__MklistOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand (_coordref, listOutputView_MklistOutputView_ConstantExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ColumnValueExpression)) 
		return listOutputView__MklistOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand (_coordref, listOutputView_MklistOutputView_ColumnValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ProjectionColumnValueExpression)) 
		return listOutputView__MklistOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand (_coordref, listOutputView_MklistOutputView_ProjectionColumnValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ParameterValueExpression)) 
		return listOutputView__MklistOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand (_coordref, listOutputView_MklistOutputView_ParameterValueExpression (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ComputationExpression)) 
		return listOutputView__MklistOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand (_coordref, listOutputView_MklistOutputView_ComputationExpression (_coordref, t));
	message (DEADLY, "a plistOutputView_UnaryExpression_operand list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_UnaryExpression_operand (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_UnaryExpression_operand)
	l =_ElemplistOutputView_UnaryExpression_operand (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_UnaryExpression_operand)
	r = _ElemplistOutputView_UnaryExpression_operand (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_UnaryExpression_operand (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_UnaryExpression_operand (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_UnaryExpression_operand root;
	listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_UnaryExpression_operand)
		t = _ElemplistOutputView_UnaryExpression_operand (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand)(((listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_UnaryExpression_operand;
#else
list = (listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_UnaryExpression_operand));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_UnaryExpression_operand;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_UnaryExpression_operand)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand)
	{listOutputView__TPPLST_listOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_BinaryExpressionplistOutputView_UnaryExpression_operand;
	} this code has been moved to _ElemplistOutputView_UnaryExpression_operand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand)
	{listOutputView__TPPLST_listOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_UnaryExpressionplistOutputView_UnaryExpression_operand;
	} this code has been moved to _ElemplistOutputView_UnaryExpression_operand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand)
	{listOutputView__TPPLST_listOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_PredefinedExpressionplistOutputView_UnaryExpression_operand;
	} this code has been moved to _ElemplistOutputView_UnaryExpression_operand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand)
	{listOutputView__TPPLST_listOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ConstantExpressionplistOutputView_UnaryExpression_operand;
	} this code has been moved to _ElemplistOutputView_UnaryExpression_operand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand)
	{listOutputView__TPPLST_listOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ColumnValueExpressionplistOutputView_UnaryExpression_operand;
	} this code has been moved to _ElemplistOutputView_UnaryExpression_operand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand)
	{listOutputView__TPPLST_listOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ProjectionColumnValueExpressionplistOutputView_UnaryExpression_operand;
	} this code has been moved to _ElemplistOutputView_UnaryExpression_operand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand)
	{listOutputView__TPPLST_listOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ParameterValueExpressionplistOutputView_UnaryExpression_operand;
	} this code has been moved to _ElemplistOutputView_UnaryExpression_operand*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand)
	{listOutputView__TPPLST_listOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ComputationExpressionplistOutputView_UnaryExpression_operand;
	} this code has been moved to _ElemplistOutputView_UnaryExpression_operand*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_UnaryExpression_operand;
#else
root = (listOutputView__TPPplistOutputView_UnaryExpression_operand) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_UnaryExpression_operand));
#endif
root->_prod = listOutputView_RULEplistOutputView_UnaryExpression_operand;
root->_desc1 = (listOutputView__TSPLST_listOutputView_UnaryExpression_operand)list;
{ listOutputView__TPPplistOutputView_UnaryExpression_operand _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_UnaryExpression_operand;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_PredefinedExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkplistOutputView_PredefinedExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPplistOutputView_PredefinedExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_PredefinedExpression;
#else
_currn = (listOutputView__TPPplistOutputView_PredefinedExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_PredefinedExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_PredefinedExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_PredefinedExpression_value) listOutputView_MklistOutputView_PredefinedExpression_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_PredefinedExpression: root of subtree no. 1 can not be made a listOutputView_PredefinedExpression_value node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_PredefinedExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_PredefinedExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_PredefinedExpression_value (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_PredefinedExpression_value (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_PredefinedExpression_value _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_PredefinedExpression_value;
#else
_currn = (listOutputView__TPPplistOutputView_PredefinedExpression_value) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_PredefinedExpression_value));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_PredefinedExpression_value;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_PredefinedExpression_value;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_PredefinedExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ConstantExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR listOutputView_MkplistOutputView_ConstantExpression (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	listOutputView__TPPplistOutputView_ConstantExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ConstantExpression;
#else
_currn = (listOutputView__TPPplistOutputView_ConstantExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ConstantExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ConstantExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ConstantExpression_keyword1) listOutputView_MklistOutputView_ConstantExpression_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ConstantExpression: root of subtree no. 1 can not be made a listOutputView_ConstantExpression_keyword1 node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_ConstantExpression_value) listOutputView_MklistOutputView_ConstantExpression_value (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ConstantExpression: root of subtree no. 2 can not be made a listOutputView_ConstantExpression_value node ", 0, _coordref);
_currn->_desc3 = (listOutputView__TSPlistOutputView_ConstantExpression_keyword2) listOutputView_MklistOutputView_ConstantExpression_keyword2 (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ConstantExpression: root of subtree no. 3 can not be made a listOutputView_ConstantExpression_keyword2 node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ConstantExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ConstantExpression_keyword1 (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ConstantExpression_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ConstantExpression_keyword1 _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ConstantExpression_keyword1;
#else
_currn = (listOutputView__TPPplistOutputView_ConstantExpression_keyword1) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ConstantExpression_keyword1));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ConstantExpression_keyword1;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ConstantExpression_keyword1;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ConstantExpression_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ConstantExpression_value (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ConstantExpression_value (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ConstantExpression_value _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ConstantExpression_value;
#else
_currn = (listOutputView__TPPplistOutputView_ConstantExpression_value) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ConstantExpression_value));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ConstantExpression_value;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ConstantExpression_value;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ConstantExpression_keyword2 (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ConstantExpression_keyword2 (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ConstantExpression_keyword2 _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ConstantExpression_keyword2;
#else
_currn = (listOutputView__TPPplistOutputView_ConstantExpression_keyword2) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ConstantExpression_keyword2));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ConstantExpression_keyword2;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ConstantExpression_keyword2;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ConstantExpression_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ColumnValueExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkplistOutputView_ColumnValueExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPplistOutputView_ColumnValueExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ColumnValueExpression;
#else
_currn = (listOutputView__TPPplistOutputView_ColumnValueExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ColumnValueExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ColumnValueExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ColumnValueExpression_column) listOutputView_MklistOutputView_ColumnValueExpression_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ColumnValueExpression: root of subtree no. 1 can not be made a listOutputView_ColumnValueExpression_column node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ColumnValueExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ColumnValueExpression_column (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ColumnValueExpression_column (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ColumnValueExpression_column _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ColumnValueExpression_column;
#else
_currn = (listOutputView__TPPplistOutputView_ColumnValueExpression_column) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ColumnValueExpression_column));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ColumnValueExpression_column;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ColumnValueExpression_column;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ProjectionColumnValueExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkplistOutputView_ProjectionColumnValueExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPplistOutputView_ProjectionColumnValueExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ProjectionColumnValueExpression;
#else
_currn = (listOutputView__TPPplistOutputView_ProjectionColumnValueExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ProjectionColumnValueExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ProjectionColumnValueExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ProjectionColumnValueExpression_column) listOutputView_MklistOutputView_ProjectionColumnValueExpression_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ProjectionColumnValueExpression: root of subtree no. 1 can not be made a listOutputView_ProjectionColumnValueExpression_column node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ProjectionColumnValueExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ProjectionColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ProjectionColumnValueExpression_column (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ProjectionColumnValueExpression_column (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ProjectionColumnValueExpression_column _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ProjectionColumnValueExpression_column;
#else
_currn = (listOutputView__TPPplistOutputView_ProjectionColumnValueExpression_column) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ProjectionColumnValueExpression_column));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ProjectionColumnValueExpression_column;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ProjectionColumnValueExpression_column;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ProjectionColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ParameterValueExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkplistOutputView_ParameterValueExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPplistOutputView_ParameterValueExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ParameterValueExpression;
#else
_currn = (listOutputView__TPPplistOutputView_ParameterValueExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ParameterValueExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ParameterValueExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ParameterValueExpression_parameter) listOutputView_MklistOutputView_ParameterValueExpression_parameter (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ParameterValueExpression: root of subtree no. 1 can not be made a listOutputView_ParameterValueExpression_parameter node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ParameterValueExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ParameterValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ParameterValueExpression_parameter (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ParameterValueExpression_parameter (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ParameterValueExpression_parameter _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ParameterValueExpression_parameter;
#else
_currn = (listOutputView__TPPplistOutputView_ParameterValueExpression_parameter) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ParameterValueExpression_parameter));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ParameterValueExpression_parameter;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ParameterValueExpression_parameter;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ParameterValueExpression_parameter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ComputationExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR listOutputView_MkplistOutputView_ComputationExpression (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	listOutputView__TPPplistOutputView_ComputationExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ComputationExpression;
#else
_currn = (listOutputView__TPPplistOutputView_ComputationExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ComputationExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ComputationExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ComputationExpression_computation) listOutputView_MklistOutputView_ComputationExpression_computation (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ComputationExpression: root of subtree no. 1 can not be made a listOutputView_ComputationExpression_computation node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_ComputationExpression_keyword1) listOutputView_MklistOutputView_ComputationExpression_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ComputationExpression: root of subtree no. 2 can not be made a listOutputView_ComputationExpression_keyword1 node ", 0, _coordref);
_currn->_desc3 = (listOutputView__TSPlistOutputView_ComputationExpression_column) listOutputView_MklistOutputView_ComputationExpression_column (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ComputationExpression: root of subtree no. 3 can not be made a listOutputView_ComputationExpression_column node ", 0, _coordref);
_currn->_desc4 = (listOutputView__TSPlistOutputView_ComputationExpression_keyword2) listOutputView_MklistOutputView_ComputationExpression_keyword2 (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ComputationExpression: root of subtree no. 4 can not be made a listOutputView_ComputationExpression_keyword2 node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ComputationExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ComputationExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ComputationExpression_computation (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ComputationExpression_computation (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ComputationExpression_computation _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ComputationExpression_computation;
#else
_currn = (listOutputView__TPPplistOutputView_ComputationExpression_computation) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ComputationExpression_computation));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ComputationExpression_computation;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ComputationExpression_computation;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ComputationExpression_computation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ComputationExpression_keyword1 (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ComputationExpression_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ComputationExpression_keyword1 _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ComputationExpression_keyword1;
#else
_currn = (listOutputView__TPPplistOutputView_ComputationExpression_keyword1) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ComputationExpression_keyword1));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ComputationExpression_keyword1;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ComputationExpression_keyword1;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ComputationExpression_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ComputationExpression_column (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ComputationExpression_column (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ComputationExpression_column _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ComputationExpression_column;
#else
_currn = (listOutputView__TPPplistOutputView_ComputationExpression_column) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ComputationExpression_column));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ComputationExpression_column;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ComputationExpression_column;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ComputationExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ComputationExpression_keyword2 (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ComputationExpression_keyword2 (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ComputationExpression_keyword2 _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ComputationExpression_keyword2;
#else
_currn = (listOutputView__TPPplistOutputView_ComputationExpression_keyword2) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ComputationExpression_keyword2));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ComputationExpression_keyword2;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ComputationExpression_keyword2;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ComputationExpression_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_MD5Modifier (POSITION *_coordref, int _TERM1)
#else
NODEPTR listOutputView_MkplistOutputView_MD5Modifier (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	listOutputView__TPPplistOutputView_MD5Modifier _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_MD5Modifier;
#else
_currn = (listOutputView__TPPplistOutputView_MD5Modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_MD5Modifier));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_MD5Modifier;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_MD5Modifier;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_MD5Modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_JoinModifier (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkplistOutputView_JoinModifier (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPplistOutputView_JoinModifier _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_JoinModifier;
#else
_currn = (listOutputView__TPPplistOutputView_JoinModifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_JoinModifier));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_JoinModifier;
_currn->_desc1 = (listOutputView__TSPlistOutputView_JoinModifier_separator) listOutputView_MklistOutputView_JoinModifier_separator (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_JoinModifier: root of subtree no. 1 can not be made a listOutputView_JoinModifier_separator node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_JoinModifier;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_JoinModifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_JoinModifier_separator (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_JoinModifier_separator (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_JoinModifier_separator _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_JoinModifier_separator;
#else
_currn = (listOutputView__TPPplistOutputView_JoinModifier_separator) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_JoinModifier_separator));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_JoinModifier_separator;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_JoinModifier_separator;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_JoinModifier_separator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_WebNodeConstantExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR listOutputView_MkplistOutputView_WebNodeConstantExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	listOutputView__TPPplistOutputView_WebNodeConstantExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_WebNodeConstantExpression;
#else
_currn = (listOutputView__TPPplistOutputView_WebNodeConstantExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_WebNodeConstantExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_WebNodeConstantExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_WebNodeConstantExpression_modifier) listOutputView_MklistOutputView_WebNodeConstantExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_WebNodeConstantExpression: root of subtree no. 1 can not be made a listOutputView_WebNodeConstantExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_WebNodeConstantExpression_value) listOutputView_MklistOutputView_WebNodeConstantExpression_value (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_WebNodeConstantExpression: root of subtree no. 2 can not be made a listOutputView_WebNodeConstantExpression_value node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_WebNodeConstantExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_WebNodeConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier;
#else
	_new = (listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier;
	_new->_desc1 = (listOutputView__TSPlistOutputView_MD5Modifier)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_WebNodeConstantExpression_modifier)_new;
	{listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier;
#else
	_new = (listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier;
	_new->_desc1 = (listOutputView__TSPlistOutputView_JoinModifier)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_WebNodeConstantExpression_modifier)_new;
	{listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_WebNodeConstantExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_MD5Modifier)) 
		return listOutputView__MklistOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier (_coordref, listOutputView_MklistOutputView_MD5Modifier (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_JoinModifier)) 
		return listOutputView__MklistOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier (_coordref, listOutputView_MklistOutputView_JoinModifier (_coordref, t));
	message (DEADLY, "a plistOutputView_WebNodeConstantExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_WebNodeConstantExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_WebNodeConstantExpression_modifier)
	l =_ElemplistOutputView_WebNodeConstantExpression_modifier (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_WebNodeConstantExpression_modifier)
	r = _ElemplistOutputView_WebNodeConstantExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_WebNodeConstantExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_WebNodeConstantExpression_modifier root;
	listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_WebNodeConstantExpression_modifier)
		t = _ElemplistOutputView_WebNodeConstantExpression_modifier (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier)(((listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_WebNodeConstantExpression_modifier;
#else
list = (listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_WebNodeConstantExpression_modifier));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_WebNodeConstantExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_WebNodeConstantExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier)
	{listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_MD5ModifierplistOutputView_WebNodeConstantExpression_modifier;
	} this code has been moved to _ElemplistOutputView_WebNodeConstantExpression_modifier*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier)
	{listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_JoinModifierplistOutputView_WebNodeConstantExpression_modifier;
	} this code has been moved to _ElemplistOutputView_WebNodeConstantExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_WebNodeConstantExpression_modifier;
#else
root = (listOutputView__TPPplistOutputView_WebNodeConstantExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_WebNodeConstantExpression_modifier));
#endif
root->_prod = listOutputView_RULEplistOutputView_WebNodeConstantExpression_modifier;
root->_desc1 = (listOutputView__TSPLST_listOutputView_WebNodeConstantExpression_modifier)list;
{ listOutputView__TPPplistOutputView_WebNodeConstantExpression_modifier _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_WebNodeConstantExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_WebNodeConstantExpression_value (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_WebNodeConstantExpression_value (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_WebNodeConstantExpression_value _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_WebNodeConstantExpression_value;
#else
_currn = (listOutputView__TPPplistOutputView_WebNodeConstantExpression_value) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_WebNodeConstantExpression_value));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_WebNodeConstantExpression_value;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_WebNodeConstantExpression_value;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_WebNodeConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_WebNodeVariableExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR listOutputView_MkplistOutputView_WebNodeVariableExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	listOutputView__TPPplistOutputView_WebNodeVariableExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_WebNodeVariableExpression;
#else
_currn = (listOutputView__TPPplistOutputView_WebNodeVariableExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_WebNodeVariableExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_WebNodeVariableExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_WebNodeVariableExpression_modifier) listOutputView_MklistOutputView_WebNodeVariableExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_WebNodeVariableExpression: root of subtree no. 1 can not be made a listOutputView_WebNodeVariableExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_WebNodeVariableExpression_content) listOutputView_MklistOutputView_WebNodeVariableExpression_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_WebNodeVariableExpression: root of subtree no. 2 can not be made a listOutputView_WebNodeVariableExpression_content node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_WebNodeVariableExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_WebNodeVariableExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier;
#else
	_new = (listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier;
	_new->_desc1 = (listOutputView__TSPlistOutputView_MD5Modifier)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_WebNodeVariableExpression_modifier)_new;
	{listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier;
#else
	_new = (listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier;
	_new->_desc1 = (listOutputView__TSPlistOutputView_JoinModifier)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_WebNodeVariableExpression_modifier)_new;
	{listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_WebNodeVariableExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_MD5Modifier)) 
		return listOutputView__MklistOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier (_coordref, listOutputView_MklistOutputView_MD5Modifier (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_JoinModifier)) 
		return listOutputView__MklistOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier (_coordref, listOutputView_MklistOutputView_JoinModifier (_coordref, t));
	message (DEADLY, "a plistOutputView_WebNodeVariableExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_WebNodeVariableExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_WebNodeVariableExpression_modifier)
	l =_ElemplistOutputView_WebNodeVariableExpression_modifier (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_WebNodeVariableExpression_modifier)
	r = _ElemplistOutputView_WebNodeVariableExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_WebNodeVariableExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_WebNodeVariableExpression_modifier root;
	listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_WebNodeVariableExpression_modifier)
		t = _ElemplistOutputView_WebNodeVariableExpression_modifier (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier)(((listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_WebNodeVariableExpression_modifier;
#else
list = (listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_WebNodeVariableExpression_modifier));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_WebNodeVariableExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_WebNodeVariableExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier)
	{listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_MD5ModifierplistOutputView_WebNodeVariableExpression_modifier;
	} this code has been moved to _ElemplistOutputView_WebNodeVariableExpression_modifier*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier)
	{listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_JoinModifierplistOutputView_WebNodeVariableExpression_modifier;
	} this code has been moved to _ElemplistOutputView_WebNodeVariableExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_WebNodeVariableExpression_modifier;
#else
root = (listOutputView__TPPplistOutputView_WebNodeVariableExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_WebNodeVariableExpression_modifier));
#endif
root->_prod = listOutputView_RULEplistOutputView_WebNodeVariableExpression_modifier;
root->_desc1 = (listOutputView__TSPLST_listOutputView_WebNodeVariableExpression_modifier)list;
{ listOutputView__TPPplistOutputView_WebNodeVariableExpression_modifier _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_WebNodeVariableExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_WebNodeVariableExpression_content (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_WebNodeVariableExpression_content (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_WebNodeVariableExpression_content _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_WebNodeVariableExpression_content;
#else
_currn = (listOutputView__TPPplistOutputView_WebNodeVariableExpression_content) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_WebNodeVariableExpression_content));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_WebNodeVariableExpression_content;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_WebNodeVariableExpression_content;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_WebNodeVariableExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_WebNodeSessionExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR listOutputView_MkplistOutputView_WebNodeSessionExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	listOutputView__TPPplistOutputView_WebNodeSessionExpression _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_WebNodeSessionExpression;
#else
_currn = (listOutputView__TPPplistOutputView_WebNodeSessionExpression) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_WebNodeSessionExpression));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_WebNodeSessionExpression;
_currn->_desc1 = (listOutputView__TSPlistOutputView_WebNodeSessionExpression_modifier) listOutputView_MklistOutputView_WebNodeSessionExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_WebNodeSessionExpression: root of subtree no. 1 can not be made a listOutputView_WebNodeSessionExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_WebNodeSessionExpression_content) listOutputView_MklistOutputView_WebNodeSessionExpression_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_WebNodeSessionExpression: root of subtree no. 2 can not be made a listOutputView_WebNodeSessionExpression_content node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_WebNodeSessionExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_WebNodeSessionExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier;
#else
	_new = (listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier;
	_new->_desc1 = (listOutputView__TSPlistOutputView_MD5Modifier)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_WebNodeSessionExpression_modifier)_new;
	{listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier;
#else
	_new = (listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier;
	_new->_desc1 = (listOutputView__TSPlistOutputView_JoinModifier)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_WebNodeSessionExpression_modifier)_new;
	{listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_WebNodeSessionExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_MD5Modifier)) 
		return listOutputView__MklistOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier (_coordref, listOutputView_MklistOutputView_MD5Modifier (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_JoinModifier)) 
		return listOutputView__MklistOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier (_coordref, listOutputView_MklistOutputView_JoinModifier (_coordref, t));
	message (DEADLY, "a plistOutputView_WebNodeSessionExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_WebNodeSessionExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_WebNodeSessionExpression_modifier)
	l =_ElemplistOutputView_WebNodeSessionExpression_modifier (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_WebNodeSessionExpression_modifier)
	r = _ElemplistOutputView_WebNodeSessionExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_WebNodeSessionExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_WebNodeSessionExpression_modifier root;
	listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_WebNodeSessionExpression_modifier)
		t = _ElemplistOutputView_WebNodeSessionExpression_modifier (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier)(((listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_WebNodeSessionExpression_modifier;
#else
list = (listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_WebNodeSessionExpression_modifier));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_WebNodeSessionExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_WebNodeSessionExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier)
	{listOutputView__TPPLST_listOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_MD5ModifierplistOutputView_WebNodeSessionExpression_modifier;
	} this code has been moved to _ElemplistOutputView_WebNodeSessionExpression_modifier*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier)
	{listOutputView__TPPLST_listOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_JoinModifierplistOutputView_WebNodeSessionExpression_modifier;
	} this code has been moved to _ElemplistOutputView_WebNodeSessionExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_WebNodeSessionExpression_modifier;
#else
root = (listOutputView__TPPplistOutputView_WebNodeSessionExpression_modifier) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_WebNodeSessionExpression_modifier));
#endif
root->_prod = listOutputView_RULEplistOutputView_WebNodeSessionExpression_modifier;
root->_desc1 = (listOutputView__TSPLST_listOutputView_WebNodeSessionExpression_modifier)list;
{ listOutputView__TPPplistOutputView_WebNodeSessionExpression_modifier _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_WebNodeSessionExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_WebNodeSessionExpression_content (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_WebNodeSessionExpression_content (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_WebNodeSessionExpression_content _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_WebNodeSessionExpression_content;
#else
_currn = (listOutputView__TPPplistOutputView_WebNodeSessionExpression_content) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_WebNodeSessionExpression_content));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_WebNodeSessionExpression_content;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_WebNodeSessionExpression_content;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_WebNodeSessionExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7, NODEPTR _desc8, NODEPTR _desc9, NODEPTR _desc10, NODEPTR _desc11)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7,_desc8,_desc9,_desc10,_desc11)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
	NODEPTR _desc8;
	NODEPTR _desc9;
	NODEPTR _desc10;
	NODEPTR _desc11;
#endif
{	listOutputView__TPPplistOutputView_ListOutputElement _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputElement;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputElement) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputElement;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ListOutputElement_styleSheetBlock) listOutputView_MklistOutputView_ListOutputElement_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 1 can not be made a listOutputView_ListOutputElement_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_ListOutputElement_name) listOutputView_MklistOutputView_ListOutputElement_name (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 2 can not be made a listOutputView_ListOutputElement_name node ", 0, _coordref);
_currn->_desc3 = (listOutputView__TSPlistOutputView_ListOutputElement_dataSourceActualParams) listOutputView_MklistOutputView_ListOutputElement_dataSourceActualParams (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 3 can not be made a listOutputView_ListOutputElement_dataSourceActualParams node ", 0, _coordref);
_currn->_desc4 = (listOutputView__TSPlistOutputView_ListOutputElement_dataSource) listOutputView_MklistOutputView_ListOutputElement_dataSource (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 4 can not be made a listOutputView_ListOutputElement_dataSource node ", 0, _coordref);
_currn->_desc5 = (listOutputView__TSPlistOutputView_ListOutputElement_maxNumberOfElements) listOutputView_MklistOutputView_ListOutputElement_maxNumberOfElements (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 5 can not be made a listOutputView_ListOutputElement_maxNumberOfElements node ", 0, _coordref);
_currn->_desc6 = (listOutputView__TSPlistOutputView_ListOutputElement_renderAs) listOutputView_MklistOutputView_ListOutputElement_renderAs (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 6 can not be made a listOutputView_ListOutputElement_renderAs node ", 0, _coordref);
_currn->_desc7 = (listOutputView__TSPlistOutputView_ListOutputElement_navigationElement) listOutputView_MklistOutputView_ListOutputElement_navigationElement (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 7 can not be made a listOutputView_ListOutputElement_navigationElement node ", 0, _coordref);
_currn->_desc8 = (listOutputView__TSPlistOutputView_ListOutputElement_columns) listOutputView_MklistOutputView_ListOutputElement_columns (_coordref, _desc8);	
if (((NODEPTR)_currn->_desc8) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 8 can not be made a listOutputView_ListOutputElement_columns node ", 0, _coordref);
_currn->_desc9 = (listOutputView__TSPlistOutputView_ListOutputElement_headerStyleClass) listOutputView_MklistOutputView_ListOutputElement_headerStyleClass (_coordref, _desc9);	
if (((NODEPTR)_currn->_desc9) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 9 can not be made a listOutputView_ListOutputElement_headerStyleClass node ", 0, _coordref);
_currn->_desc10 = (listOutputView__TSPlistOutputView_ListOutputElement_evenRowStyleClass) listOutputView_MklistOutputView_ListOutputElement_evenRowStyleClass (_coordref, _desc10);	
if (((NODEPTR)_currn->_desc10) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 10 can not be made a listOutputView_ListOutputElement_evenRowStyleClass node ", 0, _coordref);
_currn->_desc11 = (listOutputView__TSPlistOutputView_ListOutputElement_oddRowStyleClass) listOutputView_MklistOutputView_ListOutputElement_oddRowStyleClass (_coordref, _desc11);	
if (((NODEPTR)_currn->_desc11) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputElement: root of subtree no. 11 can not be made a listOutputView_ListOutputElement_oddRowStyleClass node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputElement_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputElement_styleSheetBlock;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputElement_styleSheetBlock) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_styleSheetBlock));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputElement_styleSheetBlock;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputElement_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputElement_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_name (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_name (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputElement_name _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputElement_name;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputElement_name) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_name));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputElement_name;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputElement_name;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputElement_name */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams;
#else
	_new = (listOutputView__TPPLST_listOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams;
	_new->_desc1 = (listOutputView__TSPlistOutputView_DataSourceActualParam)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputElement_dataSourceActualParams)_new;
	{listOutputView__TPPLST_listOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_ListOutputElement_dataSourceActualParams (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_DataSourceActualParam)) 
		return listOutputView__MklistOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams (_coordref, listOutputView_MklistOutputView_DataSourceActualParam (_coordref, t));
	message (DEADLY, "a plistOutputView_ListOutputElement_dataSourceActualParams list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_ListOutputElement_dataSourceActualParams (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputElement_dataSourceActualParams)
	l =_ElemplistOutputView_ListOutputElement_dataSourceActualParams (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputElement_dataSourceActualParams)
	r = _ElemplistOutputView_ListOutputElement_dataSourceActualParams (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_dataSourceActualParams (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_ListOutputElement_dataSourceActualParams root;
	listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputElement_dataSourceActualParams)
		t = _ElemplistOutputView_ListOutputElement_dataSourceActualParams (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams)(((listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_ListOutputElement_dataSourceActualParams;
#else
list = (listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_ListOutputElement_dataSourceActualParams));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_ListOutputElement_dataSourceActualParams;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_ListOutputElement_dataSourceActualParams)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams)
	{listOutputView__TPPLST_listOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_DataSourceActualParamplistOutputView_ListOutputElement_dataSourceActualParams;
	} this code has been moved to _ElemplistOutputView_ListOutputElement_dataSourceActualParams*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_ListOutputElement_dataSourceActualParams;
#else
root = (listOutputView__TPPplistOutputView_ListOutputElement_dataSourceActualParams) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_dataSourceActualParams));
#endif
root->_prod = listOutputView_RULEplistOutputView_ListOutputElement_dataSourceActualParams;
root->_desc1 = (listOutputView__TSPLST_listOutputView_ListOutputElement_dataSourceActualParams)list;
{ listOutputView__TPPplistOutputView_ListOutputElement_dataSourceActualParams _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_ListOutputElement_dataSourceActualParams;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_dataSource (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_dataSource (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputElement_dataSource _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputElement_dataSource;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputElement_dataSource) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_dataSource));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputElement_dataSource;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputElement_dataSource;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputElement_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_maxNumberOfElements (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_maxNumberOfElements (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputElement_maxNumberOfElements _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputElement_maxNumberOfElements;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputElement_maxNumberOfElements) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_maxNumberOfElements));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputElement_maxNumberOfElements;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputElement_maxNumberOfElements;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputElement_maxNumberOfElements */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_renderAs (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_renderAs (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputElement_renderAs _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputElement_renderAs;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputElement_renderAs) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_renderAs));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputElement_renderAs;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputElement_renderAs;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputElement_renderAs */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_navigationElement (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_navigationElement (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputElement_navigationElement _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputElement_navigationElement;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputElement_navigationElement) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_navigationElement));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputElement_navigationElement;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputElement_navigationElement;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputElement_navigationElement */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns;
#else
	_new = (listOutputView__TPPLST_listOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ListOutputColumn)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputElement_columns)_new;
	{listOutputView__TPPLST_listOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_ListOutputElement_columns (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_ListOutputElement_columns (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ListOutputColumn)) 
		return listOutputView__MklistOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns (_coordref, listOutputView_MklistOutputView_ListOutputColumn (_coordref, t));
	message (DEADLY, "a plistOutputView_ListOutputElement_columns list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_ListOutputElement_columns (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_ListOutputElement_columns (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputElement_columns)
	l =_ElemplistOutputView_ListOutputElement_columns (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputElement_columns)
	r = _ElemplistOutputView_ListOutputElement_columns (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_columns (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_columns (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_ListOutputElement_columns root;
	listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputElement_columns)
		t = _ElemplistOutputView_ListOutputElement_columns (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns)(((listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_ListOutputElement_columns;
#else
list = (listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_ListOutputElement_columns));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_ListOutputElement_columns;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_ListOutputElement_columns)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns)
	{listOutputView__TPPLST_listOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ListOutputColumnplistOutputView_ListOutputElement_columns;
	} this code has been moved to _ElemplistOutputView_ListOutputElement_columns*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_ListOutputElement_columns;
#else
root = (listOutputView__TPPplistOutputView_ListOutputElement_columns) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_columns));
#endif
root->_prod = listOutputView_RULEplistOutputView_ListOutputElement_columns;
root->_desc1 = (listOutputView__TSPLST_listOutputView_ListOutputElement_columns)list;
{ listOutputView__TPPplistOutputView_ListOutputElement_columns _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_ListOutputElement_columns;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_headerStyleClass (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_headerStyleClass (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputElement_headerStyleClass _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputElement_headerStyleClass;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputElement_headerStyleClass) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_headerStyleClass));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputElement_headerStyleClass;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputElement_headerStyleClass;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputElement_headerStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_evenRowStyleClass (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_evenRowStyleClass (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputElement_evenRowStyleClass _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputElement_evenRowStyleClass;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputElement_evenRowStyleClass) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_evenRowStyleClass));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputElement_evenRowStyleClass;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputElement_evenRowStyleClass;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputElement_evenRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_oddRowStyleClass (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputElement_oddRowStyleClass (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputElement_oddRowStyleClass _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputElement_oddRowStyleClass;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputElement_oddRowStyleClass) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputElement_oddRowStyleClass));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputElement_oddRowStyleClass;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputElement_oddRowStyleClass;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputElement_oddRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputColumn (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputColumn (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	listOutputView__TPPplistOutputView_ListOutputColumn _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputColumn;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputColumn) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputColumn));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputColumn;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ListOutputColumn_header) listOutputView_MklistOutputView_ListOutputColumn_header (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputColumn: root of subtree no. 1 can not be made a listOutputView_ListOutputColumn_header node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_ListOutputColumn_content) listOutputView_MklistOutputView_ListOutputColumn_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputColumn: root of subtree no. 2 can not be made a listOutputView_ListOutputColumn_content node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputColumn;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputColumn_header (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputColumn_header (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputColumn_header _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputColumn_header;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputColumn_header) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputColumn_header));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputColumn_header;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputColumn_header;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputColumn_header */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content;
#else
	_new = (listOutputView__TPPLST_listOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ListOutputConstantContent)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputColumn_content)_new;
	{listOutputView__TPPLST_listOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content;
#else
	_new = (listOutputView__TPPLST_listOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ListOutputRefContent)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputColumn_content)_new;
	{listOutputView__TPPLST_listOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content;
#else
	_new = (listOutputView__TPPLST_listOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ListOutputProjectionContent)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputColumn_content)_new;
	{listOutputView__TPPLST_listOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content;
#else
	_new = (listOutputView__TPPLST_listOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ListOutputNumerationContent)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputColumn_content)_new;
	{listOutputView__TPPLST_listOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content;
#else
	_new = (listOutputView__TPPLST_listOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ListOutputActionConnectionsContent)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputColumn_content)_new;
	{listOutputView__TPPLST_listOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_ListOutputColumn_content (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_ListOutputColumn_content (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ListOutputConstantContent)) 
		return listOutputView__MklistOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content (_coordref, listOutputView_MklistOutputView_ListOutputConstantContent (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ListOutputRefContent)) 
		return listOutputView__MklistOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content (_coordref, listOutputView_MklistOutputView_ListOutputRefContent (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ListOutputProjectionContent)) 
		return listOutputView__MklistOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content (_coordref, listOutputView_MklistOutputView_ListOutputProjectionContent (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ListOutputNumerationContent)) 
		return listOutputView__MklistOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content (_coordref, listOutputView_MklistOutputView_ListOutputNumerationContent (_coordref, t));
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ListOutputActionConnectionsContent)) 
		return listOutputView__MklistOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content (_coordref, listOutputView_MklistOutputView_ListOutputActionConnectionsContent (_coordref, t));
	message (DEADLY, "a plistOutputView_ListOutputColumn_content list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_ListOutputColumn_content (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_ListOutputColumn_content (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputColumn_content)
	l =_ElemplistOutputView_ListOutputColumn_content (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputColumn_content)
	r = _ElemplistOutputView_ListOutputColumn_content (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputColumn_content (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputColumn_content (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_ListOutputColumn_content root;
	listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputColumn_content)
		t = _ElemplistOutputView_ListOutputColumn_content (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content)(((listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_ListOutputColumn_content;
#else
list = (listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_ListOutputColumn_content));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_ListOutputColumn_content;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_ListOutputColumn_content)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content)
	{listOutputView__TPPLST_listOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ListOutputConstantContentplistOutputView_ListOutputColumn_content;
	} this code has been moved to _ElemplistOutputView_ListOutputColumn_content*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content)
	{listOutputView__TPPLST_listOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ListOutputRefContentplistOutputView_ListOutputColumn_content;
	} this code has been moved to _ElemplistOutputView_ListOutputColumn_content*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content)
	{listOutputView__TPPLST_listOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ListOutputProjectionContentplistOutputView_ListOutputColumn_content;
	} this code has been moved to _ElemplistOutputView_ListOutputColumn_content*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content)
	{listOutputView__TPPLST_listOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ListOutputNumerationContentplistOutputView_ListOutputColumn_content;
	} this code has been moved to _ElemplistOutputView_ListOutputColumn_content*/
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content)
	{listOutputView__TPPLST_listOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ListOutputActionConnectionsContentplistOutputView_ListOutputColumn_content;
	} this code has been moved to _ElemplistOutputView_ListOutputColumn_content*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_ListOutputColumn_content;
#else
root = (listOutputView__TPPplistOutputView_ListOutputColumn_content) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputColumn_content));
#endif
root->_prod = listOutputView_RULEplistOutputView_ListOutputColumn_content;
root->_desc1 = (listOutputView__TSPLST_listOutputView_ListOutputColumn_content)list;
{ listOutputView__TPPplistOutputView_ListOutputColumn_content _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_ListOutputColumn_content;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputConstantContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputConstantContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPplistOutputView_ListOutputConstantContent _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputConstantContent;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputConstantContent) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputConstantContent));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputConstantContent;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ListOutputConstantContent_value) listOutputView_MklistOutputView_ListOutputConstantContent_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputConstantContent: root of subtree no. 1 can not be made a listOutputView_ListOutputConstantContent_value node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputConstantContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputConstantContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputConstantContent_value (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputConstantContent_value (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputConstantContent_value _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputConstantContent_value;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputConstantContent_value) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputConstantContent_value));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputConstantContent_value;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputConstantContent_value;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputConstantContent_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputRefContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputRefContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPplistOutputView_ListOutputRefContent _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputRefContent;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputRefContent) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputRefContent));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputRefContent;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ListOutputRefContent_column) listOutputView_MklistOutputView_ListOutputRefContent_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputRefContent: root of subtree no. 1 can not be made a listOutputView_ListOutputRefContent_column node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputRefContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputRefContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputRefContent_column (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputRefContent_column (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputRefContent_column _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputRefContent_column;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputRefContent_column) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputRefContent_column));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputRefContent_column;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputRefContent_column;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputRefContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputProjectionContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputProjectionContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPplistOutputView_ListOutputProjectionContent _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputProjectionContent;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputProjectionContent) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputProjectionContent));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputProjectionContent;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ListOutputProjectionContent_column) listOutputView_MklistOutputView_ListOutputProjectionContent_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputProjectionContent: root of subtree no. 1 can not be made a listOutputView_ListOutputProjectionContent_column node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputProjectionContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputProjectionContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputProjectionContent_column (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputProjectionContent_column (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputProjectionContent_column _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputProjectionContent_column;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputProjectionContent_column) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputProjectionContent_column));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputProjectionContent_column;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputProjectionContent_column;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputProjectionContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputNumerationContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputNumerationContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPplistOutputView_ListOutputNumerationContent _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputNumerationContent;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputNumerationContent) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputNumerationContent));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputNumerationContent;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ListOutputNumerationContent_name) listOutputView_MklistOutputView_ListOutputNumerationContent_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputNumerationContent: root of subtree no. 1 can not be made a listOutputView_ListOutputNumerationContent_name node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputNumerationContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputNumerationContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputNumerationContent_name (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputNumerationContent_name (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ListOutputNumerationContent_name _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputNumerationContent_name;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputNumerationContent_name) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputNumerationContent_name));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputNumerationContent_name;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputNumerationContent_name;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputNumerationContent_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputActionConnectionsContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputActionConnectionsContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	listOutputView__TPPplistOutputView_ListOutputActionConnectionsContent _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ListOutputActionConnectionsContent;
#else
_currn = (listOutputView__TPPplistOutputView_ListOutputActionConnectionsContent) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputActionConnectionsContent));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ListOutputActionConnectionsContent;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ListOutputActionConnectionsContent_actionConnections) listOutputView_MklistOutputView_ListOutputActionConnectionsContent_actionConnections (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ListOutputActionConnectionsContent: root of subtree no. 1 can not be made a listOutputView_ListOutputActionConnectionsContent_actionConnections node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ListOutputActionConnectionsContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ListOutputActionConnectionsContent */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections;
#else
	_new = (listOutputView__TPPLST_listOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ActionConnection)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ListOutputActionConnectionsContent_actionConnections)_new;
	{listOutputView__TPPLST_listOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_ListOutputActionConnectionsContent_actionConnections (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ActionConnection)) 
		return listOutputView__MklistOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections (_coordref, listOutputView_MklistOutputView_ActionConnection (_coordref, t));
	message (DEADLY, "a plistOutputView_ListOutputActionConnectionsContent_actionConnections list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_ListOutputActionConnectionsContent_actionConnections (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputActionConnectionsContent_actionConnections)
	l =_ElemplistOutputView_ListOutputActionConnectionsContent_actionConnections (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputActionConnectionsContent_actionConnections)
	r = _ElemplistOutputView_ListOutputActionConnectionsContent_actionConnections (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_ListOutputActionConnectionsContent_actionConnections (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_ListOutputActionConnectionsContent_actionConnections root;
	listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_ListOutputActionConnectionsContent_actionConnections)
		t = _ElemplistOutputView_ListOutputActionConnectionsContent_actionConnections (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections)(((listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections;
#else
list = (listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_ListOutputActionConnectionsContent_actionConnections)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections)
	{listOutputView__TPPLST_listOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ActionConnectionplistOutputView_ListOutputActionConnectionsContent_actionConnections;
	} this code has been moved to _ElemplistOutputView_ListOutputActionConnectionsContent_actionConnections*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_ListOutputActionConnectionsContent_actionConnections;
#else
root = (listOutputView__TPPplistOutputView_ListOutputActionConnectionsContent_actionConnections) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ListOutputActionConnectionsContent_actionConnections));
#endif
root->_prod = listOutputView_RULEplistOutputView_ListOutputActionConnectionsContent_actionConnections;
root->_desc1 = (listOutputView__TSPLST_listOutputView_ListOutputActionConnectionsContent_actionConnections)list;
{ listOutputView__TPPplistOutputView_ListOutputActionConnectionsContent_actionConnections _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_ListOutputActionConnectionsContent_actionConnections;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ActionConnection (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR listOutputView_MkplistOutputView_ActionConnection (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	listOutputView__TPPplistOutputView_ActionConnection _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ActionConnection;
#else
_currn = (listOutputView__TPPplistOutputView_ActionConnection) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ActionConnection));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ActionConnection;
_currn->_desc1 = (listOutputView__TSPlistOutputView_ActionConnection_action) listOutputView_MklistOutputView_ActionConnection_action (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ActionConnection: root of subtree no. 1 can not be made a listOutputView_ActionConnection_action node ", 0, _coordref);
_currn->_desc2 = (listOutputView__TSPlistOutputView_ActionConnection_imageName) listOutputView_MklistOutputView_ActionConnection_imageName (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ActionConnection: root of subtree no. 2 can not be made a listOutputView_ActionConnection_imageName node ", 0, _coordref);
_currn->_desc3 = (listOutputView__TSPlistOutputView_ActionConnection_text) listOutputView_MklistOutputView_ActionConnection_text (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ActionConnection: root of subtree no. 3 can not be made a listOutputView_ActionConnection_text node ", 0, _coordref);
_currn->_desc4 = (listOutputView__TSPlistOutputView_ActionConnection_actualParams) listOutputView_MklistOutputView_ActionConnection_actualParams (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE plistOutputView_ActionConnection: root of subtree no. 4 can not be made a listOutputView_ActionConnection_actualParams node ", 0, _coordref);
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ActionConnection;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ActionConnection */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ActionConnection_action (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ActionConnection_action (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ActionConnection_action _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ActionConnection_action;
#else
_currn = (listOutputView__TPPplistOutputView_ActionConnection_action) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ActionConnection_action));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ActionConnection_action;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ActionConnection_action;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ActionConnection_action */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ActionConnection_imageName (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ActionConnection_imageName (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ActionConnection_imageName _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ActionConnection_imageName;
#else
_currn = (listOutputView__TPPplistOutputView_ActionConnection_imageName) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ActionConnection_imageName));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ActionConnection_imageName;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ActionConnection_imageName;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ActionConnection_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ActionConnection_text (POSITION *_coordref)
#else
NODEPTR listOutputView_MkplistOutputView_ActionConnection_text (_coordref)
	POSITION *_coordref;
#endif
{	listOutputView__TPPplistOutputView_ActionConnection_text _currn;
#ifdef __cplusplus
_currn = new listOutputView__TPplistOutputView_ActionConnection_text;
#else
_currn = (listOutputView__TPPplistOutputView_ActionConnection_text) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ActionConnection_text));
#endif
_currn->_prod = listOutputView_RULEplistOutputView_ActionConnection_text;
_SETCOORD(_currn)
listOutputView__TERMACT_plistOutputView_ActionConnection_text;
return ( (NODEPTR) _currn);
}/* listOutputView_MkplistOutputView_ActionConnection_text */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR listOutputView__MklistOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR listOutputView__MklistOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	listOutputView__TPPLST_listOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams _new;
#ifdef __cplusplus
	_new = new listOutputView__TPLST_listOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams;
#else
	_new = (listOutputView__TPPLST_listOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_listOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams));
#endif
	_new->_prod = listOutputView_RULELST_listOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams;
	_new->_desc1 = (listOutputView__TSPlistOutputView_ListOutputActualParam)elem;
	_new->_desc2 = (listOutputView__TSPLST_listOutputView_ActionConnection_actualParams)_new;
	{listOutputView__TPPLST_listOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams _currn = _new;
	 _SETCOORD(_currn)
	 listOutputView__TERMACT_LST_listOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElemplistOutputView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElemplistOutputView_ActionConnection_actualParams (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (listOutputView_IsSymb (t, listOutputView_SYMBlistOutputView_ListOutputActualParam)) 
		return listOutputView__MklistOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams (_coordref, listOutputView_MklistOutputView_ListOutputActualParam (_coordref, t));
	message (DEADLY, "a plistOutputView_ActionConnection_actualParams list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_Mk2plistOutputView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR listOutputView_Mk2plistOutputView_ActionConnection_actualParams (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (listOutputView_LHSMAP[l->_prod] != listOutputView_SYMBLST_listOutputView_ActionConnection_actualParams)
	l =_ElemplistOutputView_ActionConnection_actualParams (_coordref, l);
if (listOutputView_LHSMAP[r->_prod] != listOutputView_SYMBLST_listOutputView_ActionConnection_actualParams)
	r = _ElemplistOutputView_ActionConnection_actualParams (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams)r)->_desc2);
((listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams)r)->_desc2 = ((listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams)l)->_desc2;
((listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR listOutputView_MkplistOutputView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR t)
#else
NODEPTR listOutputView_MkplistOutputView_ActionConnection_actualParams (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; listOutputView__TPPplistOutputView_ActionConnection_actualParams root;
	listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams)NULLNODEPTR;
else {	if (listOutputView_LHSMAP[t->_prod] != listOutputView_SYMBLST_listOutputView_ActionConnection_actualParams)
		t = _ElemplistOutputView_ActionConnection_actualParams (_coordref, t);
	remain = (listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams)(((listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams) t)->_desc2);
	((listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new listOutputView__TPLST_0plistOutputView_ActionConnection_actualParams;
#else
list = (listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPLST_0plistOutputView_ActionConnection_actualParams));
#endif
list->_prod = listOutputView_RULELST_0plistOutputView_ActionConnection_actualParams;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (listOutputView__TPPLST_0plistOutputView_ActionConnection_actualParams)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == listOutputView_RULELST_listOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams)
	{listOutputView__TPPLST_listOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams _currn = _currn;
	 listOutputView__TERMACT_LST_listOutputView_ListOutputActualParamplistOutputView_ActionConnection_actualParams;
	} this code has been moved to _ElemplistOutputView_ActionConnection_actualParams*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new listOutputView__TPplistOutputView_ActionConnection_actualParams;
#else
root = (listOutputView__TPPplistOutputView_ActionConnection_actualParams) listOutputView_TreeNodeAlloc (sizeof (struct listOutputView__TPplistOutputView_ActionConnection_actualParams));
#endif
root->_prod = listOutputView_RULEplistOutputView_ActionConnection_actualParams;
root->_desc1 = (listOutputView__TSPLST_listOutputView_ActionConnection_actualParams)list;
{ listOutputView__TPPplistOutputView_ActionConnection_actualParams _currn = root;
  _SETCOORD(_currn)
  listOutputView__TERMACT_plistOutputView_ActionConnection_actualParams;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}
