
/* implementation of tree construction functions */

#include "webActionView_node.h"

#include "webActionView_nodecode.h"

#include "attrpredef.h"

#include "webActionView_visitmap.h"

#include "webActionView_treeact.h"

#ifdef MONITOR
#include "attr_mon_dapto.h"
#endif

#include <stdlib.h>

#define _USE_OBSTACK 1

/* use of obstack: */

#if _USE_OBSTACK

#include "obstack.h"
static struct obstack TreeSpace;
static void *_TreeBase;

#ifdef __cplusplus
void* webActionView_NODEPTR_SUB_struct::operator new(size_t size)
{
	return obstack_alloc(&TreeSpace, size);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* webActionView_TreeNodeAlloc(int size)
#else
char* webActionView_TreeNodeAlloc(size) int size;
#endif
{
	return (char *)(obstack_alloc(&TreeSpace, size));
}
#endif

void webActionView_InitTree()
{
	obstack_init(&TreeSpace);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

void webActionView_FreeTree()
{
	obstack_free(&TreeSpace, _TreeBase);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

#else

#include <stdio.h>

#ifdef __cplusplus
void* NODEPTR_struct::operator new(size_t size)
{
	void *retval = malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* webActionView_TreeNodeAlloc(int size)
#else
char* webActionView_TreeNodeAlloc(size) int size;
#endif
{
	char *retval = (char *) malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#endif

void webActionView_InitTree() { }

void webActionView_FreeTree() { }

#endif

#ifdef MONITOR
#define _SETCOORD(node) \
        node->_coord = _coordref ? *_coordref : NoCoord;
#define _COPYCOORD(node) \
        node->_coord = _currn->_desc1->_coord;
#else
#define _SETCOORD(node)
#define _COPYCOORD(node)
#endif
#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkVIEWROOT (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkVIEWROOT (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBVIEWROOT)) return (_currn);
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebAction)) return (webActionView_MkpVIEWROOT_webActionView(_coordref, _currn));
return(NULLNODEPTR);
}/* webActionView_MkVIEWROOT */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebAction (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebAction (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebAction)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebAction */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeFormalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeFormalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeFormalParam)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeFormalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeFormalParam_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeFormalParam_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeFormalParam_name)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeFormalParam_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeFormalParam_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeFormalParam_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeFormalParam_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeFormalParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeFormalParam_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeFormalParam_type)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeFormalParam_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBBlob (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBBlob (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBBlob)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBBlob */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBBoolean (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBBoolean (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBBoolean)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBBoolean */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBTimeStamp (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBTimeStamp (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBTimeStamp)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBTimeStamp */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBDate (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBDate (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBDate)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBDate */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBBigInt (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBBigInt (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBBigInt)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBBigInt */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBDouble (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBDouble (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBDouble)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBDouble */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBFloat (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBFloat (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBFloat)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBFloat */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBLong (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBLong (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBLong)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBLong */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBInteger (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBInteger (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBInteger)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBInteger */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBText (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBText (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBText)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBText */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBString (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBString (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBString)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBString */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBHasMany (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBHasMany (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBHasMany)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBHasMany */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBHasOne (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBHasOne (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBHasOne)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBHasOne */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeActualParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeActualParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeActualParam)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeActualParam_formalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeActualParam_formalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeActualParam_formalParam)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeActualParam_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeActualParam_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeActualParam_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeActualParam_expressions (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeActualParam_expressions)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeActualParam_expressions */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeSessionExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeSessionExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeSessionExpression)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeSessionExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeVariableExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeVariableExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeVariableExpression)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeVariableExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeConstantExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeConstantExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeConstantExpression)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DataSourceActualParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DataSourceActualParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DataSourceActualParam)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DataSourceActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DataSourceActualParam_formalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DataSourceActualParam_formalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DataSourceActualParam_formalParam)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DataSourceActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DataSourceActualParam_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DataSourceActualParam_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DataSourceActualParam_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DataSourceActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DataSourceActualParam_expressions (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DataSourceActualParam_expressions)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DataSourceActualParam_expressions */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBString_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBString_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBString_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBString_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBText_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBText_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBText_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBText_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBInteger_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBInteger_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBInteger_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBInteger_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBLong_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBLong_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBLong_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBLong_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBFloat_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBFloat_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBFloat_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBFloat_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBDouble_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBDouble_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBDouble_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBDouble_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBBigInt_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBBigInt_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBBigInt_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBBigInt_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBDate_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBDate_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBDate_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBDate_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBTimeStamp_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBTimeStamp_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBTimeStamp_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBTimeStamp_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBBoolean_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBBoolean_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBBoolean_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBBoolean_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBBlob_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBBlob_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBBlob_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBBlob_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBHasOne_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBHasOne_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBHasOne_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBHasOne_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBHasOne_dataSourceTable (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBHasOne_dataSourceTable (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBHasOne_dataSourceTable)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBHasOne_dataSourceTable */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBHasMany_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBHasMany_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBHasMany_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBHasMany_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DBHasMany_dataSourceTable (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DBHasMany_dataSourceTable (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DBHasMany_dataSourceTable)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DBHasMany_dataSourceTable */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_ActionHandler (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_ActionHandler (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_ActionHandler)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_ActionHandler */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_ActionHandler_targetpage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_ActionHandler_targetpage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_ActionHandler_targetpage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_ActionHandler_targetpage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_ActionHandler_params (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_ActionHandler_params (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_ActionHandler_params)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_ActionHandler_params */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebAction_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebAction_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebAction_name)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebAction_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebAction_formalParameter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebAction_formalParameter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebAction_formalParameter)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebAction_formalParameter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebAction_successpage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebAction_successpage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebAction_successpage)) return (_currn);
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_ActionHandler)) return (webActionView_Mkrule_1(_coordref, _currn));
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebAction_successpage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebAction_operations (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebAction_operations (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebAction_operations)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebAction_operations */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebAction_position (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebAction_position (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebAction_position)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebAction_position */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LoginOperation (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LoginOperation (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LoginOperation)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LoginOperation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LogoutOperation (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LogoutOperation (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LogoutOperation)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LogoutOperation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_MailingOperation (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_MailingOperation (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_MailingOperation)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_MailingOperation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_JavaOperation (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_JavaOperation (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_JavaOperation)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_JavaOperation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DataBaseOperation (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DataBaseOperation (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DataBaseOperation)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DataBaseOperation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DataBaseOperation_errorhandler (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DataBaseOperation_errorhandler (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DataBaseOperation_errorhandler)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DataBaseOperation_errorhandler */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DataBaseOperation_successMessage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DataBaseOperation_successMessage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DataBaseOperation_successMessage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DataBaseOperation_successMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DataBaseOperation_errorMessage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DataBaseOperation_errorMessage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DataBaseOperation_errorMessage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DataBaseOperation_errorMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DataBaseOperation_filter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DataBaseOperation_filter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DataBaseOperation_filter)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DataBaseOperation_filter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_DataBaseOperation_params (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_DataBaseOperation_params (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_DataBaseOperation_params)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_DataBaseOperation_params */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_JavaOperation_errorhandler (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_JavaOperation_errorhandler (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_JavaOperation_errorhandler)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_JavaOperation_errorhandler */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_JavaOperation_successMessage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_JavaOperation_successMessage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_JavaOperation_successMessage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_JavaOperation_successMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_JavaOperation_errorMessage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_JavaOperation_errorMessage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_JavaOperation_errorMessage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_JavaOperation_errorMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_JavaOperation_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_JavaOperation_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_JavaOperation_content)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_JavaOperation_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_MailingOperation_errorhandler (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_MailingOperation_errorhandler (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_MailingOperation_errorhandler)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_MailingOperation_errorhandler */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_MailingOperation_successMessage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_MailingOperation_successMessage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_MailingOperation_successMessage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_MailingOperation_successMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_MailingOperation_errorMessage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_MailingOperation_errorMessage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_MailingOperation_errorMessage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_MailingOperation_errorMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_MailingOperation_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_MailingOperation_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_MailingOperation_name)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_MailingOperation_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_MailingOperation_mailTo (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_MailingOperation_mailTo (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_MailingOperation_mailTo)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_MailingOperation_mailTo */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_MailingOperation_subject (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_MailingOperation_subject (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_MailingOperation_subject)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_MailingOperation_subject */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_MailingOperation_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_MailingOperation_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_MailingOperation_content)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_MailingOperation_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LogoutOperation_errorhandler (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LogoutOperation_errorhandler (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LogoutOperation_errorhandler)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LogoutOperation_errorhandler */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LogoutOperation_successMessage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LogoutOperation_successMessage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LogoutOperation_successMessage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LogoutOperation_successMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LogoutOperation_errorMessage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LogoutOperation_errorMessage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LogoutOperation_errorMessage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LogoutOperation_errorMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LogoutOperation_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LogoutOperation_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LogoutOperation_name)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LogoutOperation_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LoginOperation_errorhandler (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LoginOperation_errorhandler (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LoginOperation_errorhandler)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LoginOperation_errorhandler */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LoginOperation_successMessage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LoginOperation_successMessage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LoginOperation_successMessage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LoginOperation_successMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LoginOperation_errorMessage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LoginOperation_errorMessage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LoginOperation_errorMessage)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LoginOperation_errorMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LoginOperation_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LoginOperation_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LoginOperation_name)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LoginOperation_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LoginOperation_userDBColumn (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LoginOperation_userDBColumn (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LoginOperation_userDBColumn)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LoginOperation_userDBColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LoginOperation_passwdDBColumn (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LoginOperation_passwdDBColumn (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LoginOperation_passwdDBColumn)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LoginOperation_passwdDBColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LoginOperation_rolesDBColumn (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LoginOperation_rolesDBColumn (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LoginOperation_rolesDBColumn)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LoginOperation_rolesDBColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LoginOperation_userFormField (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LoginOperation_userFormField (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LoginOperation_userFormField)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LoginOperation_userFormField */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_LoginOperation_passwdFormField (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_LoginOperation_passwdFormField (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_LoginOperation_passwdFormField)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_LoginOperation_passwdFormField */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_MD5Modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_MD5Modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_MD5Modifier)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_MD5Modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_JoinModifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_JoinModifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_JoinModifier)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_JoinModifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_JoinModifier_separator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_JoinModifier_separator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_JoinModifier_separator)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_JoinModifier_separator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeConstantExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeConstantExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeConstantExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeConstantExpression_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeConstantExpression_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeConstantExpression_value)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeVariableExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeVariableExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeVariableExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeVariableExpression_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeVariableExpression_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeVariableExpression_content)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeVariableExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeSessionExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeSessionExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeSessionExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkwebActionView_WebNodeSessionExpression_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webActionView_MkwebActionView_WebNodeSessionExpression_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webActionView_IsSymb (_currn, webActionView_SYMBwebActionView_WebNodeSessionExpression_content)) return (_currn);
return(NULLNODEPTR);
}/* webActionView_MkwebActionView_WebNodeSessionExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpEmpty (POSITION *_coordref)
#else
NODEPTR webActionView_MkpEmpty (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpEmpty _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpEmpty;
#else
_currn = (webActionView__TPPpEmpty) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpEmpty));
#endif
_currn->_prod = webActionView_RULEpEmpty;
_SETCOORD(_currn)
webActionView__TERMACT_pEmpty;
return ( (NODEPTR) _currn);
}/* webActionView_MkpEmpty */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpVIEWROOT_webActionView (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpVIEWROOT_webActionView (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpVIEWROOT_webActionView _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpVIEWROOT_webActionView;
#else
_currn = (webActionView__TPPpVIEWROOT_webActionView) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpVIEWROOT_webActionView));
#endif
_currn->_prod = webActionView_RULEpVIEWROOT_webActionView;
_currn->_desc1 = (webActionView__TSPwebActionView_WebAction) webActionView_MkwebActionView_WebAction (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pVIEWROOT_webActionView: root of subtree no. 1 can not be made a webActionView_WebAction node ", 0, _coordref);
_COPYCOORD(_currn)
webActionView__TERMACT_pVIEWROOT_webActionView;
return ( (NODEPTR) _currn);
}/* webActionView_MkpVIEWROOT_webActionView */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeFormalParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeFormalParam (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	webActionView__TPPpwebActionView_WebNodeFormalParam _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeFormalParam;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeFormalParam) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeFormalParam));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeFormalParam;
_currn->_desc1 = (webActionView__TSPwebActionView_WebNodeFormalParam_name) webActionView_MkwebActionView_WebNodeFormalParam_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeFormalParam: root of subtree no. 1 can not be made a webActionView_WebNodeFormalParam_name node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_WebNodeFormalParam_keyword1) webActionView_MkwebActionView_WebNodeFormalParam_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeFormalParam: root of subtree no. 2 can not be made a webActionView_WebNodeFormalParam_keyword1 node ", 0, _coordref);
_currn->_desc3 = (webActionView__TSPwebActionView_WebNodeFormalParam_type) webActionView_MkwebActionView_WebNodeFormalParam_type (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeFormalParam: root of subtree no. 3 can not be made a webActionView_WebNodeFormalParam_type node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeFormalParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeFormalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeFormalParam_name (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeFormalParam_name (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_WebNodeFormalParam_name _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeFormalParam_name;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeFormalParam_name) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeFormalParam_name));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeFormalParam_name;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeFormalParam_name;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeFormalParam_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeFormalParam_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeFormalParam_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_WebNodeFormalParam_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeFormalParam_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeFormalParam_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeFormalParam_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeFormalParam_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeFormalParam_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeFormalParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBHasOnepwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBHasOnepwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBHasOnepwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBHasOnepwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBHasOnepwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBHasOnepwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBHasOnepwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBHasOne)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBHasOnepwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBHasOnepwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBHasManypwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBHasManypwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBHasManypwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBHasManypwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBHasManypwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBHasManypwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBHasManypwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBHasMany)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBHasManypwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBHasManypwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBStringpwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBStringpwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBString)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBTextpwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBTextpwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBTextpwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBTextpwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBTextpwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBTextpwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBTextpwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBText)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBTextpwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBTextpwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBIntegerpwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBIntegerpwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBInteger)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBLongpwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBLongpwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBLongpwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBLongpwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBLongpwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBLongpwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBLongpwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBLong)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBLongpwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBLongpwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBFloatpwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBFloatpwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBFloat)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBDoublepwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBDoublepwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBDouble)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBBigIntpwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBBigIntpwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBBigInt)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBDatepwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBDatepwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBDate)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBTimeStamp)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBBooleanpwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBBooleanpwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBBoolean)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DBBlobpwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DBBlobpwebActionView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type;
#else
	_new = (webActionView__TPPLST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type;
	_new->_desc1 = (webActionView__TSPwebActionView_DBBlob)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)_new;
	{webActionView__TPPLST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_WebNodeFormalParam_type (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBHasOne)) 
		return webActionView__MkwebActionView_DBHasOnepwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBHasOne (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBHasMany)) 
		return webActionView__MkwebActionView_DBHasManypwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBHasMany (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBString)) 
		return webActionView__MkwebActionView_DBStringpwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBString (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBText)) 
		return webActionView__MkwebActionView_DBTextpwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBText (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBInteger)) 
		return webActionView__MkwebActionView_DBIntegerpwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBInteger (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBLong)) 
		return webActionView__MkwebActionView_DBLongpwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBLong (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBFloat)) 
		return webActionView__MkwebActionView_DBFloatpwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBFloat (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBDouble)) 
		return webActionView__MkwebActionView_DBDoublepwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBDouble (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBBigInt)) 
		return webActionView__MkwebActionView_DBBigIntpwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBBigInt (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBDate)) 
		return webActionView__MkwebActionView_DBDatepwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBDate (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBTimeStamp)) 
		return webActionView__MkwebActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBTimeStamp (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBBoolean)) 
		return webActionView__MkwebActionView_DBBooleanpwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBBoolean (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DBBlob)) 
		return webActionView__MkwebActionView_DBBlobpwebActionView_WebNodeFormalParam_type (_coordref, webActionView_MkwebActionView_DBBlob (_coordref, t));
	message (DEADLY, "a pwebActionView_WebNodeFormalParam_type list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_WebNodeFormalParam_type (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_WebNodeFormalParam_type)
	l =_ElempwebActionView_WebNodeFormalParam_type (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_WebNodeFormalParam_type)
	r = _ElempwebActionView_WebNodeFormalParam_type (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeFormalParam_type (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_WebNodeFormalParam_type root;
	webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_WebNodeFormalParam_type)
		t = _ElempwebActionView_WebNodeFormalParam_type (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type)(((webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_WebNodeFormalParam_type;
#else
list = (webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_WebNodeFormalParam_type));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_WebNodeFormalParam_type;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_WebNodeFormalParam_type)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBHasOnepwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBHasOnepwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBHasOnepwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBHasManypwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBHasManypwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBHasManypwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBStringpwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBTextpwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBTextpwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBTextpwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBIntegerpwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBLongpwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBLongpwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBLongpwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBFloatpwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBDoublepwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBBigIntpwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBDatepwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBTimeStamppwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBBooleanpwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type)
	{webActionView__TPPLST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DBBlobpwebActionView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebActionView_WebNodeFormalParam_type*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_WebNodeFormalParam_type;
#else
root = (webActionView__TPPpwebActionView_WebNodeFormalParam_type) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeFormalParam_type));
#endif
root->_prod = webActionView_RULEpwebActionView_WebNodeFormalParam_type;
root->_desc1 = (webActionView__TSPLST_webActionView_WebNodeFormalParam_type)list;
{ webActionView__TPPpwebActionView_WebNodeFormalParam_type _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_WebNodeFormalParam_type;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeActualParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeActualParam (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	webActionView__TPPpwebActionView_WebNodeActualParam _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeActualParam;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeActualParam) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeActualParam));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeActualParam;
_currn->_desc1 = (webActionView__TSPwebActionView_WebNodeActualParam_formalParam) webActionView_MkwebActionView_WebNodeActualParam_formalParam (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeActualParam: root of subtree no. 1 can not be made a webActionView_WebNodeActualParam_formalParam node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_WebNodeActualParam_keyword1) webActionView_MkwebActionView_WebNodeActualParam_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeActualParam: root of subtree no. 2 can not be made a webActionView_WebNodeActualParam_keyword1 node ", 0, _coordref);
_currn->_desc3 = (webActionView__TSPwebActionView_WebNodeActualParam_expressions) webActionView_MkwebActionView_WebNodeActualParam_expressions (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeActualParam: root of subtree no. 3 can not be made a webActionView_WebNodeActualParam_expressions node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeActualParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeActualParam_formalParam (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeActualParam_formalParam (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_WebNodeActualParam_formalParam _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeActualParam_formalParam;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeActualParam_formalParam) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeActualParam_formalParam));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeActualParam_formalParam;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeActualParam_formalParam;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeActualParam_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeActualParam_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_WebNodeActualParam_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeActualParam_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeActualParam_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeActualParam_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeActualParam_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeActualParam_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions;
#else
	_new = (webActionView__TPPLST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions));
#endif
	_new->_prod = webActionView_RULELST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions;
	_new->_desc1 = (webActionView__TSPwebActionView_WebNodeConstantExpression)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeActualParam_expressions)_new;
	{webActionView__TPPLST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions;
#else
	_new = (webActionView__TPPLST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions));
#endif
	_new->_prod = webActionView_RULELST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions;
	_new->_desc1 = (webActionView__TSPwebActionView_WebNodeVariableExpression)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeActualParam_expressions)_new;
	{webActionView__TPPLST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions;
#else
	_new = (webActionView__TPPLST_webActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions));
#endif
	_new->_prod = webActionView_RULELST_webActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions;
	_new->_desc1 = (webActionView__TSPwebActionView_WebNodeSessionExpression)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeActualParam_expressions)_new;
	{webActionView__TPPLST_webActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_WebNodeActualParam_expressions (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_WebNodeConstantExpression)) 
		return webActionView__MkwebActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions (_coordref, webActionView_MkwebActionView_WebNodeConstantExpression (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_WebNodeVariableExpression)) 
		return webActionView__MkwebActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions (_coordref, webActionView_MkwebActionView_WebNodeVariableExpression (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_WebNodeSessionExpression)) 
		return webActionView__MkwebActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions (_coordref, webActionView_MkwebActionView_WebNodeSessionExpression (_coordref, t));
	message (DEADLY, "a pwebActionView_WebNodeActualParam_expressions list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_WebNodeActualParam_expressions (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_WebNodeActualParam_expressions)
	l =_ElempwebActionView_WebNodeActualParam_expressions (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_WebNodeActualParam_expressions)
	r = _ElempwebActionView_WebNodeActualParam_expressions (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeActualParam_expressions (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_WebNodeActualParam_expressions root;
	webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_WebNodeActualParam_expressions)
		t = _ElempwebActionView_WebNodeActualParam_expressions (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions)(((webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_WebNodeActualParam_expressions;
#else
list = (webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_WebNodeActualParam_expressions));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_WebNodeActualParam_expressions;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_WebNodeActualParam_expressions)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions)
	{webActionView__TPPLST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_WebNodeConstantExpressionpwebActionView_WebNodeActualParam_expressions;
	} this code has been moved to _ElempwebActionView_WebNodeActualParam_expressions*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions)
	{webActionView__TPPLST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_WebNodeVariableExpressionpwebActionView_WebNodeActualParam_expressions;
	} this code has been moved to _ElempwebActionView_WebNodeActualParam_expressions*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions)
	{webActionView__TPPLST_webActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_WebNodeSessionExpressionpwebActionView_WebNodeActualParam_expressions;
	} this code has been moved to _ElempwebActionView_WebNodeActualParam_expressions*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_WebNodeActualParam_expressions;
#else
root = (webActionView__TPPpwebActionView_WebNodeActualParam_expressions) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeActualParam_expressions));
#endif
root->_prod = webActionView_RULEpwebActionView_WebNodeActualParam_expressions;
root->_desc1 = (webActionView__TSPLST_webActionView_WebNodeActualParam_expressions)list;
{ webActionView__TPPpwebActionView_WebNodeActualParam_expressions _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_WebNodeActualParam_expressions;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DataSourceActualParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR webActionView_MkpwebActionView_DataSourceActualParam (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	webActionView__TPPpwebActionView_DataSourceActualParam _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DataSourceActualParam;
#else
_currn = (webActionView__TPPpwebActionView_DataSourceActualParam) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DataSourceActualParam));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DataSourceActualParam;
_currn->_desc1 = (webActionView__TSPwebActionView_DataSourceActualParam_formalParam) webActionView_MkwebActionView_DataSourceActualParam_formalParam (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DataSourceActualParam: root of subtree no. 1 can not be made a webActionView_DataSourceActualParam_formalParam node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_DataSourceActualParam_keyword1) webActionView_MkwebActionView_DataSourceActualParam_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DataSourceActualParam: root of subtree no. 2 can not be made a webActionView_DataSourceActualParam_keyword1 node ", 0, _coordref);
_currn->_desc3 = (webActionView__TSPwebActionView_DataSourceActualParam_expressions) webActionView_MkwebActionView_DataSourceActualParam_expressions (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DataSourceActualParam: root of subtree no. 3 can not be made a webActionView_DataSourceActualParam_expressions node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DataSourceActualParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DataSourceActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DataSourceActualParam_formalParam (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DataSourceActualParam_formalParam (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DataSourceActualParam_formalParam _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DataSourceActualParam_formalParam;
#else
_currn = (webActionView__TPPpwebActionView_DataSourceActualParam_formalParam) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DataSourceActualParam_formalParam));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DataSourceActualParam_formalParam;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DataSourceActualParam_formalParam;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DataSourceActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DataSourceActualParam_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DataSourceActualParam_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DataSourceActualParam_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DataSourceActualParam_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DataSourceActualParam_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DataSourceActualParam_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DataSourceActualParam_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DataSourceActualParam_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DataSourceActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions;
#else
	_new = (webActionView__TPPLST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions));
#endif
	_new->_prod = webActionView_RULELST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions;
	_new->_desc1 = (webActionView__TSPwebActionView_WebNodeConstantExpression)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_DataSourceActualParam_expressions)_new;
	{webActionView__TPPLST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions;
#else
	_new = (webActionView__TPPLST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions));
#endif
	_new->_prod = webActionView_RULELST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions;
	_new->_desc1 = (webActionView__TSPwebActionView_WebNodeVariableExpression)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_DataSourceActualParam_expressions)_new;
	{webActionView__TPPLST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions;
#else
	_new = (webActionView__TPPLST_webActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions));
#endif
	_new->_prod = webActionView_RULELST_webActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions;
	_new->_desc1 = (webActionView__TSPwebActionView_WebNodeSessionExpression)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_DataSourceActualParam_expressions)_new;
	{webActionView__TPPLST_webActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_DataSourceActualParam_expressions (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_WebNodeConstantExpression)) 
		return webActionView__MkwebActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions (_coordref, webActionView_MkwebActionView_WebNodeConstantExpression (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_WebNodeVariableExpression)) 
		return webActionView__MkwebActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions (_coordref, webActionView_MkwebActionView_WebNodeVariableExpression (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_WebNodeSessionExpression)) 
		return webActionView__MkwebActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions (_coordref, webActionView_MkwebActionView_WebNodeSessionExpression (_coordref, t));
	message (DEADLY, "a pwebActionView_DataSourceActualParam_expressions list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_DataSourceActualParam_expressions (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_DataSourceActualParam_expressions)
	l =_ElempwebActionView_DataSourceActualParam_expressions (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_DataSourceActualParam_expressions)
	r = _ElempwebActionView_DataSourceActualParam_expressions (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_DataSourceActualParam_expressions (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_DataSourceActualParam_expressions root;
	webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_DataSourceActualParam_expressions)
		t = _ElempwebActionView_DataSourceActualParam_expressions (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions)(((webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_DataSourceActualParam_expressions;
#else
list = (webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_DataSourceActualParam_expressions));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_DataSourceActualParam_expressions;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_DataSourceActualParam_expressions)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions)
	{webActionView__TPPLST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_WebNodeConstantExpressionpwebActionView_DataSourceActualParam_expressions;
	} this code has been moved to _ElempwebActionView_DataSourceActualParam_expressions*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions)
	{webActionView__TPPLST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_WebNodeVariableExpressionpwebActionView_DataSourceActualParam_expressions;
	} this code has been moved to _ElempwebActionView_DataSourceActualParam_expressions*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions)
	{webActionView__TPPLST_webActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_WebNodeSessionExpressionpwebActionView_DataSourceActualParam_expressions;
	} this code has been moved to _ElempwebActionView_DataSourceActualParam_expressions*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_DataSourceActualParam_expressions;
#else
root = (webActionView__TPPpwebActionView_DataSourceActualParam_expressions) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DataSourceActualParam_expressions));
#endif
root->_prod = webActionView_RULEpwebActionView_DataSourceActualParam_expressions;
root->_desc1 = (webActionView__TSPLST_webActionView_DataSourceActualParam_expressions)list;
{ webActionView__TPPpwebActionView_DataSourceActualParam_expressions _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_DataSourceActualParam_expressions;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBString (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBString (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBString _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBString;
#else
_currn = (webActionView__TPPpwebActionView_DBString) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBString));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBString;
_currn->_desc1 = (webActionView__TSPwebActionView_DBString_keyword1) webActionView_MkwebActionView_DBString_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBString: root of subtree no. 1 can not be made a webActionView_DBString_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBString;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBString */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBString_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBString_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBString_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBString_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBString_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBString_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBString_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBString_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBString_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBText (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBText (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBText _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBText;
#else
_currn = (webActionView__TPPpwebActionView_DBText) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBText));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBText;
_currn->_desc1 = (webActionView__TSPwebActionView_DBText_keyword1) webActionView_MkwebActionView_DBText_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBText: root of subtree no. 1 can not be made a webActionView_DBText_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBText;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBText */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBText_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBText_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBText_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBText_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBText_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBText_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBText_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBText_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBText_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBInteger (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBInteger (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBInteger _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBInteger;
#else
_currn = (webActionView__TPPpwebActionView_DBInteger) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBInteger));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBInteger;
_currn->_desc1 = (webActionView__TSPwebActionView_DBInteger_keyword1) webActionView_MkwebActionView_DBInteger_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBInteger: root of subtree no. 1 can not be made a webActionView_DBInteger_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBInteger;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBInteger */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBInteger_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBInteger_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBInteger_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBInteger_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBInteger_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBInteger_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBInteger_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBInteger_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBInteger_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBLong (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBLong (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBLong _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBLong;
#else
_currn = (webActionView__TPPpwebActionView_DBLong) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBLong));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBLong;
_currn->_desc1 = (webActionView__TSPwebActionView_DBLong_keyword1) webActionView_MkwebActionView_DBLong_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBLong: root of subtree no. 1 can not be made a webActionView_DBLong_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBLong;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBLong */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBLong_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBLong_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBLong_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBLong_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBLong_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBLong_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBLong_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBLong_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBLong_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBFloat (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBFloat (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBFloat _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBFloat;
#else
_currn = (webActionView__TPPpwebActionView_DBFloat) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBFloat));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBFloat;
_currn->_desc1 = (webActionView__TSPwebActionView_DBFloat_keyword1) webActionView_MkwebActionView_DBFloat_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBFloat: root of subtree no. 1 can not be made a webActionView_DBFloat_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBFloat;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBFloat */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBFloat_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBFloat_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBFloat_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBFloat_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBFloat_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBFloat_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBFloat_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBFloat_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBFloat_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBDouble (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBDouble (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBDouble _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBDouble;
#else
_currn = (webActionView__TPPpwebActionView_DBDouble) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBDouble));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBDouble;
_currn->_desc1 = (webActionView__TSPwebActionView_DBDouble_keyword1) webActionView_MkwebActionView_DBDouble_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBDouble: root of subtree no. 1 can not be made a webActionView_DBDouble_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBDouble;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBDouble */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBDouble_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBDouble_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBDouble_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBDouble_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBDouble_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBDouble_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBDouble_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBDouble_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBDouble_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBBigInt (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBBigInt (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBBigInt _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBBigInt;
#else
_currn = (webActionView__TPPpwebActionView_DBBigInt) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBBigInt));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBBigInt;
_currn->_desc1 = (webActionView__TSPwebActionView_DBBigInt_keyword1) webActionView_MkwebActionView_DBBigInt_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBBigInt: root of subtree no. 1 can not be made a webActionView_DBBigInt_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBBigInt;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBBigInt */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBBigInt_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBBigInt_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBBigInt_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBBigInt_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBBigInt_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBBigInt_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBBigInt_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBBigInt_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBBigInt_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBDate (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBDate (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBDate _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBDate;
#else
_currn = (webActionView__TPPpwebActionView_DBDate) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBDate));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBDate;
_currn->_desc1 = (webActionView__TSPwebActionView_DBDate_keyword1) webActionView_MkwebActionView_DBDate_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBDate: root of subtree no. 1 can not be made a webActionView_DBDate_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBDate;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBDate */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBDate_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBDate_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBDate_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBDate_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBDate_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBDate_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBDate_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBDate_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBDate_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBTimeStamp (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBTimeStamp (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBTimeStamp _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBTimeStamp;
#else
_currn = (webActionView__TPPpwebActionView_DBTimeStamp) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBTimeStamp));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBTimeStamp;
_currn->_desc1 = (webActionView__TSPwebActionView_DBTimeStamp_keyword1) webActionView_MkwebActionView_DBTimeStamp_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBTimeStamp: root of subtree no. 1 can not be made a webActionView_DBTimeStamp_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBTimeStamp;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBTimeStamp */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBTimeStamp_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBTimeStamp_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBTimeStamp_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBTimeStamp_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBTimeStamp_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBTimeStamp_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBTimeStamp_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBTimeStamp_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBTimeStamp_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBBoolean (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBBoolean (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBBoolean _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBBoolean;
#else
_currn = (webActionView__TPPpwebActionView_DBBoolean) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBBoolean));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBBoolean;
_currn->_desc1 = (webActionView__TSPwebActionView_DBBoolean_keyword1) webActionView_MkwebActionView_DBBoolean_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBBoolean: root of subtree no. 1 can not be made a webActionView_DBBoolean_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBBoolean;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBBoolean */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBBoolean_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBBoolean_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBBoolean_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBBoolean_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBBoolean_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBBoolean_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBBoolean_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBBoolean_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBBoolean_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBBlob (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_DBBlob (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_DBBlob _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBBlob;
#else
_currn = (webActionView__TPPpwebActionView_DBBlob) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBBlob));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBBlob;
_currn->_desc1 = (webActionView__TSPwebActionView_DBBlob_keyword1) webActionView_MkwebActionView_DBBlob_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBBlob: root of subtree no. 1 can not be made a webActionView_DBBlob_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBBlob;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBBlob */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBBlob_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBBlob_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBBlob_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBBlob_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBBlob_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBBlob_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBBlob_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBBlob_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBBlob_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBHasOne (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webActionView_MkpwebActionView_DBHasOne (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webActionView__TPPpwebActionView_DBHasOne _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBHasOne;
#else
_currn = (webActionView__TPPpwebActionView_DBHasOne) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBHasOne));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBHasOne;
_currn->_desc1 = (webActionView__TSPwebActionView_DBHasOne_keyword1) webActionView_MkwebActionView_DBHasOne_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBHasOne: root of subtree no. 1 can not be made a webActionView_DBHasOne_keyword1 node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_DBHasOne_dataSourceTable) webActionView_MkwebActionView_DBHasOne_dataSourceTable (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBHasOne: root of subtree no. 2 can not be made a webActionView_DBHasOne_dataSourceTable node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBHasOne;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBHasOne */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBHasOne_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBHasOne_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBHasOne_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBHasOne_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBHasOne_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBHasOne_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBHasOne_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBHasOne_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBHasOne_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBHasOne_dataSourceTable (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBHasOne_dataSourceTable (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBHasOne_dataSourceTable _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBHasOne_dataSourceTable;
#else
_currn = (webActionView__TPPpwebActionView_DBHasOne_dataSourceTable) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBHasOne_dataSourceTable));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBHasOne_dataSourceTable;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBHasOne_dataSourceTable;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBHasOne_dataSourceTable */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBHasMany (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webActionView_MkpwebActionView_DBHasMany (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webActionView__TPPpwebActionView_DBHasMany _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBHasMany;
#else
_currn = (webActionView__TPPpwebActionView_DBHasMany) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBHasMany));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBHasMany;
_currn->_desc1 = (webActionView__TSPwebActionView_DBHasMany_keyword1) webActionView_MkwebActionView_DBHasMany_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBHasMany: root of subtree no. 1 can not be made a webActionView_DBHasMany_keyword1 node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_DBHasMany_dataSourceTable) webActionView_MkwebActionView_DBHasMany_dataSourceTable (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DBHasMany: root of subtree no. 2 can not be made a webActionView_DBHasMany_dataSourceTable node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBHasMany;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBHasMany */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBHasMany_keyword1 (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBHasMany_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBHasMany_keyword1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBHasMany_keyword1;
#else
_currn = (webActionView__TPPpwebActionView_DBHasMany_keyword1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBHasMany_keyword1));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBHasMany_keyword1;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBHasMany_keyword1;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBHasMany_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DBHasMany_dataSourceTable (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DBHasMany_dataSourceTable (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DBHasMany_dataSourceTable _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DBHasMany_dataSourceTable;
#else
_currn = (webActionView__TPPpwebActionView_DBHasMany_dataSourceTable) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DBHasMany_dataSourceTable));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DBHasMany_dataSourceTable;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DBHasMany_dataSourceTable;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DBHasMany_dataSourceTable */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_ActionHandler (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webActionView_MkpwebActionView_ActionHandler (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webActionView__TPPpwebActionView_ActionHandler _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_ActionHandler;
#else
_currn = (webActionView__TPPpwebActionView_ActionHandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_ActionHandler));
#endif
_currn->_prod = webActionView_RULEpwebActionView_ActionHandler;
_currn->_desc1 = (webActionView__TSPwebActionView_ActionHandler_targetpage) webActionView_MkwebActionView_ActionHandler_targetpage (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_ActionHandler: root of subtree no. 1 can not be made a webActionView_ActionHandler_targetpage node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_ActionHandler_params) webActionView_MkwebActionView_ActionHandler_params (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_ActionHandler: root of subtree no. 2 can not be made a webActionView_ActionHandler_params node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_ActionHandler;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_ActionHandler */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_ActionHandler_targetpage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_ActionHandler_targetpage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_ActionHandler_targetpage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_ActionHandler_targetpage;
#else
_currn = (webActionView__TPPpwebActionView_ActionHandler_targetpage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_ActionHandler_targetpage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_ActionHandler_targetpage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_ActionHandler_targetpage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_ActionHandler_targetpage */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_WebNodeActualParampwebActionView_ActionHandler_params (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_WebNodeActualParampwebActionView_ActionHandler_params (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params;
#else
	_new = (webActionView__TPPLST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params));
#endif
	_new->_prod = webActionView_RULELST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params;
	_new->_desc1 = (webActionView__TSPwebActionView_WebNodeActualParam)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_ActionHandler_params)_new;
	{webActionView__TPPLST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_ActionHandler_params (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_ActionHandler_params (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_WebNodeActualParam)) 
		return webActionView__MkwebActionView_WebNodeActualParampwebActionView_ActionHandler_params (_coordref, webActionView_MkwebActionView_WebNodeActualParam (_coordref, t));
	message (DEADLY, "a pwebActionView_ActionHandler_params list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_ActionHandler_params (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_ActionHandler_params (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_ActionHandler_params)
	l =_ElempwebActionView_ActionHandler_params (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_ActionHandler_params)
	r = _ElempwebActionView_ActionHandler_params (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_ActionHandler_params)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_ActionHandler_params)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_ActionHandler_params)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_ActionHandler_params)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_ActionHandler_params (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_ActionHandler_params (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_ActionHandler_params root;
	webActionView__TPPLST_0pwebActionView_ActionHandler_params list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_ActionHandler_params)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_ActionHandler_params)
		t = _ElempwebActionView_ActionHandler_params (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_ActionHandler_params)(((webActionView__TPPLST_0pwebActionView_ActionHandler_params) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_ActionHandler_params) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_ActionHandler_params;
#else
list = (webActionView__TPPLST_0pwebActionView_ActionHandler_params) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_ActionHandler_params));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_ActionHandler_params;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_ActionHandler_params)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params)
	{webActionView__TPPLST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_WebNodeActualParampwebActionView_ActionHandler_params;
	} this code has been moved to _ElempwebActionView_ActionHandler_params*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_ActionHandler_params;
#else
root = (webActionView__TPPpwebActionView_ActionHandler_params) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_ActionHandler_params));
#endif
root->_prod = webActionView_RULEpwebActionView_ActionHandler_params;
root->_desc1 = (webActionView__TSPLST_webActionView_ActionHandler_params)list;
{ webActionView__TPPpwebActionView_ActionHandler_params _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_ActionHandler_params;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebAction (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5)
#else
NODEPTR webActionView_MkpwebActionView_WebAction (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
#endif
{	webActionView__TPPpwebActionView_WebAction _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebAction;
#else
_currn = (webActionView__TPPpwebActionView_WebAction) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebAction));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebAction;
_currn->_desc1 = (webActionView__TSPwebActionView_WebAction_name) webActionView_MkwebActionView_WebAction_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebAction: root of subtree no. 1 can not be made a webActionView_WebAction_name node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_WebAction_formalParameter) webActionView_MkwebActionView_WebAction_formalParameter (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebAction: root of subtree no. 2 can not be made a webActionView_WebAction_formalParameter node ", 0, _coordref);
_currn->_desc3 = (webActionView__TSPwebActionView_WebAction_successpage) webActionView_MkwebActionView_WebAction_successpage (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebAction: root of subtree no. 3 can not be made a webActionView_WebAction_successpage node ", 0, _coordref);
_currn->_desc4 = (webActionView__TSPwebActionView_WebAction_operations) webActionView_MkwebActionView_WebAction_operations (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebAction: root of subtree no. 4 can not be made a webActionView_WebAction_operations node ", 0, _coordref);
_currn->_desc5 = (webActionView__TSPwebActionView_WebAction_position) webActionView_MkwebActionView_WebAction_position (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebAction: root of subtree no. 5 can not be made a webActionView_WebAction_position node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebAction;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebAction */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebAction_name (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_WebAction_name (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_WebAction_name _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebAction_name;
#else
_currn = (webActionView__TPPpwebActionView_WebAction_name) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebAction_name));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebAction_name;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebAction_name;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebAction_name */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter;
#else
	_new = (webActionView__TPPLST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter));
#endif
	_new->_prod = webActionView_RULELST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter;
	_new->_desc1 = (webActionView__TSPwebActionView_WebNodeFormalParam)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebAction_formalParameter)_new;
	{webActionView__TPPLST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_WebAction_formalParameter (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_WebAction_formalParameter (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_WebNodeFormalParam)) 
		return webActionView__MkwebActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter (_coordref, webActionView_MkwebActionView_WebNodeFormalParam (_coordref, t));
	message (DEADLY, "a pwebActionView_WebAction_formalParameter list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_WebAction_formalParameter (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_WebAction_formalParameter (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_WebAction_formalParameter)
	l =_ElempwebActionView_WebAction_formalParameter (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_WebAction_formalParameter)
	r = _ElempwebActionView_WebAction_formalParameter (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_WebAction_formalParameter)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_WebAction_formalParameter)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_WebAction_formalParameter)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_WebAction_formalParameter)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebAction_formalParameter (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_WebAction_formalParameter (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_WebAction_formalParameter root;
	webActionView__TPPLST_0pwebActionView_WebAction_formalParameter list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_WebAction_formalParameter)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_WebAction_formalParameter)
		t = _ElempwebActionView_WebAction_formalParameter (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_WebAction_formalParameter)(((webActionView__TPPLST_0pwebActionView_WebAction_formalParameter) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_WebAction_formalParameter) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_WebAction_formalParameter;
#else
list = (webActionView__TPPLST_0pwebActionView_WebAction_formalParameter) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_WebAction_formalParameter));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_WebAction_formalParameter;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_WebAction_formalParameter)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter)
	{webActionView__TPPLST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_WebNodeFormalParampwebActionView_WebAction_formalParameter;
	} this code has been moved to _ElempwebActionView_WebAction_formalParameter*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_WebAction_formalParameter;
#else
root = (webActionView__TPPpwebActionView_WebAction_formalParameter) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebAction_formalParameter));
#endif
root->_prod = webActionView_RULEpwebActionView_WebAction_formalParameter;
root->_desc1 = (webActionView__TSPLST_webActionView_WebAction_formalParameter)list;
{ webActionView__TPPpwebActionView_WebAction_formalParameter _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_WebAction_formalParameter;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DataBaseOperationpwebActionView_WebAction_operations (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DataBaseOperationpwebActionView_WebAction_operations (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DataBaseOperationpwebActionView_WebAction_operations _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DataBaseOperationpwebActionView_WebAction_operations;
#else
	_new = (webActionView__TPPLST_webActionView_DataBaseOperationpwebActionView_WebAction_operations) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DataBaseOperationpwebActionView_WebAction_operations));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DataBaseOperationpwebActionView_WebAction_operations;
	_new->_desc1 = (webActionView__TSPwebActionView_DataBaseOperation)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebAction_operations)_new;
	{webActionView__TPPLST_webActionView_DataBaseOperationpwebActionView_WebAction_operations _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DataBaseOperationpwebActionView_WebAction_operations;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_JavaOperationpwebActionView_WebAction_operations (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_JavaOperationpwebActionView_WebAction_operations (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_JavaOperationpwebActionView_WebAction_operations _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_JavaOperationpwebActionView_WebAction_operations;
#else
	_new = (webActionView__TPPLST_webActionView_JavaOperationpwebActionView_WebAction_operations) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_JavaOperationpwebActionView_WebAction_operations));
#endif
	_new->_prod = webActionView_RULELST_webActionView_JavaOperationpwebActionView_WebAction_operations;
	_new->_desc1 = (webActionView__TSPwebActionView_JavaOperation)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebAction_operations)_new;
	{webActionView__TPPLST_webActionView_JavaOperationpwebActionView_WebAction_operations _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_JavaOperationpwebActionView_WebAction_operations;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_MailingOperationpwebActionView_WebAction_operations (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_MailingOperationpwebActionView_WebAction_operations (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_MailingOperationpwebActionView_WebAction_operations _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_MailingOperationpwebActionView_WebAction_operations;
#else
	_new = (webActionView__TPPLST_webActionView_MailingOperationpwebActionView_WebAction_operations) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_MailingOperationpwebActionView_WebAction_operations));
#endif
	_new->_prod = webActionView_RULELST_webActionView_MailingOperationpwebActionView_WebAction_operations;
	_new->_desc1 = (webActionView__TSPwebActionView_MailingOperation)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebAction_operations)_new;
	{webActionView__TPPLST_webActionView_MailingOperationpwebActionView_WebAction_operations _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_MailingOperationpwebActionView_WebAction_operations;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_LogoutOperationpwebActionView_WebAction_operations (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_LogoutOperationpwebActionView_WebAction_operations (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_LogoutOperationpwebActionView_WebAction_operations _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_LogoutOperationpwebActionView_WebAction_operations;
#else
	_new = (webActionView__TPPLST_webActionView_LogoutOperationpwebActionView_WebAction_operations) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_LogoutOperationpwebActionView_WebAction_operations));
#endif
	_new->_prod = webActionView_RULELST_webActionView_LogoutOperationpwebActionView_WebAction_operations;
	_new->_desc1 = (webActionView__TSPwebActionView_LogoutOperation)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebAction_operations)_new;
	{webActionView__TPPLST_webActionView_LogoutOperationpwebActionView_WebAction_operations _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_LogoutOperationpwebActionView_WebAction_operations;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_LoginOperationpwebActionView_WebAction_operations (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_LoginOperationpwebActionView_WebAction_operations (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_LoginOperationpwebActionView_WebAction_operations _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_LoginOperationpwebActionView_WebAction_operations;
#else
	_new = (webActionView__TPPLST_webActionView_LoginOperationpwebActionView_WebAction_operations) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_LoginOperationpwebActionView_WebAction_operations));
#endif
	_new->_prod = webActionView_RULELST_webActionView_LoginOperationpwebActionView_WebAction_operations;
	_new->_desc1 = (webActionView__TSPwebActionView_LoginOperation)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebAction_operations)_new;
	{webActionView__TPPLST_webActionView_LoginOperationpwebActionView_WebAction_operations _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_LoginOperationpwebActionView_WebAction_operations;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_WebAction_operations (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_WebAction_operations (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DataBaseOperation)) 
		return webActionView__MkwebActionView_DataBaseOperationpwebActionView_WebAction_operations (_coordref, webActionView_MkwebActionView_DataBaseOperation (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_JavaOperation)) 
		return webActionView__MkwebActionView_JavaOperationpwebActionView_WebAction_operations (_coordref, webActionView_MkwebActionView_JavaOperation (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_MailingOperation)) 
		return webActionView__MkwebActionView_MailingOperationpwebActionView_WebAction_operations (_coordref, webActionView_MkwebActionView_MailingOperation (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_LogoutOperation)) 
		return webActionView__MkwebActionView_LogoutOperationpwebActionView_WebAction_operations (_coordref, webActionView_MkwebActionView_LogoutOperation (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_LoginOperation)) 
		return webActionView__MkwebActionView_LoginOperationpwebActionView_WebAction_operations (_coordref, webActionView_MkwebActionView_LoginOperation (_coordref, t));
	message (DEADLY, "a pwebActionView_WebAction_operations list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_WebAction_operations (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_WebAction_operations (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_WebAction_operations)
	l =_ElempwebActionView_WebAction_operations (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_WebAction_operations)
	r = _ElempwebActionView_WebAction_operations (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_WebAction_operations)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_WebAction_operations)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_WebAction_operations)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_WebAction_operations)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebAction_operations (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_WebAction_operations (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_WebAction_operations root;
	webActionView__TPPLST_0pwebActionView_WebAction_operations list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_WebAction_operations)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_WebAction_operations)
		t = _ElempwebActionView_WebAction_operations (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_WebAction_operations)(((webActionView__TPPLST_0pwebActionView_WebAction_operations) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_WebAction_operations) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_WebAction_operations;
#else
list = (webActionView__TPPLST_0pwebActionView_WebAction_operations) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_WebAction_operations));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_WebAction_operations;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_WebAction_operations)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DataBaseOperationpwebActionView_WebAction_operations)
	{webActionView__TPPLST_webActionView_DataBaseOperationpwebActionView_WebAction_operations _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DataBaseOperationpwebActionView_WebAction_operations;
	} this code has been moved to _ElempwebActionView_WebAction_operations*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_JavaOperationpwebActionView_WebAction_operations)
	{webActionView__TPPLST_webActionView_JavaOperationpwebActionView_WebAction_operations _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_JavaOperationpwebActionView_WebAction_operations;
	} this code has been moved to _ElempwebActionView_WebAction_operations*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_MailingOperationpwebActionView_WebAction_operations)
	{webActionView__TPPLST_webActionView_MailingOperationpwebActionView_WebAction_operations _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_MailingOperationpwebActionView_WebAction_operations;
	} this code has been moved to _ElempwebActionView_WebAction_operations*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_LogoutOperationpwebActionView_WebAction_operations)
	{webActionView__TPPLST_webActionView_LogoutOperationpwebActionView_WebAction_operations _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_LogoutOperationpwebActionView_WebAction_operations;
	} this code has been moved to _ElempwebActionView_WebAction_operations*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_LoginOperationpwebActionView_WebAction_operations)
	{webActionView__TPPLST_webActionView_LoginOperationpwebActionView_WebAction_operations _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_LoginOperationpwebActionView_WebAction_operations;
	} this code has been moved to _ElempwebActionView_WebAction_operations*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_WebAction_operations;
#else
root = (webActionView__TPPpwebActionView_WebAction_operations) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebAction_operations));
#endif
root->_prod = webActionView_RULEpwebActionView_WebAction_operations;
root->_desc1 = (webActionView__TSPLST_webActionView_WebAction_operations)list;
{ webActionView__TPPpwebActionView_WebAction_operations _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_WebAction_operations;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebAction_position (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_WebAction_position (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_WebAction_position _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebAction_position;
#else
_currn = (webActionView__TPPpwebActionView_WebAction_position) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebAction_position));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebAction_position;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebAction_position;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebAction_position */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DataBaseOperation (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5)
#else
NODEPTR webActionView_MkpwebActionView_DataBaseOperation (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
#endif
{	webActionView__TPPpwebActionView_DataBaseOperation _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DataBaseOperation;
#else
_currn = (webActionView__TPPpwebActionView_DataBaseOperation) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DataBaseOperation));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DataBaseOperation;
_currn->_desc1 = (webActionView__TSPwebActionView_DataBaseOperation_errorhandler) webActionView_MkwebActionView_DataBaseOperation_errorhandler (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DataBaseOperation: root of subtree no. 1 can not be made a webActionView_DataBaseOperation_errorhandler node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_DataBaseOperation_successMessage) webActionView_MkwebActionView_DataBaseOperation_successMessage (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DataBaseOperation: root of subtree no. 2 can not be made a webActionView_DataBaseOperation_successMessage node ", 0, _coordref);
_currn->_desc3 = (webActionView__TSPwebActionView_DataBaseOperation_errorMessage) webActionView_MkwebActionView_DataBaseOperation_errorMessage (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DataBaseOperation: root of subtree no. 3 can not be made a webActionView_DataBaseOperation_errorMessage node ", 0, _coordref);
_currn->_desc4 = (webActionView__TSPwebActionView_DataBaseOperation_filter) webActionView_MkwebActionView_DataBaseOperation_filter (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DataBaseOperation: root of subtree no. 4 can not be made a webActionView_DataBaseOperation_filter node ", 0, _coordref);
_currn->_desc5 = (webActionView__TSPwebActionView_DataBaseOperation_params) webActionView_MkwebActionView_DataBaseOperation_params (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_DataBaseOperation: root of subtree no. 5 can not be made a webActionView_DataBaseOperation_params node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DataBaseOperation;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DataBaseOperation */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler;
#else
	_new = (webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler));
#endif
	_new->_prod = webActionView_RULELST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler;
	_new->_desc1 = (webActionView__TSPwebActionView_ActionHandler)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_DataBaseOperation_errorhandler)_new;
	{webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_DataBaseOperation_errorhandler (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_DataBaseOperation_errorhandler (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_ActionHandler)) 
		return webActionView__MkwebActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler (_coordref, webActionView_MkwebActionView_ActionHandler (_coordref, t));
	message (DEADLY, "a pwebActionView_DataBaseOperation_errorhandler list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_DataBaseOperation_errorhandler (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_DataBaseOperation_errorhandler (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_DataBaseOperation_errorhandler)
	l =_ElempwebActionView_DataBaseOperation_errorhandler (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_DataBaseOperation_errorhandler)
	r = _ElempwebActionView_DataBaseOperation_errorhandler (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DataBaseOperation_errorhandler (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_DataBaseOperation_errorhandler (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_DataBaseOperation_errorhandler root;
	webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_DataBaseOperation_errorhandler)
		t = _ElempwebActionView_DataBaseOperation_errorhandler (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler)(((webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_DataBaseOperation_errorhandler;
#else
list = (webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_DataBaseOperation_errorhandler));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_DataBaseOperation_errorhandler;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_DataBaseOperation_errorhandler)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler)
	{webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_ActionHandlerpwebActionView_DataBaseOperation_errorhandler;
	} this code has been moved to _ElempwebActionView_DataBaseOperation_errorhandler*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_DataBaseOperation_errorhandler;
#else
root = (webActionView__TPPpwebActionView_DataBaseOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DataBaseOperation_errorhandler));
#endif
root->_prod = webActionView_RULEpwebActionView_DataBaseOperation_errorhandler;
root->_desc1 = (webActionView__TSPLST_webActionView_DataBaseOperation_errorhandler)list;
{ webActionView__TPPpwebActionView_DataBaseOperation_errorhandler _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_DataBaseOperation_errorhandler;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DataBaseOperation_successMessage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DataBaseOperation_successMessage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DataBaseOperation_successMessage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DataBaseOperation_successMessage;
#else
_currn = (webActionView__TPPpwebActionView_DataBaseOperation_successMessage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DataBaseOperation_successMessage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DataBaseOperation_successMessage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DataBaseOperation_successMessage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DataBaseOperation_successMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DataBaseOperation_errorMessage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DataBaseOperation_errorMessage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DataBaseOperation_errorMessage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DataBaseOperation_errorMessage;
#else
_currn = (webActionView__TPPpwebActionView_DataBaseOperation_errorMessage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DataBaseOperation_errorMessage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DataBaseOperation_errorMessage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DataBaseOperation_errorMessage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DataBaseOperation_errorMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DataBaseOperation_filter (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_DataBaseOperation_filter (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_DataBaseOperation_filter _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_DataBaseOperation_filter;
#else
_currn = (webActionView__TPPpwebActionView_DataBaseOperation_filter) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DataBaseOperation_filter));
#endif
_currn->_prod = webActionView_RULEpwebActionView_DataBaseOperation_filter;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_DataBaseOperation_filter;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_DataBaseOperation_filter */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_DataSourceActualParampwebActionView_DataBaseOperation_params (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_DataSourceActualParampwebActionView_DataBaseOperation_params (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params;
#else
	_new = (webActionView__TPPLST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params));
#endif
	_new->_prod = webActionView_RULELST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params;
	_new->_desc1 = (webActionView__TSPwebActionView_DataSourceActualParam)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_DataBaseOperation_params)_new;
	{webActionView__TPPLST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_DataBaseOperation_params (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_DataBaseOperation_params (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_DataSourceActualParam)) 
		return webActionView__MkwebActionView_DataSourceActualParampwebActionView_DataBaseOperation_params (_coordref, webActionView_MkwebActionView_DataSourceActualParam (_coordref, t));
	message (DEADLY, "a pwebActionView_DataBaseOperation_params list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_DataBaseOperation_params (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_DataBaseOperation_params (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_DataBaseOperation_params)
	l =_ElempwebActionView_DataBaseOperation_params (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_DataBaseOperation_params)
	r = _ElempwebActionView_DataBaseOperation_params (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_DataBaseOperation_params)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_DataBaseOperation_params)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_DataBaseOperation_params)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_DataBaseOperation_params)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_DataBaseOperation_params (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_DataBaseOperation_params (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_DataBaseOperation_params root;
	webActionView__TPPLST_0pwebActionView_DataBaseOperation_params list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_DataBaseOperation_params)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_DataBaseOperation_params)
		t = _ElempwebActionView_DataBaseOperation_params (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_DataBaseOperation_params)(((webActionView__TPPLST_0pwebActionView_DataBaseOperation_params) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_DataBaseOperation_params) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_DataBaseOperation_params;
#else
list = (webActionView__TPPLST_0pwebActionView_DataBaseOperation_params) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_DataBaseOperation_params));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_DataBaseOperation_params;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_DataBaseOperation_params)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params)
	{webActionView__TPPLST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_DataSourceActualParampwebActionView_DataBaseOperation_params;
	} this code has been moved to _ElempwebActionView_DataBaseOperation_params*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_DataBaseOperation_params;
#else
root = (webActionView__TPPpwebActionView_DataBaseOperation_params) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_DataBaseOperation_params));
#endif
root->_prod = webActionView_RULEpwebActionView_DataBaseOperation_params;
root->_desc1 = (webActionView__TSPLST_webActionView_DataBaseOperation_params)list;
{ webActionView__TPPpwebActionView_DataBaseOperation_params _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_DataBaseOperation_params;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_JavaOperation (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webActionView_MkpwebActionView_JavaOperation (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webActionView__TPPpwebActionView_JavaOperation _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_JavaOperation;
#else
_currn = (webActionView__TPPpwebActionView_JavaOperation) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_JavaOperation));
#endif
_currn->_prod = webActionView_RULEpwebActionView_JavaOperation;
_currn->_desc1 = (webActionView__TSPwebActionView_JavaOperation_errorhandler) webActionView_MkwebActionView_JavaOperation_errorhandler (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_JavaOperation: root of subtree no. 1 can not be made a webActionView_JavaOperation_errorhandler node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_JavaOperation_successMessage) webActionView_MkwebActionView_JavaOperation_successMessage (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_JavaOperation: root of subtree no. 2 can not be made a webActionView_JavaOperation_successMessage node ", 0, _coordref);
_currn->_desc3 = (webActionView__TSPwebActionView_JavaOperation_errorMessage) webActionView_MkwebActionView_JavaOperation_errorMessage (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_JavaOperation: root of subtree no. 3 can not be made a webActionView_JavaOperation_errorMessage node ", 0, _coordref);
_currn->_desc4 = (webActionView__TSPwebActionView_JavaOperation_content) webActionView_MkwebActionView_JavaOperation_content (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_JavaOperation: root of subtree no. 4 can not be made a webActionView_JavaOperation_content node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_JavaOperation;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_JavaOperation */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler;
#else
	_new = (webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler));
#endif
	_new->_prod = webActionView_RULELST_webActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler;
	_new->_desc1 = (webActionView__TSPwebActionView_ActionHandler)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_JavaOperation_errorhandler)_new;
	{webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_JavaOperation_errorhandler (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_JavaOperation_errorhandler (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_ActionHandler)) 
		return webActionView__MkwebActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler (_coordref, webActionView_MkwebActionView_ActionHandler (_coordref, t));
	message (DEADLY, "a pwebActionView_JavaOperation_errorhandler list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_JavaOperation_errorhandler (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_JavaOperation_errorhandler (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_JavaOperation_errorhandler)
	l =_ElempwebActionView_JavaOperation_errorhandler (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_JavaOperation_errorhandler)
	r = _ElempwebActionView_JavaOperation_errorhandler (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_JavaOperation_errorhandler (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_JavaOperation_errorhandler (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_JavaOperation_errorhandler root;
	webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_JavaOperation_errorhandler)
		t = _ElempwebActionView_JavaOperation_errorhandler (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler)(((webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_JavaOperation_errorhandler;
#else
list = (webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_JavaOperation_errorhandler));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_JavaOperation_errorhandler;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_JavaOperation_errorhandler)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler)
	{webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_ActionHandlerpwebActionView_JavaOperation_errorhandler;
	} this code has been moved to _ElempwebActionView_JavaOperation_errorhandler*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_JavaOperation_errorhandler;
#else
root = (webActionView__TPPpwebActionView_JavaOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_JavaOperation_errorhandler));
#endif
root->_prod = webActionView_RULEpwebActionView_JavaOperation_errorhandler;
root->_desc1 = (webActionView__TSPLST_webActionView_JavaOperation_errorhandler)list;
{ webActionView__TPPpwebActionView_JavaOperation_errorhandler _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_JavaOperation_errorhandler;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_JavaOperation_successMessage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_JavaOperation_successMessage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_JavaOperation_successMessage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_JavaOperation_successMessage;
#else
_currn = (webActionView__TPPpwebActionView_JavaOperation_successMessage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_JavaOperation_successMessage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_JavaOperation_successMessage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_JavaOperation_successMessage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_JavaOperation_successMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_JavaOperation_errorMessage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_JavaOperation_errorMessage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_JavaOperation_errorMessage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_JavaOperation_errorMessage;
#else
_currn = (webActionView__TPPpwebActionView_JavaOperation_errorMessage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_JavaOperation_errorMessage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_JavaOperation_errorMessage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_JavaOperation_errorMessage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_JavaOperation_errorMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_JavaOperation_content (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_JavaOperation_content (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_JavaOperation_content _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_JavaOperation_content;
#else
_currn = (webActionView__TPPpwebActionView_JavaOperation_content) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_JavaOperation_content));
#endif
_currn->_prod = webActionView_RULEpwebActionView_JavaOperation_content;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_JavaOperation_content;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_JavaOperation_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_MailingOperation (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7)
#else
NODEPTR webActionView_MkpwebActionView_MailingOperation (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
#endif
{	webActionView__TPPpwebActionView_MailingOperation _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_MailingOperation;
#else
_currn = (webActionView__TPPpwebActionView_MailingOperation) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_MailingOperation));
#endif
_currn->_prod = webActionView_RULEpwebActionView_MailingOperation;
_currn->_desc1 = (webActionView__TSPwebActionView_MailingOperation_errorhandler) webActionView_MkwebActionView_MailingOperation_errorhandler (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_MailingOperation: root of subtree no. 1 can not be made a webActionView_MailingOperation_errorhandler node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_MailingOperation_successMessage) webActionView_MkwebActionView_MailingOperation_successMessage (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_MailingOperation: root of subtree no. 2 can not be made a webActionView_MailingOperation_successMessage node ", 0, _coordref);
_currn->_desc3 = (webActionView__TSPwebActionView_MailingOperation_errorMessage) webActionView_MkwebActionView_MailingOperation_errorMessage (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_MailingOperation: root of subtree no. 3 can not be made a webActionView_MailingOperation_errorMessage node ", 0, _coordref);
_currn->_desc4 = (webActionView__TSPwebActionView_MailingOperation_name) webActionView_MkwebActionView_MailingOperation_name (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_MailingOperation: root of subtree no. 4 can not be made a webActionView_MailingOperation_name node ", 0, _coordref);
_currn->_desc5 = (webActionView__TSPwebActionView_MailingOperation_mailTo) webActionView_MkwebActionView_MailingOperation_mailTo (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_MailingOperation: root of subtree no. 5 can not be made a webActionView_MailingOperation_mailTo node ", 0, _coordref);
_currn->_desc6 = (webActionView__TSPwebActionView_MailingOperation_subject) webActionView_MkwebActionView_MailingOperation_subject (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_MailingOperation: root of subtree no. 6 can not be made a webActionView_MailingOperation_subject node ", 0, _coordref);
_currn->_desc7 = (webActionView__TSPwebActionView_MailingOperation_content) webActionView_MkwebActionView_MailingOperation_content (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_MailingOperation: root of subtree no. 7 can not be made a webActionView_MailingOperation_content node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_MailingOperation;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_MailingOperation */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler;
#else
	_new = (webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler));
#endif
	_new->_prod = webActionView_RULELST_webActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler;
	_new->_desc1 = (webActionView__TSPwebActionView_ActionHandler)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_MailingOperation_errorhandler)_new;
	{webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_MailingOperation_errorhandler (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_MailingOperation_errorhandler (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_ActionHandler)) 
		return webActionView__MkwebActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler (_coordref, webActionView_MkwebActionView_ActionHandler (_coordref, t));
	message (DEADLY, "a pwebActionView_MailingOperation_errorhandler list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_MailingOperation_errorhandler (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_MailingOperation_errorhandler (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_MailingOperation_errorhandler)
	l =_ElempwebActionView_MailingOperation_errorhandler (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_MailingOperation_errorhandler)
	r = _ElempwebActionView_MailingOperation_errorhandler (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_MailingOperation_errorhandler (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_MailingOperation_errorhandler (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_MailingOperation_errorhandler root;
	webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_MailingOperation_errorhandler)
		t = _ElempwebActionView_MailingOperation_errorhandler (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler)(((webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_MailingOperation_errorhandler;
#else
list = (webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_MailingOperation_errorhandler));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_MailingOperation_errorhandler;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_MailingOperation_errorhandler)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler)
	{webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_ActionHandlerpwebActionView_MailingOperation_errorhandler;
	} this code has been moved to _ElempwebActionView_MailingOperation_errorhandler*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_MailingOperation_errorhandler;
#else
root = (webActionView__TPPpwebActionView_MailingOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_MailingOperation_errorhandler));
#endif
root->_prod = webActionView_RULEpwebActionView_MailingOperation_errorhandler;
root->_desc1 = (webActionView__TSPLST_webActionView_MailingOperation_errorhandler)list;
{ webActionView__TPPpwebActionView_MailingOperation_errorhandler _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_MailingOperation_errorhandler;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_MailingOperation_successMessage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_MailingOperation_successMessage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_MailingOperation_successMessage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_MailingOperation_successMessage;
#else
_currn = (webActionView__TPPpwebActionView_MailingOperation_successMessage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_MailingOperation_successMessage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_MailingOperation_successMessage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_MailingOperation_successMessage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_MailingOperation_successMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_MailingOperation_errorMessage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_MailingOperation_errorMessage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_MailingOperation_errorMessage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_MailingOperation_errorMessage;
#else
_currn = (webActionView__TPPpwebActionView_MailingOperation_errorMessage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_MailingOperation_errorMessage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_MailingOperation_errorMessage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_MailingOperation_errorMessage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_MailingOperation_errorMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_MailingOperation_name (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_MailingOperation_name (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_MailingOperation_name _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_MailingOperation_name;
#else
_currn = (webActionView__TPPpwebActionView_MailingOperation_name) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_MailingOperation_name));
#endif
_currn->_prod = webActionView_RULEpwebActionView_MailingOperation_name;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_MailingOperation_name;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_MailingOperation_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_MailingOperation_mailTo (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_MailingOperation_mailTo (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_MailingOperation_mailTo _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_MailingOperation_mailTo;
#else
_currn = (webActionView__TPPpwebActionView_MailingOperation_mailTo) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_MailingOperation_mailTo));
#endif
_currn->_prod = webActionView_RULEpwebActionView_MailingOperation_mailTo;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_MailingOperation_mailTo;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_MailingOperation_mailTo */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_MailingOperation_subject (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_MailingOperation_subject (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_MailingOperation_subject _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_MailingOperation_subject;
#else
_currn = (webActionView__TPPpwebActionView_MailingOperation_subject) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_MailingOperation_subject));
#endif
_currn->_prod = webActionView_RULEpwebActionView_MailingOperation_subject;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_MailingOperation_subject;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_MailingOperation_subject */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_MailingOperation_content (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_MailingOperation_content (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_MailingOperation_content _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_MailingOperation_content;
#else
_currn = (webActionView__TPPpwebActionView_MailingOperation_content) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_MailingOperation_content));
#endif
_currn->_prod = webActionView_RULEpwebActionView_MailingOperation_content;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_MailingOperation_content;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_MailingOperation_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LogoutOperation (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webActionView_MkpwebActionView_LogoutOperation (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webActionView__TPPpwebActionView_LogoutOperation _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LogoutOperation;
#else
_currn = (webActionView__TPPpwebActionView_LogoutOperation) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LogoutOperation));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LogoutOperation;
_currn->_desc1 = (webActionView__TSPwebActionView_LogoutOperation_errorhandler) webActionView_MkwebActionView_LogoutOperation_errorhandler (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LogoutOperation: root of subtree no. 1 can not be made a webActionView_LogoutOperation_errorhandler node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_LogoutOperation_successMessage) webActionView_MkwebActionView_LogoutOperation_successMessage (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LogoutOperation: root of subtree no. 2 can not be made a webActionView_LogoutOperation_successMessage node ", 0, _coordref);
_currn->_desc3 = (webActionView__TSPwebActionView_LogoutOperation_errorMessage) webActionView_MkwebActionView_LogoutOperation_errorMessage (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LogoutOperation: root of subtree no. 3 can not be made a webActionView_LogoutOperation_errorMessage node ", 0, _coordref);
_currn->_desc4 = (webActionView__TSPwebActionView_LogoutOperation_name) webActionView_MkwebActionView_LogoutOperation_name (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LogoutOperation: root of subtree no. 4 can not be made a webActionView_LogoutOperation_name node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LogoutOperation;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LogoutOperation */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler;
#else
	_new = (webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler));
#endif
	_new->_prod = webActionView_RULELST_webActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler;
	_new->_desc1 = (webActionView__TSPwebActionView_ActionHandler)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_LogoutOperation_errorhandler)_new;
	{webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_LogoutOperation_errorhandler (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_LogoutOperation_errorhandler (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_ActionHandler)) 
		return webActionView__MkwebActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler (_coordref, webActionView_MkwebActionView_ActionHandler (_coordref, t));
	message (DEADLY, "a pwebActionView_LogoutOperation_errorhandler list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_LogoutOperation_errorhandler (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_LogoutOperation_errorhandler (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_LogoutOperation_errorhandler)
	l =_ElempwebActionView_LogoutOperation_errorhandler (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_LogoutOperation_errorhandler)
	r = _ElempwebActionView_LogoutOperation_errorhandler (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LogoutOperation_errorhandler (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_LogoutOperation_errorhandler (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_LogoutOperation_errorhandler root;
	webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_LogoutOperation_errorhandler)
		t = _ElempwebActionView_LogoutOperation_errorhandler (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler)(((webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_LogoutOperation_errorhandler;
#else
list = (webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_LogoutOperation_errorhandler));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_LogoutOperation_errorhandler;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_LogoutOperation_errorhandler)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler)
	{webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_ActionHandlerpwebActionView_LogoutOperation_errorhandler;
	} this code has been moved to _ElempwebActionView_LogoutOperation_errorhandler*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_LogoutOperation_errorhandler;
#else
root = (webActionView__TPPpwebActionView_LogoutOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LogoutOperation_errorhandler));
#endif
root->_prod = webActionView_RULEpwebActionView_LogoutOperation_errorhandler;
root->_desc1 = (webActionView__TSPLST_webActionView_LogoutOperation_errorhandler)list;
{ webActionView__TPPpwebActionView_LogoutOperation_errorhandler _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_LogoutOperation_errorhandler;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LogoutOperation_successMessage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LogoutOperation_successMessage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LogoutOperation_successMessage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LogoutOperation_successMessage;
#else
_currn = (webActionView__TPPpwebActionView_LogoutOperation_successMessage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LogoutOperation_successMessage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LogoutOperation_successMessage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LogoutOperation_successMessage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LogoutOperation_successMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LogoutOperation_errorMessage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LogoutOperation_errorMessage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LogoutOperation_errorMessage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LogoutOperation_errorMessage;
#else
_currn = (webActionView__TPPpwebActionView_LogoutOperation_errorMessage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LogoutOperation_errorMessage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LogoutOperation_errorMessage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LogoutOperation_errorMessage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LogoutOperation_errorMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LogoutOperation_name (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LogoutOperation_name (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LogoutOperation_name _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LogoutOperation_name;
#else
_currn = (webActionView__TPPpwebActionView_LogoutOperation_name) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LogoutOperation_name));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LogoutOperation_name;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LogoutOperation_name;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LogoutOperation_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LoginOperation (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7, NODEPTR _desc8, NODEPTR _desc9)
#else
NODEPTR webActionView_MkpwebActionView_LoginOperation (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7,_desc8,_desc9)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
	NODEPTR _desc8;
	NODEPTR _desc9;
#endif
{	webActionView__TPPpwebActionView_LoginOperation _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LoginOperation;
#else
_currn = (webActionView__TPPpwebActionView_LoginOperation) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LoginOperation));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LoginOperation;
_currn->_desc1 = (webActionView__TSPwebActionView_LoginOperation_errorhandler) webActionView_MkwebActionView_LoginOperation_errorhandler (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LoginOperation: root of subtree no. 1 can not be made a webActionView_LoginOperation_errorhandler node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_LoginOperation_successMessage) webActionView_MkwebActionView_LoginOperation_successMessage (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LoginOperation: root of subtree no. 2 can not be made a webActionView_LoginOperation_successMessage node ", 0, _coordref);
_currn->_desc3 = (webActionView__TSPwebActionView_LoginOperation_errorMessage) webActionView_MkwebActionView_LoginOperation_errorMessage (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LoginOperation: root of subtree no. 3 can not be made a webActionView_LoginOperation_errorMessage node ", 0, _coordref);
_currn->_desc4 = (webActionView__TSPwebActionView_LoginOperation_name) webActionView_MkwebActionView_LoginOperation_name (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LoginOperation: root of subtree no. 4 can not be made a webActionView_LoginOperation_name node ", 0, _coordref);
_currn->_desc5 = (webActionView__TSPwebActionView_LoginOperation_userDBColumn) webActionView_MkwebActionView_LoginOperation_userDBColumn (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LoginOperation: root of subtree no. 5 can not be made a webActionView_LoginOperation_userDBColumn node ", 0, _coordref);
_currn->_desc6 = (webActionView__TSPwebActionView_LoginOperation_passwdDBColumn) webActionView_MkwebActionView_LoginOperation_passwdDBColumn (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LoginOperation: root of subtree no. 6 can not be made a webActionView_LoginOperation_passwdDBColumn node ", 0, _coordref);
_currn->_desc7 = (webActionView__TSPwebActionView_LoginOperation_rolesDBColumn) webActionView_MkwebActionView_LoginOperation_rolesDBColumn (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LoginOperation: root of subtree no. 7 can not be made a webActionView_LoginOperation_rolesDBColumn node ", 0, _coordref);
_currn->_desc8 = (webActionView__TSPwebActionView_LoginOperation_userFormField) webActionView_MkwebActionView_LoginOperation_userFormField (_coordref, _desc8);	
if (((NODEPTR)_currn->_desc8) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LoginOperation: root of subtree no. 8 can not be made a webActionView_LoginOperation_userFormField node ", 0, _coordref);
_currn->_desc9 = (webActionView__TSPwebActionView_LoginOperation_passwdFormField) webActionView_MkwebActionView_LoginOperation_passwdFormField (_coordref, _desc9);	
if (((NODEPTR)_currn->_desc9) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_LoginOperation: root of subtree no. 9 can not be made a webActionView_LoginOperation_passwdFormField node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LoginOperation;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LoginOperation */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler;
#else
	_new = (webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler));
#endif
	_new->_prod = webActionView_RULELST_webActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler;
	_new->_desc1 = (webActionView__TSPwebActionView_ActionHandler)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_LoginOperation_errorhandler)_new;
	{webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_LoginOperation_errorhandler (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_LoginOperation_errorhandler (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_ActionHandler)) 
		return webActionView__MkwebActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler (_coordref, webActionView_MkwebActionView_ActionHandler (_coordref, t));
	message (DEADLY, "a pwebActionView_LoginOperation_errorhandler list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_LoginOperation_errorhandler (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_LoginOperation_errorhandler (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_LoginOperation_errorhandler)
	l =_ElempwebActionView_LoginOperation_errorhandler (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_LoginOperation_errorhandler)
	r = _ElempwebActionView_LoginOperation_errorhandler (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LoginOperation_errorhandler (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_LoginOperation_errorhandler (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_LoginOperation_errorhandler root;
	webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_LoginOperation_errorhandler)
		t = _ElempwebActionView_LoginOperation_errorhandler (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler)(((webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_LoginOperation_errorhandler;
#else
list = (webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_LoginOperation_errorhandler));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_LoginOperation_errorhandler;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_LoginOperation_errorhandler)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler)
	{webActionView__TPPLST_webActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_ActionHandlerpwebActionView_LoginOperation_errorhandler;
	} this code has been moved to _ElempwebActionView_LoginOperation_errorhandler*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_LoginOperation_errorhandler;
#else
root = (webActionView__TPPpwebActionView_LoginOperation_errorhandler) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LoginOperation_errorhandler));
#endif
root->_prod = webActionView_RULEpwebActionView_LoginOperation_errorhandler;
root->_desc1 = (webActionView__TSPLST_webActionView_LoginOperation_errorhandler)list;
{ webActionView__TPPpwebActionView_LoginOperation_errorhandler _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_LoginOperation_errorhandler;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LoginOperation_successMessage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LoginOperation_successMessage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LoginOperation_successMessage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LoginOperation_successMessage;
#else
_currn = (webActionView__TPPpwebActionView_LoginOperation_successMessage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LoginOperation_successMessage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LoginOperation_successMessage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LoginOperation_successMessage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LoginOperation_successMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LoginOperation_errorMessage (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LoginOperation_errorMessage (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LoginOperation_errorMessage _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LoginOperation_errorMessage;
#else
_currn = (webActionView__TPPpwebActionView_LoginOperation_errorMessage) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LoginOperation_errorMessage));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LoginOperation_errorMessage;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LoginOperation_errorMessage;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LoginOperation_errorMessage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LoginOperation_name (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LoginOperation_name (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LoginOperation_name _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LoginOperation_name;
#else
_currn = (webActionView__TPPpwebActionView_LoginOperation_name) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LoginOperation_name));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LoginOperation_name;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LoginOperation_name;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LoginOperation_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LoginOperation_userDBColumn (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LoginOperation_userDBColumn (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LoginOperation_userDBColumn _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LoginOperation_userDBColumn;
#else
_currn = (webActionView__TPPpwebActionView_LoginOperation_userDBColumn) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LoginOperation_userDBColumn));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LoginOperation_userDBColumn;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LoginOperation_userDBColumn;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LoginOperation_userDBColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LoginOperation_passwdDBColumn (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LoginOperation_passwdDBColumn (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LoginOperation_passwdDBColumn _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LoginOperation_passwdDBColumn;
#else
_currn = (webActionView__TPPpwebActionView_LoginOperation_passwdDBColumn) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LoginOperation_passwdDBColumn));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LoginOperation_passwdDBColumn;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LoginOperation_passwdDBColumn;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LoginOperation_passwdDBColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LoginOperation_rolesDBColumn (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LoginOperation_rolesDBColumn (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LoginOperation_rolesDBColumn _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LoginOperation_rolesDBColumn;
#else
_currn = (webActionView__TPPpwebActionView_LoginOperation_rolesDBColumn) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LoginOperation_rolesDBColumn));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LoginOperation_rolesDBColumn;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LoginOperation_rolesDBColumn;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LoginOperation_rolesDBColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LoginOperation_userFormField (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LoginOperation_userFormField (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LoginOperation_userFormField _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LoginOperation_userFormField;
#else
_currn = (webActionView__TPPpwebActionView_LoginOperation_userFormField) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LoginOperation_userFormField));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LoginOperation_userFormField;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LoginOperation_userFormField;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LoginOperation_userFormField */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_LoginOperation_passwdFormField (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_LoginOperation_passwdFormField (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_LoginOperation_passwdFormField _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_LoginOperation_passwdFormField;
#else
_currn = (webActionView__TPPpwebActionView_LoginOperation_passwdFormField) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_LoginOperation_passwdFormField));
#endif
_currn->_prod = webActionView_RULEpwebActionView_LoginOperation_passwdFormField;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_LoginOperation_passwdFormField;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_LoginOperation_passwdFormField */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_MD5Modifier (POSITION *_coordref, int _TERM1)
#else
NODEPTR webActionView_MkpwebActionView_MD5Modifier (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webActionView__TPPpwebActionView_MD5Modifier _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_MD5Modifier;
#else
_currn = (webActionView__TPPpwebActionView_MD5Modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_MD5Modifier));
#endif
_currn->_prod = webActionView_RULEpwebActionView_MD5Modifier;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_MD5Modifier;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_MD5Modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_JoinModifier (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webActionView_MkpwebActionView_JoinModifier (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webActionView__TPPpwebActionView_JoinModifier _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_JoinModifier;
#else
_currn = (webActionView__TPPpwebActionView_JoinModifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_JoinModifier));
#endif
_currn->_prod = webActionView_RULEpwebActionView_JoinModifier;
_currn->_desc1 = (webActionView__TSPwebActionView_JoinModifier_separator) webActionView_MkwebActionView_JoinModifier_separator (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_JoinModifier: root of subtree no. 1 can not be made a webActionView_JoinModifier_separator node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_JoinModifier;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_JoinModifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_JoinModifier_separator (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_JoinModifier_separator (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_JoinModifier_separator _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_JoinModifier_separator;
#else
_currn = (webActionView__TPPpwebActionView_JoinModifier_separator) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_JoinModifier_separator));
#endif
_currn->_prod = webActionView_RULEpwebActionView_JoinModifier_separator;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_JoinModifier_separator;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_JoinModifier_separator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeConstantExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeConstantExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webActionView__TPPpwebActionView_WebNodeConstantExpression _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeConstantExpression;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeConstantExpression) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeConstantExpression));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeConstantExpression;
_currn->_desc1 = (webActionView__TSPwebActionView_WebNodeConstantExpression_modifier) webActionView_MkwebActionView_WebNodeConstantExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeConstantExpression: root of subtree no. 1 can not be made a webActionView_WebNodeConstantExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_WebNodeConstantExpression_value) webActionView_MkwebActionView_WebNodeConstantExpression_value (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeConstantExpression: root of subtree no. 2 can not be made a webActionView_WebNodeConstantExpression_value node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeConstantExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier;
#else
	_new = (webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier));
#endif
	_new->_prod = webActionView_RULELST_webActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier;
	_new->_desc1 = (webActionView__TSPwebActionView_MD5Modifier)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeConstantExpression_modifier)_new;
	{webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier;
#else
	_new = (webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier));
#endif
	_new->_prod = webActionView_RULELST_webActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier;
	_new->_desc1 = (webActionView__TSPwebActionView_JoinModifier)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeConstantExpression_modifier)_new;
	{webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_WebNodeConstantExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_MD5Modifier)) 
		return webActionView__MkwebActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier (_coordref, webActionView_MkwebActionView_MD5Modifier (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_JoinModifier)) 
		return webActionView__MkwebActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier (_coordref, webActionView_MkwebActionView_JoinModifier (_coordref, t));
	message (DEADLY, "a pwebActionView_WebNodeConstantExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_WebNodeConstantExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_WebNodeConstantExpression_modifier)
	l =_ElempwebActionView_WebNodeConstantExpression_modifier (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_WebNodeConstantExpression_modifier)
	r = _ElempwebActionView_WebNodeConstantExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeConstantExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_WebNodeConstantExpression_modifier root;
	webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_WebNodeConstantExpression_modifier)
		t = _ElempwebActionView_WebNodeConstantExpression_modifier (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier)(((webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_WebNodeConstantExpression_modifier;
#else
list = (webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_WebNodeConstantExpression_modifier));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_WebNodeConstantExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_WebNodeConstantExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier)
	{webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_MD5ModifierpwebActionView_WebNodeConstantExpression_modifier;
	} this code has been moved to _ElempwebActionView_WebNodeConstantExpression_modifier*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier)
	{webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_JoinModifierpwebActionView_WebNodeConstantExpression_modifier;
	} this code has been moved to _ElempwebActionView_WebNodeConstantExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_WebNodeConstantExpression_modifier;
#else
root = (webActionView__TPPpwebActionView_WebNodeConstantExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeConstantExpression_modifier));
#endif
root->_prod = webActionView_RULEpwebActionView_WebNodeConstantExpression_modifier;
root->_desc1 = (webActionView__TSPLST_webActionView_WebNodeConstantExpression_modifier)list;
{ webActionView__TPPpwebActionView_WebNodeConstantExpression_modifier _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_WebNodeConstantExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeConstantExpression_value (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeConstantExpression_value (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_WebNodeConstantExpression_value _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeConstantExpression_value;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeConstantExpression_value) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeConstantExpression_value));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeConstantExpression_value;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeConstantExpression_value;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeVariableExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeVariableExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webActionView__TPPpwebActionView_WebNodeVariableExpression _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeVariableExpression;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeVariableExpression) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeVariableExpression));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeVariableExpression;
_currn->_desc1 = (webActionView__TSPwebActionView_WebNodeVariableExpression_modifier) webActionView_MkwebActionView_WebNodeVariableExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeVariableExpression: root of subtree no. 1 can not be made a webActionView_WebNodeVariableExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_WebNodeVariableExpression_content) webActionView_MkwebActionView_WebNodeVariableExpression_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeVariableExpression: root of subtree no. 2 can not be made a webActionView_WebNodeVariableExpression_content node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeVariableExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeVariableExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier;
#else
	_new = (webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier));
#endif
	_new->_prod = webActionView_RULELST_webActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier;
	_new->_desc1 = (webActionView__TSPwebActionView_MD5Modifier)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeVariableExpression_modifier)_new;
	{webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier;
#else
	_new = (webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier));
#endif
	_new->_prod = webActionView_RULELST_webActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier;
	_new->_desc1 = (webActionView__TSPwebActionView_JoinModifier)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeVariableExpression_modifier)_new;
	{webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_WebNodeVariableExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_MD5Modifier)) 
		return webActionView__MkwebActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier (_coordref, webActionView_MkwebActionView_MD5Modifier (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_JoinModifier)) 
		return webActionView__MkwebActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier (_coordref, webActionView_MkwebActionView_JoinModifier (_coordref, t));
	message (DEADLY, "a pwebActionView_WebNodeVariableExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_WebNodeVariableExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_WebNodeVariableExpression_modifier)
	l =_ElempwebActionView_WebNodeVariableExpression_modifier (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_WebNodeVariableExpression_modifier)
	r = _ElempwebActionView_WebNodeVariableExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeVariableExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_WebNodeVariableExpression_modifier root;
	webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_WebNodeVariableExpression_modifier)
		t = _ElempwebActionView_WebNodeVariableExpression_modifier (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier)(((webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_WebNodeVariableExpression_modifier;
#else
list = (webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_WebNodeVariableExpression_modifier));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_WebNodeVariableExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_WebNodeVariableExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier)
	{webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_MD5ModifierpwebActionView_WebNodeVariableExpression_modifier;
	} this code has been moved to _ElempwebActionView_WebNodeVariableExpression_modifier*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier)
	{webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_JoinModifierpwebActionView_WebNodeVariableExpression_modifier;
	} this code has been moved to _ElempwebActionView_WebNodeVariableExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_WebNodeVariableExpression_modifier;
#else
root = (webActionView__TPPpwebActionView_WebNodeVariableExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeVariableExpression_modifier));
#endif
root->_prod = webActionView_RULEpwebActionView_WebNodeVariableExpression_modifier;
root->_desc1 = (webActionView__TSPLST_webActionView_WebNodeVariableExpression_modifier)list;
{ webActionView__TPPpwebActionView_WebNodeVariableExpression_modifier _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_WebNodeVariableExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeVariableExpression_content (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeVariableExpression_content (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_WebNodeVariableExpression_content _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeVariableExpression_content;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeVariableExpression_content) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeVariableExpression_content));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeVariableExpression_content;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeVariableExpression_content;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeVariableExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeSessionExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeSessionExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webActionView__TPPpwebActionView_WebNodeSessionExpression _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeSessionExpression;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeSessionExpression) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeSessionExpression));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeSessionExpression;
_currn->_desc1 = (webActionView__TSPwebActionView_WebNodeSessionExpression_modifier) webActionView_MkwebActionView_WebNodeSessionExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeSessionExpression: root of subtree no. 1 can not be made a webActionView_WebNodeSessionExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (webActionView__TSPwebActionView_WebNodeSessionExpression_content) webActionView_MkwebActionView_WebNodeSessionExpression_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebActionView_WebNodeSessionExpression: root of subtree no. 2 can not be made a webActionView_WebNodeSessionExpression_content node ", 0, _coordref);
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeSessionExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeSessionExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier;
#else
	_new = (webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier));
#endif
	_new->_prod = webActionView_RULELST_webActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier;
	_new->_desc1 = (webActionView__TSPwebActionView_MD5Modifier)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeSessionExpression_modifier)_new;
	{webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webActionView__MkwebActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webActionView__MkwebActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier _new;
#ifdef __cplusplus
	_new = new webActionView__TPLST_webActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier;
#else
	_new = (webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_webActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier));
#endif
	_new->_prod = webActionView_RULELST_webActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier;
	_new->_desc1 = (webActionView__TSPwebActionView_JoinModifier)elem;
	_new->_desc2 = (webActionView__TSPLST_webActionView_WebNodeSessionExpression_modifier)_new;
	{webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webActionView__TERMACT_LST_webActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebActionView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebActionView_WebNodeSessionExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_MD5Modifier)) 
		return webActionView__MkwebActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier (_coordref, webActionView_MkwebActionView_MD5Modifier (_coordref, t));
	if (webActionView_IsSymb (t, webActionView_SYMBwebActionView_JoinModifier)) 
		return webActionView__MkwebActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier (_coordref, webActionView_MkwebActionView_JoinModifier (_coordref, t));
	message (DEADLY, "a pwebActionView_WebNodeSessionExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mk2pwebActionView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webActionView_Mk2pwebActionView_WebNodeSessionExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webActionView_LHSMAP[l->_prod] != webActionView_SYMBLST_webActionView_WebNodeSessionExpression_modifier)
	l =_ElempwebActionView_WebNodeSessionExpression_modifier (_coordref, l);
if (webActionView_LHSMAP[r->_prod] != webActionView_SYMBLST_webActionView_WebNodeSessionExpression_modifier)
	r = _ElempwebActionView_WebNodeSessionExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier)r)->_desc2);
((webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier)r)->_desc2 = ((webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier)l)->_desc2;
((webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeSessionExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webActionView__TPPpwebActionView_WebNodeSessionExpression_modifier root;
	webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier)NULLNODEPTR;
else {	if (webActionView_LHSMAP[t->_prod] != webActionView_SYMBLST_webActionView_WebNodeSessionExpression_modifier)
		t = _ElempwebActionView_WebNodeSessionExpression_modifier (_coordref, t);
	remain = (webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier)(((webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier) t)->_desc2);
	((webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webActionView__TPLST_0pwebActionView_WebNodeSessionExpression_modifier;
#else
list = (webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPLST_0pwebActionView_WebNodeSessionExpression_modifier));
#endif
list->_prod = webActionView_RULELST_0pwebActionView_WebNodeSessionExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webActionView__TPPLST_0pwebActionView_WebNodeSessionExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webActionView_RULELST_webActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier)
	{webActionView__TPPLST_webActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_MD5ModifierpwebActionView_WebNodeSessionExpression_modifier;
	} this code has been moved to _ElempwebActionView_WebNodeSessionExpression_modifier*/
	/*if (_currn->_prod == webActionView_RULELST_webActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier)
	{webActionView__TPPLST_webActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier _currn = _currn;
	 webActionView__TERMACT_LST_webActionView_JoinModifierpwebActionView_WebNodeSessionExpression_modifier;
	} this code has been moved to _ElempwebActionView_WebNodeSessionExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webActionView__TPpwebActionView_WebNodeSessionExpression_modifier;
#else
root = (webActionView__TPPpwebActionView_WebNodeSessionExpression_modifier) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeSessionExpression_modifier));
#endif
root->_prod = webActionView_RULEpwebActionView_WebNodeSessionExpression_modifier;
root->_desc1 = (webActionView__TSPLST_webActionView_WebNodeSessionExpression_modifier)list;
{ webActionView__TPPpwebActionView_WebNodeSessionExpression_modifier _currn = root;
  _SETCOORD(_currn)
  webActionView__TERMACT_pwebActionView_WebNodeSessionExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_MkpwebActionView_WebNodeSessionExpression_content (POSITION *_coordref)
#else
NODEPTR webActionView_MkpwebActionView_WebNodeSessionExpression_content (_coordref)
	POSITION *_coordref;
#endif
{	webActionView__TPPpwebActionView_WebNodeSessionExpression_content _currn;
#ifdef __cplusplus
_currn = new webActionView__TPpwebActionView_WebNodeSessionExpression_content;
#else
_currn = (webActionView__TPPpwebActionView_WebNodeSessionExpression_content) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPpwebActionView_WebNodeSessionExpression_content));
#endif
_currn->_prod = webActionView_RULEpwebActionView_WebNodeSessionExpression_content;
_SETCOORD(_currn)
webActionView__TERMACT_pwebActionView_WebNodeSessionExpression_content;
return ( (NODEPTR) _currn);
}/* webActionView_MkpwebActionView_WebNodeSessionExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webActionView_Mkrule_1 (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR webActionView_Mkrule_1 (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	webActionView__TPPrule_1 _currn;
#ifdef __cplusplus
_currn = new webActionView__TPrule_1;
#else
_currn = (webActionView__TPPrule_1) webActionView_TreeNodeAlloc (sizeof (struct webActionView__TPrule_1));
#endif
_currn->_prod = webActionView_RULErule_1;
_currn->_desc1 = (webActionView__TSPwebActionView_ActionHandler) webActionView_MkwebActionView_ActionHandler (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE rule_1: root of subtree no. 1 can not be made a webActionView_ActionHandler node ", 0, _coordref);
_COPYCOORD(_currn)
webActionView__TERMACT_rule_1;
return ( (NODEPTR) _currn);
}/* webActionView_Mkrule_1 */
