
/* implementation of tree construction functions */

#include "webPageView_node.h"

#include "webPageView_nodecode.h"

#include "attrpredef.h"

#include "webPageView_visitmap.h"

#include "webPageView_treeact.h"

#ifdef MONITOR
#include "attr_mon_dapto.h"
#endif

#include <stdlib.h>

#define _USE_OBSTACK 1

/* use of obstack: */

#if _USE_OBSTACK

#include "obstack.h"
static struct obstack TreeSpace;
static void *_TreeBase;

#ifdef __cplusplus
void* webPageView_NODEPTR_SUB_struct::operator new(size_t size)
{
	return obstack_alloc(&TreeSpace, size);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* webPageView_TreeNodeAlloc(int size)
#else
char* webPageView_TreeNodeAlloc(size) int size;
#endif
{
	return (char *)(obstack_alloc(&TreeSpace, size));
}
#endif

void webPageView_InitTree()
{
	obstack_init(&TreeSpace);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

void webPageView_FreeTree()
{
	obstack_free(&TreeSpace, _TreeBase);
	_TreeBase=obstack_alloc(&TreeSpace,0);
}

#else

#include <stdio.h>

#ifdef __cplusplus
void* NODEPTR_struct::operator new(size_t size)
{
	void *retval = malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#else
#if defined(__STDC__) || defined(__cplusplus)
char* webPageView_TreeNodeAlloc(int size)
#else
char* webPageView_TreeNodeAlloc(size) int size;
#endif
{
	char *retval = (char *) malloc(size);
	if (retval) return retval;
	fprintf(stderr, "*** DEADLY: No more memory.\n");
	exit(1);
}
#endif

void webPageView_InitTree() { }

void webPageView_FreeTree() { }

#endif

#ifdef MONITOR
#define _SETCOORD(node) \
        node->_coord = _coordref ? *_coordref : NoCoord;
#define _COPYCOORD(node) \
        node->_coord = _currn->_desc1->_coord;
#else
#define _SETCOORD(node)
#define _COPYCOORD(node)
#endif
#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkVIEWROOT (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkVIEWROOT (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBVIEWROOT)) return (_currn);
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebPage)) return (webPageView_MkpVIEWROOT_webPageView(_coordref, _currn));
return(NULLNODEPTR);
}/* webPageView_MkVIEWROOT */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebPage (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebPage (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebPage)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebPage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularCheckboxElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularCheckboxElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularCheckboxElement_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularCheckboxElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularCheckboxElement_type)) return (_currn);
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularCheckboxElement_name)) return (webPageView_MkpwebPageView_FormularCheckboxElement_type(_coordref, _currn));
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularCheckboxElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularCheckboxElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularCheckboxElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularCheckboxElement_description)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularCheckboxElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularCheckboxElement_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularCheckboxElement_name)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularCheckboxElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DoubleRangeValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DoubleRangeValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DoubleRangeValidator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DoubleRangeValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_LongRangeValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_LongRangeValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_LongRangeValidator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_LongRangeValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_StringLengthValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_StringLengthValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_StringLengthValidator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_StringLengthValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_RegExprValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_RegExprValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_RegExprValidator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_RegExprValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_CreditCardValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_CreditCardValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_CreditCardValidator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_CreditCardValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_EmailValidator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_EmailValidator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_EmailValidator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_EmailValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularTextElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularTextElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularTextElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularTextElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularTextElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularTextElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularTextElement_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularTextElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularTextElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularTextElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularTextElement_type)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularTextElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularTextElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularTextElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularTextElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularTextElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularTextElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularTextElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularTextElement_description)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularTextElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularDateElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularDateElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularDateElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularDateElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularDateElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularDateElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularDateElement_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularDateElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularDateElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularDateElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularDateElement_type)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularDateElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularDateElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularDateElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularDateElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularDateElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularDateElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularDateElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularDateElement_description)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularDateElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularFileUploadElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularFileUploadElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularFileUploadElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularFileUploadElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularFileUploadElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularFileUploadElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularFileUploadElement_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularFileUploadElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularFileUploadElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularFileUploadElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularFileUploadElement_type)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularFileUploadElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularFileUploadElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularFileUploadElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularFileUploadElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularFileUploadElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularFileUploadElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularFileUploadElement_description)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularFileUploadElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularPasswordElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularPasswordElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularPasswordElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularPasswordElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularPasswordElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularPasswordElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularPasswordElement_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularPasswordElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularPasswordElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularPasswordElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularPasswordElement_type)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularPasswordElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularPasswordElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularPasswordElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularPasswordElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularPasswordElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularPasswordElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularPasswordElement_description)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularPasswordElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularTextAreaElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularTextAreaElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularTextAreaElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularTextAreaElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularTextAreaElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularTextAreaElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularTextAreaElement_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularTextAreaElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularTextAreaElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularTextAreaElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularTextAreaElement_type)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularTextAreaElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularTextAreaElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularTextAreaElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularTextAreaElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularTextAreaElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularTextAreaElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularTextAreaElement_description)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularTextAreaElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularSelectElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularSelectElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularSelectElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularSelectElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularSelectElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularSelectElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularSelectElement_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularSelectElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularSelectElement_multiple (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularSelectElement_multiple (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularSelectElement_multiple)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularSelectElement_multiple */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularSelectElement_options (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularSelectElement_options (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularSelectElement_options)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularSelectElement_options */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularSelectElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularSelectElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularSelectElement_description)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularSelectElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularDataSourceSelectOption (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularDataSourceSelectOption (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularDataSourceSelectOption)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularDataSourceSelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularConstantSelectOption (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularConstantSelectOption (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularConstantSelectOption)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularConstantSelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioElement_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioElement_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioElement_type)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioElement_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DataSourceActualParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DataSourceActualParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DataSourceActualParam)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DataSourceActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DataSourceActualParam_formalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DataSourceActualParam_formalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DataSourceActualParam_formalParam)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DataSourceActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DataSourceActualParam_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DataSourceActualParam_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DataSourceActualParam_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DataSourceActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DataSourceActualParam_expressions (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DataSourceActualParam_expressions)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DataSourceActualParam_expressions */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeSessionExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeSessionExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeSessionExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeSessionExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeVariableExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeVariableExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeVariableExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeVariableExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeConstantExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeConstantExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeConstantExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeActualParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeActualParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeActualParam)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeActualParam_formalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeActualParam_formalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeActualParam_formalParam)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeActualParam_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeActualParam_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeActualParam_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeActualParam_expressions (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeActualParam_expressions)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeActualParam_expressions */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeFormalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeFormalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeFormalParam)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeFormalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeFormalParam_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeFormalParam_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeFormalParam_name)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeFormalParam_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeFormalParam_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeFormalParam_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeFormalParam_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeFormalParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeFormalParam_type (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeFormalParam_type)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeFormalParam_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBBlob (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBBlob (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBBlob)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBBlob */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBBoolean (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBBoolean (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBBoolean)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBBoolean */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBTimeStamp (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBTimeStamp (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBTimeStamp)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBTimeStamp */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBDate (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBDate (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBDate)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBDate */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBBigInt (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBBigInt (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBBigInt)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBBigInt */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBDouble (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBDouble (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBDouble)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBDouble */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBFloat (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBFloat (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBFloat)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBFloat */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBLong (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBLong (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBLong)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBLong */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBInteger (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBInteger (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBInteger)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBInteger */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBText (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBText (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBText)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBText */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBString (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBString (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBString)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBString */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBHasMany (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBHasMany (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBHasMany)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBHasMany */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBHasOne (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBHasOne (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBHasOne)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBHasOne */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_MapArea (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_MapArea (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_MapArea)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_MapArea */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_MapArea_altText (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_MapArea_altText (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_MapArea_altText)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_MapArea_altText */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_MapArea_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_MapArea_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_MapArea_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_MapArea_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_MapArea_coords (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_MapArea_coords (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_MapArea_coords)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_MapArea_coords */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_MapArea_keyword2 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_MapArea_keyword2 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_MapArea_keyword2)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_MapArea_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_MapArea_link (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_MapArea_link (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_MapArea_link)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_MapArea_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_MapArea_queryString (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_MapArea_queryString (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_MapArea_queryString)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_MapArea_queryString */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBString_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBString_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBString_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBString_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBText_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBText_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBText_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBText_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBInteger_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBInteger_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBInteger_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBInteger_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBLong_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBLong_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBLong_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBLong_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBFloat_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBFloat_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBFloat_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBFloat_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBDouble_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBDouble_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBDouble_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBDouble_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBBigInt_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBBigInt_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBBigInt_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBBigInt_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBDate_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBDate_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBDate_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBDate_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBTimeStamp_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBTimeStamp_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBTimeStamp_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBTimeStamp_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBBoolean_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBBoolean_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBBoolean_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBBoolean_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBBlob_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBBlob_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBBlob_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBBlob_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBHasOne_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBHasOne_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBHasOne_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBHasOne_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBHasOne_dataSourceTable (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBHasOne_dataSourceTable (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBHasOne_dataSourceTable)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBHasOne_dataSourceTable */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBHasMany_keyword1 (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBHasMany_keyword1 (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBHasMany_keyword1)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBHasMany_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DBHasMany_dataSourceTable (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DBHasMany_dataSourceTable (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DBHasMany_dataSourceTable)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DBHasMany_dataSourceTable */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebPage_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebPage_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebPage_name)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebPage_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebPage_formalParameter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebPage_formalParameter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebPage_formalParameter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebPage_formalParameter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebPage_title (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebPage_title (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebPage_title)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebPage_title */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebPage_frame (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebPage_frame (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebPage_frame)) return (_currn);
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Frame)) return (webPageView_Mkrule_1(_coordref, _currn));
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebPage_frame */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebPage_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebPage_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebPage_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebPage_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebPage_position (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebPage_position (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebPage_position)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebPage_position */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Frame (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Frame (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Frame)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Frame */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Frame_components (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Frame_components (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Frame_components)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Frame_components */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageMap (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageMap (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageMap)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageMap */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_OutputMessagesElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_OutputMessagesElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_OutputMessagesElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_OutputMessagesElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Formular (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Formular (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Formular)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Formular */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Table (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Table (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Table)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Table */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Heading (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Heading (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Heading)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Heading */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Paragraph (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Paragraph (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Paragraph)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Paragraph */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FrameRef (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FrameRef (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FrameRef)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FrameRef */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FrameRef_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FrameRef_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FrameRef_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FrameRef_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FrameRef_frame (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FrameRef_frame (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FrameRef_frame)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FrameRef_frame */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_BinaryExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_BinaryExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_BinaryExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_BinaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_BinaryExpression_leftOperand (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_BinaryExpression_leftOperand)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_BinaryExpression_leftOperand */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_BinaryExpression_rightOperand (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_BinaryExpression_rightOperand)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_BinaryExpression_rightOperand */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_BinaryExpression_operator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_BinaryExpression_operator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_BinaryExpression_operator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_BinaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ComputationExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ComputationExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ComputationExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ComputationExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ParameterValueExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ParameterValueExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ParameterValueExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ParameterValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ProjectionColumnValueExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ProjectionColumnValueExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ProjectionColumnValueExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ProjectionColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ColumnValueExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ColumnValueExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ColumnValueExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ConstantExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ConstantExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ConstantExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_PredefinedExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_PredefinedExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_PredefinedExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_PredefinedExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_UnaryExpression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_UnaryExpression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_UnaryExpression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_UnaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_UnaryExpression_operand (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_UnaryExpression_operand)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_UnaryExpression_operand */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_UnaryExpression_operator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_UnaryExpression_operator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_UnaryExpression_operator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_UnaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_PredefinedExpression_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_PredefinedExpression_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_PredefinedExpression_value)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_PredefinedExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ConstantExpression_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ConstantExpression_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ConstantExpression_value)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ColumnValueExpression_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ColumnValueExpression_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ColumnValueExpression_column)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ProjectionColumnValueExpression_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ProjectionColumnValueExpression_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ProjectionColumnValueExpression_column)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ProjectionColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ParameterValueExpression_parameter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ParameterValueExpression_parameter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ParameterValueExpression_parameter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ParameterValueExpression_parameter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ComputationExpression_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ComputationExpression_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ComputationExpression_column)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ComputationExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ComputationExpression_computation (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ComputationExpression_computation (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ComputationExpression_computation)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ComputationExpression_computation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Paragraph_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Paragraph_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Paragraph_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Paragraph_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Paragraph_fragments (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Paragraph_fragments (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Paragraph_fragments)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Paragraph_fragments */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_OutputFragment (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_OutputFragment (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_OutputFragment)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_OutputFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageFragment (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageFragment (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageFragment)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_TextFragment (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_TextFragment (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_TextFragment)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_TextFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_TextFragment_link (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_TextFragment_link (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_TextFragment_link)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_TextFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_TextFragment_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_TextFragment_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_TextFragment_value)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_TextFragment_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_TextFragment_fontstyle (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_TextFragment_fontstyle (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_TextFragment_fontstyle)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_TextFragment_fontstyle */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageFragment_link (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageFragment_link (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageFragment_link)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageFragment_width (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageFragment_width (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageFragment_width)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageFragment_width */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageFragment_height (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageFragment_height (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageFragment_height)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageFragment_height */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageFragment_border (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageFragment_border (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageFragment_border)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageFragment_border */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageFragment_verticalAlign (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageFragment_verticalAlign (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageFragment_verticalAlign)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageFragment_verticalAlign */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageFragment_float (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageFragment_float (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageFragment_float)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageFragment_float */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageFragment_text (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageFragment_text (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageFragment_text)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageFragment_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageFragment_imageName (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageFragment_imageName (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageFragment_imageName)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageFragment_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Heading_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Heading_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Heading_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Heading_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Heading_text (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Heading_text (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Heading_text)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Heading_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Heading_level (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Heading_level (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Heading_level)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Heading_level */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Table_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Table_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Table_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Table_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Table_rows (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Table_rows (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Table_rows)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Table_rows */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Table_columns (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Table_columns (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Table_columns)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Table_columns */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_TableRow (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_TableRow (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_TableRow)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_TableRow */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_TableColumn (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_TableColumn (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_TableColumn)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_TableColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_TableRow_cells (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_TableRow_cells (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_TableRow_cells)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_TableRow_cells */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_TableCell (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_TableCell (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_TableCell)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_TableCell */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_TableCell_columnRef (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_TableCell_columnRef (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_TableCell_columnRef)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_TableCell_columnRef */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_TableCell_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_TableCell_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_TableCell_content)) return (_currn);
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Frame)) return (webPageView_Mkrule_2(_coordref, _currn));
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_TableCell_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Formular_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Formular_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Formular_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Formular_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Formular_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Formular_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Formular_name)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Formular_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Formular_action (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Formular_action (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Formular_action)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Formular_action */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Formular_dataSource (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Formular_dataSource (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Formular_dataSource)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Formular_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Formular_dataSourceId (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Formular_dataSourceId (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Formular_dataSourceId)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Formular_dataSourceId */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Formular_elements (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Formular_elements (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Formular_elements)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Formular_elements */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_Formular_actualParams (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_Formular_actualParams (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_Formular_actualParams)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_Formular_actualParams */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_RegExprValidator_pattern (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_RegExprValidator_pattern (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_RegExprValidator_pattern)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_RegExprValidator_pattern */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_StringLengthValidator_min (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_StringLengthValidator_min (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_StringLengthValidator_min)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_StringLengthValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_StringLengthValidator_max (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_StringLengthValidator_max (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_StringLengthValidator_max)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_StringLengthValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_LongRangeValidator_min (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_LongRangeValidator_min (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_LongRangeValidator_min)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_LongRangeValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_LongRangeValidator_max (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_LongRangeValidator_max (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_LongRangeValidator_max)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_LongRangeValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DoubleRangeValidator_min (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DoubleRangeValidator_min (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DoubleRangeValidator_min)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DoubleRangeValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DoubleRangeValidator_max (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DoubleRangeValidator_max (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DoubleRangeValidator_max)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DoubleRangeValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_IntegerNumberConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_IntegerNumberConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_IntegerNumberConverter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_IntegerNumberConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_IntegerNumberConverter_minIntegerDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_IntegerNumberConverter_minIntegerDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_IntegerNumberConverter_minIntegerDigits)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_IntegerNumberConverter_minIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_IntegerNumberConverter_maxIntegerDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_IntegerNumberConverter_maxIntegerDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_IntegerNumberConverter_maxIntegerDigits)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_IntegerNumberConverter_maxIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DoubleNumberConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DoubleNumberConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DoubleNumberConverter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DoubleNumberConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DoubleNumberConverter_minIntegerDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DoubleNumberConverter_minIntegerDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DoubleNumberConverter_minIntegerDigits)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DoubleNumberConverter_minIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DoubleNumberConverter_maxIntegerDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DoubleNumberConverter_maxIntegerDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DoubleNumberConverter_maxIntegerDigits)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DoubleNumberConverter_maxIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DoubleNumberConverter_minFractionDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DoubleNumberConverter_minFractionDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DoubleNumberConverter_minFractionDigits)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DoubleNumberConverter_minFractionDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DoubleNumberConverter_maxFractionDigits (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DoubleNumberConverter_maxFractionDigits (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DoubleNumberConverter_maxFractionDigits)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DoubleNumberConverter_maxFractionDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_IntegerConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_IntegerConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_IntegerConverter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_IntegerConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_LongConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_LongConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_LongConverter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_LongConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_BigIntegerConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_BigIntegerConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_BigIntegerConverter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_BigIntegerConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FloatConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FloatConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FloatConverter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FloatConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DoubleConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DoubleConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DoubleConverter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DoubleConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_BooleanConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_BooleanConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_BooleanConverter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_BooleanConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_DateTimeConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_DateTimeConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_DateTimeConverter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_DateTimeConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_PatternConverter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_PatternConverter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_PatternConverter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_PatternConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_PatternConverter_pattern (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_PatternConverter_pattern (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_PatternConverter_pattern)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_PatternConverter_pattern */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement_name)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_description (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_description (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement_description)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_pvalue (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_pvalue (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement_pvalue)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement_pvalue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_required (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_required (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement_required)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement_required */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_validator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement_validator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement_validator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_converter (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement_converter)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement_converter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_layout (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_layout (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement_layout)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement_layout */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_elements (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_elements (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement_elements)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement_elements */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_checked (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularRadioGroupElement_checked (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularRadioGroupElement_checked)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularRadioGroupElement_checked */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularConstantSelectOption_options (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularConstantSelectOption_options)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularConstantSelectOption_options */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_SelectOption (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_SelectOption (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_SelectOption)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_SelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_SelectOption_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_SelectOption_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_SelectOption_value)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_SelectOption_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_SelectOption_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_SelectOption_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_SelectOption_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_SelectOption_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularDataSourceSelectOption_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularDataSourceSelectOption_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularDataSourceSelectOption_name)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularDataSourceSelectOption_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularDataSourceSelectOption_dataSource (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularDataSourceSelectOption_dataSource (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularDataSourceSelectOption_dataSource)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularDataSourceSelectOption_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularDataSourceSelectOption_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularDataSourceSelectOption_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularDataSourceSelectOption_value)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularDataSourceSelectOption_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_FormularDataSourceSelectOption_label (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_FormularDataSourceSelectOption_label (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_FormularDataSourceSelectOption_label)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_FormularDataSourceSelectOption_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_MD5Modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_MD5Modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_MD5Modifier)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_MD5Modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_JoinModifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_JoinModifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_JoinModifier)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_JoinModifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_JoinModifier_separator (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_JoinModifier_separator (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_JoinModifier_separator)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_JoinModifier_separator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeConstantExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeConstantExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeConstantExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeConstantExpression_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeConstantExpression_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeConstantExpression_value)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeVariableExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeVariableExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeVariableExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeVariableExpression_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeVariableExpression_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeVariableExpression_content)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeVariableExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeSessionExpression_modifier (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeSessionExpression_modifier)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeSessionExpression_modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_WebNodeSessionExpression_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_WebNodeSessionExpression_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_WebNodeSessionExpression_content)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_WebNodeSessionExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_OutputFragment_link (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_OutputFragment_link (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_OutputFragment_link)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_OutputFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_OutputFragment_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_OutputFragment_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_OutputFragment_content)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_OutputFragment_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_OutputMessagesElement_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_OutputMessagesElement_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_OutputMessagesElement_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_OutputMessagesElement_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_OutputMessagesElement_errorStyleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_OutputMessagesElement_errorStyleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_OutputMessagesElement_errorStyleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_OutputMessagesElement_errorStyleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_OutputMessagesElement_infoStyleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_OutputMessagesElement_infoStyleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_OutputMessagesElement_infoStyleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_OutputMessagesElement_infoStyleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_OutputMessagesElement_layout (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_OutputMessagesElement_layout (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_OutputMessagesElement_layout)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_OutputMessagesElement_layout */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputActualParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputActualParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputActualParam)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputActualParam_formalParam (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputActualParam_formalParam (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputActualParam_formalParam)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputActualParam_expression (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputActualParam_expression)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputActualParam_expression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_name)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_dataSourceActualParams (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_dataSourceActualParams)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_dataSourceActualParams */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_dataSource (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_dataSource (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_dataSource)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_maxNumberOfElements (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_maxNumberOfElements (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_maxNumberOfElements)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_maxNumberOfElements */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_renderAs (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_renderAs (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_renderAs)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_renderAs */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_navigationElement (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_navigationElement (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_navigationElement)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_navigationElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_columns (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_columns (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_columns)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_columns */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_headerStyleClass (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_headerStyleClass (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_headerStyleClass)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_headerStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_evenRowStyleClass (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_evenRowStyleClass (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_evenRowStyleClass)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_evenRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputElement_oddRowStyleClass (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputElement_oddRowStyleClass (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputElement_oddRowStyleClass)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputElement_oddRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputColumn (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputColumn (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputColumn)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputColumn_header (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputColumn_header (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputColumn_header)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputColumn_header */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputColumn_content (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputColumn_content (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputColumn_content)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputColumn_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputActionConnectionsContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputActionConnectionsContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputActionConnectionsContent)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputActionConnectionsContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputNumerationContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputNumerationContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputNumerationContent)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputNumerationContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputProjectionContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputProjectionContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputProjectionContent)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputProjectionContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputRefContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputRefContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputRefContent)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputRefContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputConstantContent (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputConstantContent (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputConstantContent)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputConstantContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputConstantContent_value (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputConstantContent_value (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputConstantContent_value)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputConstantContent_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputRefContent_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputRefContent_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputRefContent_column)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputRefContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputProjectionContent_column (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputProjectionContent_column (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputProjectionContent_column)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputProjectionContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputNumerationContent_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputNumerationContent_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputNumerationContent_name)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputNumerationContent_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ListOutputActionConnectionsContent_actionConnections (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ListOutputActionConnectionsContent_actionConnections)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ListOutputActionConnectionsContent_actionConnections */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ActionConnection (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ActionConnection (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ActionConnection)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ActionConnection */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ActionConnection_action (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ActionConnection_action (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ActionConnection_action)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ActionConnection_action */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ActionConnection_imageName (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ActionConnection_imageName (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ActionConnection_imageName)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ActionConnection_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ActionConnection_text (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ActionConnection_text (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ActionConnection_text)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ActionConnection_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ActionConnection_actualParams (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ActionConnection_actualParams)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ActionConnection_actualParams */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageMap_styleSheetBlock (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageMap_styleSheetBlock (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageMap_styleSheetBlock)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageMap_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageMap_name (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageMap_name (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageMap_name)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageMap_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageMap_imageName (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageMap_imageName (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageMap_imageName)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageMap_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageMap_altText (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageMap_altText (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageMap_altText)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageMap_altText */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkwebPageView_ImageMap_mapAreas (POSITION *_coordref, NODEPTR _currn)
#else
NODEPTR webPageView_MkwebPageView_ImageMap_mapAreas (_coordref, _currn)
	POSITION *_coordref; NODEPTR _currn;
#endif
{
if (_currn == NULLNODEPTR) return NULLNODEPTR;
if (webPageView_IsSymb (_currn, webPageView_SYMBwebPageView_ImageMap_mapAreas)) return (_currn);
return(NULLNODEPTR);
}/* webPageView_MkwebPageView_ImageMap_mapAreas */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpEmpty (POSITION *_coordref)
#else
NODEPTR webPageView_MkpEmpty (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpEmpty _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpEmpty;
#else
_currn = (webPageView__TPPpEmpty) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpEmpty));
#endif
_currn->_prod = webPageView_RULEpEmpty;
_SETCOORD(_currn)
webPageView__TERMACT_pEmpty;
return ( (NODEPTR) _currn);
}/* webPageView_MkpEmpty */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpVIEWROOT_webPageView (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpVIEWROOT_webPageView (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpVIEWROOT_webPageView _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpVIEWROOT_webPageView;
#else
_currn = (webPageView__TPPpVIEWROOT_webPageView) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpVIEWROOT_webPageView));
#endif
_currn->_prod = webPageView_RULEpVIEWROOT_webPageView;
_currn->_desc1 = (webPageView__TSPwebPageView_WebPage) webPageView_MkwebPageView_WebPage (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pVIEWROOT_webPageView: root of subtree no. 1 can not be made a webPageView_WebPage node ", 0, _coordref);
_COPYCOORD(_currn)
webPageView__TERMACT_pVIEWROOT_webPageView;
return ( (NODEPTR) _currn);
}/* webPageView_MkpVIEWROOT_webPageView */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_FormularCheckboxElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularCheckboxElement;
#else
_currn = (webPageView__TPPpwebPageView_FormularCheckboxElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularCheckboxElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularCheckboxElement;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularCheckboxElement_label) webPageView_MkwebPageView_FormularCheckboxElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularCheckboxElement: root of subtree no. 1 can not be made a webPageView_FormularCheckboxElement_label node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FormularCheckboxElement_type) webPageView_MkwebPageView_FormularCheckboxElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularCheckboxElement: root of subtree no. 2 can not be made a webPageView_FormularCheckboxElement_type node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_FormularCheckboxElement_validator) webPageView_MkwebPageView_FormularCheckboxElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularCheckboxElement: root of subtree no. 3 can not be made a webPageView_FormularCheckboxElement_validator node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_FormularCheckboxElement_description) webPageView_MkwebPageView_FormularCheckboxElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularCheckboxElement: root of subtree no. 4 can not be made a webPageView_FormularCheckboxElement_description node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularCheckboxElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularCheckboxElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularCheckboxElement_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularCheckboxElement_label;
#else
_currn = (webPageView__TPPpwebPageView_FormularCheckboxElement_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularCheckboxElement_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularCheckboxElement_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularCheckboxElement_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularCheckboxElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement_name (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement_name (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularCheckboxElement_name _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularCheckboxElement_name;
#else
_currn = (webPageView__TPPpwebPageView_FormularCheckboxElement_name) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularCheckboxElement_name));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularCheckboxElement_name;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularCheckboxElement_name;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularCheckboxElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement_type (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement_type (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_FormularCheckboxElement_type _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularCheckboxElement_type;
#else
_currn = (webPageView__TPPpwebPageView_FormularCheckboxElement_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularCheckboxElement_type));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularCheckboxElement_type;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularCheckboxElement_name) webPageView_MkwebPageView_FormularCheckboxElement_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularCheckboxElement_type: root of subtree no. 1 can not be made a webPageView_FormularCheckboxElement_name node ", 0, _coordref);
_COPYCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularCheckboxElement_type;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularCheckboxElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_EmailValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularCheckboxElement_validator)_new;
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_CreditCardValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularCheckboxElement_validator)_new;
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_RegExprValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularCheckboxElement_validator)_new;
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_StringLengthValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularCheckboxElement_validator)_new;
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_LongRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularCheckboxElement_validator)_new;
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_DoubleRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularCheckboxElement_validator)_new;
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularCheckboxElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_EmailValidator)) 
		return webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, webPageView_MkwebPageView_EmailValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_CreditCardValidator)) 
		return webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, webPageView_MkwebPageView_CreditCardValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_RegExprValidator)) 
		return webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, webPageView_MkwebPageView_RegExprValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_StringLengthValidator)) 
		return webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, webPageView_MkwebPageView_StringLengthValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_LongRangeValidator)) 
		return webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, webPageView_MkwebPageView_LongRangeValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DoubleRangeValidator)) 
		return webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator (_coordref, webPageView_MkwebPageView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularCheckboxElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularCheckboxElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularCheckboxElement_validator)
	l =_ElempwebPageView_FormularCheckboxElement_validator (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularCheckboxElement_validator)
	r = _ElempwebPageView_FormularCheckboxElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularCheckboxElement_validator root;
	webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularCheckboxElement_validator)
		t = _ElempwebPageView_FormularCheckboxElement_validator (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator)(((webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularCheckboxElement_validator;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularCheckboxElement_validator));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularCheckboxElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularCheckboxElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator)
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempwebPageView_FormularCheckboxElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator)
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempwebPageView_FormularCheckboxElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator)
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempwebPageView_FormularCheckboxElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator)
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempwebPageView_FormularCheckboxElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator)
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempwebPageView_FormularCheckboxElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator)
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularCheckboxElement_validator;
	} this code has been moved to _ElempwebPageView_FormularCheckboxElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularCheckboxElement_validator;
#else
root = (webPageView__TPPpwebPageView_FormularCheckboxElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularCheckboxElement_validator));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularCheckboxElement_validator;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularCheckboxElement_validator)list;
{ webPageView__TPPpwebPageView_FormularCheckboxElement_validator _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularCheckboxElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement_description (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularCheckboxElement_description (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularCheckboxElement_description _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularCheckboxElement_description;
#else
_currn = (webPageView__TPPpwebPageView_FormularCheckboxElement_description) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularCheckboxElement_description));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularCheckboxElement_description;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularCheckboxElement_description;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularCheckboxElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularTextElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_FormularTextElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_FormularTextElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularTextElement;
#else
_currn = (webPageView__TPPpwebPageView_FormularTextElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularTextElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularTextElement;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularTextElement_label) webPageView_MkwebPageView_FormularTextElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularTextElement: root of subtree no. 1 can not be made a webPageView_FormularTextElement_label node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FormularTextElement_type) webPageView_MkwebPageView_FormularTextElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularTextElement: root of subtree no. 2 can not be made a webPageView_FormularTextElement_type node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_FormularTextElement_validator) webPageView_MkwebPageView_FormularTextElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularTextElement: root of subtree no. 3 can not be made a webPageView_FormularTextElement_validator node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_FormularTextElement_description) webPageView_MkwebPageView_FormularTextElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularTextElement: root of subtree no. 4 can not be made a webPageView_FormularTextElement_description node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularTextElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularTextElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularTextElement_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularTextElement_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularTextElement_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularTextElement_label;
#else
_currn = (webPageView__TPPpwebPageView_FormularTextElement_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularTextElement_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularTextElement_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularTextElement_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularTextElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularTextElement_type (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularTextElement_type (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularTextElement_type _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularTextElement_type;
#else
_currn = (webPageView__TPPpwebPageView_FormularTextElement_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularTextElement_type));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularTextElement_type;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularTextElement_type;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularTextElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularTextElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularTextElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularTextElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularTextElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_EmailValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextElement_validator)_new;
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_CreditCardValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextElement_validator)_new;
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularTextElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularTextElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularTextElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularTextElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_RegExprValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextElement_validator)_new;
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_StringLengthValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextElement_validator)_new;
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_LongRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextElement_validator)_new;
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_DoubleRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextElement_validator)_new;
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularTextElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularTextElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_EmailValidator)) 
		return webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularTextElement_validator (_coordref, webPageView_MkwebPageView_EmailValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_CreditCardValidator)) 
		return webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator (_coordref, webPageView_MkwebPageView_CreditCardValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_RegExprValidator)) 
		return webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularTextElement_validator (_coordref, webPageView_MkwebPageView_RegExprValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_StringLengthValidator)) 
		return webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator (_coordref, webPageView_MkwebPageView_StringLengthValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_LongRangeValidator)) 
		return webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator (_coordref, webPageView_MkwebPageView_LongRangeValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DoubleRangeValidator)) 
		return webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator (_coordref, webPageView_MkwebPageView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularTextElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularTextElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularTextElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularTextElement_validator)
	l =_ElempwebPageView_FormularTextElement_validator (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularTextElement_validator)
	r = _ElempwebPageView_FormularTextElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularTextElement_validator)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularTextElement_validator)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularTextElement_validator)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularTextElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularTextElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularTextElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularTextElement_validator root;
	webPageView__TPPLST_0pwebPageView_FormularTextElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularTextElement_validator)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularTextElement_validator)
		t = _ElempwebPageView_FormularTextElement_validator (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularTextElement_validator)(((webPageView__TPPLST_0pwebPageView_FormularTextElement_validator) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularTextElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularTextElement_validator;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularTextElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularTextElement_validator));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularTextElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularTextElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularTextElement_validator)
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularTextElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularTextElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator)
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularTextElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularTextElement_validator)
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularTextElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularTextElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator)
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularTextElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator)
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularTextElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator)
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularTextElement_validator;
#else
root = (webPageView__TPPpwebPageView_FormularTextElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularTextElement_validator));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularTextElement_validator;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularTextElement_validator)list;
{ webPageView__TPPpwebPageView_FormularTextElement_validator _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularTextElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularTextElement_description (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularTextElement_description (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularTextElement_description _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularTextElement_description;
#else
_currn = (webPageView__TPPpwebPageView_FormularTextElement_description) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularTextElement_description));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularTextElement_description;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularTextElement_description;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularTextElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularDateElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_FormularDateElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_FormularDateElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularDateElement;
#else
_currn = (webPageView__TPPpwebPageView_FormularDateElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularDateElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularDateElement;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularDateElement_label) webPageView_MkwebPageView_FormularDateElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularDateElement: root of subtree no. 1 can not be made a webPageView_FormularDateElement_label node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FormularDateElement_type) webPageView_MkwebPageView_FormularDateElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularDateElement: root of subtree no. 2 can not be made a webPageView_FormularDateElement_type node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_FormularDateElement_validator) webPageView_MkwebPageView_FormularDateElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularDateElement: root of subtree no. 3 can not be made a webPageView_FormularDateElement_validator node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_FormularDateElement_description) webPageView_MkwebPageView_FormularDateElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularDateElement: root of subtree no. 4 can not be made a webPageView_FormularDateElement_description node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularDateElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularDateElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularDateElement_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularDateElement_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularDateElement_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularDateElement_label;
#else
_currn = (webPageView__TPPpwebPageView_FormularDateElement_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularDateElement_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularDateElement_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularDateElement_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularDateElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularDateElement_type (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularDateElement_type (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularDateElement_type _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularDateElement_type;
#else
_currn = (webPageView__TPPpwebPageView_FormularDateElement_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularDateElement_type));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularDateElement_type;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularDateElement_type;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularDateElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularDateElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularDateElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularDateElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularDateElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_EmailValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularDateElement_validator)_new;
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_CreditCardValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularDateElement_validator)_new;
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularDateElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularDateElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularDateElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularDateElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_RegExprValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularDateElement_validator)_new;
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_StringLengthValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularDateElement_validator)_new;
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_LongRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularDateElement_validator)_new;
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_DoubleRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularDateElement_validator)_new;
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularDateElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularDateElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_EmailValidator)) 
		return webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularDateElement_validator (_coordref, webPageView_MkwebPageView_EmailValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_CreditCardValidator)) 
		return webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator (_coordref, webPageView_MkwebPageView_CreditCardValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_RegExprValidator)) 
		return webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularDateElement_validator (_coordref, webPageView_MkwebPageView_RegExprValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_StringLengthValidator)) 
		return webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator (_coordref, webPageView_MkwebPageView_StringLengthValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_LongRangeValidator)) 
		return webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator (_coordref, webPageView_MkwebPageView_LongRangeValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DoubleRangeValidator)) 
		return webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator (_coordref, webPageView_MkwebPageView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularDateElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularDateElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularDateElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularDateElement_validator)
	l =_ElempwebPageView_FormularDateElement_validator (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularDateElement_validator)
	r = _ElempwebPageView_FormularDateElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularDateElement_validator)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularDateElement_validator)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularDateElement_validator)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularDateElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularDateElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularDateElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularDateElement_validator root;
	webPageView__TPPLST_0pwebPageView_FormularDateElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularDateElement_validator)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularDateElement_validator)
		t = _ElempwebPageView_FormularDateElement_validator (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularDateElement_validator)(((webPageView__TPPLST_0pwebPageView_FormularDateElement_validator) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularDateElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularDateElement_validator;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularDateElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularDateElement_validator));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularDateElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularDateElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularDateElement_validator)
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularDateElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularDateElement_validator;
	} this code has been moved to _ElempwebPageView_FormularDateElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator)
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularDateElement_validator;
	} this code has been moved to _ElempwebPageView_FormularDateElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularDateElement_validator)
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularDateElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularDateElement_validator;
	} this code has been moved to _ElempwebPageView_FormularDateElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator)
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularDateElement_validator;
	} this code has been moved to _ElempwebPageView_FormularDateElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator)
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularDateElement_validator;
	} this code has been moved to _ElempwebPageView_FormularDateElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator)
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularDateElement_validator;
	} this code has been moved to _ElempwebPageView_FormularDateElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularDateElement_validator;
#else
root = (webPageView__TPPpwebPageView_FormularDateElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularDateElement_validator));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularDateElement_validator;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularDateElement_validator)list;
{ webPageView__TPPpwebPageView_FormularDateElement_validator _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularDateElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularDateElement_description (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularDateElement_description (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularDateElement_description _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularDateElement_description;
#else
_currn = (webPageView__TPPpwebPageView_FormularDateElement_description) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularDateElement_description));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularDateElement_description;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularDateElement_description;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularDateElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularFileUploadElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_FormularFileUploadElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_FormularFileUploadElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularFileUploadElement;
#else
_currn = (webPageView__TPPpwebPageView_FormularFileUploadElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularFileUploadElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularFileUploadElement;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularFileUploadElement_label) webPageView_MkwebPageView_FormularFileUploadElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularFileUploadElement: root of subtree no. 1 can not be made a webPageView_FormularFileUploadElement_label node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FormularFileUploadElement_type) webPageView_MkwebPageView_FormularFileUploadElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularFileUploadElement: root of subtree no. 2 can not be made a webPageView_FormularFileUploadElement_type node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_FormularFileUploadElement_validator) webPageView_MkwebPageView_FormularFileUploadElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularFileUploadElement: root of subtree no. 3 can not be made a webPageView_FormularFileUploadElement_validator node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_FormularFileUploadElement_description) webPageView_MkwebPageView_FormularFileUploadElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularFileUploadElement: root of subtree no. 4 can not be made a webPageView_FormularFileUploadElement_description node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularFileUploadElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularFileUploadElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularFileUploadElement_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularFileUploadElement_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularFileUploadElement_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularFileUploadElement_label;
#else
_currn = (webPageView__TPPpwebPageView_FormularFileUploadElement_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularFileUploadElement_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularFileUploadElement_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularFileUploadElement_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularFileUploadElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularFileUploadElement_type (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularFileUploadElement_type (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularFileUploadElement_type _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularFileUploadElement_type;
#else
_currn = (webPageView__TPPpwebPageView_FormularFileUploadElement_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularFileUploadElement_type));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularFileUploadElement_type;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularFileUploadElement_type;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularFileUploadElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_EmailValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularFileUploadElement_validator)_new;
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_CreditCardValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularFileUploadElement_validator)_new;
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_RegExprValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularFileUploadElement_validator)_new;
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_StringLengthValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularFileUploadElement_validator)_new;
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_LongRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularFileUploadElement_validator)_new;
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_DoubleRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularFileUploadElement_validator)_new;
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularFileUploadElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_EmailValidator)) 
		return webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, webPageView_MkwebPageView_EmailValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_CreditCardValidator)) 
		return webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, webPageView_MkwebPageView_CreditCardValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_RegExprValidator)) 
		return webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, webPageView_MkwebPageView_RegExprValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_StringLengthValidator)) 
		return webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, webPageView_MkwebPageView_StringLengthValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_LongRangeValidator)) 
		return webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, webPageView_MkwebPageView_LongRangeValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DoubleRangeValidator)) 
		return webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator (_coordref, webPageView_MkwebPageView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularFileUploadElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularFileUploadElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularFileUploadElement_validator)
	l =_ElempwebPageView_FormularFileUploadElement_validator (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularFileUploadElement_validator)
	r = _ElempwebPageView_FormularFileUploadElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularFileUploadElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularFileUploadElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularFileUploadElement_validator root;
	webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularFileUploadElement_validator)
		t = _ElempwebPageView_FormularFileUploadElement_validator (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator)(((webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularFileUploadElement_validator;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularFileUploadElement_validator));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularFileUploadElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularFileUploadElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator)
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempwebPageView_FormularFileUploadElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator)
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempwebPageView_FormularFileUploadElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator)
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempwebPageView_FormularFileUploadElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator)
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempwebPageView_FormularFileUploadElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator)
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempwebPageView_FormularFileUploadElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator)
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularFileUploadElement_validator;
	} this code has been moved to _ElempwebPageView_FormularFileUploadElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularFileUploadElement_validator;
#else
root = (webPageView__TPPpwebPageView_FormularFileUploadElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularFileUploadElement_validator));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularFileUploadElement_validator;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularFileUploadElement_validator)list;
{ webPageView__TPPpwebPageView_FormularFileUploadElement_validator _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularFileUploadElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularFileUploadElement_description (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularFileUploadElement_description (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularFileUploadElement_description _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularFileUploadElement_description;
#else
_currn = (webPageView__TPPpwebPageView_FormularFileUploadElement_description) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularFileUploadElement_description));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularFileUploadElement_description;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularFileUploadElement_description;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularFileUploadElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularPasswordElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_FormularPasswordElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_FormularPasswordElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularPasswordElement;
#else
_currn = (webPageView__TPPpwebPageView_FormularPasswordElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularPasswordElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularPasswordElement;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularPasswordElement_label) webPageView_MkwebPageView_FormularPasswordElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularPasswordElement: root of subtree no. 1 can not be made a webPageView_FormularPasswordElement_label node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FormularPasswordElement_type) webPageView_MkwebPageView_FormularPasswordElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularPasswordElement: root of subtree no. 2 can not be made a webPageView_FormularPasswordElement_type node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_FormularPasswordElement_validator) webPageView_MkwebPageView_FormularPasswordElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularPasswordElement: root of subtree no. 3 can not be made a webPageView_FormularPasswordElement_validator node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_FormularPasswordElement_description) webPageView_MkwebPageView_FormularPasswordElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularPasswordElement: root of subtree no. 4 can not be made a webPageView_FormularPasswordElement_description node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularPasswordElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularPasswordElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularPasswordElement_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularPasswordElement_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularPasswordElement_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularPasswordElement_label;
#else
_currn = (webPageView__TPPpwebPageView_FormularPasswordElement_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularPasswordElement_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularPasswordElement_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularPasswordElement_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularPasswordElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularPasswordElement_type (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularPasswordElement_type (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularPasswordElement_type _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularPasswordElement_type;
#else
_currn = (webPageView__TPPpwebPageView_FormularPasswordElement_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularPasswordElement_type));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularPasswordElement_type;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularPasswordElement_type;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularPasswordElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_EmailValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularPasswordElement_validator)_new;
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_CreditCardValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularPasswordElement_validator)_new;
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_RegExprValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularPasswordElement_validator)_new;
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_StringLengthValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularPasswordElement_validator)_new;
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_LongRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularPasswordElement_validator)_new;
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_DoubleRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularPasswordElement_validator)_new;
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularPasswordElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_EmailValidator)) 
		return webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator (_coordref, webPageView_MkwebPageView_EmailValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_CreditCardValidator)) 
		return webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator (_coordref, webPageView_MkwebPageView_CreditCardValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_RegExprValidator)) 
		return webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator (_coordref, webPageView_MkwebPageView_RegExprValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_StringLengthValidator)) 
		return webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator (_coordref, webPageView_MkwebPageView_StringLengthValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_LongRangeValidator)) 
		return webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator (_coordref, webPageView_MkwebPageView_LongRangeValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DoubleRangeValidator)) 
		return webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator (_coordref, webPageView_MkwebPageView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularPasswordElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularPasswordElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularPasswordElement_validator)
	l =_ElempwebPageView_FormularPasswordElement_validator (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularPasswordElement_validator)
	r = _ElempwebPageView_FormularPasswordElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularPasswordElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularPasswordElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularPasswordElement_validator root;
	webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularPasswordElement_validator)
		t = _ElempwebPageView_FormularPasswordElement_validator (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator)(((webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularPasswordElement_validator;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularPasswordElement_validator));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularPasswordElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularPasswordElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator)
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularPasswordElement_validator;
	} this code has been moved to _ElempwebPageView_FormularPasswordElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator)
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularPasswordElement_validator;
	} this code has been moved to _ElempwebPageView_FormularPasswordElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator)
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularPasswordElement_validator;
	} this code has been moved to _ElempwebPageView_FormularPasswordElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator)
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularPasswordElement_validator;
	} this code has been moved to _ElempwebPageView_FormularPasswordElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator)
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularPasswordElement_validator;
	} this code has been moved to _ElempwebPageView_FormularPasswordElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator)
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularPasswordElement_validator;
	} this code has been moved to _ElempwebPageView_FormularPasswordElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularPasswordElement_validator;
#else
root = (webPageView__TPPpwebPageView_FormularPasswordElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularPasswordElement_validator));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularPasswordElement_validator;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularPasswordElement_validator)list;
{ webPageView__TPPpwebPageView_FormularPasswordElement_validator _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularPasswordElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularPasswordElement_description (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularPasswordElement_description (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularPasswordElement_description _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularPasswordElement_description;
#else
_currn = (webPageView__TPPpwebPageView_FormularPasswordElement_description) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularPasswordElement_description));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularPasswordElement_description;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularPasswordElement_description;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularPasswordElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularTextAreaElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_FormularTextAreaElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_FormularTextAreaElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularTextAreaElement;
#else
_currn = (webPageView__TPPpwebPageView_FormularTextAreaElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularTextAreaElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularTextAreaElement;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularTextAreaElement_label) webPageView_MkwebPageView_FormularTextAreaElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularTextAreaElement: root of subtree no. 1 can not be made a webPageView_FormularTextAreaElement_label node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FormularTextAreaElement_type) webPageView_MkwebPageView_FormularTextAreaElement_type (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularTextAreaElement: root of subtree no. 2 can not be made a webPageView_FormularTextAreaElement_type node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_FormularTextAreaElement_validator) webPageView_MkwebPageView_FormularTextAreaElement_validator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularTextAreaElement: root of subtree no. 3 can not be made a webPageView_FormularTextAreaElement_validator node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_FormularTextAreaElement_description) webPageView_MkwebPageView_FormularTextAreaElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularTextAreaElement: root of subtree no. 4 can not be made a webPageView_FormularTextAreaElement_description node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularTextAreaElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularTextAreaElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularTextAreaElement_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularTextAreaElement_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularTextAreaElement_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularTextAreaElement_label;
#else
_currn = (webPageView__TPPpwebPageView_FormularTextAreaElement_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularTextAreaElement_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularTextAreaElement_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularTextAreaElement_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularTextAreaElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularTextAreaElement_type (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularTextAreaElement_type (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularTextAreaElement_type _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularTextAreaElement_type;
#else
_currn = (webPageView__TPPpwebPageView_FormularTextAreaElement_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularTextAreaElement_type));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularTextAreaElement_type;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularTextAreaElement_type;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularTextAreaElement_type */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_EmailValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextAreaElement_validator)_new;
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_CreditCardValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextAreaElement_validator)_new;
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_RegExprValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextAreaElement_validator)_new;
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_StringLengthValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextAreaElement_validator)_new;
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_LongRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextAreaElement_validator)_new;
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_DoubleRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularTextAreaElement_validator)_new;
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularTextAreaElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_EmailValidator)) 
		return webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, webPageView_MkwebPageView_EmailValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_CreditCardValidator)) 
		return webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, webPageView_MkwebPageView_CreditCardValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_RegExprValidator)) 
		return webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, webPageView_MkwebPageView_RegExprValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_StringLengthValidator)) 
		return webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, webPageView_MkwebPageView_StringLengthValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_LongRangeValidator)) 
		return webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, webPageView_MkwebPageView_LongRangeValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DoubleRangeValidator)) 
		return webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator (_coordref, webPageView_MkwebPageView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularTextAreaElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularTextAreaElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularTextAreaElement_validator)
	l =_ElempwebPageView_FormularTextAreaElement_validator (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularTextAreaElement_validator)
	r = _ElempwebPageView_FormularTextAreaElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularTextAreaElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularTextAreaElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularTextAreaElement_validator root;
	webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularTextAreaElement_validator)
		t = _ElempwebPageView_FormularTextAreaElement_validator (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator)(((webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularTextAreaElement_validator;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularTextAreaElement_validator));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularTextAreaElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularTextAreaElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator)
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextAreaElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator)
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextAreaElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator)
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextAreaElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator)
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextAreaElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator)
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextAreaElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator)
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularTextAreaElement_validator;
	} this code has been moved to _ElempwebPageView_FormularTextAreaElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularTextAreaElement_validator;
#else
root = (webPageView__TPPpwebPageView_FormularTextAreaElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularTextAreaElement_validator));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularTextAreaElement_validator;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularTextAreaElement_validator)list;
{ webPageView__TPPpwebPageView_FormularTextAreaElement_validator _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularTextAreaElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularTextAreaElement_description (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularTextAreaElement_description (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularTextAreaElement_description _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularTextAreaElement_description;
#else
_currn = (webPageView__TPPpwebPageView_FormularTextAreaElement_description) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularTextAreaElement_description));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularTextAreaElement_description;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularTextAreaElement_description;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularTextAreaElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularSelectElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_FormularSelectElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_FormularSelectElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularSelectElement;
#else
_currn = (webPageView__TPPpwebPageView_FormularSelectElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularSelectElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularSelectElement;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularSelectElement_label) webPageView_MkwebPageView_FormularSelectElement_label (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularSelectElement: root of subtree no. 1 can not be made a webPageView_FormularSelectElement_label node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FormularSelectElement_multiple) webPageView_MkwebPageView_FormularSelectElement_multiple (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularSelectElement: root of subtree no. 2 can not be made a webPageView_FormularSelectElement_multiple node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_FormularSelectElement_options) webPageView_MkwebPageView_FormularSelectElement_options (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularSelectElement: root of subtree no. 3 can not be made a webPageView_FormularSelectElement_options node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_FormularSelectElement_description) webPageView_MkwebPageView_FormularSelectElement_description (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularSelectElement: root of subtree no. 4 can not be made a webPageView_FormularSelectElement_description node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularSelectElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularSelectElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularSelectElement_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularSelectElement_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularSelectElement_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularSelectElement_label;
#else
_currn = (webPageView__TPPpwebPageView_FormularSelectElement_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularSelectElement_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularSelectElement_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularSelectElement_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularSelectElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularSelectElement_multiple (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularSelectElement_multiple (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularSelectElement_multiple _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularSelectElement_multiple;
#else
_currn = (webPageView__TPPpwebPageView_FormularSelectElement_multiple) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularSelectElement_multiple));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularSelectElement_multiple;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularSelectElement_multiple;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularSelectElement_multiple */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options;
#else
	_new = (webPageView__TPPLST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularConstantSelectOption)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularSelectElement_options)_new;
	{webPageView__TPPLST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options;
#else
	_new = (webPageView__TPPLST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularDataSourceSelectOption)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularSelectElement_options)_new;
	{webPageView__TPPLST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularSelectElement_options (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularSelectElement_options (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularConstantSelectOption)) 
		return webPageView__MkwebPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options (_coordref, webPageView_MkwebPageView_FormularConstantSelectOption (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularDataSourceSelectOption)) 
		return webPageView__MkwebPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options (_coordref, webPageView_MkwebPageView_FormularDataSourceSelectOption (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularSelectElement_options list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularSelectElement_options (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularSelectElement_options (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularSelectElement_options)
	l =_ElempwebPageView_FormularSelectElement_options (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularSelectElement_options)
	r = _ElempwebPageView_FormularSelectElement_options (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularSelectElement_options)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularSelectElement_options)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularSelectElement_options)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularSelectElement_options)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularSelectElement_options (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularSelectElement_options (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularSelectElement_options root;
	webPageView__TPPLST_0pwebPageView_FormularSelectElement_options list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularSelectElement_options)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularSelectElement_options)
		t = _ElempwebPageView_FormularSelectElement_options (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularSelectElement_options)(((webPageView__TPPLST_0pwebPageView_FormularSelectElement_options) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularSelectElement_options) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularSelectElement_options;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularSelectElement_options) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularSelectElement_options));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularSelectElement_options;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularSelectElement_options)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options)
	{webPageView__TPPLST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularConstantSelectOptionpwebPageView_FormularSelectElement_options;
	} this code has been moved to _ElempwebPageView_FormularSelectElement_options*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options)
	{webPageView__TPPLST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularDataSourceSelectOptionpwebPageView_FormularSelectElement_options;
	} this code has been moved to _ElempwebPageView_FormularSelectElement_options*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularSelectElement_options;
#else
root = (webPageView__TPPpwebPageView_FormularSelectElement_options) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularSelectElement_options));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularSelectElement_options;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularSelectElement_options)list;
{ webPageView__TPPpwebPageView_FormularSelectElement_options _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularSelectElement_options;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularSelectElement_description (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularSelectElement_description (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularSelectElement_description _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularSelectElement_description;
#else
_currn = (webPageView__TPPpwebPageView_FormularSelectElement_description) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularSelectElement_description));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularSelectElement_description;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularSelectElement_description;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularSelectElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioElement (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_FormularRadioElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioElement;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioElement;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularRadioElement_type) webPageView_MkwebPageView_FormularRadioElement_type (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioElement: root of subtree no. 1 can not be made a webPageView_FormularRadioElement_type node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FormularRadioElement_label) webPageView_MkwebPageView_FormularRadioElement_label (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioElement: root of subtree no. 2 can not be made a webPageView_FormularRadioElement_label node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioElement_type (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioElement_type (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularRadioElement_type _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioElement_type;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioElement_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioElement_type));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioElement_type;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioElement_type;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioElement_type */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioElement_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioElement_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularRadioElement_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioElement_label;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioElement_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioElement_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioElement_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioElement_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DataSourceActualParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR webPageView_MkpwebPageView_DataSourceActualParam (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	webPageView__TPPpwebPageView_DataSourceActualParam _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DataSourceActualParam;
#else
_currn = (webPageView__TPPpwebPageView_DataSourceActualParam) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DataSourceActualParam));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DataSourceActualParam;
_currn->_desc1 = (webPageView__TSPwebPageView_DataSourceActualParam_formalParam) webPageView_MkwebPageView_DataSourceActualParam_formalParam (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DataSourceActualParam: root of subtree no. 1 can not be made a webPageView_DataSourceActualParam_formalParam node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_DataSourceActualParam_keyword1) webPageView_MkwebPageView_DataSourceActualParam_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DataSourceActualParam: root of subtree no. 2 can not be made a webPageView_DataSourceActualParam_keyword1 node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_DataSourceActualParam_expressions) webPageView_MkwebPageView_DataSourceActualParam_expressions (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DataSourceActualParam: root of subtree no. 3 can not be made a webPageView_DataSourceActualParam_expressions node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DataSourceActualParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DataSourceActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DataSourceActualParam_formalParam (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DataSourceActualParam_formalParam (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DataSourceActualParam_formalParam _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DataSourceActualParam_formalParam;
#else
_currn = (webPageView__TPPpwebPageView_DataSourceActualParam_formalParam) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DataSourceActualParam_formalParam));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DataSourceActualParam_formalParam;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DataSourceActualParam_formalParam;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DataSourceActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DataSourceActualParam_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DataSourceActualParam_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DataSourceActualParam_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DataSourceActualParam_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DataSourceActualParam_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DataSourceActualParam_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DataSourceActualParam_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DataSourceActualParam_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DataSourceActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions;
#else
	_new = (webPageView__TPPLST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions));
#endif
	_new->_prod = webPageView_RULELST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions;
	_new->_desc1 = (webPageView__TSPwebPageView_WebNodeConstantExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_DataSourceActualParam_expressions)_new;
	{webPageView__TPPLST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions;
#else
	_new = (webPageView__TPPLST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions));
#endif
	_new->_prod = webPageView_RULELST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions;
	_new->_desc1 = (webPageView__TSPwebPageView_WebNodeVariableExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_DataSourceActualParam_expressions)_new;
	{webPageView__TPPLST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions;
#else
	_new = (webPageView__TPPLST_webPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions));
#endif
	_new->_prod = webPageView_RULELST_webPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions;
	_new->_desc1 = (webPageView__TSPwebPageView_WebNodeSessionExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_DataSourceActualParam_expressions)_new;
	{webPageView__TPPLST_webPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_DataSourceActualParam_expressions (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_WebNodeConstantExpression)) 
		return webPageView__MkwebPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions (_coordref, webPageView_MkwebPageView_WebNodeConstantExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_WebNodeVariableExpression)) 
		return webPageView__MkwebPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions (_coordref, webPageView_MkwebPageView_WebNodeVariableExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_WebNodeSessionExpression)) 
		return webPageView__MkwebPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions (_coordref, webPageView_MkwebPageView_WebNodeSessionExpression (_coordref, t));
	message (DEADLY, "a pwebPageView_DataSourceActualParam_expressions list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_DataSourceActualParam_expressions (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_DataSourceActualParam_expressions)
	l =_ElempwebPageView_DataSourceActualParam_expressions (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_DataSourceActualParam_expressions)
	r = _ElempwebPageView_DataSourceActualParam_expressions (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DataSourceActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_DataSourceActualParam_expressions (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_DataSourceActualParam_expressions root;
	webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_DataSourceActualParam_expressions)
		t = _ElempwebPageView_DataSourceActualParam_expressions (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions)(((webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_DataSourceActualParam_expressions;
#else
list = (webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_DataSourceActualParam_expressions));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_DataSourceActualParam_expressions;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_DataSourceActualParam_expressions)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions)
	{webPageView__TPPLST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_WebNodeConstantExpressionpwebPageView_DataSourceActualParam_expressions;
	} this code has been moved to _ElempwebPageView_DataSourceActualParam_expressions*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions)
	{webPageView__TPPLST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_WebNodeVariableExpressionpwebPageView_DataSourceActualParam_expressions;
	} this code has been moved to _ElempwebPageView_DataSourceActualParam_expressions*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions)
	{webPageView__TPPLST_webPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_WebNodeSessionExpressionpwebPageView_DataSourceActualParam_expressions;
	} this code has been moved to _ElempwebPageView_DataSourceActualParam_expressions*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_DataSourceActualParam_expressions;
#else
root = (webPageView__TPPpwebPageView_DataSourceActualParam_expressions) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DataSourceActualParam_expressions));
#endif
root->_prod = webPageView_RULEpwebPageView_DataSourceActualParam_expressions;
root->_desc1 = (webPageView__TSPLST_webPageView_DataSourceActualParam_expressions)list;
{ webPageView__TPPpwebPageView_DataSourceActualParam_expressions _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_DataSourceActualParam_expressions;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeActualParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeActualParam (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	webPageView__TPPpwebPageView_WebNodeActualParam _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeActualParam;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeActualParam) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeActualParam));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeActualParam;
_currn->_desc1 = (webPageView__TSPwebPageView_WebNodeActualParam_formalParam) webPageView_MkwebPageView_WebNodeActualParam_formalParam (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeActualParam: root of subtree no. 1 can not be made a webPageView_WebNodeActualParam_formalParam node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_WebNodeActualParam_keyword1) webPageView_MkwebPageView_WebNodeActualParam_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeActualParam: root of subtree no. 2 can not be made a webPageView_WebNodeActualParam_keyword1 node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_WebNodeActualParam_expressions) webPageView_MkwebPageView_WebNodeActualParam_expressions (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeActualParam: root of subtree no. 3 can not be made a webPageView_WebNodeActualParam_expressions node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeActualParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeActualParam_formalParam (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeActualParam_formalParam (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebNodeActualParam_formalParam _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeActualParam_formalParam;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeActualParam_formalParam) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeActualParam_formalParam));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeActualParam_formalParam;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeActualParam_formalParam;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeActualParam_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeActualParam_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebNodeActualParam_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeActualParam_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeActualParam_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeActualParam_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeActualParam_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeActualParam_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeActualParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions;
#else
	_new = (webPageView__TPPLST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions));
#endif
	_new->_prod = webPageView_RULELST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions;
	_new->_desc1 = (webPageView__TSPwebPageView_WebNodeConstantExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeActualParam_expressions)_new;
	{webPageView__TPPLST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions;
#else
	_new = (webPageView__TPPLST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions));
#endif
	_new->_prod = webPageView_RULELST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions;
	_new->_desc1 = (webPageView__TSPwebPageView_WebNodeVariableExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeActualParam_expressions)_new;
	{webPageView__TPPLST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions;
#else
	_new = (webPageView__TPPLST_webPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions));
#endif
	_new->_prod = webPageView_RULELST_webPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions;
	_new->_desc1 = (webPageView__TSPwebPageView_WebNodeSessionExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeActualParam_expressions)_new;
	{webPageView__TPPLST_webPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_WebNodeActualParam_expressions (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_WebNodeConstantExpression)) 
		return webPageView__MkwebPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions (_coordref, webPageView_MkwebPageView_WebNodeConstantExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_WebNodeVariableExpression)) 
		return webPageView__MkwebPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions (_coordref, webPageView_MkwebPageView_WebNodeVariableExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_WebNodeSessionExpression)) 
		return webPageView__MkwebPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions (_coordref, webPageView_MkwebPageView_WebNodeSessionExpression (_coordref, t));
	message (DEADLY, "a pwebPageView_WebNodeActualParam_expressions list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_WebNodeActualParam_expressions (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_WebNodeActualParam_expressions)
	l =_ElempwebPageView_WebNodeActualParam_expressions (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_WebNodeActualParam_expressions)
	r = _ElempwebPageView_WebNodeActualParam_expressions (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeActualParam_expressions (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeActualParam_expressions (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_WebNodeActualParam_expressions root;
	webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_WebNodeActualParam_expressions)
		t = _ElempwebPageView_WebNodeActualParam_expressions (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions)(((webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_WebNodeActualParam_expressions;
#else
list = (webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_WebNodeActualParam_expressions));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_WebNodeActualParam_expressions;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_WebNodeActualParam_expressions)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions)
	{webPageView__TPPLST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_WebNodeConstantExpressionpwebPageView_WebNodeActualParam_expressions;
	} this code has been moved to _ElempwebPageView_WebNodeActualParam_expressions*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions)
	{webPageView__TPPLST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_WebNodeVariableExpressionpwebPageView_WebNodeActualParam_expressions;
	} this code has been moved to _ElempwebPageView_WebNodeActualParam_expressions*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions)
	{webPageView__TPPLST_webPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_WebNodeSessionExpressionpwebPageView_WebNodeActualParam_expressions;
	} this code has been moved to _ElempwebPageView_WebNodeActualParam_expressions*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_WebNodeActualParam_expressions;
#else
root = (webPageView__TPPpwebPageView_WebNodeActualParam_expressions) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeActualParam_expressions));
#endif
root->_prod = webPageView_RULEpwebPageView_WebNodeActualParam_expressions;
root->_desc1 = (webPageView__TSPLST_webPageView_WebNodeActualParam_expressions)list;
{ webPageView__TPPpwebPageView_WebNodeActualParam_expressions _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_WebNodeActualParam_expressions;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeFormalParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeFormalParam (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	webPageView__TPPpwebPageView_WebNodeFormalParam _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeFormalParam;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeFormalParam) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeFormalParam));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeFormalParam;
_currn->_desc1 = (webPageView__TSPwebPageView_WebNodeFormalParam_name) webPageView_MkwebPageView_WebNodeFormalParam_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeFormalParam: root of subtree no. 1 can not be made a webPageView_WebNodeFormalParam_name node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_WebNodeFormalParam_keyword1) webPageView_MkwebPageView_WebNodeFormalParam_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeFormalParam: root of subtree no. 2 can not be made a webPageView_WebNodeFormalParam_keyword1 node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_WebNodeFormalParam_type) webPageView_MkwebPageView_WebNodeFormalParam_type (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeFormalParam: root of subtree no. 3 can not be made a webPageView_WebNodeFormalParam_type node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeFormalParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeFormalParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeFormalParam_name (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeFormalParam_name (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebNodeFormalParam_name _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeFormalParam_name;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeFormalParam_name) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeFormalParam_name));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeFormalParam_name;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeFormalParam_name;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeFormalParam_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeFormalParam_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeFormalParam_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebNodeFormalParam_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeFormalParam_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeFormalParam_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeFormalParam_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeFormalParam_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeFormalParam_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeFormalParam_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBHasOnepwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBHasOnepwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBHasOnepwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBHasOnepwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBHasOnepwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBHasOnepwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBHasOnepwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBHasOne)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBHasOnepwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBHasOnepwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBHasManypwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBHasManypwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBHasManypwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBHasManypwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBHasManypwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBHasManypwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBHasManypwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBHasMany)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBHasManypwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBHasManypwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBStringpwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBStringpwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBString)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBTextpwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBTextpwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBTextpwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBTextpwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBTextpwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBTextpwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBTextpwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBText)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBTextpwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBTextpwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBIntegerpwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBIntegerpwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBInteger)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBLongpwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBLongpwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBLongpwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBLongpwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBLongpwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBLongpwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBLongpwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBLong)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBLongpwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBLongpwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBFloatpwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBFloatpwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBFloat)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBDoublepwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBDoublepwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBDouble)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBBigIntpwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBBigIntpwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBBigInt)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBDatepwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBDatepwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBDate)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBTimeStamp)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBBooleanpwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBBooleanpwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBBoolean)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DBBlobpwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DBBlobpwebPageView_WebNodeFormalParam_type (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type;
#else
	_new = (webPageView__TPPLST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type;
	_new->_desc1 = (webPageView__TSPwebPageView_DBBlob)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)_new;
	{webPageView__TPPLST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_WebNodeFormalParam_type (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBHasOne)) 
		return webPageView__MkwebPageView_DBHasOnepwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBHasOne (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBHasMany)) 
		return webPageView__MkwebPageView_DBHasManypwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBHasMany (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBString)) 
		return webPageView__MkwebPageView_DBStringpwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBString (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBText)) 
		return webPageView__MkwebPageView_DBTextpwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBText (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBInteger)) 
		return webPageView__MkwebPageView_DBIntegerpwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBInteger (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBLong)) 
		return webPageView__MkwebPageView_DBLongpwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBLong (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBFloat)) 
		return webPageView__MkwebPageView_DBFloatpwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBFloat (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBDouble)) 
		return webPageView__MkwebPageView_DBDoublepwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBDouble (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBBigInt)) 
		return webPageView__MkwebPageView_DBBigIntpwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBBigInt (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBDate)) 
		return webPageView__MkwebPageView_DBDatepwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBDate (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBTimeStamp)) 
		return webPageView__MkwebPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBTimeStamp (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBBoolean)) 
		return webPageView__MkwebPageView_DBBooleanpwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBBoolean (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DBBlob)) 
		return webPageView__MkwebPageView_DBBlobpwebPageView_WebNodeFormalParam_type (_coordref, webPageView_MkwebPageView_DBBlob (_coordref, t));
	message (DEADLY, "a pwebPageView_WebNodeFormalParam_type list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_WebNodeFormalParam_type (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_WebNodeFormalParam_type)
	l =_ElempwebPageView_WebNodeFormalParam_type (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_WebNodeFormalParam_type)
	r = _ElempwebPageView_WebNodeFormalParam_type (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeFormalParam_type (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeFormalParam_type (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_WebNodeFormalParam_type root;
	webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_WebNodeFormalParam_type)
		t = _ElempwebPageView_WebNodeFormalParam_type (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type)(((webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_WebNodeFormalParam_type;
#else
list = (webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_WebNodeFormalParam_type));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_WebNodeFormalParam_type;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_WebNodeFormalParam_type)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBHasOnepwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBHasOnepwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBHasOnepwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBHasManypwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBHasManypwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBHasManypwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBStringpwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBTextpwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBTextpwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBTextpwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBIntegerpwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBLongpwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBLongpwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBLongpwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBFloatpwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBDoublepwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBBigIntpwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBDatepwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBTimeStamppwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBBooleanpwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type)
	{webPageView__TPPLST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DBBlobpwebPageView_WebNodeFormalParam_type;
	} this code has been moved to _ElempwebPageView_WebNodeFormalParam_type*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_WebNodeFormalParam_type;
#else
root = (webPageView__TPPpwebPageView_WebNodeFormalParam_type) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeFormalParam_type));
#endif
root->_prod = webPageView_RULEpwebPageView_WebNodeFormalParam_type;
root->_desc1 = (webPageView__TSPLST_webPageView_WebNodeFormalParam_type)list;
{ webPageView__TPPpwebPageView_WebNodeFormalParam_type _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_WebNodeFormalParam_type;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_MapArea (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6)
#else
NODEPTR webPageView_MkpwebPageView_MapArea (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
#endif
{	webPageView__TPPpwebPageView_MapArea _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_MapArea;
#else
_currn = (webPageView__TPPpwebPageView_MapArea) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_MapArea));
#endif
_currn->_prod = webPageView_RULEpwebPageView_MapArea;
_currn->_desc1 = (webPageView__TSPwebPageView_MapArea_altText) webPageView_MkwebPageView_MapArea_altText (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_MapArea: root of subtree no. 1 can not be made a webPageView_MapArea_altText node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_MapArea_keyword1) webPageView_MkwebPageView_MapArea_keyword1 (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_MapArea: root of subtree no. 2 can not be made a webPageView_MapArea_keyword1 node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_MapArea_coords) webPageView_MkwebPageView_MapArea_coords (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_MapArea: root of subtree no. 3 can not be made a webPageView_MapArea_coords node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_MapArea_keyword2) webPageView_MkwebPageView_MapArea_keyword2 (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_MapArea: root of subtree no. 4 can not be made a webPageView_MapArea_keyword2 node ", 0, _coordref);
_currn->_desc5 = (webPageView__TSPwebPageView_MapArea_link) webPageView_MkwebPageView_MapArea_link (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_MapArea: root of subtree no. 5 can not be made a webPageView_MapArea_link node ", 0, _coordref);
_currn->_desc6 = (webPageView__TSPwebPageView_MapArea_queryString) webPageView_MkwebPageView_MapArea_queryString (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_MapArea: root of subtree no. 6 can not be made a webPageView_MapArea_queryString node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_MapArea;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_MapArea */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_MapArea_altText (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_MapArea_altText (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_MapArea_altText _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_MapArea_altText;
#else
_currn = (webPageView__TPPpwebPageView_MapArea_altText) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_MapArea_altText));
#endif
_currn->_prod = webPageView_RULEpwebPageView_MapArea_altText;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_MapArea_altText;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_MapArea_altText */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_MapArea_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_MapArea_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_MapArea_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_MapArea_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_MapArea_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_MapArea_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_MapArea_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_MapArea_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_MapArea_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_MapArea_coords (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_MapArea_coords (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_MapArea_coords _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_MapArea_coords;
#else
_currn = (webPageView__TPPpwebPageView_MapArea_coords) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_MapArea_coords));
#endif
_currn->_prod = webPageView_RULEpwebPageView_MapArea_coords;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_MapArea_coords;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_MapArea_coords */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_MapArea_keyword2 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_MapArea_keyword2 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_MapArea_keyword2 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_MapArea_keyword2;
#else
_currn = (webPageView__TPPpwebPageView_MapArea_keyword2) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_MapArea_keyword2));
#endif
_currn->_prod = webPageView_RULEpwebPageView_MapArea_keyword2;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_MapArea_keyword2;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_MapArea_keyword2 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_MapArea_link (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_MapArea_link (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_MapArea_link _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_MapArea_link;
#else
_currn = (webPageView__TPPpwebPageView_MapArea_link) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_MapArea_link));
#endif
_currn->_prod = webPageView_RULEpwebPageView_MapArea_link;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_MapArea_link;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_MapArea_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_MapArea_queryString (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_MapArea_queryString (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_MapArea_queryString _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_MapArea_queryString;
#else
_currn = (webPageView__TPPpwebPageView_MapArea_queryString) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_MapArea_queryString));
#endif
_currn->_prod = webPageView_RULEpwebPageView_MapArea_queryString;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_MapArea_queryString;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_MapArea_queryString */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBString (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBString (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBString _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBString;
#else
_currn = (webPageView__TPPpwebPageView_DBString) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBString));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBString;
_currn->_desc1 = (webPageView__TSPwebPageView_DBString_keyword1) webPageView_MkwebPageView_DBString_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBString: root of subtree no. 1 can not be made a webPageView_DBString_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBString;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBString */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBString_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBString_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBString_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBString_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBString_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBString_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBString_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBString_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBString_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBText (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBText (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBText _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBText;
#else
_currn = (webPageView__TPPpwebPageView_DBText) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBText));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBText;
_currn->_desc1 = (webPageView__TSPwebPageView_DBText_keyword1) webPageView_MkwebPageView_DBText_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBText: root of subtree no. 1 can not be made a webPageView_DBText_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBText;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBText */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBText_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBText_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBText_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBText_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBText_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBText_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBText_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBText_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBText_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBInteger (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBInteger (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBInteger _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBInteger;
#else
_currn = (webPageView__TPPpwebPageView_DBInteger) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBInteger));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBInteger;
_currn->_desc1 = (webPageView__TSPwebPageView_DBInteger_keyword1) webPageView_MkwebPageView_DBInteger_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBInteger: root of subtree no. 1 can not be made a webPageView_DBInteger_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBInteger;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBInteger */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBInteger_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBInteger_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBInteger_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBInteger_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBInteger_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBInteger_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBInteger_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBInteger_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBInteger_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBLong (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBLong (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBLong _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBLong;
#else
_currn = (webPageView__TPPpwebPageView_DBLong) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBLong));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBLong;
_currn->_desc1 = (webPageView__TSPwebPageView_DBLong_keyword1) webPageView_MkwebPageView_DBLong_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBLong: root of subtree no. 1 can not be made a webPageView_DBLong_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBLong;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBLong */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBLong_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBLong_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBLong_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBLong_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBLong_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBLong_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBLong_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBLong_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBLong_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBFloat (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBFloat (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBFloat _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBFloat;
#else
_currn = (webPageView__TPPpwebPageView_DBFloat) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBFloat));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBFloat;
_currn->_desc1 = (webPageView__TSPwebPageView_DBFloat_keyword1) webPageView_MkwebPageView_DBFloat_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBFloat: root of subtree no. 1 can not be made a webPageView_DBFloat_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBFloat;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBFloat */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBFloat_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBFloat_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBFloat_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBFloat_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBFloat_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBFloat_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBFloat_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBFloat_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBFloat_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBDouble (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBDouble (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBDouble _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBDouble;
#else
_currn = (webPageView__TPPpwebPageView_DBDouble) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBDouble));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBDouble;
_currn->_desc1 = (webPageView__TSPwebPageView_DBDouble_keyword1) webPageView_MkwebPageView_DBDouble_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBDouble: root of subtree no. 1 can not be made a webPageView_DBDouble_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBDouble;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBDouble */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBDouble_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBDouble_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBDouble_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBDouble_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBDouble_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBDouble_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBDouble_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBDouble_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBDouble_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBBigInt (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBBigInt (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBBigInt _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBBigInt;
#else
_currn = (webPageView__TPPpwebPageView_DBBigInt) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBBigInt));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBBigInt;
_currn->_desc1 = (webPageView__TSPwebPageView_DBBigInt_keyword1) webPageView_MkwebPageView_DBBigInt_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBBigInt: root of subtree no. 1 can not be made a webPageView_DBBigInt_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBBigInt;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBBigInt */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBBigInt_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBBigInt_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBBigInt_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBBigInt_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBBigInt_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBBigInt_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBBigInt_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBBigInt_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBBigInt_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBDate (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBDate (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBDate _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBDate;
#else
_currn = (webPageView__TPPpwebPageView_DBDate) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBDate));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBDate;
_currn->_desc1 = (webPageView__TSPwebPageView_DBDate_keyword1) webPageView_MkwebPageView_DBDate_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBDate: root of subtree no. 1 can not be made a webPageView_DBDate_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBDate;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBDate */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBDate_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBDate_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBDate_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBDate_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBDate_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBDate_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBDate_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBDate_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBDate_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBTimeStamp (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBTimeStamp (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBTimeStamp _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBTimeStamp;
#else
_currn = (webPageView__TPPpwebPageView_DBTimeStamp) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBTimeStamp));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBTimeStamp;
_currn->_desc1 = (webPageView__TSPwebPageView_DBTimeStamp_keyword1) webPageView_MkwebPageView_DBTimeStamp_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBTimeStamp: root of subtree no. 1 can not be made a webPageView_DBTimeStamp_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBTimeStamp;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBTimeStamp */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBTimeStamp_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBTimeStamp_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBTimeStamp_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBTimeStamp_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBTimeStamp_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBTimeStamp_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBTimeStamp_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBTimeStamp_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBTimeStamp_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBBoolean (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBBoolean (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBBoolean _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBBoolean;
#else
_currn = (webPageView__TPPpwebPageView_DBBoolean) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBBoolean));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBBoolean;
_currn->_desc1 = (webPageView__TSPwebPageView_DBBoolean_keyword1) webPageView_MkwebPageView_DBBoolean_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBBoolean: root of subtree no. 1 can not be made a webPageView_DBBoolean_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBBoolean;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBBoolean */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBBoolean_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBBoolean_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBBoolean_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBBoolean_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBBoolean_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBBoolean_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBBoolean_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBBoolean_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBBoolean_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBBlob (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_DBBlob (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_DBBlob _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBBlob;
#else
_currn = (webPageView__TPPpwebPageView_DBBlob) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBBlob));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBBlob;
_currn->_desc1 = (webPageView__TSPwebPageView_DBBlob_keyword1) webPageView_MkwebPageView_DBBlob_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBBlob: root of subtree no. 1 can not be made a webPageView_DBBlob_keyword1 node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBBlob;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBBlob */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBBlob_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBBlob_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBBlob_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBBlob_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBBlob_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBBlob_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBBlob_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBBlob_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBBlob_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBHasOne (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_DBHasOne (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_DBHasOne _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBHasOne;
#else
_currn = (webPageView__TPPpwebPageView_DBHasOne) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBHasOne));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBHasOne;
_currn->_desc1 = (webPageView__TSPwebPageView_DBHasOne_keyword1) webPageView_MkwebPageView_DBHasOne_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBHasOne: root of subtree no. 1 can not be made a webPageView_DBHasOne_keyword1 node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_DBHasOne_dataSourceTable) webPageView_MkwebPageView_DBHasOne_dataSourceTable (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBHasOne: root of subtree no. 2 can not be made a webPageView_DBHasOne_dataSourceTable node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBHasOne;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBHasOne */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBHasOne_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBHasOne_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBHasOne_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBHasOne_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBHasOne_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBHasOne_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBHasOne_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBHasOne_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBHasOne_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBHasOne_dataSourceTable (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBHasOne_dataSourceTable (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBHasOne_dataSourceTable _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBHasOne_dataSourceTable;
#else
_currn = (webPageView__TPPpwebPageView_DBHasOne_dataSourceTable) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBHasOne_dataSourceTable));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBHasOne_dataSourceTable;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBHasOne_dataSourceTable;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBHasOne_dataSourceTable */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBHasMany (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_DBHasMany (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_DBHasMany _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBHasMany;
#else
_currn = (webPageView__TPPpwebPageView_DBHasMany) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBHasMany));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBHasMany;
_currn->_desc1 = (webPageView__TSPwebPageView_DBHasMany_keyword1) webPageView_MkwebPageView_DBHasMany_keyword1 (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBHasMany: root of subtree no. 1 can not be made a webPageView_DBHasMany_keyword1 node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_DBHasMany_dataSourceTable) webPageView_MkwebPageView_DBHasMany_dataSourceTable (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DBHasMany: root of subtree no. 2 can not be made a webPageView_DBHasMany_dataSourceTable node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBHasMany;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBHasMany */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBHasMany_keyword1 (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBHasMany_keyword1 (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBHasMany_keyword1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBHasMany_keyword1;
#else
_currn = (webPageView__TPPpwebPageView_DBHasMany_keyword1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBHasMany_keyword1));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBHasMany_keyword1;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBHasMany_keyword1;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBHasMany_keyword1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DBHasMany_dataSourceTable (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DBHasMany_dataSourceTable (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DBHasMany_dataSourceTable _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DBHasMany_dataSourceTable;
#else
_currn = (webPageView__TPPpwebPageView_DBHasMany_dataSourceTable) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DBHasMany_dataSourceTable));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DBHasMany_dataSourceTable;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DBHasMany_dataSourceTable;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DBHasMany_dataSourceTable */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebPage (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6)
#else
NODEPTR webPageView_MkpwebPageView_WebPage (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
#endif
{	webPageView__TPPpwebPageView_WebPage _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebPage;
#else
_currn = (webPageView__TPPpwebPageView_WebPage) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebPage));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebPage;
_currn->_desc1 = (webPageView__TSPwebPageView_WebPage_name) webPageView_MkwebPageView_WebPage_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebPage: root of subtree no. 1 can not be made a webPageView_WebPage_name node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_WebPage_formalParameter) webPageView_MkwebPageView_WebPage_formalParameter (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebPage: root of subtree no. 2 can not be made a webPageView_WebPage_formalParameter node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_WebPage_title) webPageView_MkwebPageView_WebPage_title (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebPage: root of subtree no. 3 can not be made a webPageView_WebPage_title node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_WebPage_frame) webPageView_MkwebPageView_WebPage_frame (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebPage: root of subtree no. 4 can not be made a webPageView_WebPage_frame node ", 0, _coordref);
_currn->_desc5 = (webPageView__TSPwebPageView_WebPage_styleSheetBlock) webPageView_MkwebPageView_WebPage_styleSheetBlock (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebPage: root of subtree no. 5 can not be made a webPageView_WebPage_styleSheetBlock node ", 0, _coordref);
_currn->_desc6 = (webPageView__TSPwebPageView_WebPage_position) webPageView_MkwebPageView_WebPage_position (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebPage: root of subtree no. 6 can not be made a webPageView_WebPage_position node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebPage;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebPage */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebPage_name (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebPage_name (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebPage_name _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebPage_name;
#else
_currn = (webPageView__TPPpwebPageView_WebPage_name) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebPage_name));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebPage_name;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebPage_name;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebPage_name */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter;
#else
	_new = (webPageView__TPPLST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter;
	_new->_desc1 = (webPageView__TSPwebPageView_WebNodeFormalParam)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebPage_formalParameter)_new;
	{webPageView__TPPLST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_WebPage_formalParameter (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_WebPage_formalParameter (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_WebNodeFormalParam)) 
		return webPageView__MkwebPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter (_coordref, webPageView_MkwebPageView_WebNodeFormalParam (_coordref, t));
	message (DEADLY, "a pwebPageView_WebPage_formalParameter list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_WebPage_formalParameter (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_WebPage_formalParameter (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_WebPage_formalParameter)
	l =_ElempwebPageView_WebPage_formalParameter (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_WebPage_formalParameter)
	r = _ElempwebPageView_WebPage_formalParameter (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_WebPage_formalParameter)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_WebPage_formalParameter)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_WebPage_formalParameter)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_WebPage_formalParameter)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebPage_formalParameter (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_WebPage_formalParameter (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_WebPage_formalParameter root;
	webPageView__TPPLST_0pwebPageView_WebPage_formalParameter list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_WebPage_formalParameter)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_WebPage_formalParameter)
		t = _ElempwebPageView_WebPage_formalParameter (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_WebPage_formalParameter)(((webPageView__TPPLST_0pwebPageView_WebPage_formalParameter) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_WebPage_formalParameter) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_WebPage_formalParameter;
#else
list = (webPageView__TPPLST_0pwebPageView_WebPage_formalParameter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_WebPage_formalParameter));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_WebPage_formalParameter;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_WebPage_formalParameter)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter)
	{webPageView__TPPLST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_WebNodeFormalParampwebPageView_WebPage_formalParameter;
	} this code has been moved to _ElempwebPageView_WebPage_formalParameter*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_WebPage_formalParameter;
#else
root = (webPageView__TPPpwebPageView_WebPage_formalParameter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebPage_formalParameter));
#endif
root->_prod = webPageView_RULEpwebPageView_WebPage_formalParameter;
root->_desc1 = (webPageView__TSPLST_webPageView_WebPage_formalParameter)list;
{ webPageView__TPPpwebPageView_WebPage_formalParameter _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_WebPage_formalParameter;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebPage_title (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebPage_title (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebPage_title _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebPage_title;
#else
_currn = (webPageView__TPPpwebPageView_WebPage_title) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebPage_title));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebPage_title;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebPage_title;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebPage_title */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebPage_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebPage_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebPage_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebPage_styleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_WebPage_styleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebPage_styleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebPage_styleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebPage_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebPage_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebPage_position (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebPage_position (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebPage_position _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebPage_position;
#else
_currn = (webPageView__TPPpwebPageView_WebPage_position) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebPage_position));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebPage_position;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebPage_position;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebPage_position */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Frame (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_Frame (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_Frame _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Frame;
#else
_currn = (webPageView__TPPpwebPageView_Frame) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Frame));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Frame;
_currn->_desc1 = (webPageView__TSPwebPageView_Frame_components) webPageView_MkwebPageView_Frame_components (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Frame: root of subtree no. 1 can not be made a webPageView_Frame_components node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Frame;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Frame */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FrameRefpwebPageView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FrameRefpwebPageView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FrameRefpwebPageView_Frame_components _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FrameRefpwebPageView_Frame_components;
#else
	_new = (webPageView__TPPLST_webPageView_FrameRefpwebPageView_Frame_components) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FrameRefpwebPageView_Frame_components));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FrameRefpwebPageView_Frame_components;
	_new->_desc1 = (webPageView__TSPwebPageView_FrameRef)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Frame_components)_new;
	{webPageView__TPPLST_webPageView_FrameRefpwebPageView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FrameRefpwebPageView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ParagraphpwebPageView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ParagraphpwebPageView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ParagraphpwebPageView_Frame_components _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ParagraphpwebPageView_Frame_components;
#else
	_new = (webPageView__TPPLST_webPageView_ParagraphpwebPageView_Frame_components) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ParagraphpwebPageView_Frame_components));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ParagraphpwebPageView_Frame_components;
	_new->_desc1 = (webPageView__TSPwebPageView_Paragraph)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Frame_components)_new;
	{webPageView__TPPLST_webPageView_ParagraphpwebPageView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ParagraphpwebPageView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_HeadingpwebPageView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_HeadingpwebPageView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_HeadingpwebPageView_Frame_components _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_HeadingpwebPageView_Frame_components;
#else
	_new = (webPageView__TPPLST_webPageView_HeadingpwebPageView_Frame_components) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_HeadingpwebPageView_Frame_components));
#endif
	_new->_prod = webPageView_RULELST_webPageView_HeadingpwebPageView_Frame_components;
	_new->_desc1 = (webPageView__TSPwebPageView_Heading)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Frame_components)_new;
	{webPageView__TPPLST_webPageView_HeadingpwebPageView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_HeadingpwebPageView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_TablepwebPageView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_TablepwebPageView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_TablepwebPageView_Frame_components _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_TablepwebPageView_Frame_components;
#else
	_new = (webPageView__TPPLST_webPageView_TablepwebPageView_Frame_components) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_TablepwebPageView_Frame_components));
#endif
	_new->_prod = webPageView_RULELST_webPageView_TablepwebPageView_Frame_components;
	_new->_desc1 = (webPageView__TSPwebPageView_Table)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Frame_components)_new;
	{webPageView__TPPLST_webPageView_TablepwebPageView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_TablepwebPageView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularpwebPageView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularpwebPageView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularpwebPageView_Frame_components _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularpwebPageView_Frame_components;
#else
	_new = (webPageView__TPPLST_webPageView_FormularpwebPageView_Frame_components) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularpwebPageView_Frame_components));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularpwebPageView_Frame_components;
	_new->_desc1 = (webPageView__TSPwebPageView_Formular)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Frame_components)_new;
	{webPageView__TPPLST_webPageView_FormularpwebPageView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularpwebPageView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_OutputMessagesElementpwebPageView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_OutputMessagesElementpwebPageView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_OutputMessagesElementpwebPageView_Frame_components _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_OutputMessagesElementpwebPageView_Frame_components;
#else
	_new = (webPageView__TPPLST_webPageView_OutputMessagesElementpwebPageView_Frame_components) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_OutputMessagesElementpwebPageView_Frame_components));
#endif
	_new->_prod = webPageView_RULELST_webPageView_OutputMessagesElementpwebPageView_Frame_components;
	_new->_desc1 = (webPageView__TSPwebPageView_OutputMessagesElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Frame_components)_new;
	{webPageView__TPPLST_webPageView_OutputMessagesElementpwebPageView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_OutputMessagesElementpwebPageView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ListOutputElementpwebPageView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ListOutputElementpwebPageView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ListOutputElementpwebPageView_Frame_components _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ListOutputElementpwebPageView_Frame_components;
#else
	_new = (webPageView__TPPLST_webPageView_ListOutputElementpwebPageView_Frame_components) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ListOutputElementpwebPageView_Frame_components));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ListOutputElementpwebPageView_Frame_components;
	_new->_desc1 = (webPageView__TSPwebPageView_ListOutputElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Frame_components)_new;
	{webPageView__TPPLST_webPageView_ListOutputElementpwebPageView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ListOutputElementpwebPageView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ImageMappwebPageView_Frame_components (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ImageMappwebPageView_Frame_components (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ImageMappwebPageView_Frame_components _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ImageMappwebPageView_Frame_components;
#else
	_new = (webPageView__TPPLST_webPageView_ImageMappwebPageView_Frame_components) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ImageMappwebPageView_Frame_components));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ImageMappwebPageView_Frame_components;
	_new->_desc1 = (webPageView__TSPwebPageView_ImageMap)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Frame_components)_new;
	{webPageView__TPPLST_webPageView_ImageMappwebPageView_Frame_components _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ImageMappwebPageView_Frame_components;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_Frame_components (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_Frame_components (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FrameRef)) 
		return webPageView__MkwebPageView_FrameRefpwebPageView_Frame_components (_coordref, webPageView_MkwebPageView_FrameRef (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_Paragraph)) 
		return webPageView__MkwebPageView_ParagraphpwebPageView_Frame_components (_coordref, webPageView_MkwebPageView_Paragraph (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_Heading)) 
		return webPageView__MkwebPageView_HeadingpwebPageView_Frame_components (_coordref, webPageView_MkwebPageView_Heading (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_Table)) 
		return webPageView__MkwebPageView_TablepwebPageView_Frame_components (_coordref, webPageView_MkwebPageView_Table (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_Formular)) 
		return webPageView__MkwebPageView_FormularpwebPageView_Frame_components (_coordref, webPageView_MkwebPageView_Formular (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_OutputMessagesElement)) 
		return webPageView__MkwebPageView_OutputMessagesElementpwebPageView_Frame_components (_coordref, webPageView_MkwebPageView_OutputMessagesElement (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ListOutputElement)) 
		return webPageView__MkwebPageView_ListOutputElementpwebPageView_Frame_components (_coordref, webPageView_MkwebPageView_ListOutputElement (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ImageMap)) 
		return webPageView__MkwebPageView_ImageMappwebPageView_Frame_components (_coordref, webPageView_MkwebPageView_ImageMap (_coordref, t));
	message (DEADLY, "a pwebPageView_Frame_components list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_Frame_components (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_Frame_components (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_Frame_components)
	l =_ElempwebPageView_Frame_components (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_Frame_components)
	r = _ElempwebPageView_Frame_components (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_Frame_components)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_Frame_components)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_Frame_components)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_Frame_components)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Frame_components (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_Frame_components (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_Frame_components root;
	webPageView__TPPLST_0pwebPageView_Frame_components list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_Frame_components)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_Frame_components)
		t = _ElempwebPageView_Frame_components (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_Frame_components)(((webPageView__TPPLST_0pwebPageView_Frame_components) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_Frame_components) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_Frame_components;
#else
list = (webPageView__TPPLST_0pwebPageView_Frame_components) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_Frame_components));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_Frame_components;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_Frame_components)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FrameRefpwebPageView_Frame_components)
	{webPageView__TPPLST_webPageView_FrameRefpwebPageView_Frame_components _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FrameRefpwebPageView_Frame_components;
	} this code has been moved to _ElempwebPageView_Frame_components*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ParagraphpwebPageView_Frame_components)
	{webPageView__TPPLST_webPageView_ParagraphpwebPageView_Frame_components _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ParagraphpwebPageView_Frame_components;
	} this code has been moved to _ElempwebPageView_Frame_components*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_HeadingpwebPageView_Frame_components)
	{webPageView__TPPLST_webPageView_HeadingpwebPageView_Frame_components _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_HeadingpwebPageView_Frame_components;
	} this code has been moved to _ElempwebPageView_Frame_components*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_TablepwebPageView_Frame_components)
	{webPageView__TPPLST_webPageView_TablepwebPageView_Frame_components _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_TablepwebPageView_Frame_components;
	} this code has been moved to _ElempwebPageView_Frame_components*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularpwebPageView_Frame_components)
	{webPageView__TPPLST_webPageView_FormularpwebPageView_Frame_components _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularpwebPageView_Frame_components;
	} this code has been moved to _ElempwebPageView_Frame_components*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_OutputMessagesElementpwebPageView_Frame_components)
	{webPageView__TPPLST_webPageView_OutputMessagesElementpwebPageView_Frame_components _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_OutputMessagesElementpwebPageView_Frame_components;
	} this code has been moved to _ElempwebPageView_Frame_components*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ListOutputElementpwebPageView_Frame_components)
	{webPageView__TPPLST_webPageView_ListOutputElementpwebPageView_Frame_components _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ListOutputElementpwebPageView_Frame_components;
	} this code has been moved to _ElempwebPageView_Frame_components*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ImageMappwebPageView_Frame_components)
	{webPageView__TPPLST_webPageView_ImageMappwebPageView_Frame_components _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ImageMappwebPageView_Frame_components;
	} this code has been moved to _ElempwebPageView_Frame_components*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_Frame_components;
#else
root = (webPageView__TPPpwebPageView_Frame_components) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Frame_components));
#endif
root->_prod = webPageView_RULEpwebPageView_Frame_components;
root->_desc1 = (webPageView__TSPLST_webPageView_Frame_components)list;
{ webPageView__TPPpwebPageView_Frame_components _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_Frame_components;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FrameRef (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_FrameRef (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_FrameRef _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FrameRef;
#else
_currn = (webPageView__TPPpwebPageView_FrameRef) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FrameRef));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FrameRef;
_currn->_desc1 = (webPageView__TSPwebPageView_FrameRef_styleSheetBlock) webPageView_MkwebPageView_FrameRef_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FrameRef: root of subtree no. 1 can not be made a webPageView_FrameRef_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FrameRef_frame) webPageView_MkwebPageView_FrameRef_frame (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FrameRef: root of subtree no. 2 can not be made a webPageView_FrameRef_frame node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FrameRef;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FrameRef */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FrameRef_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FrameRef_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FrameRef_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FrameRef_styleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_FrameRef_styleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FrameRef_styleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FrameRef_styleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FrameRef_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FrameRef_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FrameRef_frame (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FrameRef_frame (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FrameRef_frame _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FrameRef_frame;
#else
_currn = (webPageView__TPPpwebPageView_FrameRef_frame) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FrameRef_frame));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FrameRef_frame;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FrameRef_frame;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FrameRef_frame */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_BinaryExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR webPageView_MkpwebPageView_BinaryExpression (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	webPageView__TPPpwebPageView_BinaryExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_BinaryExpression;
#else
_currn = (webPageView__TPPpwebPageView_BinaryExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_BinaryExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_BinaryExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_BinaryExpression_leftOperand) webPageView_MkwebPageView_BinaryExpression_leftOperand (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_BinaryExpression: root of subtree no. 1 can not be made a webPageView_BinaryExpression_leftOperand node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_BinaryExpression_rightOperand) webPageView_MkwebPageView_BinaryExpression_rightOperand (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_BinaryExpression: root of subtree no. 2 can not be made a webPageView_BinaryExpression_rightOperand node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_BinaryExpression_operator) webPageView_MkwebPageView_BinaryExpression_operator (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_BinaryExpression: root of subtree no. 3 can not be made a webPageView_BinaryExpression_operator node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_BinaryExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_BinaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand;
#else
	_new = (webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_BinaryExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_leftOperand)_new;
	{webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand;
#else
	_new = (webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_UnaryExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_leftOperand)_new;
	{webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand;
#else
	_new = (webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_PredefinedExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_leftOperand)_new;
	{webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand;
#else
	_new = (webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_ConstantExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_leftOperand)_new;
	{webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand;
#else
	_new = (webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_ColumnValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_leftOperand)_new;
	{webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand;
#else
	_new = (webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_leftOperand)_new;
	{webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand;
#else
	_new = (webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_ParameterValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_leftOperand)_new;
	{webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand;
#else
	_new = (webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_ComputationExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_leftOperand)_new;
	{webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_BinaryExpression_leftOperand (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_BinaryExpression)) 
		return webPageView__MkwebPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, webPageView_MkwebPageView_BinaryExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_UnaryExpression)) 
		return webPageView__MkwebPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, webPageView_MkwebPageView_UnaryExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_PredefinedExpression)) 
		return webPageView__MkwebPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, webPageView_MkwebPageView_PredefinedExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ConstantExpression)) 
		return webPageView__MkwebPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, webPageView_MkwebPageView_ConstantExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ColumnValueExpression)) 
		return webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, webPageView_MkwebPageView_ColumnValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ProjectionColumnValueExpression)) 
		return webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, webPageView_MkwebPageView_ProjectionColumnValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ParameterValueExpression)) 
		return webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, webPageView_MkwebPageView_ParameterValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ComputationExpression)) 
		return webPageView__MkwebPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand (_coordref, webPageView_MkwebPageView_ComputationExpression (_coordref, t));
	message (DEADLY, "a pwebPageView_BinaryExpression_leftOperand list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_BinaryExpression_leftOperand (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_BinaryExpression_leftOperand)
	l =_ElempwebPageView_BinaryExpression_leftOperand (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_BinaryExpression_leftOperand)
	r = _ElempwebPageView_BinaryExpression_leftOperand (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_BinaryExpression_leftOperand (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_BinaryExpression_leftOperand (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_BinaryExpression_leftOperand root;
	webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_BinaryExpression_leftOperand)
		t = _ElempwebPageView_BinaryExpression_leftOperand (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand)(((webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_BinaryExpression_leftOperand;
#else
list = (webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_BinaryExpression_leftOperand));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_BinaryExpression_leftOperand;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_BinaryExpression_leftOperand)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand)
	{webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand)
	{webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand)
	{webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand)
	{webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand)
	{webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand)
	{webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand)
	{webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_leftOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand)
	{webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_leftOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_leftOperand*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_BinaryExpression_leftOperand;
#else
root = (webPageView__TPPpwebPageView_BinaryExpression_leftOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_BinaryExpression_leftOperand));
#endif
root->_prod = webPageView_RULEpwebPageView_BinaryExpression_leftOperand;
root->_desc1 = (webPageView__TSPLST_webPageView_BinaryExpression_leftOperand)list;
{ webPageView__TPPpwebPageView_BinaryExpression_leftOperand _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_BinaryExpression_leftOperand;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand;
#else
	_new = (webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_BinaryExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_rightOperand)_new;
	{webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand;
#else
	_new = (webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_UnaryExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_rightOperand)_new;
	{webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand;
#else
	_new = (webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_PredefinedExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_rightOperand)_new;
	{webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand;
#else
	_new = (webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_ConstantExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_rightOperand)_new;
	{webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand;
#else
	_new = (webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_ColumnValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_rightOperand)_new;
	{webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand;
#else
	_new = (webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_rightOperand)_new;
	{webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand;
#else
	_new = (webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_ParameterValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_rightOperand)_new;
	{webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand;
#else
	_new = (webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand;
	_new->_desc1 = (webPageView__TSPwebPageView_ComputationExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_BinaryExpression_rightOperand)_new;
	{webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_BinaryExpression_rightOperand (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_BinaryExpression)) 
		return webPageView__MkwebPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, webPageView_MkwebPageView_BinaryExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_UnaryExpression)) 
		return webPageView__MkwebPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, webPageView_MkwebPageView_UnaryExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_PredefinedExpression)) 
		return webPageView__MkwebPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, webPageView_MkwebPageView_PredefinedExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ConstantExpression)) 
		return webPageView__MkwebPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, webPageView_MkwebPageView_ConstantExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ColumnValueExpression)) 
		return webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, webPageView_MkwebPageView_ColumnValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ProjectionColumnValueExpression)) 
		return webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, webPageView_MkwebPageView_ProjectionColumnValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ParameterValueExpression)) 
		return webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, webPageView_MkwebPageView_ParameterValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ComputationExpression)) 
		return webPageView__MkwebPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand (_coordref, webPageView_MkwebPageView_ComputationExpression (_coordref, t));
	message (DEADLY, "a pwebPageView_BinaryExpression_rightOperand list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_BinaryExpression_rightOperand (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_BinaryExpression_rightOperand)
	l =_ElempwebPageView_BinaryExpression_rightOperand (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_BinaryExpression_rightOperand)
	r = _ElempwebPageView_BinaryExpression_rightOperand (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_BinaryExpression_rightOperand (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_BinaryExpression_rightOperand (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_BinaryExpression_rightOperand root;
	webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_BinaryExpression_rightOperand)
		t = _ElempwebPageView_BinaryExpression_rightOperand (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand)(((webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_BinaryExpression_rightOperand;
#else
list = (webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_BinaryExpression_rightOperand));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_BinaryExpression_rightOperand;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_BinaryExpression_rightOperand)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand)
	{webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_BinaryExpressionpwebPageView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand)
	{webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_UnaryExpressionpwebPageView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand)
	{webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_PredefinedExpressionpwebPageView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand)
	{webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ConstantExpressionpwebPageView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand)
	{webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ColumnValueExpressionpwebPageView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand)
	{webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ProjectionColumnValueExpressionpwebPageView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand)
	{webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ParameterValueExpressionpwebPageView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_rightOperand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand)
	{webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ComputationExpressionpwebPageView_BinaryExpression_rightOperand;
	} this code has been moved to _ElempwebPageView_BinaryExpression_rightOperand*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_BinaryExpression_rightOperand;
#else
root = (webPageView__TPPpwebPageView_BinaryExpression_rightOperand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_BinaryExpression_rightOperand));
#endif
root->_prod = webPageView_RULEpwebPageView_BinaryExpression_rightOperand;
root->_desc1 = (webPageView__TSPLST_webPageView_BinaryExpression_rightOperand)list;
{ webPageView__TPPpwebPageView_BinaryExpression_rightOperand _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_BinaryExpression_rightOperand;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_BinaryExpression_operator (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_BinaryExpression_operator (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_BinaryExpression_operator _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_BinaryExpression_operator;
#else
_currn = (webPageView__TPPpwebPageView_BinaryExpression_operator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_BinaryExpression_operator));
#endif
_currn->_prod = webPageView_RULEpwebPageView_BinaryExpression_operator;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_BinaryExpression_operator;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_BinaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_UnaryExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_UnaryExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_UnaryExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_UnaryExpression;
#else
_currn = (webPageView__TPPpwebPageView_UnaryExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_UnaryExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_UnaryExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_UnaryExpression_operand) webPageView_MkwebPageView_UnaryExpression_operand (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_UnaryExpression: root of subtree no. 1 can not be made a webPageView_UnaryExpression_operand node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_UnaryExpression_operator) webPageView_MkwebPageView_UnaryExpression_operator (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_UnaryExpression: root of subtree no. 2 can not be made a webPageView_UnaryExpression_operator node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_UnaryExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_UnaryExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_BinaryExpressionpwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_BinaryExpressionpwebPageView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_BinaryExpressionpwebPageView_UnaryExpression_operand;
#else
	_new = (webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_UnaryExpression_operand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_BinaryExpressionpwebPageView_UnaryExpression_operand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_BinaryExpressionpwebPageView_UnaryExpression_operand;
	_new->_desc1 = (webPageView__TSPwebPageView_BinaryExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_UnaryExpression_operand)_new;
	{webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_BinaryExpressionpwebPageView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_UnaryExpressionpwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_UnaryExpressionpwebPageView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_UnaryExpressionpwebPageView_UnaryExpression_operand;
#else
	_new = (webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_UnaryExpression_operand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_UnaryExpressionpwebPageView_UnaryExpression_operand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_UnaryExpressionpwebPageView_UnaryExpression_operand;
	_new->_desc1 = (webPageView__TSPwebPageView_UnaryExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_UnaryExpression_operand)_new;
	{webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_UnaryExpressionpwebPageView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand;
#else
	_new = (webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand;
	_new->_desc1 = (webPageView__TSPwebPageView_PredefinedExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_UnaryExpression_operand)_new;
	{webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ConstantExpressionpwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ConstantExpressionpwebPageView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ConstantExpressionpwebPageView_UnaryExpression_operand;
#else
	_new = (webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_UnaryExpression_operand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ConstantExpressionpwebPageView_UnaryExpression_operand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ConstantExpressionpwebPageView_UnaryExpression_operand;
	_new->_desc1 = (webPageView__TSPwebPageView_ConstantExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_UnaryExpression_operand)_new;
	{webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ConstantExpressionpwebPageView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand;
#else
	_new = (webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand;
	_new->_desc1 = (webPageView__TSPwebPageView_ColumnValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_UnaryExpression_operand)_new;
	{webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand;
#else
	_new = (webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand;
	_new->_desc1 = (webPageView__TSPwebPageView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_UnaryExpression_operand)_new;
	{webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand;
#else
	_new = (webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand;
	_new->_desc1 = (webPageView__TSPwebPageView_ParameterValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_UnaryExpression_operand)_new;
	{webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ComputationExpressionpwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ComputationExpressionpwebPageView_UnaryExpression_operand (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_UnaryExpression_operand _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ComputationExpressionpwebPageView_UnaryExpression_operand;
#else
	_new = (webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_UnaryExpression_operand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ComputationExpressionpwebPageView_UnaryExpression_operand));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ComputationExpressionpwebPageView_UnaryExpression_operand;
	_new->_desc1 = (webPageView__TSPwebPageView_ComputationExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_UnaryExpression_operand)_new;
	{webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_UnaryExpression_operand _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ComputationExpressionpwebPageView_UnaryExpression_operand;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_UnaryExpression_operand (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_BinaryExpression)) 
		return webPageView__MkwebPageView_BinaryExpressionpwebPageView_UnaryExpression_operand (_coordref, webPageView_MkwebPageView_BinaryExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_UnaryExpression)) 
		return webPageView__MkwebPageView_UnaryExpressionpwebPageView_UnaryExpression_operand (_coordref, webPageView_MkwebPageView_UnaryExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_PredefinedExpression)) 
		return webPageView__MkwebPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand (_coordref, webPageView_MkwebPageView_PredefinedExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ConstantExpression)) 
		return webPageView__MkwebPageView_ConstantExpressionpwebPageView_UnaryExpression_operand (_coordref, webPageView_MkwebPageView_ConstantExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ColumnValueExpression)) 
		return webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand (_coordref, webPageView_MkwebPageView_ColumnValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ProjectionColumnValueExpression)) 
		return webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand (_coordref, webPageView_MkwebPageView_ProjectionColumnValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ParameterValueExpression)) 
		return webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand (_coordref, webPageView_MkwebPageView_ParameterValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ComputationExpression)) 
		return webPageView__MkwebPageView_ComputationExpressionpwebPageView_UnaryExpression_operand (_coordref, webPageView_MkwebPageView_ComputationExpression (_coordref, t));
	message (DEADLY, "a pwebPageView_UnaryExpression_operand list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_UnaryExpression_operand (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_UnaryExpression_operand)
	l =_ElempwebPageView_UnaryExpression_operand (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_UnaryExpression_operand)
	r = _ElempwebPageView_UnaryExpression_operand (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_UnaryExpression_operand)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_UnaryExpression_operand)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_UnaryExpression_operand)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_UnaryExpression_operand)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_UnaryExpression_operand (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_UnaryExpression_operand (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_UnaryExpression_operand root;
	webPageView__TPPLST_0pwebPageView_UnaryExpression_operand list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_UnaryExpression_operand)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_UnaryExpression_operand)
		t = _ElempwebPageView_UnaryExpression_operand (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_UnaryExpression_operand)(((webPageView__TPPLST_0pwebPageView_UnaryExpression_operand) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_UnaryExpression_operand) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_UnaryExpression_operand;
#else
list = (webPageView__TPPLST_0pwebPageView_UnaryExpression_operand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_UnaryExpression_operand));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_UnaryExpression_operand;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_UnaryExpression_operand)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_BinaryExpressionpwebPageView_UnaryExpression_operand)
	{webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_UnaryExpression_operand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_BinaryExpressionpwebPageView_UnaryExpression_operand;
	} this code has been moved to _ElempwebPageView_UnaryExpression_operand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_UnaryExpressionpwebPageView_UnaryExpression_operand)
	{webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_UnaryExpression_operand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_UnaryExpressionpwebPageView_UnaryExpression_operand;
	} this code has been moved to _ElempwebPageView_UnaryExpression_operand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand)
	{webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_PredefinedExpressionpwebPageView_UnaryExpression_operand;
	} this code has been moved to _ElempwebPageView_UnaryExpression_operand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ConstantExpressionpwebPageView_UnaryExpression_operand)
	{webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_UnaryExpression_operand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ConstantExpressionpwebPageView_UnaryExpression_operand;
	} this code has been moved to _ElempwebPageView_UnaryExpression_operand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand)
	{webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ColumnValueExpressionpwebPageView_UnaryExpression_operand;
	} this code has been moved to _ElempwebPageView_UnaryExpression_operand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand)
	{webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ProjectionColumnValueExpressionpwebPageView_UnaryExpression_operand;
	} this code has been moved to _ElempwebPageView_UnaryExpression_operand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand)
	{webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ParameterValueExpressionpwebPageView_UnaryExpression_operand;
	} this code has been moved to _ElempwebPageView_UnaryExpression_operand*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ComputationExpressionpwebPageView_UnaryExpression_operand)
	{webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_UnaryExpression_operand _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ComputationExpressionpwebPageView_UnaryExpression_operand;
	} this code has been moved to _ElempwebPageView_UnaryExpression_operand*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_UnaryExpression_operand;
#else
root = (webPageView__TPPpwebPageView_UnaryExpression_operand) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_UnaryExpression_operand));
#endif
root->_prod = webPageView_RULEpwebPageView_UnaryExpression_operand;
root->_desc1 = (webPageView__TSPLST_webPageView_UnaryExpression_operand)list;
{ webPageView__TPPpwebPageView_UnaryExpression_operand _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_UnaryExpression_operand;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_UnaryExpression_operator (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_UnaryExpression_operator (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_UnaryExpression_operator _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_UnaryExpression_operator;
#else
_currn = (webPageView__TPPpwebPageView_UnaryExpression_operator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_UnaryExpression_operator));
#endif
_currn->_prod = webPageView_RULEpwebPageView_UnaryExpression_operator;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_UnaryExpression_operator;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_UnaryExpression_operator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_PredefinedExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_PredefinedExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_PredefinedExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_PredefinedExpression;
#else
_currn = (webPageView__TPPpwebPageView_PredefinedExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_PredefinedExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_PredefinedExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_PredefinedExpression_value) webPageView_MkwebPageView_PredefinedExpression_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_PredefinedExpression: root of subtree no. 1 can not be made a webPageView_PredefinedExpression_value node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_PredefinedExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_PredefinedExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_PredefinedExpression_value (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_PredefinedExpression_value (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_PredefinedExpression_value _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_PredefinedExpression_value;
#else
_currn = (webPageView__TPPpwebPageView_PredefinedExpression_value) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_PredefinedExpression_value));
#endif
_currn->_prod = webPageView_RULEpwebPageView_PredefinedExpression_value;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_PredefinedExpression_value;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_PredefinedExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ConstantExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_ConstantExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_ConstantExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ConstantExpression;
#else
_currn = (webPageView__TPPpwebPageView_ConstantExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ConstantExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ConstantExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_ConstantExpression_value) webPageView_MkwebPageView_ConstantExpression_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ConstantExpression: root of subtree no. 1 can not be made a webPageView_ConstantExpression_value node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ConstantExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ConstantExpression_value (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ConstantExpression_value (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ConstantExpression_value _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ConstantExpression_value;
#else
_currn = (webPageView__TPPpwebPageView_ConstantExpression_value) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ConstantExpression_value));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ConstantExpression_value;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ConstantExpression_value;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ColumnValueExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_ColumnValueExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_ColumnValueExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ColumnValueExpression;
#else
_currn = (webPageView__TPPpwebPageView_ColumnValueExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ColumnValueExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ColumnValueExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_ColumnValueExpression_column) webPageView_MkwebPageView_ColumnValueExpression_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ColumnValueExpression: root of subtree no. 1 can not be made a webPageView_ColumnValueExpression_column node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ColumnValueExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ColumnValueExpression_column (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ColumnValueExpression_column (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ColumnValueExpression_column _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ColumnValueExpression_column;
#else
_currn = (webPageView__TPPpwebPageView_ColumnValueExpression_column) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ColumnValueExpression_column));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ColumnValueExpression_column;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ColumnValueExpression_column;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ProjectionColumnValueExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_ProjectionColumnValueExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_ProjectionColumnValueExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ProjectionColumnValueExpression;
#else
_currn = (webPageView__TPPpwebPageView_ProjectionColumnValueExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ProjectionColumnValueExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ProjectionColumnValueExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_ProjectionColumnValueExpression_column) webPageView_MkwebPageView_ProjectionColumnValueExpression_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ProjectionColumnValueExpression: root of subtree no. 1 can not be made a webPageView_ProjectionColumnValueExpression_column node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ProjectionColumnValueExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ProjectionColumnValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ProjectionColumnValueExpression_column (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ProjectionColumnValueExpression_column (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ProjectionColumnValueExpression_column _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ProjectionColumnValueExpression_column;
#else
_currn = (webPageView__TPPpwebPageView_ProjectionColumnValueExpression_column) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ProjectionColumnValueExpression_column));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ProjectionColumnValueExpression_column;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ProjectionColumnValueExpression_column;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ProjectionColumnValueExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ParameterValueExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_ParameterValueExpression (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_ParameterValueExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ParameterValueExpression;
#else
_currn = (webPageView__TPPpwebPageView_ParameterValueExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ParameterValueExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ParameterValueExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_ParameterValueExpression_parameter) webPageView_MkwebPageView_ParameterValueExpression_parameter (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ParameterValueExpression: root of subtree no. 1 can not be made a webPageView_ParameterValueExpression_parameter node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ParameterValueExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ParameterValueExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ParameterValueExpression_parameter (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ParameterValueExpression_parameter (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ParameterValueExpression_parameter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ParameterValueExpression_parameter;
#else
_currn = (webPageView__TPPpwebPageView_ParameterValueExpression_parameter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ParameterValueExpression_parameter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ParameterValueExpression_parameter;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ParameterValueExpression_parameter;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ParameterValueExpression_parameter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ComputationExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_ComputationExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_ComputationExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ComputationExpression;
#else
_currn = (webPageView__TPPpwebPageView_ComputationExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ComputationExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ComputationExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_ComputationExpression_column) webPageView_MkwebPageView_ComputationExpression_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ComputationExpression: root of subtree no. 1 can not be made a webPageView_ComputationExpression_column node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_ComputationExpression_computation) webPageView_MkwebPageView_ComputationExpression_computation (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ComputationExpression: root of subtree no. 2 can not be made a webPageView_ComputationExpression_computation node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ComputationExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ComputationExpression */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ComputationExpression_column (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ComputationExpression_column (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ComputationExpression_column _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ComputationExpression_column;
#else
_currn = (webPageView__TPPpwebPageView_ComputationExpression_column) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ComputationExpression_column));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ComputationExpression_column;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ComputationExpression_column;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ComputationExpression_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ComputationExpression_computation (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ComputationExpression_computation (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ComputationExpression_computation _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ComputationExpression_computation;
#else
_currn = (webPageView__TPPpwebPageView_ComputationExpression_computation) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ComputationExpression_computation));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ComputationExpression_computation;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ComputationExpression_computation;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ComputationExpression_computation */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Paragraph (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_Paragraph (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_Paragraph _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Paragraph;
#else
_currn = (webPageView__TPPpwebPageView_Paragraph) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Paragraph));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Paragraph;
_currn->_desc1 = (webPageView__TSPwebPageView_Paragraph_styleSheetBlock) webPageView_MkwebPageView_Paragraph_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Paragraph: root of subtree no. 1 can not be made a webPageView_Paragraph_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_Paragraph_fragments) webPageView_MkwebPageView_Paragraph_fragments (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Paragraph: root of subtree no. 2 can not be made a webPageView_Paragraph_fragments node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Paragraph;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Paragraph */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Paragraph_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_Paragraph_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_Paragraph_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Paragraph_styleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_Paragraph_styleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Paragraph_styleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Paragraph_styleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Paragraph_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Paragraph_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_TextFragmentpwebPageView_Paragraph_fragments (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_TextFragmentpwebPageView_Paragraph_fragments (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_TextFragmentpwebPageView_Paragraph_fragments _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_TextFragmentpwebPageView_Paragraph_fragments;
#else
	_new = (webPageView__TPPLST_webPageView_TextFragmentpwebPageView_Paragraph_fragments) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_TextFragmentpwebPageView_Paragraph_fragments));
#endif
	_new->_prod = webPageView_RULELST_webPageView_TextFragmentpwebPageView_Paragraph_fragments;
	_new->_desc1 = (webPageView__TSPwebPageView_TextFragment)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Paragraph_fragments)_new;
	{webPageView__TPPLST_webPageView_TextFragmentpwebPageView_Paragraph_fragments _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_TextFragmentpwebPageView_Paragraph_fragments;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ImageFragmentpwebPageView_Paragraph_fragments (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ImageFragmentpwebPageView_Paragraph_fragments (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments;
#else
	_new = (webPageView__TPPLST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments;
	_new->_desc1 = (webPageView__TSPwebPageView_ImageFragment)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Paragraph_fragments)_new;
	{webPageView__TPPLST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_OutputFragmentpwebPageView_Paragraph_fragments (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_OutputFragmentpwebPageView_Paragraph_fragments (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_OutputFragmentpwebPageView_Paragraph_fragments _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_OutputFragmentpwebPageView_Paragraph_fragments;
#else
	_new = (webPageView__TPPLST_webPageView_OutputFragmentpwebPageView_Paragraph_fragments) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_OutputFragmentpwebPageView_Paragraph_fragments));
#endif
	_new->_prod = webPageView_RULELST_webPageView_OutputFragmentpwebPageView_Paragraph_fragments;
	_new->_desc1 = (webPageView__TSPwebPageView_OutputFragment)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Paragraph_fragments)_new;
	{webPageView__TPPLST_webPageView_OutputFragmentpwebPageView_Paragraph_fragments _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_OutputFragmentpwebPageView_Paragraph_fragments;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_Paragraph_fragments (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_Paragraph_fragments (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_TextFragment)) 
		return webPageView__MkwebPageView_TextFragmentpwebPageView_Paragraph_fragments (_coordref, webPageView_MkwebPageView_TextFragment (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ImageFragment)) 
		return webPageView__MkwebPageView_ImageFragmentpwebPageView_Paragraph_fragments (_coordref, webPageView_MkwebPageView_ImageFragment (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_OutputFragment)) 
		return webPageView__MkwebPageView_OutputFragmentpwebPageView_Paragraph_fragments (_coordref, webPageView_MkwebPageView_OutputFragment (_coordref, t));
	message (DEADLY, "a pwebPageView_Paragraph_fragments list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_Paragraph_fragments (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_Paragraph_fragments (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_Paragraph_fragments)
	l =_ElempwebPageView_Paragraph_fragments (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_Paragraph_fragments)
	r = _ElempwebPageView_Paragraph_fragments (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_Paragraph_fragments)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_Paragraph_fragments)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_Paragraph_fragments)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_Paragraph_fragments)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Paragraph_fragments (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_Paragraph_fragments (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_Paragraph_fragments root;
	webPageView__TPPLST_0pwebPageView_Paragraph_fragments list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_Paragraph_fragments)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_Paragraph_fragments)
		t = _ElempwebPageView_Paragraph_fragments (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_Paragraph_fragments)(((webPageView__TPPLST_0pwebPageView_Paragraph_fragments) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_Paragraph_fragments) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_Paragraph_fragments;
#else
list = (webPageView__TPPLST_0pwebPageView_Paragraph_fragments) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_Paragraph_fragments));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_Paragraph_fragments;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_Paragraph_fragments)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_TextFragmentpwebPageView_Paragraph_fragments)
	{webPageView__TPPLST_webPageView_TextFragmentpwebPageView_Paragraph_fragments _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_TextFragmentpwebPageView_Paragraph_fragments;
	} this code has been moved to _ElempwebPageView_Paragraph_fragments*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments)
	{webPageView__TPPLST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ImageFragmentpwebPageView_Paragraph_fragments;
	} this code has been moved to _ElempwebPageView_Paragraph_fragments*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_OutputFragmentpwebPageView_Paragraph_fragments)
	{webPageView__TPPLST_webPageView_OutputFragmentpwebPageView_Paragraph_fragments _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_OutputFragmentpwebPageView_Paragraph_fragments;
	} this code has been moved to _ElempwebPageView_Paragraph_fragments*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_Paragraph_fragments;
#else
root = (webPageView__TPPpwebPageView_Paragraph_fragments) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Paragraph_fragments));
#endif
root->_prod = webPageView_RULEpwebPageView_Paragraph_fragments;
root->_desc1 = (webPageView__TSPLST_webPageView_Paragraph_fragments)list;
{ webPageView__TPPpwebPageView_Paragraph_fragments _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_Paragraph_fragments;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_TextFragment (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR webPageView_MkpwebPageView_TextFragment (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	webPageView__TPPpwebPageView_TextFragment _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_TextFragment;
#else
_currn = (webPageView__TPPpwebPageView_TextFragment) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_TextFragment));
#endif
_currn->_prod = webPageView_RULEpwebPageView_TextFragment;
_currn->_desc1 = (webPageView__TSPwebPageView_TextFragment_link) webPageView_MkwebPageView_TextFragment_link (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_TextFragment: root of subtree no. 1 can not be made a webPageView_TextFragment_link node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_TextFragment_value) webPageView_MkwebPageView_TextFragment_value (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_TextFragment: root of subtree no. 2 can not be made a webPageView_TextFragment_value node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_TextFragment_fontstyle) webPageView_MkwebPageView_TextFragment_fontstyle (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_TextFragment: root of subtree no. 3 can not be made a webPageView_TextFragment_fontstyle node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_TextFragment;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_TextFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_TextFragment_link (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_TextFragment_link (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_TextFragment_link _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_TextFragment_link;
#else
_currn = (webPageView__TPPpwebPageView_TextFragment_link) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_TextFragment_link));
#endif
_currn->_prod = webPageView_RULEpwebPageView_TextFragment_link;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_TextFragment_link;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_TextFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_TextFragment_value (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_TextFragment_value (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_TextFragment_value _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_TextFragment_value;
#else
_currn = (webPageView__TPPpwebPageView_TextFragment_value) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_TextFragment_value));
#endif
_currn->_prod = webPageView_RULEpwebPageView_TextFragment_value;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_TextFragment_value;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_TextFragment_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_TextFragment_fontstyle (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_TextFragment_fontstyle (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_TextFragment_fontstyle _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_TextFragment_fontstyle;
#else
_currn = (webPageView__TPPpwebPageView_TextFragment_fontstyle) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_TextFragment_fontstyle));
#endif
_currn->_prod = webPageView_RULEpwebPageView_TextFragment_fontstyle;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_TextFragment_fontstyle;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_TextFragment_fontstyle */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageFragment (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7, NODEPTR _desc8)
#else
NODEPTR webPageView_MkpwebPageView_ImageFragment (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7,_desc8)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
	NODEPTR _desc8;
#endif
{	webPageView__TPPpwebPageView_ImageFragment _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageFragment;
#else
_currn = (webPageView__TPPpwebPageView_ImageFragment) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageFragment));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageFragment;
_currn->_desc1 = (webPageView__TSPwebPageView_ImageFragment_link) webPageView_MkwebPageView_ImageFragment_link (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageFragment: root of subtree no. 1 can not be made a webPageView_ImageFragment_link node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_ImageFragment_width) webPageView_MkwebPageView_ImageFragment_width (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageFragment: root of subtree no. 2 can not be made a webPageView_ImageFragment_width node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_ImageFragment_height) webPageView_MkwebPageView_ImageFragment_height (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageFragment: root of subtree no. 3 can not be made a webPageView_ImageFragment_height node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_ImageFragment_border) webPageView_MkwebPageView_ImageFragment_border (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageFragment: root of subtree no. 4 can not be made a webPageView_ImageFragment_border node ", 0, _coordref);
_currn->_desc5 = (webPageView__TSPwebPageView_ImageFragment_verticalAlign) webPageView_MkwebPageView_ImageFragment_verticalAlign (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageFragment: root of subtree no. 5 can not be made a webPageView_ImageFragment_verticalAlign node ", 0, _coordref);
_currn->_desc6 = (webPageView__TSPwebPageView_ImageFragment_float) webPageView_MkwebPageView_ImageFragment_float (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageFragment: root of subtree no. 6 can not be made a webPageView_ImageFragment_float node ", 0, _coordref);
_currn->_desc7 = (webPageView__TSPwebPageView_ImageFragment_text) webPageView_MkwebPageView_ImageFragment_text (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageFragment: root of subtree no. 7 can not be made a webPageView_ImageFragment_text node ", 0, _coordref);
_currn->_desc8 = (webPageView__TSPwebPageView_ImageFragment_imageName) webPageView_MkwebPageView_ImageFragment_imageName (_coordref, _desc8);	
if (((NODEPTR)_currn->_desc8) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageFragment: root of subtree no. 8 can not be made a webPageView_ImageFragment_imageName node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageFragment;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageFragment_link (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageFragment_link (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageFragment_link _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageFragment_link;
#else
_currn = (webPageView__TPPpwebPageView_ImageFragment_link) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageFragment_link));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageFragment_link;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageFragment_link;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageFragment_width (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageFragment_width (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageFragment_width _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageFragment_width;
#else
_currn = (webPageView__TPPpwebPageView_ImageFragment_width) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageFragment_width));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageFragment_width;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageFragment_width;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageFragment_width */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageFragment_height (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageFragment_height (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageFragment_height _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageFragment_height;
#else
_currn = (webPageView__TPPpwebPageView_ImageFragment_height) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageFragment_height));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageFragment_height;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageFragment_height;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageFragment_height */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageFragment_border (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageFragment_border (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageFragment_border _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageFragment_border;
#else
_currn = (webPageView__TPPpwebPageView_ImageFragment_border) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageFragment_border));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageFragment_border;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageFragment_border;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageFragment_border */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageFragment_verticalAlign (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageFragment_verticalAlign (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageFragment_verticalAlign _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageFragment_verticalAlign;
#else
_currn = (webPageView__TPPpwebPageView_ImageFragment_verticalAlign) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageFragment_verticalAlign));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageFragment_verticalAlign;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageFragment_verticalAlign;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageFragment_verticalAlign */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageFragment_float (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageFragment_float (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageFragment_float _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageFragment_float;
#else
_currn = (webPageView__TPPpwebPageView_ImageFragment_float) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageFragment_float));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageFragment_float;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageFragment_float;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageFragment_float */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageFragment_text (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageFragment_text (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageFragment_text _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageFragment_text;
#else
_currn = (webPageView__TPPpwebPageView_ImageFragment_text) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageFragment_text));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageFragment_text;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageFragment_text;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageFragment_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageFragment_imageName (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageFragment_imageName (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageFragment_imageName _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageFragment_imageName;
#else
_currn = (webPageView__TPPpwebPageView_ImageFragment_imageName) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageFragment_imageName));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageFragment_imageName;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageFragment_imageName;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageFragment_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Heading (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR webPageView_MkpwebPageView_Heading (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	webPageView__TPPpwebPageView_Heading _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Heading;
#else
_currn = (webPageView__TPPpwebPageView_Heading) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Heading));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Heading;
_currn->_desc1 = (webPageView__TSPwebPageView_Heading_styleSheetBlock) webPageView_MkwebPageView_Heading_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Heading: root of subtree no. 1 can not be made a webPageView_Heading_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_Heading_text) webPageView_MkwebPageView_Heading_text (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Heading: root of subtree no. 2 can not be made a webPageView_Heading_text node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_Heading_level) webPageView_MkwebPageView_Heading_level (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Heading: root of subtree no. 3 can not be made a webPageView_Heading_level node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Heading;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Heading */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Heading_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_Heading_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_Heading_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Heading_styleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_Heading_styleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Heading_styleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Heading_styleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Heading_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Heading_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Heading_text (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_Heading_text (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_Heading_text _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Heading_text;
#else
_currn = (webPageView__TPPpwebPageView_Heading_text) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Heading_text));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Heading_text;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Heading_text;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Heading_text */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Heading_level (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_Heading_level (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_Heading_level _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Heading_level;
#else
_currn = (webPageView__TPPpwebPageView_Heading_level) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Heading_level));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Heading_level;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Heading_level;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Heading_level */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Table (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3)
#else
NODEPTR webPageView_MkpwebPageView_Table (_coordref, _TERM1,_desc1,_desc2,_desc3)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
#endif
{	webPageView__TPPpwebPageView_Table _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Table;
#else
_currn = (webPageView__TPPpwebPageView_Table) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Table));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Table;
_currn->_desc1 = (webPageView__TSPwebPageView_Table_styleSheetBlock) webPageView_MkwebPageView_Table_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Table: root of subtree no. 1 can not be made a webPageView_Table_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_Table_rows) webPageView_MkwebPageView_Table_rows (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Table: root of subtree no. 2 can not be made a webPageView_Table_rows node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_Table_columns) webPageView_MkwebPageView_Table_columns (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Table: root of subtree no. 3 can not be made a webPageView_Table_columns node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Table;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Table */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Table_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_Table_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_Table_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Table_styleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_Table_styleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Table_styleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Table_styleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Table_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Table_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_TableRowpwebPageView_Table_rows (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_TableRowpwebPageView_Table_rows (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_TableRowpwebPageView_Table_rows _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_TableRowpwebPageView_Table_rows;
#else
	_new = (webPageView__TPPLST_webPageView_TableRowpwebPageView_Table_rows) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_TableRowpwebPageView_Table_rows));
#endif
	_new->_prod = webPageView_RULELST_webPageView_TableRowpwebPageView_Table_rows;
	_new->_desc1 = (webPageView__TSPwebPageView_TableRow)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Table_rows)_new;
	{webPageView__TPPLST_webPageView_TableRowpwebPageView_Table_rows _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_TableRowpwebPageView_Table_rows;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_Table_rows (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_Table_rows (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_TableRow)) 
		return webPageView__MkwebPageView_TableRowpwebPageView_Table_rows (_coordref, webPageView_MkwebPageView_TableRow (_coordref, t));
	message (DEADLY, "a pwebPageView_Table_rows list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_Table_rows (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_Table_rows (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_Table_rows)
	l =_ElempwebPageView_Table_rows (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_Table_rows)
	r = _ElempwebPageView_Table_rows (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_Table_rows)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_Table_rows)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_Table_rows)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_Table_rows)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Table_rows (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_Table_rows (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_Table_rows root;
	webPageView__TPPLST_0pwebPageView_Table_rows list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_Table_rows)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_Table_rows)
		t = _ElempwebPageView_Table_rows (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_Table_rows)(((webPageView__TPPLST_0pwebPageView_Table_rows) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_Table_rows) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_Table_rows;
#else
list = (webPageView__TPPLST_0pwebPageView_Table_rows) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_Table_rows));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_Table_rows;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_Table_rows)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_TableRowpwebPageView_Table_rows)
	{webPageView__TPPLST_webPageView_TableRowpwebPageView_Table_rows _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_TableRowpwebPageView_Table_rows;
	} this code has been moved to _ElempwebPageView_Table_rows*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_Table_rows;
#else
root = (webPageView__TPPpwebPageView_Table_rows) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Table_rows));
#endif
root->_prod = webPageView_RULEpwebPageView_Table_rows;
root->_desc1 = (webPageView__TSPLST_webPageView_Table_rows)list;
{ webPageView__TPPpwebPageView_Table_rows _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_Table_rows;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_TableColumnpwebPageView_Table_columns (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_TableColumnpwebPageView_Table_columns (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_TableColumnpwebPageView_Table_columns _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_TableColumnpwebPageView_Table_columns;
#else
	_new = (webPageView__TPPLST_webPageView_TableColumnpwebPageView_Table_columns) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_TableColumnpwebPageView_Table_columns));
#endif
	_new->_prod = webPageView_RULELST_webPageView_TableColumnpwebPageView_Table_columns;
	_new->_desc1 = (webPageView__TSPwebPageView_TableColumn)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Table_columns)_new;
	{webPageView__TPPLST_webPageView_TableColumnpwebPageView_Table_columns _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_TableColumnpwebPageView_Table_columns;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_Table_columns (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_Table_columns (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_TableColumn)) 
		return webPageView__MkwebPageView_TableColumnpwebPageView_Table_columns (_coordref, webPageView_MkwebPageView_TableColumn (_coordref, t));
	message (DEADLY, "a pwebPageView_Table_columns list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_Table_columns (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_Table_columns (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_Table_columns)
	l =_ElempwebPageView_Table_columns (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_Table_columns)
	r = _ElempwebPageView_Table_columns (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_Table_columns)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_Table_columns)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_Table_columns)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_Table_columns)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Table_columns (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_Table_columns (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_Table_columns root;
	webPageView__TPPLST_0pwebPageView_Table_columns list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_Table_columns)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_Table_columns)
		t = _ElempwebPageView_Table_columns (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_Table_columns)(((webPageView__TPPLST_0pwebPageView_Table_columns) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_Table_columns) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_Table_columns;
#else
list = (webPageView__TPPLST_0pwebPageView_Table_columns) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_Table_columns));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_Table_columns;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_Table_columns)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_TableColumnpwebPageView_Table_columns)
	{webPageView__TPPLST_webPageView_TableColumnpwebPageView_Table_columns _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_TableColumnpwebPageView_Table_columns;
	} this code has been moved to _ElempwebPageView_Table_columns*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_Table_columns;
#else
root = (webPageView__TPPpwebPageView_Table_columns) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Table_columns));
#endif
root->_prod = webPageView_RULEpwebPageView_Table_columns;
root->_desc1 = (webPageView__TSPLST_webPageView_Table_columns)list;
{ webPageView__TPPpwebPageView_Table_columns _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_Table_columns;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_TableRow (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_TableRow (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_TableRow _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_TableRow;
#else
_currn = (webPageView__TPPpwebPageView_TableRow) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_TableRow));
#endif
_currn->_prod = webPageView_RULEpwebPageView_TableRow;
_currn->_desc1 = (webPageView__TSPwebPageView_TableRow_cells) webPageView_MkwebPageView_TableRow_cells (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_TableRow: root of subtree no. 1 can not be made a webPageView_TableRow_cells node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_TableRow;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_TableRow */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_TableCellpwebPageView_TableRow_cells (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_TableCellpwebPageView_TableRow_cells (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_TableCellpwebPageView_TableRow_cells _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_TableCellpwebPageView_TableRow_cells;
#else
	_new = (webPageView__TPPLST_webPageView_TableCellpwebPageView_TableRow_cells) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_TableCellpwebPageView_TableRow_cells));
#endif
	_new->_prod = webPageView_RULELST_webPageView_TableCellpwebPageView_TableRow_cells;
	_new->_desc1 = (webPageView__TSPwebPageView_TableCell)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_TableRow_cells)_new;
	{webPageView__TPPLST_webPageView_TableCellpwebPageView_TableRow_cells _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_TableCellpwebPageView_TableRow_cells;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_TableRow_cells (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_TableRow_cells (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_TableCell)) 
		return webPageView__MkwebPageView_TableCellpwebPageView_TableRow_cells (_coordref, webPageView_MkwebPageView_TableCell (_coordref, t));
	message (DEADLY, "a pwebPageView_TableRow_cells list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_TableRow_cells (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_TableRow_cells (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_TableRow_cells)
	l =_ElempwebPageView_TableRow_cells (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_TableRow_cells)
	r = _ElempwebPageView_TableRow_cells (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_TableRow_cells)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_TableRow_cells)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_TableRow_cells)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_TableRow_cells)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_TableRow_cells (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_TableRow_cells (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_TableRow_cells root;
	webPageView__TPPLST_0pwebPageView_TableRow_cells list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_TableRow_cells)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_TableRow_cells)
		t = _ElempwebPageView_TableRow_cells (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_TableRow_cells)(((webPageView__TPPLST_0pwebPageView_TableRow_cells) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_TableRow_cells) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_TableRow_cells;
#else
list = (webPageView__TPPLST_0pwebPageView_TableRow_cells) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_TableRow_cells));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_TableRow_cells;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_TableRow_cells)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_TableCellpwebPageView_TableRow_cells)
	{webPageView__TPPLST_webPageView_TableCellpwebPageView_TableRow_cells _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_TableCellpwebPageView_TableRow_cells;
	} this code has been moved to _ElempwebPageView_TableRow_cells*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_TableRow_cells;
#else
root = (webPageView__TPPpwebPageView_TableRow_cells) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_TableRow_cells));
#endif
root->_prod = webPageView_RULEpwebPageView_TableRow_cells;
root->_desc1 = (webPageView__TSPLST_webPageView_TableRow_cells)list;
{ webPageView__TPPpwebPageView_TableRow_cells _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_TableRow_cells;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_TableColumn (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_TableColumn (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_TableColumn _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_TableColumn;
#else
_currn = (webPageView__TPPpwebPageView_TableColumn) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_TableColumn));
#endif
_currn->_prod = webPageView_RULEpwebPageView_TableColumn;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_TableColumn;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_TableColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_TableCell (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_TableCell (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_TableCell _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_TableCell;
#else
_currn = (webPageView__TPPpwebPageView_TableCell) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_TableCell));
#endif
_currn->_prod = webPageView_RULEpwebPageView_TableCell;
_currn->_desc1 = (webPageView__TSPwebPageView_TableCell_columnRef) webPageView_MkwebPageView_TableCell_columnRef (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_TableCell: root of subtree no. 1 can not be made a webPageView_TableCell_columnRef node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_TableCell_content) webPageView_MkwebPageView_TableCell_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_TableCell: root of subtree no. 2 can not be made a webPageView_TableCell_content node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_TableCell;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_TableCell */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_TableCell_columnRef (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_TableCell_columnRef (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_TableCell_columnRef _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_TableCell_columnRef;
#else
_currn = (webPageView__TPPpwebPageView_TableCell_columnRef) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_TableCell_columnRef));
#endif
_currn->_prod = webPageView_RULEpwebPageView_TableCell_columnRef;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_TableCell_columnRef;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_TableCell_columnRef */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Formular (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7)
#else
NODEPTR webPageView_MkpwebPageView_Formular (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
#endif
{	webPageView__TPPpwebPageView_Formular _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Formular;
#else
_currn = (webPageView__TPPpwebPageView_Formular) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Formular));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Formular;
_currn->_desc1 = (webPageView__TSPwebPageView_Formular_styleSheetBlock) webPageView_MkwebPageView_Formular_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Formular: root of subtree no. 1 can not be made a webPageView_Formular_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_Formular_name) webPageView_MkwebPageView_Formular_name (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Formular: root of subtree no. 2 can not be made a webPageView_Formular_name node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_Formular_action) webPageView_MkwebPageView_Formular_action (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Formular: root of subtree no. 3 can not be made a webPageView_Formular_action node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_Formular_dataSource) webPageView_MkwebPageView_Formular_dataSource (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Formular: root of subtree no. 4 can not be made a webPageView_Formular_dataSource node ", 0, _coordref);
_currn->_desc5 = (webPageView__TSPwebPageView_Formular_dataSourceId) webPageView_MkwebPageView_Formular_dataSourceId (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Formular: root of subtree no. 5 can not be made a webPageView_Formular_dataSourceId node ", 0, _coordref);
_currn->_desc6 = (webPageView__TSPwebPageView_Formular_elements) webPageView_MkwebPageView_Formular_elements (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Formular: root of subtree no. 6 can not be made a webPageView_Formular_elements node ", 0, _coordref);
_currn->_desc7 = (webPageView__TSPwebPageView_Formular_actualParams) webPageView_MkwebPageView_Formular_actualParams (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_Formular: root of subtree no. 7 can not be made a webPageView_Formular_actualParams node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Formular;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Formular */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Formular_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_Formular_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_Formular_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Formular_styleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_Formular_styleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Formular_styleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Formular_styleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Formular_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Formular_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Formular_name (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_Formular_name (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_Formular_name _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Formular_name;
#else
_currn = (webPageView__TPPpwebPageView_Formular_name) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Formular_name));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Formular_name;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Formular_name;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Formular_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Formular_action (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_Formular_action (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_Formular_action _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Formular_action;
#else
_currn = (webPageView__TPPpwebPageView_Formular_action) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Formular_action));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Formular_action;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Formular_action;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Formular_action */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Formular_dataSource (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_Formular_dataSource (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_Formular_dataSource _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Formular_dataSource;
#else
_currn = (webPageView__TPPpwebPageView_Formular_dataSource) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Formular_dataSource));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Formular_dataSource;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Formular_dataSource;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Formular_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Formular_dataSourceId (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_Formular_dataSourceId (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_Formular_dataSourceId _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_Formular_dataSourceId;
#else
_currn = (webPageView__TPPpwebPageView_Formular_dataSourceId) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Formular_dataSourceId));
#endif
_currn->_prod = webPageView_RULEpwebPageView_Formular_dataSourceId;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_Formular_dataSourceId;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_Formular_dataSourceId */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularRadioGroupElementpwebPageView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularRadioGroupElementpwebPageView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements;
#else
	_new = (webPageView__TPPLST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularRadioGroupElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Formular_elements)_new;
	{webPageView__TPPLST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularTextElementpwebPageView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularTextElementpwebPageView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularTextElementpwebPageView_Formular_elements _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularTextElementpwebPageView_Formular_elements;
#else
	_new = (webPageView__TPPLST_webPageView_FormularTextElementpwebPageView_Formular_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularTextElementpwebPageView_Formular_elements));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularTextElementpwebPageView_Formular_elements;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularTextElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Formular_elements)_new;
	{webPageView__TPPLST_webPageView_FormularTextElementpwebPageView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularTextElementpwebPageView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularTextAreaElementpwebPageView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularTextAreaElementpwebPageView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements;
#else
	_new = (webPageView__TPPLST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularTextAreaElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Formular_elements)_new;
	{webPageView__TPPLST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularPasswordElementpwebPageView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularPasswordElementpwebPageView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularPasswordElementpwebPageView_Formular_elements _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularPasswordElementpwebPageView_Formular_elements;
#else
	_new = (webPageView__TPPLST_webPageView_FormularPasswordElementpwebPageView_Formular_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularPasswordElementpwebPageView_Formular_elements));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularPasswordElementpwebPageView_Formular_elements;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularPasswordElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Formular_elements)_new;
	{webPageView__TPPLST_webPageView_FormularPasswordElementpwebPageView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularPasswordElementpwebPageView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularDateElementpwebPageView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularDateElementpwebPageView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularDateElementpwebPageView_Formular_elements _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularDateElementpwebPageView_Formular_elements;
#else
	_new = (webPageView__TPPLST_webPageView_FormularDateElementpwebPageView_Formular_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularDateElementpwebPageView_Formular_elements));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularDateElementpwebPageView_Formular_elements;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularDateElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Formular_elements)_new;
	{webPageView__TPPLST_webPageView_FormularDateElementpwebPageView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularDateElementpwebPageView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularFileUploadElementpwebPageView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularFileUploadElementpwebPageView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularFileUploadElementpwebPageView_Formular_elements _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularFileUploadElementpwebPageView_Formular_elements;
#else
	_new = (webPageView__TPPLST_webPageView_FormularFileUploadElementpwebPageView_Formular_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularFileUploadElementpwebPageView_Formular_elements));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularFileUploadElementpwebPageView_Formular_elements;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularFileUploadElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Formular_elements)_new;
	{webPageView__TPPLST_webPageView_FormularFileUploadElementpwebPageView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularFileUploadElementpwebPageView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularCheckboxElementpwebPageView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularCheckboxElementpwebPageView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements;
#else
	_new = (webPageView__TPPLST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularCheckboxElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Formular_elements)_new;
	{webPageView__TPPLST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularSelectElementpwebPageView_Formular_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularSelectElementpwebPageView_Formular_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularSelectElementpwebPageView_Formular_elements _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularSelectElementpwebPageView_Formular_elements;
#else
	_new = (webPageView__TPPLST_webPageView_FormularSelectElementpwebPageView_Formular_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularSelectElementpwebPageView_Formular_elements));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularSelectElementpwebPageView_Formular_elements;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularSelectElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Formular_elements)_new;
	{webPageView__TPPLST_webPageView_FormularSelectElementpwebPageView_Formular_elements _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularSelectElementpwebPageView_Formular_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_Formular_elements (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_Formular_elements (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularRadioGroupElement)) 
		return webPageView__MkwebPageView_FormularRadioGroupElementpwebPageView_Formular_elements (_coordref, webPageView_MkwebPageView_FormularRadioGroupElement (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularTextElement)) 
		return webPageView__MkwebPageView_FormularTextElementpwebPageView_Formular_elements (_coordref, webPageView_MkwebPageView_FormularTextElement (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularTextAreaElement)) 
		return webPageView__MkwebPageView_FormularTextAreaElementpwebPageView_Formular_elements (_coordref, webPageView_MkwebPageView_FormularTextAreaElement (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularPasswordElement)) 
		return webPageView__MkwebPageView_FormularPasswordElementpwebPageView_Formular_elements (_coordref, webPageView_MkwebPageView_FormularPasswordElement (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularDateElement)) 
		return webPageView__MkwebPageView_FormularDateElementpwebPageView_Formular_elements (_coordref, webPageView_MkwebPageView_FormularDateElement (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularFileUploadElement)) 
		return webPageView__MkwebPageView_FormularFileUploadElementpwebPageView_Formular_elements (_coordref, webPageView_MkwebPageView_FormularFileUploadElement (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularCheckboxElement)) 
		return webPageView__MkwebPageView_FormularCheckboxElementpwebPageView_Formular_elements (_coordref, webPageView_MkwebPageView_FormularCheckboxElement (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularSelectElement)) 
		return webPageView__MkwebPageView_FormularSelectElementpwebPageView_Formular_elements (_coordref, webPageView_MkwebPageView_FormularSelectElement (_coordref, t));
	message (DEADLY, "a pwebPageView_Formular_elements list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_Formular_elements (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_Formular_elements (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_Formular_elements)
	l =_ElempwebPageView_Formular_elements (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_Formular_elements)
	r = _ElempwebPageView_Formular_elements (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_Formular_elements)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_Formular_elements)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_Formular_elements)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_Formular_elements)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Formular_elements (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_Formular_elements (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_Formular_elements root;
	webPageView__TPPLST_0pwebPageView_Formular_elements list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_Formular_elements)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_Formular_elements)
		t = _ElempwebPageView_Formular_elements (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_Formular_elements)(((webPageView__TPPLST_0pwebPageView_Formular_elements) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_Formular_elements) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_Formular_elements;
#else
list = (webPageView__TPPLST_0pwebPageView_Formular_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_Formular_elements));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_Formular_elements;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_Formular_elements)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements)
	{webPageView__TPPLST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularRadioGroupElementpwebPageView_Formular_elements;
	} this code has been moved to _ElempwebPageView_Formular_elements*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularTextElementpwebPageView_Formular_elements)
	{webPageView__TPPLST_webPageView_FormularTextElementpwebPageView_Formular_elements _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularTextElementpwebPageView_Formular_elements;
	} this code has been moved to _ElempwebPageView_Formular_elements*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements)
	{webPageView__TPPLST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularTextAreaElementpwebPageView_Formular_elements;
	} this code has been moved to _ElempwebPageView_Formular_elements*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularPasswordElementpwebPageView_Formular_elements)
	{webPageView__TPPLST_webPageView_FormularPasswordElementpwebPageView_Formular_elements _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularPasswordElementpwebPageView_Formular_elements;
	} this code has been moved to _ElempwebPageView_Formular_elements*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularDateElementpwebPageView_Formular_elements)
	{webPageView__TPPLST_webPageView_FormularDateElementpwebPageView_Formular_elements _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularDateElementpwebPageView_Formular_elements;
	} this code has been moved to _ElempwebPageView_Formular_elements*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularFileUploadElementpwebPageView_Formular_elements)
	{webPageView__TPPLST_webPageView_FormularFileUploadElementpwebPageView_Formular_elements _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularFileUploadElementpwebPageView_Formular_elements;
	} this code has been moved to _ElempwebPageView_Formular_elements*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements)
	{webPageView__TPPLST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularCheckboxElementpwebPageView_Formular_elements;
	} this code has been moved to _ElempwebPageView_Formular_elements*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularSelectElementpwebPageView_Formular_elements)
	{webPageView__TPPLST_webPageView_FormularSelectElementpwebPageView_Formular_elements _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularSelectElementpwebPageView_Formular_elements;
	} this code has been moved to _ElempwebPageView_Formular_elements*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_Formular_elements;
#else
root = (webPageView__TPPpwebPageView_Formular_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Formular_elements));
#endif
root->_prod = webPageView_RULEpwebPageView_Formular_elements;
root->_desc1 = (webPageView__TSPLST_webPageView_Formular_elements)list;
{ webPageView__TPPpwebPageView_Formular_elements _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_Formular_elements;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_WebNodeActualParampwebPageView_Formular_actualParams (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_WebNodeActualParampwebPageView_Formular_actualParams (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams;
#else
	_new = (webPageView__TPPLST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams));
#endif
	_new->_prod = webPageView_RULELST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams;
	_new->_desc1 = (webPageView__TSPwebPageView_WebNodeActualParam)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_Formular_actualParams)_new;
	{webPageView__TPPLST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_Formular_actualParams (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_Formular_actualParams (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_WebNodeActualParam)) 
		return webPageView__MkwebPageView_WebNodeActualParampwebPageView_Formular_actualParams (_coordref, webPageView_MkwebPageView_WebNodeActualParam (_coordref, t));
	message (DEADLY, "a pwebPageView_Formular_actualParams list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_Formular_actualParams (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_Formular_actualParams (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_Formular_actualParams)
	l =_ElempwebPageView_Formular_actualParams (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_Formular_actualParams)
	r = _ElempwebPageView_Formular_actualParams (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_Formular_actualParams)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_Formular_actualParams)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_Formular_actualParams)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_Formular_actualParams)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_Formular_actualParams (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_Formular_actualParams (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_Formular_actualParams root;
	webPageView__TPPLST_0pwebPageView_Formular_actualParams list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_Formular_actualParams)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_Formular_actualParams)
		t = _ElempwebPageView_Formular_actualParams (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_Formular_actualParams)(((webPageView__TPPLST_0pwebPageView_Formular_actualParams) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_Formular_actualParams) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_Formular_actualParams;
#else
list = (webPageView__TPPLST_0pwebPageView_Formular_actualParams) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_Formular_actualParams));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_Formular_actualParams;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_Formular_actualParams)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams)
	{webPageView__TPPLST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_WebNodeActualParampwebPageView_Formular_actualParams;
	} this code has been moved to _ElempwebPageView_Formular_actualParams*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_Formular_actualParams;
#else
root = (webPageView__TPPpwebPageView_Formular_actualParams) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_Formular_actualParams));
#endif
root->_prod = webPageView_RULEpwebPageView_Formular_actualParams;
root->_desc1 = (webPageView__TSPLST_webPageView_Formular_actualParams)list;
{ webPageView__TPPpwebPageView_Formular_actualParams _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_Formular_actualParams;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_EmailValidator (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_EmailValidator (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_EmailValidator _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_EmailValidator;
#else
_currn = (webPageView__TPPpwebPageView_EmailValidator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_EmailValidator));
#endif
_currn->_prod = webPageView_RULEpwebPageView_EmailValidator;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_EmailValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_EmailValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_CreditCardValidator (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_CreditCardValidator (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_CreditCardValidator _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_CreditCardValidator;
#else
_currn = (webPageView__TPPpwebPageView_CreditCardValidator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_CreditCardValidator));
#endif
_currn->_prod = webPageView_RULEpwebPageView_CreditCardValidator;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_CreditCardValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_CreditCardValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_RegExprValidator (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_RegExprValidator (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_RegExprValidator _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_RegExprValidator;
#else
_currn = (webPageView__TPPpwebPageView_RegExprValidator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_RegExprValidator));
#endif
_currn->_prod = webPageView_RULEpwebPageView_RegExprValidator;
_currn->_desc1 = (webPageView__TSPwebPageView_RegExprValidator_pattern) webPageView_MkwebPageView_RegExprValidator_pattern (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_RegExprValidator: root of subtree no. 1 can not be made a webPageView_RegExprValidator_pattern node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_RegExprValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_RegExprValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_RegExprValidator_pattern (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_RegExprValidator_pattern (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_RegExprValidator_pattern _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_RegExprValidator_pattern;
#else
_currn = (webPageView__TPPpwebPageView_RegExprValidator_pattern) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_RegExprValidator_pattern));
#endif
_currn->_prod = webPageView_RULEpwebPageView_RegExprValidator_pattern;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_RegExprValidator_pattern;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_RegExprValidator_pattern */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_StringLengthValidator (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_StringLengthValidator (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_StringLengthValidator _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_StringLengthValidator;
#else
_currn = (webPageView__TPPpwebPageView_StringLengthValidator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_StringLengthValidator));
#endif
_currn->_prod = webPageView_RULEpwebPageView_StringLengthValidator;
_currn->_desc1 = (webPageView__TSPwebPageView_StringLengthValidator_min) webPageView_MkwebPageView_StringLengthValidator_min (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_StringLengthValidator: root of subtree no. 1 can not be made a webPageView_StringLengthValidator_min node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_StringLengthValidator_max) webPageView_MkwebPageView_StringLengthValidator_max (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_StringLengthValidator: root of subtree no. 2 can not be made a webPageView_StringLengthValidator_max node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_StringLengthValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_StringLengthValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_StringLengthValidator_min (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_StringLengthValidator_min (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_StringLengthValidator_min _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_StringLengthValidator_min;
#else
_currn = (webPageView__TPPpwebPageView_StringLengthValidator_min) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_StringLengthValidator_min));
#endif
_currn->_prod = webPageView_RULEpwebPageView_StringLengthValidator_min;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_StringLengthValidator_min;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_StringLengthValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_StringLengthValidator_max (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_StringLengthValidator_max (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_StringLengthValidator_max _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_StringLengthValidator_max;
#else
_currn = (webPageView__TPPpwebPageView_StringLengthValidator_max) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_StringLengthValidator_max));
#endif
_currn->_prod = webPageView_RULEpwebPageView_StringLengthValidator_max;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_StringLengthValidator_max;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_StringLengthValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_LongRangeValidator (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_LongRangeValidator (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_LongRangeValidator _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_LongRangeValidator;
#else
_currn = (webPageView__TPPpwebPageView_LongRangeValidator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_LongRangeValidator));
#endif
_currn->_prod = webPageView_RULEpwebPageView_LongRangeValidator;
_currn->_desc1 = (webPageView__TSPwebPageView_LongRangeValidator_min) webPageView_MkwebPageView_LongRangeValidator_min (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_LongRangeValidator: root of subtree no. 1 can not be made a webPageView_LongRangeValidator_min node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_LongRangeValidator_max) webPageView_MkwebPageView_LongRangeValidator_max (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_LongRangeValidator: root of subtree no. 2 can not be made a webPageView_LongRangeValidator_max node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_LongRangeValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_LongRangeValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_LongRangeValidator_min (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_LongRangeValidator_min (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_LongRangeValidator_min _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_LongRangeValidator_min;
#else
_currn = (webPageView__TPPpwebPageView_LongRangeValidator_min) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_LongRangeValidator_min));
#endif
_currn->_prod = webPageView_RULEpwebPageView_LongRangeValidator_min;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_LongRangeValidator_min;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_LongRangeValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_LongRangeValidator_max (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_LongRangeValidator_max (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_LongRangeValidator_max _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_LongRangeValidator_max;
#else
_currn = (webPageView__TPPpwebPageView_LongRangeValidator_max) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_LongRangeValidator_max));
#endif
_currn->_prod = webPageView_RULEpwebPageView_LongRangeValidator_max;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_LongRangeValidator_max;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_LongRangeValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DoubleRangeValidator (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_DoubleRangeValidator (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_DoubleRangeValidator _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DoubleRangeValidator;
#else
_currn = (webPageView__TPPpwebPageView_DoubleRangeValidator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DoubleRangeValidator));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DoubleRangeValidator;
_currn->_desc1 = (webPageView__TSPwebPageView_DoubleRangeValidator_min) webPageView_MkwebPageView_DoubleRangeValidator_min (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DoubleRangeValidator: root of subtree no. 1 can not be made a webPageView_DoubleRangeValidator_min node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_DoubleRangeValidator_max) webPageView_MkwebPageView_DoubleRangeValidator_max (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DoubleRangeValidator: root of subtree no. 2 can not be made a webPageView_DoubleRangeValidator_max node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DoubleRangeValidator;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DoubleRangeValidator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DoubleRangeValidator_min (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DoubleRangeValidator_min (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DoubleRangeValidator_min _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DoubleRangeValidator_min;
#else
_currn = (webPageView__TPPpwebPageView_DoubleRangeValidator_min) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DoubleRangeValidator_min));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DoubleRangeValidator_min;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DoubleRangeValidator_min;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DoubleRangeValidator_min */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DoubleRangeValidator_max (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DoubleRangeValidator_max (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DoubleRangeValidator_max _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DoubleRangeValidator_max;
#else
_currn = (webPageView__TPPpwebPageView_DoubleRangeValidator_max) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DoubleRangeValidator_max));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DoubleRangeValidator_max;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DoubleRangeValidator_max;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DoubleRangeValidator_max */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_IntegerNumberConverter (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_IntegerNumberConverter (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_IntegerNumberConverter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_IntegerNumberConverter;
#else
_currn = (webPageView__TPPpwebPageView_IntegerNumberConverter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_IntegerNumberConverter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_IntegerNumberConverter;
_currn->_desc1 = (webPageView__TSPwebPageView_IntegerNumberConverter_minIntegerDigits) webPageView_MkwebPageView_IntegerNumberConverter_minIntegerDigits (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_IntegerNumberConverter: root of subtree no. 1 can not be made a webPageView_IntegerNumberConverter_minIntegerDigits node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_IntegerNumberConverter_maxIntegerDigits) webPageView_MkwebPageView_IntegerNumberConverter_maxIntegerDigits (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_IntegerNumberConverter: root of subtree no. 2 can not be made a webPageView_IntegerNumberConverter_maxIntegerDigits node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_IntegerNumberConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_IntegerNumberConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_IntegerNumberConverter_minIntegerDigits (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_IntegerNumberConverter_minIntegerDigits (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_IntegerNumberConverter_minIntegerDigits _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_IntegerNumberConverter_minIntegerDigits;
#else
_currn = (webPageView__TPPpwebPageView_IntegerNumberConverter_minIntegerDigits) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_IntegerNumberConverter_minIntegerDigits));
#endif
_currn->_prod = webPageView_RULEpwebPageView_IntegerNumberConverter_minIntegerDigits;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_IntegerNumberConverter_minIntegerDigits;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_IntegerNumberConverter_minIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_IntegerNumberConverter_maxIntegerDigits (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_IntegerNumberConverter_maxIntegerDigits (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_IntegerNumberConverter_maxIntegerDigits _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_IntegerNumberConverter_maxIntegerDigits;
#else
_currn = (webPageView__TPPpwebPageView_IntegerNumberConverter_maxIntegerDigits) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_IntegerNumberConverter_maxIntegerDigits));
#endif
_currn->_prod = webPageView_RULEpwebPageView_IntegerNumberConverter_maxIntegerDigits;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_IntegerNumberConverter_maxIntegerDigits;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_IntegerNumberConverter_maxIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DoubleNumberConverter (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_DoubleNumberConverter (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_DoubleNumberConverter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DoubleNumberConverter;
#else
_currn = (webPageView__TPPpwebPageView_DoubleNumberConverter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DoubleNumberConverter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DoubleNumberConverter;
_currn->_desc1 = (webPageView__TSPwebPageView_DoubleNumberConverter_minIntegerDigits) webPageView_MkwebPageView_DoubleNumberConverter_minIntegerDigits (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DoubleNumberConverter: root of subtree no. 1 can not be made a webPageView_DoubleNumberConverter_minIntegerDigits node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_DoubleNumberConverter_maxIntegerDigits) webPageView_MkwebPageView_DoubleNumberConverter_maxIntegerDigits (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DoubleNumberConverter: root of subtree no. 2 can not be made a webPageView_DoubleNumberConverter_maxIntegerDigits node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_DoubleNumberConverter_minFractionDigits) webPageView_MkwebPageView_DoubleNumberConverter_minFractionDigits (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DoubleNumberConverter: root of subtree no. 3 can not be made a webPageView_DoubleNumberConverter_minFractionDigits node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_DoubleNumberConverter_maxFractionDigits) webPageView_MkwebPageView_DoubleNumberConverter_maxFractionDigits (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_DoubleNumberConverter: root of subtree no. 4 can not be made a webPageView_DoubleNumberConverter_maxFractionDigits node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DoubleNumberConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DoubleNumberConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DoubleNumberConverter_minIntegerDigits (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DoubleNumberConverter_minIntegerDigits (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DoubleNumberConverter_minIntegerDigits _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DoubleNumberConverter_minIntegerDigits;
#else
_currn = (webPageView__TPPpwebPageView_DoubleNumberConverter_minIntegerDigits) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DoubleNumberConverter_minIntegerDigits));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DoubleNumberConverter_minIntegerDigits;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DoubleNumberConverter_minIntegerDigits;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DoubleNumberConverter_minIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DoubleNumberConverter_maxIntegerDigits (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DoubleNumberConverter_maxIntegerDigits (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DoubleNumberConverter_maxIntegerDigits _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DoubleNumberConverter_maxIntegerDigits;
#else
_currn = (webPageView__TPPpwebPageView_DoubleNumberConverter_maxIntegerDigits) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DoubleNumberConverter_maxIntegerDigits));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DoubleNumberConverter_maxIntegerDigits;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DoubleNumberConverter_maxIntegerDigits;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DoubleNumberConverter_maxIntegerDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DoubleNumberConverter_minFractionDigits (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DoubleNumberConverter_minFractionDigits (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DoubleNumberConverter_minFractionDigits _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DoubleNumberConverter_minFractionDigits;
#else
_currn = (webPageView__TPPpwebPageView_DoubleNumberConverter_minFractionDigits) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DoubleNumberConverter_minFractionDigits));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DoubleNumberConverter_minFractionDigits;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DoubleNumberConverter_minFractionDigits;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DoubleNumberConverter_minFractionDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DoubleNumberConverter_maxFractionDigits (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_DoubleNumberConverter_maxFractionDigits (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_DoubleNumberConverter_maxFractionDigits _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DoubleNumberConverter_maxFractionDigits;
#else
_currn = (webPageView__TPPpwebPageView_DoubleNumberConverter_maxFractionDigits) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DoubleNumberConverter_maxFractionDigits));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DoubleNumberConverter_maxFractionDigits;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DoubleNumberConverter_maxFractionDigits;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DoubleNumberConverter_maxFractionDigits */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_IntegerConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_IntegerConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_IntegerConverter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_IntegerConverter;
#else
_currn = (webPageView__TPPpwebPageView_IntegerConverter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_IntegerConverter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_IntegerConverter;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_IntegerConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_IntegerConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_LongConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_LongConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_LongConverter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_LongConverter;
#else
_currn = (webPageView__TPPpwebPageView_LongConverter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_LongConverter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_LongConverter;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_LongConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_LongConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_BigIntegerConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_BigIntegerConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_BigIntegerConverter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_BigIntegerConverter;
#else
_currn = (webPageView__TPPpwebPageView_BigIntegerConverter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_BigIntegerConverter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_BigIntegerConverter;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_BigIntegerConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_BigIntegerConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FloatConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_FloatConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_FloatConverter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FloatConverter;
#else
_currn = (webPageView__TPPpwebPageView_FloatConverter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FloatConverter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FloatConverter;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FloatConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FloatConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DoubleConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_DoubleConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_DoubleConverter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DoubleConverter;
#else
_currn = (webPageView__TPPpwebPageView_DoubleConverter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DoubleConverter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DoubleConverter;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DoubleConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DoubleConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_BooleanConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_BooleanConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_BooleanConverter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_BooleanConverter;
#else
_currn = (webPageView__TPPpwebPageView_BooleanConverter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_BooleanConverter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_BooleanConverter;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_BooleanConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_BooleanConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_DateTimeConverter (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_DateTimeConverter (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_DateTimeConverter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_DateTimeConverter;
#else
_currn = (webPageView__TPPpwebPageView_DateTimeConverter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_DateTimeConverter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_DateTimeConverter;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_DateTimeConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_DateTimeConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_PatternConverter (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_PatternConverter (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_PatternConverter _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_PatternConverter;
#else
_currn = (webPageView__TPPpwebPageView_PatternConverter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_PatternConverter));
#endif
_currn->_prod = webPageView_RULEpwebPageView_PatternConverter;
_currn->_desc1 = (webPageView__TSPwebPageView_PatternConverter_pattern) webPageView_MkwebPageView_PatternConverter_pattern (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_PatternConverter: root of subtree no. 1 can not be made a webPageView_PatternConverter_pattern node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_PatternConverter;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_PatternConverter */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_PatternConverter_pattern (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_PatternConverter_pattern (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_PatternConverter_pattern _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_PatternConverter_pattern;
#else
_currn = (webPageView__TPPpwebPageView_PatternConverter_pattern) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_PatternConverter_pattern));
#endif
_currn->_prod = webPageView_RULEpwebPageView_PatternConverter_pattern;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_PatternConverter_pattern;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_PatternConverter_pattern */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7, NODEPTR _desc8, NODEPTR _desc9, NODEPTR _desc10)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7,_desc8,_desc9,_desc10)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
	NODEPTR _desc8;
	NODEPTR _desc9;
	NODEPTR _desc10;
#endif
{	webPageView__TPPpwebPageView_FormularRadioGroupElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioGroupElement;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioGroupElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularRadioGroupElement_name) webPageView_MkwebPageView_FormularRadioGroupElement_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioGroupElement: root of subtree no. 1 can not be made a webPageView_FormularRadioGroupElement_name node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FormularRadioGroupElement_label) webPageView_MkwebPageView_FormularRadioGroupElement_label (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioGroupElement: root of subtree no. 2 can not be made a webPageView_FormularRadioGroupElement_label node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_FormularRadioGroupElement_description) webPageView_MkwebPageView_FormularRadioGroupElement_description (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioGroupElement: root of subtree no. 3 can not be made a webPageView_FormularRadioGroupElement_description node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_FormularRadioGroupElement_pvalue) webPageView_MkwebPageView_FormularRadioGroupElement_pvalue (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioGroupElement: root of subtree no. 4 can not be made a webPageView_FormularRadioGroupElement_pvalue node ", 0, _coordref);
_currn->_desc5 = (webPageView__TSPwebPageView_FormularRadioGroupElement_required) webPageView_MkwebPageView_FormularRadioGroupElement_required (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioGroupElement: root of subtree no. 5 can not be made a webPageView_FormularRadioGroupElement_required node ", 0, _coordref);
_currn->_desc6 = (webPageView__TSPwebPageView_FormularRadioGroupElement_validator) webPageView_MkwebPageView_FormularRadioGroupElement_validator (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioGroupElement: root of subtree no. 6 can not be made a webPageView_FormularRadioGroupElement_validator node ", 0, _coordref);
_currn->_desc7 = (webPageView__TSPwebPageView_FormularRadioGroupElement_converter) webPageView_MkwebPageView_FormularRadioGroupElement_converter (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioGroupElement: root of subtree no. 7 can not be made a webPageView_FormularRadioGroupElement_converter node ", 0, _coordref);
_currn->_desc8 = (webPageView__TSPwebPageView_FormularRadioGroupElement_layout) webPageView_MkwebPageView_FormularRadioGroupElement_layout (_coordref, _desc8);	
if (((NODEPTR)_currn->_desc8) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioGroupElement: root of subtree no. 8 can not be made a webPageView_FormularRadioGroupElement_layout node ", 0, _coordref);
_currn->_desc9 = (webPageView__TSPwebPageView_FormularRadioGroupElement_elements) webPageView_MkwebPageView_FormularRadioGroupElement_elements (_coordref, _desc9);	
if (((NODEPTR)_currn->_desc9) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioGroupElement: root of subtree no. 9 can not be made a webPageView_FormularRadioGroupElement_elements node ", 0, _coordref);
_currn->_desc10 = (webPageView__TSPwebPageView_FormularRadioGroupElement_checked) webPageView_MkwebPageView_FormularRadioGroupElement_checked (_coordref, _desc10);	
if (((NODEPTR)_currn->_desc10) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularRadioGroupElement: root of subtree no. 10 can not be made a webPageView_FormularRadioGroupElement_checked node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioGroupElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioGroupElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_name (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_name (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularRadioGroupElement_name _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioGroupElement_name;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioGroupElement_name) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement_name));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement_name;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioGroupElement_name;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioGroupElement_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularRadioGroupElement_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioGroupElement_label;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioGroupElement_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioGroupElement_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioGroupElement_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_description (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_description (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularRadioGroupElement_description _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioGroupElement_description;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioGroupElement_description) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement_description));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement_description;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioGroupElement_description;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioGroupElement_description */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_pvalue (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_pvalue (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularRadioGroupElement_pvalue _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioGroupElement_pvalue;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioGroupElement_pvalue) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement_pvalue));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement_pvalue;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioGroupElement_pvalue;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioGroupElement_pvalue */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_required (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_required (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularRadioGroupElement_required _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioGroupElement_required;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioGroupElement_required) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement_required));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement_required;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioGroupElement_required;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioGroupElement_required */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_EmailValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_validator)_new;
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_CreditCardValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_validator)_new;
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_RegExprValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_validator)_new;
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_StringLengthValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_validator)_new;
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_LongRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_validator)_new;
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator;
#else
	_new = (webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator;
	_new->_desc1 = (webPageView__TSPwebPageView_DoubleRangeValidator)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_validator)_new;
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularRadioGroupElement_validator (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_EmailValidator)) 
		return webPageView__MkwebPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, webPageView_MkwebPageView_EmailValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_CreditCardValidator)) 
		return webPageView__MkwebPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, webPageView_MkwebPageView_CreditCardValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_RegExprValidator)) 
		return webPageView__MkwebPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, webPageView_MkwebPageView_RegExprValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_StringLengthValidator)) 
		return webPageView__MkwebPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, webPageView_MkwebPageView_StringLengthValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_LongRangeValidator)) 
		return webPageView__MkwebPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, webPageView_MkwebPageView_LongRangeValidator (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DoubleRangeValidator)) 
		return webPageView__MkwebPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator (_coordref, webPageView_MkwebPageView_DoubleRangeValidator (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularRadioGroupElement_validator list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularRadioGroupElement_validator (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularRadioGroupElement_validator)
	l =_ElempwebPageView_FormularRadioGroupElement_validator (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularRadioGroupElement_validator)
	r = _ElempwebPageView_FormularRadioGroupElement_validator (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_validator (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_validator (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularRadioGroupElement_validator root;
	webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularRadioGroupElement_validator)
		t = _ElempwebPageView_FormularRadioGroupElement_validator (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator)(((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularRadioGroupElement_validator;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularRadioGroupElement_validator));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularRadioGroupElement_validator;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_validator)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator)
	{webPageView__TPPLST_webPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_EmailValidatorpwebPageView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator)
	{webPageView__TPPLST_webPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_CreditCardValidatorpwebPageView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator)
	{webPageView__TPPLST_webPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_RegExprValidatorpwebPageView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator)
	{webPageView__TPPLST_webPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_StringLengthValidatorpwebPageView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator)
	{webPageView__TPPLST_webPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_LongRangeValidatorpwebPageView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_validator*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator)
	{webPageView__TPPLST_webPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DoubleRangeValidatorpwebPageView_FormularRadioGroupElement_validator;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_validator*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularRadioGroupElement_validator;
#else
root = (webPageView__TPPpwebPageView_FormularRadioGroupElement_validator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement_validator));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement_validator;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_validator)list;
{ webPageView__TPPpwebPageView_FormularRadioGroupElement_validator _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularRadioGroupElement_validator;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter;
#else
	_new = (webPageView__TPPLST_webPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter;
	_new->_desc1 = (webPageView__TSPwebPageView_IntegerNumberConverter)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)_new;
	{webPageView__TPPLST_webPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter;
#else
	_new = (webPageView__TPPLST_webPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter;
	_new->_desc1 = (webPageView__TSPwebPageView_DoubleNumberConverter)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)_new;
	{webPageView__TPPLST_webPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter;
#else
	_new = (webPageView__TPPLST_webPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter;
	_new->_desc1 = (webPageView__TSPwebPageView_IntegerConverter)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)_new;
	{webPageView__TPPLST_webPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter;
#else
	_new = (webPageView__TPPLST_webPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter;
	_new->_desc1 = (webPageView__TSPwebPageView_LongConverter)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)_new;
	{webPageView__TPPLST_webPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter;
#else
	_new = (webPageView__TPPLST_webPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter;
	_new->_desc1 = (webPageView__TSPwebPageView_BigIntegerConverter)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)_new;
	{webPageView__TPPLST_webPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter;
#else
	_new = (webPageView__TPPLST_webPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter;
	_new->_desc1 = (webPageView__TSPwebPageView_FloatConverter)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)_new;
	{webPageView__TPPLST_webPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter;
#else
	_new = (webPageView__TPPLST_webPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter;
	_new->_desc1 = (webPageView__TSPwebPageView_DoubleConverter)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)_new;
	{webPageView__TPPLST_webPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter;
#else
	_new = (webPageView__TPPLST_webPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter;
	_new->_desc1 = (webPageView__TSPwebPageView_BooleanConverter)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)_new;
	{webPageView__TPPLST_webPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter;
#else
	_new = (webPageView__TPPLST_webPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter;
	_new->_desc1 = (webPageView__TSPwebPageView_DateTimeConverter)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)_new;
	{webPageView__TPPLST_webPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter;
#else
	_new = (webPageView__TPPLST_webPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter));
#endif
	_new->_prod = webPageView_RULELST_webPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter;
	_new->_desc1 = (webPageView__TSPwebPageView_PatternConverter)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)_new;
	{webPageView__TPPLST_webPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularRadioGroupElement_converter (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_IntegerNumberConverter)) 
		return webPageView__MkwebPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, webPageView_MkwebPageView_IntegerNumberConverter (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DoubleNumberConverter)) 
		return webPageView__MkwebPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, webPageView_MkwebPageView_DoubleNumberConverter (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_IntegerConverter)) 
		return webPageView__MkwebPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, webPageView_MkwebPageView_IntegerConverter (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_LongConverter)) 
		return webPageView__MkwebPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, webPageView_MkwebPageView_LongConverter (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_BigIntegerConverter)) 
		return webPageView__MkwebPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, webPageView_MkwebPageView_BigIntegerConverter (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FloatConverter)) 
		return webPageView__MkwebPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, webPageView_MkwebPageView_FloatConverter (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DoubleConverter)) 
		return webPageView__MkwebPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, webPageView_MkwebPageView_DoubleConverter (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_BooleanConverter)) 
		return webPageView__MkwebPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, webPageView_MkwebPageView_BooleanConverter (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DateTimeConverter)) 
		return webPageView__MkwebPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, webPageView_MkwebPageView_DateTimeConverter (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_PatternConverter)) 
		return webPageView__MkwebPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter (_coordref, webPageView_MkwebPageView_PatternConverter (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularRadioGroupElement_converter list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularRadioGroupElement_converter (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularRadioGroupElement_converter)
	l =_ElempwebPageView_FormularRadioGroupElement_converter (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularRadioGroupElement_converter)
	r = _ElempwebPageView_FormularRadioGroupElement_converter (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_converter (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_converter (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularRadioGroupElement_converter root;
	webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularRadioGroupElement_converter)
		t = _ElempwebPageView_FormularRadioGroupElement_converter (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter)(((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularRadioGroupElement_converter;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularRadioGroupElement_converter));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularRadioGroupElement_converter;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_converter)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter)
	{webPageView__TPPLST_webPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_IntegerNumberConverterpwebPageView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter)
	{webPageView__TPPLST_webPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DoubleNumberConverterpwebPageView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter)
	{webPageView__TPPLST_webPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_IntegerConverterpwebPageView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter)
	{webPageView__TPPLST_webPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_LongConverterpwebPageView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter)
	{webPageView__TPPLST_webPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_BigIntegerConverterpwebPageView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter)
	{webPageView__TPPLST_webPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FloatConverterpwebPageView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter)
	{webPageView__TPPLST_webPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DoubleConverterpwebPageView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter)
	{webPageView__TPPLST_webPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_BooleanConverterpwebPageView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter)
	{webPageView__TPPLST_webPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DateTimeConverterpwebPageView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_converter*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter)
	{webPageView__TPPLST_webPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_PatternConverterpwebPageView_FormularRadioGroupElement_converter;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_converter*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularRadioGroupElement_converter;
#else
root = (webPageView__TPPpwebPageView_FormularRadioGroupElement_converter) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement_converter));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement_converter;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_converter)list;
{ webPageView__TPPpwebPageView_FormularRadioGroupElement_converter _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularRadioGroupElement_converter;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_layout (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_layout (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularRadioGroupElement_layout _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioGroupElement_layout;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioGroupElement_layout) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement_layout));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement_layout;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioGroupElement_layout;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioGroupElement_layout */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements;
#else
	_new = (webPageView__TPPLST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements));
#endif
	_new->_prod = webPageView_RULELST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements;
	_new->_desc1 = (webPageView__TSPwebPageView_FormularRadioElement)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_elements)_new;
	{webPageView__TPPLST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularRadioGroupElement_elements (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularRadioGroupElement_elements (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_FormularRadioElement)) 
		return webPageView__MkwebPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements (_coordref, webPageView_MkwebPageView_FormularRadioElement (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularRadioGroupElement_elements list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularRadioGroupElement_elements (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularRadioGroupElement_elements (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularRadioGroupElement_elements)
	l =_ElempwebPageView_FormularRadioGroupElement_elements (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularRadioGroupElement_elements)
	r = _ElempwebPageView_FormularRadioGroupElement_elements (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_elements (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_elements (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularRadioGroupElement_elements root;
	webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularRadioGroupElement_elements)
		t = _ElempwebPageView_FormularRadioGroupElement_elements (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements)(((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularRadioGroupElement_elements;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularRadioGroupElement_elements));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularRadioGroupElement_elements;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularRadioGroupElement_elements)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements)
	{webPageView__TPPLST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_FormularRadioElementpwebPageView_FormularRadioGroupElement_elements;
	} this code has been moved to _ElempwebPageView_FormularRadioGroupElement_elements*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularRadioGroupElement_elements;
#else
root = (webPageView__TPPpwebPageView_FormularRadioGroupElement_elements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement_elements));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement_elements;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularRadioGroupElement_elements)list;
{ webPageView__TPPpwebPageView_FormularRadioGroupElement_elements _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularRadioGroupElement_elements;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_checked (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularRadioGroupElement_checked (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularRadioGroupElement_checked _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularRadioGroupElement_checked;
#else
_currn = (webPageView__TPPpwebPageView_FormularRadioGroupElement_checked) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularRadioGroupElement_checked));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularRadioGroupElement_checked;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularRadioGroupElement_checked;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularRadioGroupElement_checked */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularConstantSelectOption (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_FormularConstantSelectOption (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_FormularConstantSelectOption _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularConstantSelectOption;
#else
_currn = (webPageView__TPPpwebPageView_FormularConstantSelectOption) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularConstantSelectOption));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularConstantSelectOption;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularConstantSelectOption_options) webPageView_MkwebPageView_FormularConstantSelectOption_options (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularConstantSelectOption: root of subtree no. 1 can not be made a webPageView_FormularConstantSelectOption_options node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularConstantSelectOption;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularConstantSelectOption */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options;
#else
	_new = (webPageView__TPPLST_webPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options));
#endif
	_new->_prod = webPageView_RULELST_webPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options;
	_new->_desc1 = (webPageView__TSPwebPageView_SelectOption)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_FormularConstantSelectOption_options)_new;
	{webPageView__TPPLST_webPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_FormularConstantSelectOption_options (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_SelectOption)) 
		return webPageView__MkwebPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options (_coordref, webPageView_MkwebPageView_SelectOption (_coordref, t));
	message (DEADLY, "a pwebPageView_FormularConstantSelectOption_options list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_FormularConstantSelectOption_options (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_FormularConstantSelectOption_options)
	l =_ElempwebPageView_FormularConstantSelectOption_options (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_FormularConstantSelectOption_options)
	r = _ElempwebPageView_FormularConstantSelectOption_options (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularConstantSelectOption_options (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_FormularConstantSelectOption_options (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_FormularConstantSelectOption_options root;
	webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_FormularConstantSelectOption_options)
		t = _ElempwebPageView_FormularConstantSelectOption_options (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options)(((webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_FormularConstantSelectOption_options;
#else
list = (webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_FormularConstantSelectOption_options));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_FormularConstantSelectOption_options;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_FormularConstantSelectOption_options)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options)
	{webPageView__TPPLST_webPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_SelectOptionpwebPageView_FormularConstantSelectOption_options;
	} this code has been moved to _ElempwebPageView_FormularConstantSelectOption_options*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_FormularConstantSelectOption_options;
#else
root = (webPageView__TPPpwebPageView_FormularConstantSelectOption_options) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularConstantSelectOption_options));
#endif
root->_prod = webPageView_RULEpwebPageView_FormularConstantSelectOption_options;
root->_desc1 = (webPageView__TSPLST_webPageView_FormularConstantSelectOption_options)list;
{ webPageView__TPPpwebPageView_FormularConstantSelectOption_options _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_FormularConstantSelectOption_options;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_SelectOption (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_SelectOption (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_SelectOption _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_SelectOption;
#else
_currn = (webPageView__TPPpwebPageView_SelectOption) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_SelectOption));
#endif
_currn->_prod = webPageView_RULEpwebPageView_SelectOption;
_currn->_desc1 = (webPageView__TSPwebPageView_SelectOption_value) webPageView_MkwebPageView_SelectOption_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_SelectOption: root of subtree no. 1 can not be made a webPageView_SelectOption_value node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_SelectOption_label) webPageView_MkwebPageView_SelectOption_label (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_SelectOption: root of subtree no. 2 can not be made a webPageView_SelectOption_label node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_SelectOption;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_SelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_SelectOption_value (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_SelectOption_value (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_SelectOption_value _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_SelectOption_value;
#else
_currn = (webPageView__TPPpwebPageView_SelectOption_value) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_SelectOption_value));
#endif
_currn->_prod = webPageView_RULEpwebPageView_SelectOption_value;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_SelectOption_value;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_SelectOption_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_SelectOption_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_SelectOption_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_SelectOption_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_SelectOption_label;
#else
_currn = (webPageView__TPPpwebPageView_SelectOption_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_SelectOption_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_SelectOption_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_SelectOption_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_SelectOption_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularDataSourceSelectOption (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_FormularDataSourceSelectOption (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_FormularDataSourceSelectOption _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularDataSourceSelectOption;
#else
_currn = (webPageView__TPPpwebPageView_FormularDataSourceSelectOption) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularDataSourceSelectOption));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularDataSourceSelectOption;
_currn->_desc1 = (webPageView__TSPwebPageView_FormularDataSourceSelectOption_name) webPageView_MkwebPageView_FormularDataSourceSelectOption_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularDataSourceSelectOption: root of subtree no. 1 can not be made a webPageView_FormularDataSourceSelectOption_name node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_FormularDataSourceSelectOption_dataSource) webPageView_MkwebPageView_FormularDataSourceSelectOption_dataSource (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularDataSourceSelectOption: root of subtree no. 2 can not be made a webPageView_FormularDataSourceSelectOption_dataSource node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_FormularDataSourceSelectOption_value) webPageView_MkwebPageView_FormularDataSourceSelectOption_value (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularDataSourceSelectOption: root of subtree no. 3 can not be made a webPageView_FormularDataSourceSelectOption_value node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_FormularDataSourceSelectOption_label) webPageView_MkwebPageView_FormularDataSourceSelectOption_label (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_FormularDataSourceSelectOption: root of subtree no. 4 can not be made a webPageView_FormularDataSourceSelectOption_label node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularDataSourceSelectOption;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularDataSourceSelectOption */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularDataSourceSelectOption_name (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularDataSourceSelectOption_name (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularDataSourceSelectOption_name _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularDataSourceSelectOption_name;
#else
_currn = (webPageView__TPPpwebPageView_FormularDataSourceSelectOption_name) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularDataSourceSelectOption_name));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularDataSourceSelectOption_name;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularDataSourceSelectOption_name;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularDataSourceSelectOption_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularDataSourceSelectOption_dataSource (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularDataSourceSelectOption_dataSource (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularDataSourceSelectOption_dataSource _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularDataSourceSelectOption_dataSource;
#else
_currn = (webPageView__TPPpwebPageView_FormularDataSourceSelectOption_dataSource) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularDataSourceSelectOption_dataSource));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularDataSourceSelectOption_dataSource;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularDataSourceSelectOption_dataSource;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularDataSourceSelectOption_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularDataSourceSelectOption_value (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularDataSourceSelectOption_value (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularDataSourceSelectOption_value _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularDataSourceSelectOption_value;
#else
_currn = (webPageView__TPPpwebPageView_FormularDataSourceSelectOption_value) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularDataSourceSelectOption_value));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularDataSourceSelectOption_value;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularDataSourceSelectOption_value;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularDataSourceSelectOption_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_FormularDataSourceSelectOption_label (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_FormularDataSourceSelectOption_label (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_FormularDataSourceSelectOption_label _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_FormularDataSourceSelectOption_label;
#else
_currn = (webPageView__TPPpwebPageView_FormularDataSourceSelectOption_label) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_FormularDataSourceSelectOption_label));
#endif
_currn->_prod = webPageView_RULEpwebPageView_FormularDataSourceSelectOption_label;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_FormularDataSourceSelectOption_label;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_FormularDataSourceSelectOption_label */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_MD5Modifier (POSITION *_coordref, int _TERM1)
#else
NODEPTR webPageView_MkpwebPageView_MD5Modifier (_coordref, _TERM1)
	POSITION *_coordref;
	int _TERM1;
#endif
{	webPageView__TPPpwebPageView_MD5Modifier _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_MD5Modifier;
#else
_currn = (webPageView__TPPpwebPageView_MD5Modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_MD5Modifier));
#endif
_currn->_prod = webPageView_RULEpwebPageView_MD5Modifier;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_MD5Modifier;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_MD5Modifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_JoinModifier (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_JoinModifier (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_JoinModifier _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_JoinModifier;
#else
_currn = (webPageView__TPPpwebPageView_JoinModifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_JoinModifier));
#endif
_currn->_prod = webPageView_RULEpwebPageView_JoinModifier;
_currn->_desc1 = (webPageView__TSPwebPageView_JoinModifier_separator) webPageView_MkwebPageView_JoinModifier_separator (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_JoinModifier: root of subtree no. 1 can not be made a webPageView_JoinModifier_separator node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_JoinModifier;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_JoinModifier */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_JoinModifier_separator (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_JoinModifier_separator (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_JoinModifier_separator _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_JoinModifier_separator;
#else
_currn = (webPageView__TPPpwebPageView_JoinModifier_separator) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_JoinModifier_separator));
#endif
_currn->_prod = webPageView_RULEpwebPageView_JoinModifier_separator;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_JoinModifier_separator;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_JoinModifier_separator */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeConstantExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeConstantExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_WebNodeConstantExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeConstantExpression;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeConstantExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeConstantExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeConstantExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_WebNodeConstantExpression_modifier) webPageView_MkwebPageView_WebNodeConstantExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeConstantExpression: root of subtree no. 1 can not be made a webPageView_WebNodeConstantExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_WebNodeConstantExpression_value) webPageView_MkwebPageView_WebNodeConstantExpression_value (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeConstantExpression: root of subtree no. 2 can not be made a webPageView_WebNodeConstantExpression_value node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeConstantExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeConstantExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier;
#else
	_new = (webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier));
#endif
	_new->_prod = webPageView_RULELST_webPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier;
	_new->_desc1 = (webPageView__TSPwebPageView_MD5Modifier)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeConstantExpression_modifier)_new;
	{webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier;
#else
	_new = (webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier));
#endif
	_new->_prod = webPageView_RULELST_webPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier;
	_new->_desc1 = (webPageView__TSPwebPageView_JoinModifier)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeConstantExpression_modifier)_new;
	{webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_WebNodeConstantExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_MD5Modifier)) 
		return webPageView__MkwebPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier (_coordref, webPageView_MkwebPageView_MD5Modifier (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_JoinModifier)) 
		return webPageView__MkwebPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier (_coordref, webPageView_MkwebPageView_JoinModifier (_coordref, t));
	message (DEADLY, "a pwebPageView_WebNodeConstantExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_WebNodeConstantExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_WebNodeConstantExpression_modifier)
	l =_ElempwebPageView_WebNodeConstantExpression_modifier (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_WebNodeConstantExpression_modifier)
	r = _ElempwebPageView_WebNodeConstantExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeConstantExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeConstantExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_WebNodeConstantExpression_modifier root;
	webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_WebNodeConstantExpression_modifier)
		t = _ElempwebPageView_WebNodeConstantExpression_modifier (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier)(((webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_WebNodeConstantExpression_modifier;
#else
list = (webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_WebNodeConstantExpression_modifier));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_WebNodeConstantExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_WebNodeConstantExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier)
	{webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_MD5ModifierpwebPageView_WebNodeConstantExpression_modifier;
	} this code has been moved to _ElempwebPageView_WebNodeConstantExpression_modifier*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier)
	{webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_JoinModifierpwebPageView_WebNodeConstantExpression_modifier;
	} this code has been moved to _ElempwebPageView_WebNodeConstantExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_WebNodeConstantExpression_modifier;
#else
root = (webPageView__TPPpwebPageView_WebNodeConstantExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeConstantExpression_modifier));
#endif
root->_prod = webPageView_RULEpwebPageView_WebNodeConstantExpression_modifier;
root->_desc1 = (webPageView__TSPLST_webPageView_WebNodeConstantExpression_modifier)list;
{ webPageView__TPPpwebPageView_WebNodeConstantExpression_modifier _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_WebNodeConstantExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeConstantExpression_value (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeConstantExpression_value (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebNodeConstantExpression_value _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeConstantExpression_value;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeConstantExpression_value) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeConstantExpression_value));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeConstantExpression_value;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeConstantExpression_value;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeConstantExpression_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeVariableExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeVariableExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_WebNodeVariableExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeVariableExpression;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeVariableExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeVariableExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeVariableExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_WebNodeVariableExpression_modifier) webPageView_MkwebPageView_WebNodeVariableExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeVariableExpression: root of subtree no. 1 can not be made a webPageView_WebNodeVariableExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_WebNodeVariableExpression_content) webPageView_MkwebPageView_WebNodeVariableExpression_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeVariableExpression: root of subtree no. 2 can not be made a webPageView_WebNodeVariableExpression_content node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeVariableExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeVariableExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier;
#else
	_new = (webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier));
#endif
	_new->_prod = webPageView_RULELST_webPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier;
	_new->_desc1 = (webPageView__TSPwebPageView_MD5Modifier)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeVariableExpression_modifier)_new;
	{webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier;
#else
	_new = (webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier));
#endif
	_new->_prod = webPageView_RULELST_webPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier;
	_new->_desc1 = (webPageView__TSPwebPageView_JoinModifier)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeVariableExpression_modifier)_new;
	{webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_WebNodeVariableExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_MD5Modifier)) 
		return webPageView__MkwebPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier (_coordref, webPageView_MkwebPageView_MD5Modifier (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_JoinModifier)) 
		return webPageView__MkwebPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier (_coordref, webPageView_MkwebPageView_JoinModifier (_coordref, t));
	message (DEADLY, "a pwebPageView_WebNodeVariableExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_WebNodeVariableExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_WebNodeVariableExpression_modifier)
	l =_ElempwebPageView_WebNodeVariableExpression_modifier (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_WebNodeVariableExpression_modifier)
	r = _ElempwebPageView_WebNodeVariableExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeVariableExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeVariableExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_WebNodeVariableExpression_modifier root;
	webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_WebNodeVariableExpression_modifier)
		t = _ElempwebPageView_WebNodeVariableExpression_modifier (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier)(((webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_WebNodeVariableExpression_modifier;
#else
list = (webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_WebNodeVariableExpression_modifier));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_WebNodeVariableExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_WebNodeVariableExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier)
	{webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_MD5ModifierpwebPageView_WebNodeVariableExpression_modifier;
	} this code has been moved to _ElempwebPageView_WebNodeVariableExpression_modifier*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier)
	{webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_JoinModifierpwebPageView_WebNodeVariableExpression_modifier;
	} this code has been moved to _ElempwebPageView_WebNodeVariableExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_WebNodeVariableExpression_modifier;
#else
root = (webPageView__TPPpwebPageView_WebNodeVariableExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeVariableExpression_modifier));
#endif
root->_prod = webPageView_RULEpwebPageView_WebNodeVariableExpression_modifier;
root->_desc1 = (webPageView__TSPLST_webPageView_WebNodeVariableExpression_modifier)list;
{ webPageView__TPPpwebPageView_WebNodeVariableExpression_modifier _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_WebNodeVariableExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeVariableExpression_content (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeVariableExpression_content (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebNodeVariableExpression_content _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeVariableExpression_content;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeVariableExpression_content) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeVariableExpression_content));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeVariableExpression_content;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeVariableExpression_content;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeVariableExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeSessionExpression (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeSessionExpression (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_WebNodeSessionExpression _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeSessionExpression;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeSessionExpression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeSessionExpression));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeSessionExpression;
_currn->_desc1 = (webPageView__TSPwebPageView_WebNodeSessionExpression_modifier) webPageView_MkwebPageView_WebNodeSessionExpression_modifier (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeSessionExpression: root of subtree no. 1 can not be made a webPageView_WebNodeSessionExpression_modifier node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_WebNodeSessionExpression_content) webPageView_MkwebPageView_WebNodeSessionExpression_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_WebNodeSessionExpression: root of subtree no. 2 can not be made a webPageView_WebNodeSessionExpression_content node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeSessionExpression;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeSessionExpression */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier;
#else
	_new = (webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier));
#endif
	_new->_prod = webPageView_RULELST_webPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier;
	_new->_desc1 = (webPageView__TSPwebPageView_MD5Modifier)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeSessionExpression_modifier)_new;
	{webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier;
#else
	_new = (webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier));
#endif
	_new->_prod = webPageView_RULELST_webPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier;
	_new->_desc1 = (webPageView__TSPwebPageView_JoinModifier)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_WebNodeSessionExpression_modifier)_new;
	{webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_WebNodeSessionExpression_modifier (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_MD5Modifier)) 
		return webPageView__MkwebPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier (_coordref, webPageView_MkwebPageView_MD5Modifier (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_JoinModifier)) 
		return webPageView__MkwebPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier (_coordref, webPageView_MkwebPageView_JoinModifier (_coordref, t));
	message (DEADLY, "a pwebPageView_WebNodeSessionExpression_modifier list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_WebNodeSessionExpression_modifier (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_WebNodeSessionExpression_modifier)
	l =_ElempwebPageView_WebNodeSessionExpression_modifier (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_WebNodeSessionExpression_modifier)
	r = _ElempwebPageView_WebNodeSessionExpression_modifier (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeSessionExpression_modifier (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeSessionExpression_modifier (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_WebNodeSessionExpression_modifier root;
	webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_WebNodeSessionExpression_modifier)
		t = _ElempwebPageView_WebNodeSessionExpression_modifier (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier)(((webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_WebNodeSessionExpression_modifier;
#else
list = (webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_WebNodeSessionExpression_modifier));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_WebNodeSessionExpression_modifier;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_WebNodeSessionExpression_modifier)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier)
	{webPageView__TPPLST_webPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_MD5ModifierpwebPageView_WebNodeSessionExpression_modifier;
	} this code has been moved to _ElempwebPageView_WebNodeSessionExpression_modifier*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier)
	{webPageView__TPPLST_webPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_JoinModifierpwebPageView_WebNodeSessionExpression_modifier;
	} this code has been moved to _ElempwebPageView_WebNodeSessionExpression_modifier*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_WebNodeSessionExpression_modifier;
#else
root = (webPageView__TPPpwebPageView_WebNodeSessionExpression_modifier) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeSessionExpression_modifier));
#endif
root->_prod = webPageView_RULEpwebPageView_WebNodeSessionExpression_modifier;
root->_desc1 = (webPageView__TSPLST_webPageView_WebNodeSessionExpression_modifier)list;
{ webPageView__TPPpwebPageView_WebNodeSessionExpression_modifier _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_WebNodeSessionExpression_modifier;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_WebNodeSessionExpression_content (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_WebNodeSessionExpression_content (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_WebNodeSessionExpression_content _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_WebNodeSessionExpression_content;
#else
_currn = (webPageView__TPPpwebPageView_WebNodeSessionExpression_content) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_WebNodeSessionExpression_content));
#endif
_currn->_prod = webPageView_RULEpwebPageView_WebNodeSessionExpression_content;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_WebNodeSessionExpression_content;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_WebNodeSessionExpression_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_OutputFragment (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_OutputFragment (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_OutputFragment _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_OutputFragment;
#else
_currn = (webPageView__TPPpwebPageView_OutputFragment) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_OutputFragment));
#endif
_currn->_prod = webPageView_RULEpwebPageView_OutputFragment;
_currn->_desc1 = (webPageView__TSPwebPageView_OutputFragment_link) webPageView_MkwebPageView_OutputFragment_link (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_OutputFragment: root of subtree no. 1 can not be made a webPageView_OutputFragment_link node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_OutputFragment_content) webPageView_MkwebPageView_OutputFragment_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_OutputFragment: root of subtree no. 2 can not be made a webPageView_OutputFragment_content node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_OutputFragment;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_OutputFragment */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_OutputFragment_link (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_OutputFragment_link (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_OutputFragment_link _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_OutputFragment_link;
#else
_currn = (webPageView__TPPpwebPageView_OutputFragment_link) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_OutputFragment_link));
#endif
_currn->_prod = webPageView_RULEpwebPageView_OutputFragment_link;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_OutputFragment_link;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_OutputFragment_link */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_OutputFragment_content (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_OutputFragment_content (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_OutputFragment_content _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_OutputFragment_content;
#else
_currn = (webPageView__TPPpwebPageView_OutputFragment_content) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_OutputFragment_content));
#endif
_currn->_prod = webPageView_RULEpwebPageView_OutputFragment_content;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_OutputFragment_content;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_OutputFragment_content */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_OutputMessagesElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_OutputMessagesElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_OutputMessagesElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_OutputMessagesElement;
#else
_currn = (webPageView__TPPpwebPageView_OutputMessagesElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_OutputMessagesElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_OutputMessagesElement;
_currn->_desc1 = (webPageView__TSPwebPageView_OutputMessagesElement_styleSheetBlock) webPageView_MkwebPageView_OutputMessagesElement_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_OutputMessagesElement: root of subtree no. 1 can not be made a webPageView_OutputMessagesElement_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_OutputMessagesElement_errorStyleSheetBlock) webPageView_MkwebPageView_OutputMessagesElement_errorStyleSheetBlock (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_OutputMessagesElement: root of subtree no. 2 can not be made a webPageView_OutputMessagesElement_errorStyleSheetBlock node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_OutputMessagesElement_infoStyleSheetBlock) webPageView_MkwebPageView_OutputMessagesElement_infoStyleSheetBlock (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_OutputMessagesElement: root of subtree no. 3 can not be made a webPageView_OutputMessagesElement_infoStyleSheetBlock node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_OutputMessagesElement_layout) webPageView_MkwebPageView_OutputMessagesElement_layout (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_OutputMessagesElement: root of subtree no. 4 can not be made a webPageView_OutputMessagesElement_layout node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_OutputMessagesElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_OutputMessagesElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_OutputMessagesElement_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_OutputMessagesElement_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_OutputMessagesElement_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_OutputMessagesElement_styleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_OutputMessagesElement_styleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_OutputMessagesElement_styleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_OutputMessagesElement_styleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_OutputMessagesElement_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_OutputMessagesElement_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_OutputMessagesElement_errorStyleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_OutputMessagesElement_errorStyleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_OutputMessagesElement_errorStyleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_OutputMessagesElement_errorStyleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_OutputMessagesElement_errorStyleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_OutputMessagesElement_errorStyleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_OutputMessagesElement_errorStyleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_OutputMessagesElement_errorStyleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_OutputMessagesElement_errorStyleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_OutputMessagesElement_infoStyleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_OutputMessagesElement_infoStyleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_OutputMessagesElement_infoStyleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_OutputMessagesElement_infoStyleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_OutputMessagesElement_infoStyleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_OutputMessagesElement_infoStyleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_OutputMessagesElement_infoStyleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_OutputMessagesElement_infoStyleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_OutputMessagesElement_infoStyleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_OutputMessagesElement_layout (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_OutputMessagesElement_layout (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_OutputMessagesElement_layout _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_OutputMessagesElement_layout;
#else
_currn = (webPageView__TPPpwebPageView_OutputMessagesElement_layout) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_OutputMessagesElement_layout));
#endif
_currn->_prod = webPageView_RULEpwebPageView_OutputMessagesElement_layout;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_OutputMessagesElement_layout;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_OutputMessagesElement_layout */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputActualParam (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputActualParam (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_ListOutputActualParam _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputActualParam;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputActualParam) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputActualParam));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputActualParam;
_currn->_desc1 = (webPageView__TSPwebPageView_ListOutputActualParam_formalParam) webPageView_MkwebPageView_ListOutputActualParam_formalParam (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputActualParam: root of subtree no. 1 can not be made a webPageView_ListOutputActualParam_formalParam node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_ListOutputActualParam_expression) webPageView_MkwebPageView_ListOutputActualParam_expression (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputActualParam: root of subtree no. 2 can not be made a webPageView_ListOutputActualParam_expression node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputActualParam;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputActualParam */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputActualParam_formalParam (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputActualParam_formalParam (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputActualParam_formalParam _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputActualParam_formalParam;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputActualParam_formalParam) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputActualParam_formalParam));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputActualParam_formalParam;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputActualParam_formalParam;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputActualParam_formalParam */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression;
#else
	_new = (webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression));
#endif
	_new->_prod = webPageView_RULELST_webPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression;
	_new->_desc1 = (webPageView__TSPwebPageView_BinaryExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputActualParam_expression)_new;
	{webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression;
#else
	_new = (webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression));
#endif
	_new->_prod = webPageView_RULELST_webPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression;
	_new->_desc1 = (webPageView__TSPwebPageView_UnaryExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputActualParam_expression)_new;
	{webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression;
#else
	_new = (webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression));
#endif
	_new->_prod = webPageView_RULELST_webPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression;
	_new->_desc1 = (webPageView__TSPwebPageView_PredefinedExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputActualParam_expression)_new;
	{webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression;
#else
	_new = (webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression;
	_new->_desc1 = (webPageView__TSPwebPageView_ConstantExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputActualParam_expression)_new;
	{webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression;
#else
	_new = (webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression;
	_new->_desc1 = (webPageView__TSPwebPageView_ColumnValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputActualParam_expression)_new;
	{webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression;
#else
	_new = (webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression;
	_new->_desc1 = (webPageView__TSPwebPageView_ProjectionColumnValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputActualParam_expression)_new;
	{webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression;
#else
	_new = (webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression;
	_new->_desc1 = (webPageView__TSPwebPageView_ParameterValueExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputActualParam_expression)_new;
	{webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression;
#else
	_new = (webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression;
	_new->_desc1 = (webPageView__TSPwebPageView_ComputationExpression)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputActualParam_expression)_new;
	{webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_ListOutputActualParam_expression (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_BinaryExpression)) 
		return webPageView__MkwebPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression (_coordref, webPageView_MkwebPageView_BinaryExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_UnaryExpression)) 
		return webPageView__MkwebPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression (_coordref, webPageView_MkwebPageView_UnaryExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_PredefinedExpression)) 
		return webPageView__MkwebPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression (_coordref, webPageView_MkwebPageView_PredefinedExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ConstantExpression)) 
		return webPageView__MkwebPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression (_coordref, webPageView_MkwebPageView_ConstantExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ColumnValueExpression)) 
		return webPageView__MkwebPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression (_coordref, webPageView_MkwebPageView_ColumnValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ProjectionColumnValueExpression)) 
		return webPageView__MkwebPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression (_coordref, webPageView_MkwebPageView_ProjectionColumnValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ParameterValueExpression)) 
		return webPageView__MkwebPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression (_coordref, webPageView_MkwebPageView_ParameterValueExpression (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ComputationExpression)) 
		return webPageView__MkwebPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression (_coordref, webPageView_MkwebPageView_ComputationExpression (_coordref, t));
	message (DEADLY, "a pwebPageView_ListOutputActualParam_expression list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_ListOutputActualParam_expression (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_ListOutputActualParam_expression)
	l =_ElempwebPageView_ListOutputActualParam_expression (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_ListOutputActualParam_expression)
	r = _ElempwebPageView_ListOutputActualParam_expression (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputActualParam_expression (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputActualParam_expression (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_ListOutputActualParam_expression root;
	webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_ListOutputActualParam_expression)
		t = _ElempwebPageView_ListOutputActualParam_expression (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression)(((webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_ListOutputActualParam_expression;
#else
list = (webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_ListOutputActualParam_expression));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_ListOutputActualParam_expression;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_ListOutputActualParam_expression)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression)
	{webPageView__TPPLST_webPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_BinaryExpressionpwebPageView_ListOutputActualParam_expression;
	} this code has been moved to _ElempwebPageView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression)
	{webPageView__TPPLST_webPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_UnaryExpressionpwebPageView_ListOutputActualParam_expression;
	} this code has been moved to _ElempwebPageView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression)
	{webPageView__TPPLST_webPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_PredefinedExpressionpwebPageView_ListOutputActualParam_expression;
	} this code has been moved to _ElempwebPageView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression)
	{webPageView__TPPLST_webPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ConstantExpressionpwebPageView_ListOutputActualParam_expression;
	} this code has been moved to _ElempwebPageView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression)
	{webPageView__TPPLST_webPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ColumnValueExpressionpwebPageView_ListOutputActualParam_expression;
	} this code has been moved to _ElempwebPageView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression)
	{webPageView__TPPLST_webPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ProjectionColumnValueExpressionpwebPageView_ListOutputActualParam_expression;
	} this code has been moved to _ElempwebPageView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression)
	{webPageView__TPPLST_webPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ParameterValueExpressionpwebPageView_ListOutputActualParam_expression;
	} this code has been moved to _ElempwebPageView_ListOutputActualParam_expression*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression)
	{webPageView__TPPLST_webPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ComputationExpressionpwebPageView_ListOutputActualParam_expression;
	} this code has been moved to _ElempwebPageView_ListOutputActualParam_expression*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_ListOutputActualParam_expression;
#else
root = (webPageView__TPPpwebPageView_ListOutputActualParam_expression) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputActualParam_expression));
#endif
root->_prod = webPageView_RULEpwebPageView_ListOutputActualParam_expression;
root->_desc1 = (webPageView__TSPLST_webPageView_ListOutputActualParam_expression)list;
{ webPageView__TPPpwebPageView_ListOutputActualParam_expression _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_ListOutputActualParam_expression;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5, NODEPTR _desc6, NODEPTR _desc7, NODEPTR _desc8, NODEPTR _desc9, NODEPTR _desc10, NODEPTR _desc11)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5,_desc6,_desc7,_desc8,_desc9,_desc10,_desc11)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
	NODEPTR _desc6;
	NODEPTR _desc7;
	NODEPTR _desc8;
	NODEPTR _desc9;
	NODEPTR _desc10;
	NODEPTR _desc11;
#endif
{	webPageView__TPPpwebPageView_ListOutputElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputElement;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputElement;
_currn->_desc1 = (webPageView__TSPwebPageView_ListOutputElement_styleSheetBlock) webPageView_MkwebPageView_ListOutputElement_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 1 can not be made a webPageView_ListOutputElement_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_ListOutputElement_name) webPageView_MkwebPageView_ListOutputElement_name (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 2 can not be made a webPageView_ListOutputElement_name node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_ListOutputElement_dataSourceActualParams) webPageView_MkwebPageView_ListOutputElement_dataSourceActualParams (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 3 can not be made a webPageView_ListOutputElement_dataSourceActualParams node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_ListOutputElement_dataSource) webPageView_MkwebPageView_ListOutputElement_dataSource (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 4 can not be made a webPageView_ListOutputElement_dataSource node ", 0, _coordref);
_currn->_desc5 = (webPageView__TSPwebPageView_ListOutputElement_maxNumberOfElements) webPageView_MkwebPageView_ListOutputElement_maxNumberOfElements (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 5 can not be made a webPageView_ListOutputElement_maxNumberOfElements node ", 0, _coordref);
_currn->_desc6 = (webPageView__TSPwebPageView_ListOutputElement_renderAs) webPageView_MkwebPageView_ListOutputElement_renderAs (_coordref, _desc6);	
if (((NODEPTR)_currn->_desc6) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 6 can not be made a webPageView_ListOutputElement_renderAs node ", 0, _coordref);
_currn->_desc7 = (webPageView__TSPwebPageView_ListOutputElement_navigationElement) webPageView_MkwebPageView_ListOutputElement_navigationElement (_coordref, _desc7);	
if (((NODEPTR)_currn->_desc7) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 7 can not be made a webPageView_ListOutputElement_navigationElement node ", 0, _coordref);
_currn->_desc8 = (webPageView__TSPwebPageView_ListOutputElement_columns) webPageView_MkwebPageView_ListOutputElement_columns (_coordref, _desc8);	
if (((NODEPTR)_currn->_desc8) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 8 can not be made a webPageView_ListOutputElement_columns node ", 0, _coordref);
_currn->_desc9 = (webPageView__TSPwebPageView_ListOutputElement_headerStyleClass) webPageView_MkwebPageView_ListOutputElement_headerStyleClass (_coordref, _desc9);	
if (((NODEPTR)_currn->_desc9) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 9 can not be made a webPageView_ListOutputElement_headerStyleClass node ", 0, _coordref);
_currn->_desc10 = (webPageView__TSPwebPageView_ListOutputElement_evenRowStyleClass) webPageView_MkwebPageView_ListOutputElement_evenRowStyleClass (_coordref, _desc10);	
if (((NODEPTR)_currn->_desc10) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 10 can not be made a webPageView_ListOutputElement_evenRowStyleClass node ", 0, _coordref);
_currn->_desc11 = (webPageView__TSPwebPageView_ListOutputElement_oddRowStyleClass) webPageView_MkwebPageView_ListOutputElement_oddRowStyleClass (_coordref, _desc11);	
if (((NODEPTR)_currn->_desc11) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputElement: root of subtree no. 11 can not be made a webPageView_ListOutputElement_oddRowStyleClass node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputElement;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputElement */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputElement_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputElement_styleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputElement_styleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_styleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputElement_styleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputElement_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputElement_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_name (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_name (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputElement_name _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputElement_name;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputElement_name) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_name));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputElement_name;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputElement_name;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputElement_name */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams;
#else
	_new = (webPageView__TPPLST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams));
#endif
	_new->_prod = webPageView_RULELST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams;
	_new->_desc1 = (webPageView__TSPwebPageView_DataSourceActualParam)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputElement_dataSourceActualParams)_new;
	{webPageView__TPPLST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_ListOutputElement_dataSourceActualParams (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_DataSourceActualParam)) 
		return webPageView__MkwebPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams (_coordref, webPageView_MkwebPageView_DataSourceActualParam (_coordref, t));
	message (DEADLY, "a pwebPageView_ListOutputElement_dataSourceActualParams list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_ListOutputElement_dataSourceActualParams (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_ListOutputElement_dataSourceActualParams)
	l =_ElempwebPageView_ListOutputElement_dataSourceActualParams (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_ListOutputElement_dataSourceActualParams)
	r = _ElempwebPageView_ListOutputElement_dataSourceActualParams (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_dataSourceActualParams (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_dataSourceActualParams (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_ListOutputElement_dataSourceActualParams root;
	webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_ListOutputElement_dataSourceActualParams)
		t = _ElempwebPageView_ListOutputElement_dataSourceActualParams (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams)(((webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_ListOutputElement_dataSourceActualParams;
#else
list = (webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_ListOutputElement_dataSourceActualParams));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_ListOutputElement_dataSourceActualParams;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_ListOutputElement_dataSourceActualParams)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams)
	{webPageView__TPPLST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_DataSourceActualParampwebPageView_ListOutputElement_dataSourceActualParams;
	} this code has been moved to _ElempwebPageView_ListOutputElement_dataSourceActualParams*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_ListOutputElement_dataSourceActualParams;
#else
root = (webPageView__TPPpwebPageView_ListOutputElement_dataSourceActualParams) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_dataSourceActualParams));
#endif
root->_prod = webPageView_RULEpwebPageView_ListOutputElement_dataSourceActualParams;
root->_desc1 = (webPageView__TSPLST_webPageView_ListOutputElement_dataSourceActualParams)list;
{ webPageView__TPPpwebPageView_ListOutputElement_dataSourceActualParams _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_ListOutputElement_dataSourceActualParams;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_dataSource (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_dataSource (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputElement_dataSource _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputElement_dataSource;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputElement_dataSource) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_dataSource));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputElement_dataSource;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputElement_dataSource;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputElement_dataSource */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_maxNumberOfElements (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_maxNumberOfElements (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputElement_maxNumberOfElements _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputElement_maxNumberOfElements;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputElement_maxNumberOfElements) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_maxNumberOfElements));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputElement_maxNumberOfElements;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputElement_maxNumberOfElements;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputElement_maxNumberOfElements */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_renderAs (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_renderAs (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputElement_renderAs _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputElement_renderAs;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputElement_renderAs) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_renderAs));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputElement_renderAs;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputElement_renderAs;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputElement_renderAs */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_navigationElement (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_navigationElement (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputElement_navigationElement _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputElement_navigationElement;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputElement_navigationElement) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_navigationElement));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputElement_navigationElement;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputElement_navigationElement;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputElement_navigationElement */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ListOutputColumnpwebPageView_ListOutputElement_columns (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ListOutputColumnpwebPageView_ListOutputElement_columns (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ListOutputColumnpwebPageView_ListOutputElement_columns _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ListOutputColumnpwebPageView_ListOutputElement_columns;
#else
	_new = (webPageView__TPPLST_webPageView_ListOutputColumnpwebPageView_ListOutputElement_columns) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ListOutputColumnpwebPageView_ListOutputElement_columns));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ListOutputColumnpwebPageView_ListOutputElement_columns;
	_new->_desc1 = (webPageView__TSPwebPageView_ListOutputColumn)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputElement_columns)_new;
	{webPageView__TPPLST_webPageView_ListOutputColumnpwebPageView_ListOutputElement_columns _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ListOutputColumnpwebPageView_ListOutputElement_columns;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_ListOutputElement_columns (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_ListOutputElement_columns (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ListOutputColumn)) 
		return webPageView__MkwebPageView_ListOutputColumnpwebPageView_ListOutputElement_columns (_coordref, webPageView_MkwebPageView_ListOutputColumn (_coordref, t));
	message (DEADLY, "a pwebPageView_ListOutputElement_columns list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_ListOutputElement_columns (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_ListOutputElement_columns (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_ListOutputElement_columns)
	l =_ElempwebPageView_ListOutputElement_columns (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_ListOutputElement_columns)
	r = _ElempwebPageView_ListOutputElement_columns (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_ListOutputElement_columns)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_ListOutputElement_columns)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_ListOutputElement_columns)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_ListOutputElement_columns)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_columns (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_columns (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_ListOutputElement_columns root;
	webPageView__TPPLST_0pwebPageView_ListOutputElement_columns list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_ListOutputElement_columns)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_ListOutputElement_columns)
		t = _ElempwebPageView_ListOutputElement_columns (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_ListOutputElement_columns)(((webPageView__TPPLST_0pwebPageView_ListOutputElement_columns) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_ListOutputElement_columns) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_ListOutputElement_columns;
#else
list = (webPageView__TPPLST_0pwebPageView_ListOutputElement_columns) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_ListOutputElement_columns));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_ListOutputElement_columns;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_ListOutputElement_columns)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ListOutputColumnpwebPageView_ListOutputElement_columns)
	{webPageView__TPPLST_webPageView_ListOutputColumnpwebPageView_ListOutputElement_columns _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ListOutputColumnpwebPageView_ListOutputElement_columns;
	} this code has been moved to _ElempwebPageView_ListOutputElement_columns*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_ListOutputElement_columns;
#else
root = (webPageView__TPPpwebPageView_ListOutputElement_columns) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_columns));
#endif
root->_prod = webPageView_RULEpwebPageView_ListOutputElement_columns;
root->_desc1 = (webPageView__TSPLST_webPageView_ListOutputElement_columns)list;
{ webPageView__TPPpwebPageView_ListOutputElement_columns _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_ListOutputElement_columns;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_headerStyleClass (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_headerStyleClass (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputElement_headerStyleClass _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputElement_headerStyleClass;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputElement_headerStyleClass) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_headerStyleClass));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputElement_headerStyleClass;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputElement_headerStyleClass;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputElement_headerStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_evenRowStyleClass (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_evenRowStyleClass (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputElement_evenRowStyleClass _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputElement_evenRowStyleClass;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputElement_evenRowStyleClass) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_evenRowStyleClass));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputElement_evenRowStyleClass;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputElement_evenRowStyleClass;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputElement_evenRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputElement_oddRowStyleClass (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputElement_oddRowStyleClass (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputElement_oddRowStyleClass _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputElement_oddRowStyleClass;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputElement_oddRowStyleClass) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputElement_oddRowStyleClass));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputElement_oddRowStyleClass;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputElement_oddRowStyleClass;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputElement_oddRowStyleClass */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputColumn (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputColumn (_coordref, _TERM1,_desc1,_desc2)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
#endif
{	webPageView__TPPpwebPageView_ListOutputColumn _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputColumn;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputColumn) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputColumn));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputColumn;
_currn->_desc1 = (webPageView__TSPwebPageView_ListOutputColumn_header) webPageView_MkwebPageView_ListOutputColumn_header (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputColumn: root of subtree no. 1 can not be made a webPageView_ListOutputColumn_header node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_ListOutputColumn_content) webPageView_MkwebPageView_ListOutputColumn_content (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputColumn: root of subtree no. 2 can not be made a webPageView_ListOutputColumn_content node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputColumn;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputColumn */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputColumn_header (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputColumn_header (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputColumn_header _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputColumn_header;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputColumn_header) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputColumn_header));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputColumn_header;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputColumn_header;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputColumn_header */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content;
#else
	_new = (webPageView__TPPLST_webPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content;
	_new->_desc1 = (webPageView__TSPwebPageView_ListOutputConstantContent)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputColumn_content)_new;
	{webPageView__TPPLST_webPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content;
#else
	_new = (webPageView__TPPLST_webPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content;
	_new->_desc1 = (webPageView__TSPwebPageView_ListOutputRefContent)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputColumn_content)_new;
	{webPageView__TPPLST_webPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content;
#else
	_new = (webPageView__TPPLST_webPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content;
	_new->_desc1 = (webPageView__TSPwebPageView_ListOutputProjectionContent)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputColumn_content)_new;
	{webPageView__TPPLST_webPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content;
#else
	_new = (webPageView__TPPLST_webPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content;
	_new->_desc1 = (webPageView__TSPwebPageView_ListOutputNumerationContent)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputColumn_content)_new;
	{webPageView__TPPLST_webPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content;
#else
	_new = (webPageView__TPPLST_webPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content;
	_new->_desc1 = (webPageView__TSPwebPageView_ListOutputActionConnectionsContent)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputColumn_content)_new;
	{webPageView__TPPLST_webPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_ListOutputColumn_content (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_ListOutputColumn_content (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ListOutputConstantContent)) 
		return webPageView__MkwebPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content (_coordref, webPageView_MkwebPageView_ListOutputConstantContent (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ListOutputRefContent)) 
		return webPageView__MkwebPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content (_coordref, webPageView_MkwebPageView_ListOutputRefContent (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ListOutputProjectionContent)) 
		return webPageView__MkwebPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content (_coordref, webPageView_MkwebPageView_ListOutputProjectionContent (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ListOutputNumerationContent)) 
		return webPageView__MkwebPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content (_coordref, webPageView_MkwebPageView_ListOutputNumerationContent (_coordref, t));
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ListOutputActionConnectionsContent)) 
		return webPageView__MkwebPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content (_coordref, webPageView_MkwebPageView_ListOutputActionConnectionsContent (_coordref, t));
	message (DEADLY, "a pwebPageView_ListOutputColumn_content list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_ListOutputColumn_content (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_ListOutputColumn_content (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_ListOutputColumn_content)
	l =_ElempwebPageView_ListOutputColumn_content (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_ListOutputColumn_content)
	r = _ElempwebPageView_ListOutputColumn_content (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_ListOutputColumn_content)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_ListOutputColumn_content)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_ListOutputColumn_content)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_ListOutputColumn_content)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputColumn_content (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputColumn_content (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_ListOutputColumn_content root;
	webPageView__TPPLST_0pwebPageView_ListOutputColumn_content list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_ListOutputColumn_content)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_ListOutputColumn_content)
		t = _ElempwebPageView_ListOutputColumn_content (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_ListOutputColumn_content)(((webPageView__TPPLST_0pwebPageView_ListOutputColumn_content) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_ListOutputColumn_content) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_ListOutputColumn_content;
#else
list = (webPageView__TPPLST_0pwebPageView_ListOutputColumn_content) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_ListOutputColumn_content));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_ListOutputColumn_content;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_ListOutputColumn_content)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content)
	{webPageView__TPPLST_webPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ListOutputConstantContentpwebPageView_ListOutputColumn_content;
	} this code has been moved to _ElempwebPageView_ListOutputColumn_content*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content)
	{webPageView__TPPLST_webPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ListOutputRefContentpwebPageView_ListOutputColumn_content;
	} this code has been moved to _ElempwebPageView_ListOutputColumn_content*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content)
	{webPageView__TPPLST_webPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ListOutputProjectionContentpwebPageView_ListOutputColumn_content;
	} this code has been moved to _ElempwebPageView_ListOutputColumn_content*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content)
	{webPageView__TPPLST_webPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ListOutputNumerationContentpwebPageView_ListOutputColumn_content;
	} this code has been moved to _ElempwebPageView_ListOutputColumn_content*/
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content)
	{webPageView__TPPLST_webPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ListOutputActionConnectionsContentpwebPageView_ListOutputColumn_content;
	} this code has been moved to _ElempwebPageView_ListOutputColumn_content*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_ListOutputColumn_content;
#else
root = (webPageView__TPPpwebPageView_ListOutputColumn_content) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputColumn_content));
#endif
root->_prod = webPageView_RULEpwebPageView_ListOutputColumn_content;
root->_desc1 = (webPageView__TSPLST_webPageView_ListOutputColumn_content)list;
{ webPageView__TPPpwebPageView_ListOutputColumn_content _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_ListOutputColumn_content;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputConstantContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputConstantContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_ListOutputConstantContent _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputConstantContent;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputConstantContent) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputConstantContent));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputConstantContent;
_currn->_desc1 = (webPageView__TSPwebPageView_ListOutputConstantContent_value) webPageView_MkwebPageView_ListOutputConstantContent_value (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputConstantContent: root of subtree no. 1 can not be made a webPageView_ListOutputConstantContent_value node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputConstantContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputConstantContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputConstantContent_value (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputConstantContent_value (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputConstantContent_value _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputConstantContent_value;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputConstantContent_value) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputConstantContent_value));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputConstantContent_value;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputConstantContent_value;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputConstantContent_value */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputRefContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputRefContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_ListOutputRefContent _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputRefContent;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputRefContent) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputRefContent));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputRefContent;
_currn->_desc1 = (webPageView__TSPwebPageView_ListOutputRefContent_column) webPageView_MkwebPageView_ListOutputRefContent_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputRefContent: root of subtree no. 1 can not be made a webPageView_ListOutputRefContent_column node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputRefContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputRefContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputRefContent_column (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputRefContent_column (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputRefContent_column _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputRefContent_column;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputRefContent_column) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputRefContent_column));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputRefContent_column;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputRefContent_column;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputRefContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputProjectionContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputProjectionContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_ListOutputProjectionContent _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputProjectionContent;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputProjectionContent) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputProjectionContent));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputProjectionContent;
_currn->_desc1 = (webPageView__TSPwebPageView_ListOutputProjectionContent_column) webPageView_MkwebPageView_ListOutputProjectionContent_column (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputProjectionContent: root of subtree no. 1 can not be made a webPageView_ListOutputProjectionContent_column node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputProjectionContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputProjectionContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputProjectionContent_column (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputProjectionContent_column (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputProjectionContent_column _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputProjectionContent_column;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputProjectionContent_column) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputProjectionContent_column));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputProjectionContent_column;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputProjectionContent_column;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputProjectionContent_column */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputNumerationContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputNumerationContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_ListOutputNumerationContent _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputNumerationContent;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputNumerationContent) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputNumerationContent));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputNumerationContent;
_currn->_desc1 = (webPageView__TSPwebPageView_ListOutputNumerationContent_name) webPageView_MkwebPageView_ListOutputNumerationContent_name (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputNumerationContent: root of subtree no. 1 can not be made a webPageView_ListOutputNumerationContent_name node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputNumerationContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputNumerationContent */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputNumerationContent_name (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputNumerationContent_name (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ListOutputNumerationContent_name _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputNumerationContent_name;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputNumerationContent_name) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputNumerationContent_name));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputNumerationContent_name;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputNumerationContent_name;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputNumerationContent_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputActionConnectionsContent (POSITION *_coordref, int _TERM1, NODEPTR _desc1)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputActionConnectionsContent (_coordref, _TERM1,_desc1)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
#endif
{	webPageView__TPPpwebPageView_ListOutputActionConnectionsContent _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ListOutputActionConnectionsContent;
#else
_currn = (webPageView__TPPpwebPageView_ListOutputActionConnectionsContent) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputActionConnectionsContent));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ListOutputActionConnectionsContent;
_currn->_desc1 = (webPageView__TSPwebPageView_ListOutputActionConnectionsContent_actionConnections) webPageView_MkwebPageView_ListOutputActionConnectionsContent_actionConnections (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ListOutputActionConnectionsContent: root of subtree no. 1 can not be made a webPageView_ListOutputActionConnectionsContent_actionConnections node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ListOutputActionConnectionsContent;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ListOutputActionConnectionsContent */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections;
#else
	_new = (webPageView__TPPLST_webPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections;
	_new->_desc1 = (webPageView__TSPwebPageView_ActionConnection)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ListOutputActionConnectionsContent_actionConnections)_new;
	{webPageView__TPPLST_webPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_ListOutputActionConnectionsContent_actionConnections (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ActionConnection)) 
		return webPageView__MkwebPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections (_coordref, webPageView_MkwebPageView_ActionConnection (_coordref, t));
	message (DEADLY, "a pwebPageView_ListOutputActionConnectionsContent_actionConnections list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_ListOutputActionConnectionsContent_actionConnections (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_ListOutputActionConnectionsContent_actionConnections)
	l =_ElempwebPageView_ListOutputActionConnectionsContent_actionConnections (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_ListOutputActionConnectionsContent_actionConnections)
	r = _ElempwebPageView_ListOutputActionConnectionsContent_actionConnections (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ListOutputActionConnectionsContent_actionConnections (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_ListOutputActionConnectionsContent_actionConnections (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_ListOutputActionConnectionsContent_actionConnections root;
	webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_ListOutputActionConnectionsContent_actionConnections)
		t = _ElempwebPageView_ListOutputActionConnectionsContent_actionConnections (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections)(((webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections;
#else
list = (webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_ListOutputActionConnectionsContent_actionConnections)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections)
	{webPageView__TPPLST_webPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ActionConnectionpwebPageView_ListOutputActionConnectionsContent_actionConnections;
	} this code has been moved to _ElempwebPageView_ListOutputActionConnectionsContent_actionConnections*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_ListOutputActionConnectionsContent_actionConnections;
#else
root = (webPageView__TPPpwebPageView_ListOutputActionConnectionsContent_actionConnections) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ListOutputActionConnectionsContent_actionConnections));
#endif
root->_prod = webPageView_RULEpwebPageView_ListOutputActionConnectionsContent_actionConnections;
root->_desc1 = (webPageView__TSPLST_webPageView_ListOutputActionConnectionsContent_actionConnections)list;
{ webPageView__TPPpwebPageView_ListOutputActionConnectionsContent_actionConnections _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_ListOutputActionConnectionsContent_actionConnections;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ActionConnection (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4)
#else
NODEPTR webPageView_MkpwebPageView_ActionConnection (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
#endif
{	webPageView__TPPpwebPageView_ActionConnection _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ActionConnection;
#else
_currn = (webPageView__TPPpwebPageView_ActionConnection) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ActionConnection));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ActionConnection;
_currn->_desc1 = (webPageView__TSPwebPageView_ActionConnection_action) webPageView_MkwebPageView_ActionConnection_action (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ActionConnection: root of subtree no. 1 can not be made a webPageView_ActionConnection_action node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_ActionConnection_imageName) webPageView_MkwebPageView_ActionConnection_imageName (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ActionConnection: root of subtree no. 2 can not be made a webPageView_ActionConnection_imageName node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_ActionConnection_text) webPageView_MkwebPageView_ActionConnection_text (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ActionConnection: root of subtree no. 3 can not be made a webPageView_ActionConnection_text node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_ActionConnection_actualParams) webPageView_MkwebPageView_ActionConnection_actualParams (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ActionConnection: root of subtree no. 4 can not be made a webPageView_ActionConnection_actualParams node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ActionConnection;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ActionConnection */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ActionConnection_action (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ActionConnection_action (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ActionConnection_action _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ActionConnection_action;
#else
_currn = (webPageView__TPPpwebPageView_ActionConnection_action) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ActionConnection_action));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ActionConnection_action;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ActionConnection_action;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ActionConnection_action */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ActionConnection_imageName (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ActionConnection_imageName (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ActionConnection_imageName _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ActionConnection_imageName;
#else
_currn = (webPageView__TPPpwebPageView_ActionConnection_imageName) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ActionConnection_imageName));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ActionConnection_imageName;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ActionConnection_imageName;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ActionConnection_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ActionConnection_text (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ActionConnection_text (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ActionConnection_text _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ActionConnection_text;
#else
_currn = (webPageView__TPPpwebPageView_ActionConnection_text) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ActionConnection_text));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ActionConnection_text;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ActionConnection_text;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ActionConnection_text */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams;
#else
	_new = (webPageView__TPPLST_webPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams));
#endif
	_new->_prod = webPageView_RULELST_webPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams;
	_new->_desc1 = (webPageView__TSPwebPageView_ListOutputActualParam)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ActionConnection_actualParams)_new;
	{webPageView__TPPLST_webPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_ActionConnection_actualParams (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_ListOutputActualParam)) 
		return webPageView__MkwebPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams (_coordref, webPageView_MkwebPageView_ListOutputActualParam (_coordref, t));
	message (DEADLY, "a pwebPageView_ActionConnection_actualParams list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_ActionConnection_actualParams (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_ActionConnection_actualParams)
	l =_ElempwebPageView_ActionConnection_actualParams (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_ActionConnection_actualParams)
	r = _ElempwebPageView_ActionConnection_actualParams (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ActionConnection_actualParams (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_ActionConnection_actualParams (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_ActionConnection_actualParams root;
	webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_ActionConnection_actualParams)
		t = _ElempwebPageView_ActionConnection_actualParams (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams)(((webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_ActionConnection_actualParams;
#else
list = (webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_ActionConnection_actualParams));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_ActionConnection_actualParams;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_ActionConnection_actualParams)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams)
	{webPageView__TPPLST_webPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_ListOutputActualParampwebPageView_ActionConnection_actualParams;
	} this code has been moved to _ElempwebPageView_ActionConnection_actualParams*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_ActionConnection_actualParams;
#else
root = (webPageView__TPPpwebPageView_ActionConnection_actualParams) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ActionConnection_actualParams));
#endif
root->_prod = webPageView_RULEpwebPageView_ActionConnection_actualParams;
root->_desc1 = (webPageView__TSPLST_webPageView_ActionConnection_actualParams)list;
{ webPageView__TPPpwebPageView_ActionConnection_actualParams _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_ActionConnection_actualParams;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageMap (POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5)
#else
NODEPTR webPageView_MkpwebPageView_ImageMap (_coordref, _TERM1,_desc1,_desc2,_desc3,_desc4,_desc5)
	POSITION *_coordref;
	int _TERM1;
	NODEPTR _desc1;
	NODEPTR _desc2;
	NODEPTR _desc3;
	NODEPTR _desc4;
	NODEPTR _desc5;
#endif
{	webPageView__TPPpwebPageView_ImageMap _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageMap;
#else
_currn = (webPageView__TPPpwebPageView_ImageMap) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageMap));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageMap;
_currn->_desc1 = (webPageView__TSPwebPageView_ImageMap_styleSheetBlock) webPageView_MkwebPageView_ImageMap_styleSheetBlock (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageMap: root of subtree no. 1 can not be made a webPageView_ImageMap_styleSheetBlock node ", 0, _coordref);
_currn->_desc2 = (webPageView__TSPwebPageView_ImageMap_name) webPageView_MkwebPageView_ImageMap_name (_coordref, _desc2);	
if (((NODEPTR)_currn->_desc2) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageMap: root of subtree no. 2 can not be made a webPageView_ImageMap_name node ", 0, _coordref);
_currn->_desc3 = (webPageView__TSPwebPageView_ImageMap_imageName) webPageView_MkwebPageView_ImageMap_imageName (_coordref, _desc3);	
if (((NODEPTR)_currn->_desc3) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageMap: root of subtree no. 3 can not be made a webPageView_ImageMap_imageName node ", 0, _coordref);
_currn->_desc4 = (webPageView__TSPwebPageView_ImageMap_altText) webPageView_MkwebPageView_ImageMap_altText (_coordref, _desc4);	
if (((NODEPTR)_currn->_desc4) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageMap: root of subtree no. 4 can not be made a webPageView_ImageMap_altText node ", 0, _coordref);
_currn->_desc5 = (webPageView__TSPwebPageView_ImageMap_mapAreas) webPageView_MkwebPageView_ImageMap_mapAreas (_coordref, _desc5);	
if (((NODEPTR)_currn->_desc5) == NULLNODEPTR)	
	message (DEADLY, "RULE pwebPageView_ImageMap: root of subtree no. 5 can not be made a webPageView_ImageMap_mapAreas node ", 0, _coordref);
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageMap;
#ifdef MONITOR
_dapto_term_int(((NODEPTR)_currn), "ID", _TERM1);
#endif

return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageMap */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageMap_styleSheetBlock (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageMap_styleSheetBlock (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageMap_styleSheetBlock _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageMap_styleSheetBlock;
#else
_currn = (webPageView__TPPpwebPageView_ImageMap_styleSheetBlock) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageMap_styleSheetBlock));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageMap_styleSheetBlock;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageMap_styleSheetBlock;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageMap_styleSheetBlock */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageMap_name (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageMap_name (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageMap_name _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageMap_name;
#else
_currn = (webPageView__TPPpwebPageView_ImageMap_name) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageMap_name));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageMap_name;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageMap_name;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageMap_name */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageMap_imageName (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageMap_imageName (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageMap_imageName _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageMap_imageName;
#else
_currn = (webPageView__TPPpwebPageView_ImageMap_imageName) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageMap_imageName));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageMap_imageName;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageMap_imageName;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageMap_imageName */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageMap_altText (POSITION *_coordref)
#else
NODEPTR webPageView_MkpwebPageView_ImageMap_altText (_coordref)
	POSITION *_coordref;
#endif
{	webPageView__TPPpwebPageView_ImageMap_altText _currn;
#ifdef __cplusplus
_currn = new webPageView__TPpwebPageView_ImageMap_altText;
#else
_currn = (webPageView__TPPpwebPageView_ImageMap_altText) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageMap_altText));
#endif
_currn->_prod = webPageView_RULEpwebPageView_ImageMap_altText;
_SETCOORD(_currn)
webPageView__TERMACT_pwebPageView_ImageMap_altText;
return ( (NODEPTR) _currn);
}/* webPageView_MkpwebPageView_ImageMap_altText */

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR webPageView__MkwebPageView_MapAreapwebPageView_ImageMap_mapAreas (POSITION *_coordref, NODEPTR elem)
#else
static NODEPTR webPageView__MkwebPageView_MapAreapwebPageView_ImageMap_mapAreas (_coordref, elem)
	POSITION *_coordref; NODEPTR elem;
#endif
{
	webPageView__TPPLST_webPageView_MapAreapwebPageView_ImageMap_mapAreas _new;
#ifdef __cplusplus
	_new = new webPageView__TPLST_webPageView_MapAreapwebPageView_ImageMap_mapAreas;
#else
	_new = (webPageView__TPPLST_webPageView_MapAreapwebPageView_ImageMap_mapAreas) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_webPageView_MapAreapwebPageView_ImageMap_mapAreas));
#endif
	_new->_prod = webPageView_RULELST_webPageView_MapAreapwebPageView_ImageMap_mapAreas;
	_new->_desc1 = (webPageView__TSPwebPageView_MapArea)elem;
	_new->_desc2 = (webPageView__TSPLST_webPageView_ImageMap_mapAreas)_new;
	{webPageView__TPPLST_webPageView_MapAreapwebPageView_ImageMap_mapAreas _currn = _new;
	 _SETCOORD(_currn)
	 webPageView__TERMACT_LST_webPageView_MapAreapwebPageView_ImageMap_mapAreas;
	}
	return (NODEPTR)_new;
}

#if defined(__STDC__) || defined(__cplusplus)
static NODEPTR _ElempwebPageView_ImageMap_mapAreas (POSITION *_coordref, NODEPTR t)
#else
static NODEPTR _ElempwebPageView_ImageMap_mapAreas (_coordref, t)
	POSITION *_coordref; NODEPTR t;
#endif
/* coerces t to a list element and returns a single circular list */
{	NODEPTR elem;
	/* check first without then with coercion: */
	if (webPageView_IsSymb (t, webPageView_SYMBwebPageView_MapArea)) 
		return webPageView__MkwebPageView_MapAreapwebPageView_ImageMap_mapAreas (_coordref, webPageView_MkwebPageView_MapArea (_coordref, t));
	message (DEADLY, "a pwebPageView_ImageMap_mapAreas list element node can not be generated ",
		0, _coordref);
	return t; /* never reached */
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mk2pwebPageView_ImageMap_mapAreas (POSITION *_coordref, NODEPTR l, NODEPTR r)
#else
NODEPTR webPageView_Mk2pwebPageView_ImageMap_mapAreas (_coordref, l, r) POSITION *_coordref; NODEPTR l, r;
#endif
/* make a list of l and r, which may be null, elements, or lists */
{	NODEPTR last;
if (l == NULLNODEPTR) return r;
if (r == NULLNODEPTR) return l;
/* ensure l and r to be lists: */
if (webPageView_LHSMAP[l->_prod] != webPageView_SYMBLST_webPageView_ImageMap_mapAreas)
	l =_ElempwebPageView_ImageMap_mapAreas (_coordref, l);
if (webPageView_LHSMAP[r->_prod] != webPageView_SYMBLST_webPageView_ImageMap_mapAreas)
	r = _ElempwebPageView_ImageMap_mapAreas (_coordref, r);
/* concatenate two lists: */
last = ((NODEPTR)((webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas)r)->_desc2);
((webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas)r)->_desc2 = ((webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas)l)->_desc2;
((webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas)l)->_desc2 = last;
return l;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_MkpwebPageView_ImageMap_mapAreas (POSITION *_coordref, NODEPTR t)
#else
NODEPTR webPageView_MkpwebPageView_ImageMap_mapAreas (_coordref, t) POSITION *_coordref; NODEPTR t;
#endif
{	NODEPTR _currn; webPageView__TPPpwebPageView_ImageMap_mapAreas root;
	webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas list, remain, p;
/* argument t may be empty, a list element, or a list: */
if (t == NULLNODEPTR)
	remain = (webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas)NULLNODEPTR;
else {	if (webPageView_LHSMAP[t->_prod] != webPageView_SYMBLST_webPageView_ImageMap_mapAreas)
		t = _ElempwebPageView_ImageMap_mapAreas (_coordref, t);
	remain = (webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas)(((webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas) t)->_desc2);
	((webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas) t)->_desc2 = NULLNODEPTR;
}
/* remain is a possibly empty list in reverse order */
/* finalize the list by an empty context: */
#ifdef __cplusplus
list = new webPageView__TPLST_0pwebPageView_ImageMap_mapAreas;
#else
list = (webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPLST_0pwebPageView_ImageMap_mapAreas));
#endif
list->_prod = webPageView_RULELST_0pwebPageView_ImageMap_mapAreas;
list->_desc1 = NULLNODEPTR;
list->_desc2 = NULLNODEPTR;
_SETCOORD(list)
_currn = (NODEPTR)list;
/* reverse the list and visit its nodes: */
while (remain) {
	p = (webPageView__TPPLST_0pwebPageView_ImageMap_mapAreas)(remain->_desc2);
	remain->_desc2 = (NODEPTR)list;
	list = remain;
	remain = p;
	_currn = (NODEPTR)list;
	/*if (_currn->_prod == webPageView_RULELST_webPageView_MapAreapwebPageView_ImageMap_mapAreas)
	{webPageView__TPPLST_webPageView_MapAreapwebPageView_ImageMap_mapAreas _currn = _currn;
	 webPageView__TERMACT_LST_webPageView_MapAreapwebPageView_ImageMap_mapAreas;
	} this code has been moved to _ElempwebPageView_ImageMap_mapAreas*/
}
/* make root node and visit it: */
#ifdef __cplusplus
root = new webPageView__TPpwebPageView_ImageMap_mapAreas;
#else
root = (webPageView__TPPpwebPageView_ImageMap_mapAreas) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPpwebPageView_ImageMap_mapAreas));
#endif
root->_prod = webPageView_RULEpwebPageView_ImageMap_mapAreas;
root->_desc1 = (webPageView__TSPLST_webPageView_ImageMap_mapAreas)list;
{ webPageView__TPPpwebPageView_ImageMap_mapAreas _currn = root;
  _SETCOORD(_currn)
  webPageView__TERMACT_pwebPageView_ImageMap_mapAreas;
}
_currn = (NODEPTR)root;
return (NODEPTR)_currn;
}

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mkrule_1 (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR webPageView_Mkrule_1 (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	webPageView__TPPrule_1 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPrule_1;
#else
_currn = (webPageView__TPPrule_1) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPrule_1));
#endif
_currn->_prod = webPageView_RULErule_1;
_currn->_desc1 = (webPageView__TSPwebPageView_Frame) webPageView_MkwebPageView_Frame (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE rule_1: root of subtree no. 1 can not be made a webPageView_Frame node ", 0, _coordref);
_COPYCOORD(_currn)
webPageView__TERMACT_rule_1;
return ( (NODEPTR) _currn);
}/* webPageView_Mkrule_1 */

#if defined(__STDC__) || defined(__cplusplus)
NODEPTR webPageView_Mkrule_2 (POSITION *_coordref, NODEPTR _desc1)
#else
NODEPTR webPageView_Mkrule_2 (_coordref,_desc1)
	POSITION *_coordref;
	NODEPTR _desc1;
#endif
{	webPageView__TPPrule_2 _currn;
#ifdef __cplusplus
_currn = new webPageView__TPrule_2;
#else
_currn = (webPageView__TPPrule_2) webPageView_TreeNodeAlloc (sizeof (struct webPageView__TPrule_2));
#endif
_currn->_prod = webPageView_RULErule_2;
_currn->_desc1 = (webPageView__TSPwebPageView_Frame) webPageView_MkwebPageView_Frame (_coordref, _desc1);	
if (((NODEPTR)_currn->_desc1) == NULLNODEPTR)	
	message (DEADLY, "RULE rule_2: root of subtree no. 1 can not be made a webPageView_Frame node ", 0, _coordref);
_COPYCOORD(_currn)
webPageView__TERMACT_rule_2;
return ( (NODEPTR) _currn);
}/* webPageView_Mkrule_2 */
